### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class Operator(APIObject):
	gpk: str
	name: str
	description: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")

	@staticmethod
	def create_ta(name_new: str, description_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		return {'name': 'dhcpcfg.operator.create', 'new': _denullify_dict({'name': name_new, 'description': description_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, description_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, description_new=description_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str = None) -> dict:
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'dhcpcfg.operator.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str = None) -> list:
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dhcpcfg.operator.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, description_new: Union[str, ExplicitNull] = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'dhcpcfg.operator.update', 'new': _denullify_dict({'name': name_new, 'description': description_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, description_new: Union[str, ExplicitNull] = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, description_new=description_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Dt2operator2dt(APIObject):
	gpk: str
	operator: str
	left_data_type: str
	right_data_type: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.operator, str):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(self.operator)}")
		if not isinstance(self.left_data_type, str):
			raise ValueError(f"'left_data_type' of incorrect type. Expected str, got {type(self.left_data_type)}")
		if not isinstance(self.right_data_type, str):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(self.right_data_type)}")

	@staticmethod
	def create_ta(operator_new: str, left_data_type_new: str, right_data_type_new: str) -> dict:
		if not (isinstance(operator_new, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_new)}")
		if not (isinstance(left_data_type_new, str)):
			raise ValueError(f"'left_data_type' of incorrect type. Expected str, got {type(left_data_type_new)}")
		if not (isinstance(right_data_type_new, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_new)}")

		return {'name': 'dhcpcfg.dt2operator2dt.create', 'new': _denullify_dict({'operator': operator_new, 'left_data_type': left_data_type_new, 'right_data_type': right_data_type_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, operator_new: str, left_data_type_new: str, right_data_type_new: str) -> list:
		if not (isinstance(operator_new, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_new)}")
		if not (isinstance(left_data_type_new, str)):
			raise ValueError(f"'left_data_type' of incorrect type. Expected str, got {type(left_data_type_new)}")
		if not (isinstance(right_data_type_new, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(operator_new=operator_new, left_data_type_new=left_data_type_new, right_data_type_new=right_data_type_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(operator_old: str, left_data_type_old: str, right_data_type_old: str) -> dict:
		if not (isinstance(operator_old, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_old)}")
		if not (isinstance(left_data_type_old, str)):
			raise ValueError(f"'left_data_type' of incorrect type. Expected str, got {type(left_data_type_old)}")
		if not (isinstance(right_data_type_old, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_old)}")

		return {'name': 'dhcpcfg.dt2operator2dt.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'operator': operator_old, 'left_data_type': left_data_type_old, 'right_data_type': right_data_type_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, operator_old: str, left_data_type_old: str, right_data_type_old: str) -> list:
		if not (isinstance(operator_old, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_old)}")
		if not (isinstance(left_data_type_old, str)):
			raise ValueError(f"'left_data_type' of incorrect type. Expected str, got {type(left_data_type_old)}")
		if not (isinstance(right_data_type_old, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(operator_old=operator_old, left_data_type_old=left_data_type_old, right_data_type_old=right_data_type_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, operator_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, left_data_type_old: str = None, right_data_type_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if operator_old is not None and not (isinstance(operator_old, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if left_data_type_old is not None and not (isinstance(left_data_type_old, str)):
			raise ValueError(f"'left_data_type' of incorrect type. Expected str, got {type(left_data_type_old)}")
		if right_data_type_old is not None and not (isinstance(right_data_type_old, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dhcpcfg.dt2operator2dt.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'operator': operator_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'left_data_type': left_data_type_old, 'right_data_type': right_data_type_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, operator_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, left_data_type_old: str = None, right_data_type_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if operator_old is not None and not (isinstance(operator_old, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if left_data_type_old is not None and not (isinstance(left_data_type_old, str)):
			raise ValueError(f"'left_data_type' of incorrect type. Expected str, got {type(left_data_type_old)}")
		if right_data_type_old is not None and not (isinstance(right_data_type_old, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, operator_old=operator_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, left_data_type_old=left_data_type_old, right_data_type_old=right_data_type_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(operator_old: str, left_data_type_old: str, right_data_type_old: str, operator_new: str = None, left_data_type_new: str = None, right_data_type_new: str = None) -> dict:
		if operator_new is not None and not (isinstance(operator_new, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_new)}")
		if left_data_type_new is not None and not (isinstance(left_data_type_new, str)):
			raise ValueError(f"'left_data_type' of incorrect type. Expected str, got {type(left_data_type_new)}")
		if right_data_type_new is not None and not (isinstance(right_data_type_new, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_new)}")
		if not (isinstance(operator_old, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_old)}")
		if not (isinstance(left_data_type_old, str)):
			raise ValueError(f"'left_data_type' of incorrect type. Expected str, got {type(left_data_type_old)}")
		if not (isinstance(right_data_type_old, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_old)}")

		return {'name': 'dhcpcfg.dt2operator2dt.update', 'new': _denullify_dict({'operator': operator_new, 'left_data_type': left_data_type_new, 'right_data_type': right_data_type_new}), 'old': _denullify_dict({'operator': operator_old, 'left_data_type': left_data_type_old, 'right_data_type': right_data_type_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, operator_old: str, left_data_type_old: str, right_data_type_old: str, operator_new: str = None, left_data_type_new: str = None, right_data_type_new: str = None) -> list:
		if operator_new is not None and not (isinstance(operator_new, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_new)}")
		if left_data_type_new is not None and not (isinstance(left_data_type_new, str)):
			raise ValueError(f"'left_data_type' of incorrect type. Expected str, got {type(left_data_type_new)}")
		if right_data_type_new is not None and not (isinstance(right_data_type_new, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_new)}")
		if not (isinstance(operator_old, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_old)}")
		if not (isinstance(left_data_type_old, str)):
			raise ValueError(f"'left_data_type' of incorrect type. Expected str, got {type(left_data_type_old)}")
		if not (isinstance(right_data_type_old, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(operator_new=operator_new, left_data_type_new=left_data_type_new, right_data_type_new=right_data_type_new, operator_old=operator_old, left_data_type_old=left_data_type_old, right_data_type_old=right_data_type_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
