### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class ZoneKey(APIObject):
	gpk: str
	tag: int
	data: str
	fqdn: str
	flags: int
	is_ksk: bool
	is_active: bool
	creation_ts: str
	activation_ts: str
	dnskey_rr_data: str
	deactivation_ts: str
	ds_rr_data_list: list

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if self.tag is not None and not isinstance(self.tag, int):
			raise ValueError(f"'tag' of incorrect type. Expected int, got {type(self.tag)}")
		if self.data is not None and not isinstance(self.data, str):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(self.data)}")
		if not isinstance(self.fqdn, str):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(self.fqdn)}")
		if not isinstance(self.flags, int):
			raise ValueError(f"'flags' of incorrect type. Expected int, got {type(self.flags)}")
		if not isinstance(self.is_ksk, bool):
			raise ValueError(f"'is_ksk' of incorrect type. Expected bool, got {type(self.is_ksk)}")
		if not isinstance(self.is_active, bool):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(self.is_active)}")
		if not isinstance(self.creation_ts, str):
			raise ValueError(f"'creation_ts' of incorrect type. Expected str, got {type(self.creation_ts)}")
		if self.activation_ts is not None and not isinstance(self.activation_ts, str):
			raise ValueError(f"'activation_ts' of incorrect type. Expected str, got {type(self.activation_ts)}")
		if not isinstance(self.dnskey_rr_data, str):
			raise ValueError(f"'dnskey_rr_data' of incorrect type. Expected str, got {type(self.dnskey_rr_data)}")
		if self.deactivation_ts is not None and not isinstance(self.deactivation_ts, str):
			raise ValueError(f"'deactivation_ts' of incorrect type. Expected str, got {type(self.deactivation_ts)}")
		if not isinstance(self.ds_rr_data_list, list):
			raise ValueError(f"'ds_rr_data_list' of incorrect type. Expected list, got {type(self.ds_rr_data_list)}")

	@staticmethod
	def create_ta(fqdn_new: str, is_ksk_new: bool) -> dict:
		if not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if not (isinstance(is_ksk_new, bool)):
			raise ValueError(f"'is_ksk' of incorrect type. Expected bool, got {type(is_ksk_new)}")

		return {'name': 'dnssec.zone_key.create', 'new': _denullify_dict({'fqdn': fqdn_new, 'is_ksk': is_ksk_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, fqdn_new: str, is_ksk_new: bool) -> list:
		if not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if not (isinstance(is_ksk_new, bool)):
			raise ValueError(f"'is_ksk' of incorrect type. Expected bool, got {type(is_ksk_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(fqdn_new=fqdn_new, is_ksk_new=is_ksk_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dnssec.zone_key.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, fqdn_old: str = None, is_ksk_old: bool = None, is_active_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fqdn_old is not None and not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")
		if is_ksk_old is not None and not (isinstance(is_ksk_old, bool)):
			raise ValueError(f"'is_ksk' of incorrect type. Expected bool, got {type(is_ksk_old)}")
		if is_active_old is not None and not (isinstance(is_active_old, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")

		return {'name': 'dnssec.zone_key.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'fqdn': fqdn_old, 'is_ksk': is_ksk_old, 'is_active': is_active_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, fqdn_old: str = None, is_ksk_old: bool = None, is_active_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fqdn_old is not None and not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")
		if is_ksk_old is not None and not (isinstance(is_ksk_old, bool)):
			raise ValueError(f"'is_ksk' of incorrect type. Expected bool, got {type(is_ksk_old)}")
		if is_active_old is not None and not (isinstance(is_active_old, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, fqdn_old=fqdn_old, is_ksk_old=is_ksk_old, is_active_old=is_active_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
