### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class Client(APIObject):
	gpk: str
	is_own: bool
	wpa_key: str
	bcd_name: str
	mac_addr: str
	description: str
	last_login_date: str
	last_login_node_info: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if self.wpa_key is not None and not isinstance(self.wpa_key, str):
			raise ValueError(f"'wpa_key' of incorrect type. Expected str, got {type(self.wpa_key)}")
		if not isinstance(self.bcd_name, str):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(self.bcd_name)}")
		if not isinstance(self.mac_addr, str):
			raise ValueError(f"'mac_addr' of incorrect type. Expected str, got {type(self.mac_addr)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if self.last_login_date is not None and not isinstance(self.last_login_date, str):
			raise ValueError(f"'last_login_date' of incorrect type. Expected str, got {type(self.last_login_date)}")
		if self.last_login_node_info is not None and not isinstance(self.last_login_node_info, str):
			raise ValueError(f"'last_login_node_info' of incorrect type. Expected str, got {type(self.last_login_node_info)}")

	@staticmethod
	def create_ta(bcd_name_new: str, mac_addr_new: str, description_new: Union[str, ExplicitNull] = None, do_refresh_wpa_key_new: bool = True) -> dict:
		if not (isinstance(bcd_name_new, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_new)}")
		if not (isinstance(mac_addr_new, str)):
			raise ValueError(f"'mac_addr' of incorrect type. Expected str, got {type(mac_addr_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_refresh_wpa_key_new is not None and not (isinstance(do_refresh_wpa_key_new, bool)):
			raise ValueError(f"'do_refresh_wpa_key' of incorrect type. Expected bool, got {type(do_refresh_wpa_key_new)}")

		return {'name': 'macauth.client.create', 'new': _denullify_dict({'bcd_name': bcd_name_new, 'mac_addr': mac_addr_new, 'description': description_new, 'do_refresh_wpa_key': do_refresh_wpa_key_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, bcd_name_new: str, mac_addr_new: str, description_new: Union[str, ExplicitNull] = None, do_refresh_wpa_key_new: bool = True) -> list:
		if not (isinstance(bcd_name_new, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_new)}")
		if not (isinstance(mac_addr_new, str)):
			raise ValueError(f"'mac_addr' of incorrect type. Expected str, got {type(mac_addr_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_refresh_wpa_key_new is not None and not (isinstance(do_refresh_wpa_key_new, bool)):
			raise ValueError(f"'do_refresh_wpa_key' of incorrect type. Expected bool, got {type(do_refresh_wpa_key_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(bcd_name_new=bcd_name_new, mac_addr_new=mac_addr_new, description_new=description_new, do_refresh_wpa_key_new=do_refresh_wpa_key_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(mac_addr_old: str) -> dict:
		if not (isinstance(mac_addr_old, str)):
			raise ValueError(f"'mac_addr' of incorrect type. Expected str, got {type(mac_addr_old)}")

		return {'name': 'macauth.client.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'mac_addr': mac_addr_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, mac_addr_old: str) -> list:
		if not (isinstance(mac_addr_old, str)):
			raise ValueError(f"'mac_addr' of incorrect type. Expected str, got {type(mac_addr_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(mac_addr_old=mac_addr_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, bcd_name_old: str = None, mac_addr_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, description_regexp_old: str = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if bcd_name_old is not None and not (isinstance(bcd_name_old, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_old)}")
		if mac_addr_old is not None and not (isinstance(mac_addr_old, str)):
			raise ValueError(f"'mac_addr' of incorrect type. Expected str, got {type(mac_addr_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if description_regexp_old is not None and not (isinstance(description_regexp_old, str) or isinstance(description_regexp_old, ExplicitNull)):
			raise ValueError(f"'description_regexp' of incorrect type. Expected str, got {type(description_regexp_old)}")

		return {'name': 'macauth.client.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'bcd_name': bcd_name_old, 'mac_addr': mac_addr_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'description_regexp': description_regexp_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, bcd_name_old: str = None, mac_addr_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, description_regexp_old: str = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if bcd_name_old is not None and not (isinstance(bcd_name_old, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_old)}")
		if mac_addr_old is not None and not (isinstance(mac_addr_old, str)):
			raise ValueError(f"'mac_addr' of incorrect type. Expected str, got {type(mac_addr_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if description_regexp_old is not None and not (isinstance(description_regexp_old, str) or isinstance(description_regexp_old, ExplicitNull)):
			raise ValueError(f"'description_regexp' of incorrect type. Expected str, got {type(description_regexp_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, bcd_name_old=bcd_name_old, mac_addr_old=mac_addr_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, description_regexp_old=description_regexp_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(mac_addr_old: str, bcd_name_new: str = None, mac_addr_new: str = None, description_new: Union[str, ExplicitNull] = None, do_refresh_wpa_key_new: bool = None) -> dict:
		if bcd_name_new is not None and not (isinstance(bcd_name_new, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_new)}")
		if mac_addr_new is not None and not (isinstance(mac_addr_new, str)):
			raise ValueError(f"'mac_addr' of incorrect type. Expected str, got {type(mac_addr_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_refresh_wpa_key_new is not None and not (isinstance(do_refresh_wpa_key_new, bool)):
			raise ValueError(f"'do_refresh_wpa_key' of incorrect type. Expected bool, got {type(do_refresh_wpa_key_new)}")
		if not (isinstance(mac_addr_old, str)):
			raise ValueError(f"'mac_addr' of incorrect type. Expected str, got {type(mac_addr_old)}")

		return {'name': 'macauth.client.update', 'new': _denullify_dict({'bcd_name': bcd_name_new, 'mac_addr': mac_addr_new, 'description': description_new, 'do_refresh_wpa_key': do_refresh_wpa_key_new}), 'old': _denullify_dict({'mac_addr': mac_addr_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, mac_addr_old: str, bcd_name_new: str = None, mac_addr_new: str = None, description_new: Union[str, ExplicitNull] = None, do_refresh_wpa_key_new: bool = None) -> list:
		if bcd_name_new is not None and not (isinstance(bcd_name_new, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_new)}")
		if mac_addr_new is not None and not (isinstance(mac_addr_new, str)):
			raise ValueError(f"'mac_addr' of incorrect type. Expected str, got {type(mac_addr_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_refresh_wpa_key_new is not None and not (isinstance(do_refresh_wpa_key_new, bool)):
			raise ValueError(f"'do_refresh_wpa_key' of incorrect type. Expected bool, got {type(do_refresh_wpa_key_new)}")
		if not (isinstance(mac_addr_old, str)):
			raise ValueError(f"'mac_addr' of incorrect type. Expected str, got {type(mac_addr_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(bcd_name_new=bcd_name_new, mac_addr_new=mac_addr_new, description_new=description_new, do_refresh_wpa_key_new=do_refresh_wpa_key_new, mac_addr_old=mac_addr_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
