### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class FqdnType(APIObject):
	gpk: str
	name: str
	is_own: bool
	is_dhcp: bool
	is_host: bool
	_intname: str
	position: int
	rad_type: int
	_groupname: str
	description: str
	is_wildcard: bool
	is_nonterminal: bool
	version_name_dict: dict
	permission_fq_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.is_dhcp, bool):
			raise ValueError(f"'is_dhcp' of incorrect type. Expected bool, got {type(self.is_dhcp)}")
		if not isinstance(self.is_host, bool):
			raise ValueError(f"'is_host' of incorrect type. Expected bool, got {type(self.is_host)}")
		if not isinstance(self._intname, str):
			raise ValueError(f"'_intname' of incorrect type. Expected str, got {type(self._intname)}")
		if not isinstance(self.position, int):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(self.position)}")
		if not isinstance(self.rad_type, int):
			raise ValueError(f"'rad_type' of incorrect type. Expected int, got {type(self.rad_type)}")
		if not isinstance(self._groupname, str):
			raise ValueError(f"'_groupname' of incorrect type. Expected str, got {type(self._groupname)}")
		if not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.is_wildcard, bool):
			raise ValueError(f"'is_wildcard' of incorrect type. Expected bool, got {type(self.is_wildcard)}")
		if not isinstance(self.is_nonterminal, bool):
			raise ValueError(f"'is_nonterminal' of incorrect type. Expected bool, got {type(self.is_nonterminal)}")
		if not isinstance(self.version_name_dict, dict):
			raise ValueError(f"'version_name_dict' of incorrect type. Expected dict, got {type(self.version_name_dict)}")
		if self.permission_fq_name is not None and not isinstance(self.permission_fq_name, str):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(self.permission_fq_name)}")

	@staticmethod
	def create_ta(name_new: str, is_dhcp_new: bool, is_host_new: bool, position_new: int, rad_type_new: int, _groupname_new: str, description_new: str, is_wildcard_new: bool, is_nonterminal_new: bool, do_include_release_new: bool = True, permission_fq_name_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(is_dhcp_new, bool)):
			raise ValueError(f"'is_dhcp' of incorrect type. Expected bool, got {type(is_dhcp_new)}")
		if not (isinstance(is_host_new, bool)):
			raise ValueError(f"'is_host' of incorrect type. Expected bool, got {type(is_host_new)}")
		if not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if not (isinstance(rad_type_new, int)):
			raise ValueError(f"'rad_type' of incorrect type. Expected int, got {type(rad_type_new)}")
		if not (isinstance(_groupname_new, str)):
			raise ValueError(f"'_groupname' of incorrect type. Expected str, got {type(_groupname_new)}")
		if not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(is_wildcard_new, bool)):
			raise ValueError(f"'is_wildcard' of incorrect type. Expected bool, got {type(is_wildcard_new)}")
		if not (isinstance(is_nonterminal_new, bool)):
			raise ValueError(f"'is_nonterminal' of incorrect type. Expected bool, got {type(is_nonterminal_new)}")
		if do_include_release_new is not None and not (isinstance(do_include_release_new, bool)):
			raise ValueError(f"'do_include_release' of incorrect type. Expected bool, got {type(do_include_release_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")

		return {'name': 'dnscfg.fqdn_type.create', 'new': _denullify_dict({'name': name_new, 'is_dhcp': is_dhcp_new, 'is_host': is_host_new, 'position': position_new, 'rad_type': rad_type_new, '_groupname': _groupname_new, 'description': description_new, 'is_wildcard': is_wildcard_new, 'is_nonterminal': is_nonterminal_new, 'do_include_release': do_include_release_new, 'permission_fq_name': permission_fq_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, is_dhcp_new: bool, is_host_new: bool, position_new: int, rad_type_new: int, _groupname_new: str, description_new: str, is_wildcard_new: bool, is_nonterminal_new: bool, do_include_release_new: bool = True, permission_fq_name_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(is_dhcp_new, bool)):
			raise ValueError(f"'is_dhcp' of incorrect type. Expected bool, got {type(is_dhcp_new)}")
		if not (isinstance(is_host_new, bool)):
			raise ValueError(f"'is_host' of incorrect type. Expected bool, got {type(is_host_new)}")
		if not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if not (isinstance(rad_type_new, int)):
			raise ValueError(f"'rad_type' of incorrect type. Expected int, got {type(rad_type_new)}")
		if not (isinstance(_groupname_new, str)):
			raise ValueError(f"'_groupname' of incorrect type. Expected str, got {type(_groupname_new)}")
		if not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(is_wildcard_new, bool)):
			raise ValueError(f"'is_wildcard' of incorrect type. Expected bool, got {type(is_wildcard_new)}")
		if not (isinstance(is_nonterminal_new, bool)):
			raise ValueError(f"'is_nonterminal' of incorrect type. Expected bool, got {type(is_nonterminal_new)}")
		if do_include_release_new is not None and not (isinstance(do_include_release_new, bool)):
			raise ValueError(f"'do_include_release' of incorrect type. Expected bool, got {type(do_include_release_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, is_dhcp_new=is_dhcp_new, is_host_new=is_host_new, position_new=position_new, rad_type_new=rad_type_new, _groupname_new=_groupname_new, description_new=description_new, is_wildcard_new=is_wildcard_new, is_nonterminal_new=is_nonterminal_new, do_include_release_new=do_include_release_new, permission_fq_name_new=permission_fq_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(_intname_old: str) -> dict:
		if not (isinstance(_intname_old, str)):
			raise ValueError(f"'_intname' of incorrect type. Expected str, got {type(_intname_old)}")

		return {'name': 'dnscfg.fqdn_type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'_intname': _intname_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, _intname_old: str) -> list:
		if not (isinstance(_intname_old, str)):
			raise ValueError(f"'_intname' of incorrect type. Expected str, got {type(_intname_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(_intname_old=_intname_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, is_dhcp_old: bool = None, is_host_old: bool = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, is_wildcard_old: bool = None, fetch_offset_old: int = None, rad_type_list_old: list = None, is_nonterminal_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_dhcp_old is not None and not (isinstance(is_dhcp_old, bool)):
			raise ValueError(f"'is_dhcp' of incorrect type. Expected bool, got {type(is_dhcp_old)}")
		if is_host_old is not None and not (isinstance(is_host_old, bool)):
			raise ValueError(f"'is_host' of incorrect type. Expected bool, got {type(is_host_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_wildcard_old is not None and not (isinstance(is_wildcard_old, bool)):
			raise ValueError(f"'is_wildcard' of incorrect type. Expected bool, got {type(is_wildcard_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if rad_type_list_old is not None and not (isinstance(rad_type_list_old, list)):
			raise ValueError(f"'rad_type_list' of incorrect type. Expected list, got {type(rad_type_list_old)}")
		if is_nonterminal_old is not None and not (isinstance(is_nonterminal_old, bool)):
			raise ValueError(f"'is_nonterminal' of incorrect type. Expected bool, got {type(is_nonterminal_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dnscfg.fqdn_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'is_dhcp': is_dhcp_old, 'is_host': is_host_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'is_wildcard': is_wildcard_old, 'fetch_offset': fetch_offset_old, 'rad_type_list': rad_type_list_old, 'is_nonterminal': is_nonterminal_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, is_dhcp_old: bool = None, is_host_old: bool = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, is_wildcard_old: bool = None, fetch_offset_old: int = None, rad_type_list_old: list = None, is_nonterminal_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_dhcp_old is not None and not (isinstance(is_dhcp_old, bool)):
			raise ValueError(f"'is_dhcp' of incorrect type. Expected bool, got {type(is_dhcp_old)}")
		if is_host_old is not None and not (isinstance(is_host_old, bool)):
			raise ValueError(f"'is_host' of incorrect type. Expected bool, got {type(is_host_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_wildcard_old is not None and not (isinstance(is_wildcard_old, bool)):
			raise ValueError(f"'is_wildcard' of incorrect type. Expected bool, got {type(is_wildcard_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if rad_type_list_old is not None and not (isinstance(rad_type_list_old, list)):
			raise ValueError(f"'rad_type_list' of incorrect type. Expected list, got {type(rad_type_list_old)}")
		if is_nonterminal_old is not None and not (isinstance(is_nonterminal_old, bool)):
			raise ValueError(f"'is_nonterminal' of incorrect type. Expected bool, got {type(is_nonterminal_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, is_dhcp_old=is_dhcp_old, is_host_old=is_host_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, is_wildcard_old=is_wildcard_old, fetch_offset_old=fetch_offset_old, rad_type_list_old=rad_type_list_old, is_nonterminal_old=is_nonterminal_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(_intname_old: str, is_dhcp_new: bool = None, is_host_new: bool = None, position_new: int = None, rad_type_new: int = None, _groupname_new: str = None, description_new: str = None, is_wildcard_new: bool = None, is_nonterminal_new: bool = None, version_name_dict_new: dict = None, permission_fq_name_new: Union[str, ExplicitNull] = None) -> dict:
		if is_dhcp_new is not None and not (isinstance(is_dhcp_new, bool)):
			raise ValueError(f"'is_dhcp' of incorrect type. Expected bool, got {type(is_dhcp_new)}")
		if is_host_new is not None and not (isinstance(is_host_new, bool)):
			raise ValueError(f"'is_host' of incorrect type. Expected bool, got {type(is_host_new)}")
		if position_new is not None and not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if rad_type_new is not None and not (isinstance(rad_type_new, int)):
			raise ValueError(f"'rad_type' of incorrect type. Expected int, got {type(rad_type_new)}")
		if _groupname_new is not None and not (isinstance(_groupname_new, str)):
			raise ValueError(f"'_groupname' of incorrect type. Expected str, got {type(_groupname_new)}")
		if description_new is not None and not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_wildcard_new is not None and not (isinstance(is_wildcard_new, bool)):
			raise ValueError(f"'is_wildcard' of incorrect type. Expected bool, got {type(is_wildcard_new)}")
		if is_nonterminal_new is not None and not (isinstance(is_nonterminal_new, bool)):
			raise ValueError(f"'is_nonterminal' of incorrect type. Expected bool, got {type(is_nonterminal_new)}")
		if version_name_dict_new is not None and not (isinstance(version_name_dict_new, dict)):
			raise ValueError(f"'version_name_dict' of incorrect type. Expected dict, got {type(version_name_dict_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if not (isinstance(_intname_old, str)):
			raise ValueError(f"'_intname' of incorrect type. Expected str, got {type(_intname_old)}")

		return {'name': 'dnscfg.fqdn_type.update', 'new': _denullify_dict({'is_dhcp': is_dhcp_new, 'is_host': is_host_new, 'position': position_new, 'rad_type': rad_type_new, '_groupname': _groupname_new, 'description': description_new, 'is_wildcard': is_wildcard_new, 'is_nonterminal': is_nonterminal_new, 'version_name_dict': version_name_dict_new, 'permission_fq_name': permission_fq_name_new}), 'old': _denullify_dict({'_intname': _intname_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, _intname_old: str, is_dhcp_new: bool = None, is_host_new: bool = None, position_new: int = None, rad_type_new: int = None, _groupname_new: str = None, description_new: str = None, is_wildcard_new: bool = None, is_nonterminal_new: bool = None, version_name_dict_new: dict = None, permission_fq_name_new: Union[str, ExplicitNull] = None) -> list:
		if is_dhcp_new is not None and not (isinstance(is_dhcp_new, bool)):
			raise ValueError(f"'is_dhcp' of incorrect type. Expected bool, got {type(is_dhcp_new)}")
		if is_host_new is not None and not (isinstance(is_host_new, bool)):
			raise ValueError(f"'is_host' of incorrect type. Expected bool, got {type(is_host_new)}")
		if position_new is not None and not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if rad_type_new is not None and not (isinstance(rad_type_new, int)):
			raise ValueError(f"'rad_type' of incorrect type. Expected int, got {type(rad_type_new)}")
		if _groupname_new is not None and not (isinstance(_groupname_new, str)):
			raise ValueError(f"'_groupname' of incorrect type. Expected str, got {type(_groupname_new)}")
		if description_new is not None and not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_wildcard_new is not None and not (isinstance(is_wildcard_new, bool)):
			raise ValueError(f"'is_wildcard' of incorrect type. Expected bool, got {type(is_wildcard_new)}")
		if is_nonterminal_new is not None and not (isinstance(is_nonterminal_new, bool)):
			raise ValueError(f"'is_nonterminal' of incorrect type. Expected bool, got {type(is_nonterminal_new)}")
		if version_name_dict_new is not None and not (isinstance(version_name_dict_new, dict)):
			raise ValueError(f"'version_name_dict' of incorrect type. Expected dict, got {type(version_name_dict_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if not (isinstance(_intname_old, str)):
			raise ValueError(f"'_intname' of incorrect type. Expected str, got {type(_intname_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(is_dhcp_new=is_dhcp_new, is_host_new=is_host_new, position_new=position_new, rad_type_new=rad_type_new, _groupname_new=_groupname_new, description_new=description_new, is_wildcard_new=is_wildcard_new, is_nonterminal_new=is_nonterminal_new, version_name_dict_new=version_name_dict_new, permission_fq_name_new=permission_fq_name_new, _intname_old=_intname_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class RecordType(APIObject):
	gpk: str
	name: str
	rfc_info: str
	num_value: int
	is_internal: bool
	is_addr_based: bool
	is_name_based: bool
	force_auto_dml: bool
	fqdn_type_dflt: str
	_fqdn_inttype_dflt: str
	target_is_singleton_dflt: bool
	target_is_reverse_unique_dflt: bool
	dnspython_rdata_target_attribute_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if self.rfc_info is not None and not isinstance(self.rfc_info, str):
			raise ValueError(f"'rfc_info' of incorrect type. Expected str, got {type(self.rfc_info)}")
		if not isinstance(self.num_value, int):
			raise ValueError(f"'num_value' of incorrect type. Expected int, got {type(self.num_value)}")
		if not isinstance(self.is_internal, bool):
			raise ValueError(f"'is_internal' of incorrect type. Expected bool, got {type(self.is_internal)}")
		if not isinstance(self.is_addr_based, bool):
			raise ValueError(f"'is_addr_based' of incorrect type. Expected bool, got {type(self.is_addr_based)}")
		if not isinstance(self.is_name_based, bool):
			raise ValueError(f"'is_name_based' of incorrect type. Expected bool, got {type(self.is_name_based)}")
		if not isinstance(self.force_auto_dml, bool):
			raise ValueError(f"'force_auto_dml' of incorrect type. Expected bool, got {type(self.force_auto_dml)}")
		if self.fqdn_type_dflt is not None and not isinstance(self.fqdn_type_dflt, str):
			raise ValueError(f"'fqdn_type_dflt' of incorrect type. Expected str, got {type(self.fqdn_type_dflt)}")
		if self._fqdn_inttype_dflt is not None and not isinstance(self._fqdn_inttype_dflt, str):
			raise ValueError(f"'_fqdn_inttype_dflt' of incorrect type. Expected str, got {type(self._fqdn_inttype_dflt)}")
		if not isinstance(self.target_is_singleton_dflt, bool):
			raise ValueError(f"'target_is_singleton_dflt' of incorrect type. Expected bool, got {type(self.target_is_singleton_dflt)}")
		if not isinstance(self.target_is_reverse_unique_dflt, bool):
			raise ValueError(f"'target_is_reverse_unique_dflt' of incorrect type. Expected bool, got {type(self.target_is_reverse_unique_dflt)}")
		if self.dnspython_rdata_target_attribute_name is not None and not isinstance(self.dnspython_rdata_target_attribute_name, str):
			raise ValueError(f"'dnspython_rdata_target_attribute_name' of incorrect type. Expected str, got {type(self.dnspython_rdata_target_attribute_name)}")

	@staticmethod
	def create_ta(name_new: str, num_value_new: int, is_internal_new: bool, is_addr_based_new: bool, is_name_based_new: bool, force_auto_dml_new: bool, target_is_singleton_dflt_new: bool, target_is_reverse_unique_dflt_new: bool, rfc_info_new: Union[str, ExplicitNull] = None, _fqdn_inttype_dflt_new: Union[str, ExplicitNull] = None, dnspython_rdata_target_attribute_name_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if rfc_info_new is not None and not (isinstance(rfc_info_new, str) or isinstance(rfc_info_new, ExplicitNull)):
			raise ValueError(f"'rfc_info' of incorrect type. Expected str, got {type(rfc_info_new)}")
		if not (isinstance(num_value_new, int)):
			raise ValueError(f"'num_value' of incorrect type. Expected int, got {type(num_value_new)}")
		if not (isinstance(is_internal_new, bool)):
			raise ValueError(f"'is_internal' of incorrect type. Expected bool, got {type(is_internal_new)}")
		if not (isinstance(is_addr_based_new, bool)):
			raise ValueError(f"'is_addr_based' of incorrect type. Expected bool, got {type(is_addr_based_new)}")
		if not (isinstance(is_name_based_new, bool)):
			raise ValueError(f"'is_name_based' of incorrect type. Expected bool, got {type(is_name_based_new)}")
		if not (isinstance(force_auto_dml_new, bool)):
			raise ValueError(f"'force_auto_dml' of incorrect type. Expected bool, got {type(force_auto_dml_new)}")
		if _fqdn_inttype_dflt_new is not None and not (isinstance(_fqdn_inttype_dflt_new, str) or isinstance(_fqdn_inttype_dflt_new, ExplicitNull)):
			raise ValueError(f"'_fqdn_inttype_dflt' of incorrect type. Expected str, got {type(_fqdn_inttype_dflt_new)}")
		if not (isinstance(target_is_singleton_dflt_new, bool)):
			raise ValueError(f"'target_is_singleton_dflt' of incorrect type. Expected bool, got {type(target_is_singleton_dflt_new)}")
		if not (isinstance(target_is_reverse_unique_dflt_new, bool)):
			raise ValueError(f"'target_is_reverse_unique_dflt' of incorrect type. Expected bool, got {type(target_is_reverse_unique_dflt_new)}")
		if dnspython_rdata_target_attribute_name_new is not None and not (isinstance(dnspython_rdata_target_attribute_name_new, str) or isinstance(dnspython_rdata_target_attribute_name_new, ExplicitNull)):
			raise ValueError(f"'dnspython_rdata_target_attribute_name' of incorrect type. Expected str, got {type(dnspython_rdata_target_attribute_name_new)}")

		return {'name': 'dnscfg.record_type.create', 'new': _denullify_dict({'name': name_new, 'rfc_info': rfc_info_new, 'num_value': num_value_new, 'is_internal': is_internal_new, 'is_addr_based': is_addr_based_new, 'is_name_based': is_name_based_new, 'force_auto_dml': force_auto_dml_new, '_fqdn_inttype_dflt': _fqdn_inttype_dflt_new, 'target_is_singleton_dflt': target_is_singleton_dflt_new, 'target_is_reverse_unique_dflt': target_is_reverse_unique_dflt_new, 'dnspython_rdata_target_attribute_name': dnspython_rdata_target_attribute_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, num_value_new: int, is_internal_new: bool, is_addr_based_new: bool, is_name_based_new: bool, force_auto_dml_new: bool, target_is_singleton_dflt_new: bool, target_is_reverse_unique_dflt_new: bool, rfc_info_new: Union[str, ExplicitNull] = None, _fqdn_inttype_dflt_new: Union[str, ExplicitNull] = None, dnspython_rdata_target_attribute_name_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if rfc_info_new is not None and not (isinstance(rfc_info_new, str) or isinstance(rfc_info_new, ExplicitNull)):
			raise ValueError(f"'rfc_info' of incorrect type. Expected str, got {type(rfc_info_new)}")
		if not (isinstance(num_value_new, int)):
			raise ValueError(f"'num_value' of incorrect type. Expected int, got {type(num_value_new)}")
		if not (isinstance(is_internal_new, bool)):
			raise ValueError(f"'is_internal' of incorrect type. Expected bool, got {type(is_internal_new)}")
		if not (isinstance(is_addr_based_new, bool)):
			raise ValueError(f"'is_addr_based' of incorrect type. Expected bool, got {type(is_addr_based_new)}")
		if not (isinstance(is_name_based_new, bool)):
			raise ValueError(f"'is_name_based' of incorrect type. Expected bool, got {type(is_name_based_new)}")
		if not (isinstance(force_auto_dml_new, bool)):
			raise ValueError(f"'force_auto_dml' of incorrect type. Expected bool, got {type(force_auto_dml_new)}")
		if _fqdn_inttype_dflt_new is not None and not (isinstance(_fqdn_inttype_dflt_new, str) or isinstance(_fqdn_inttype_dflt_new, ExplicitNull)):
			raise ValueError(f"'_fqdn_inttype_dflt' of incorrect type. Expected str, got {type(_fqdn_inttype_dflt_new)}")
		if not (isinstance(target_is_singleton_dflt_new, bool)):
			raise ValueError(f"'target_is_singleton_dflt' of incorrect type. Expected bool, got {type(target_is_singleton_dflt_new)}")
		if not (isinstance(target_is_reverse_unique_dflt_new, bool)):
			raise ValueError(f"'target_is_reverse_unique_dflt' of incorrect type. Expected bool, got {type(target_is_reverse_unique_dflt_new)}")
		if dnspython_rdata_target_attribute_name_new is not None and not (isinstance(dnspython_rdata_target_attribute_name_new, str) or isinstance(dnspython_rdata_target_attribute_name_new, ExplicitNull)):
			raise ValueError(f"'dnspython_rdata_target_attribute_name' of incorrect type. Expected str, got {type(dnspython_rdata_target_attribute_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, rfc_info_new=rfc_info_new, num_value_new=num_value_new, is_internal_new=is_internal_new, is_addr_based_new=is_addr_based_new, is_name_based_new=is_name_based_new, force_auto_dml_new=force_auto_dml_new, _fqdn_inttype_dflt_new=_fqdn_inttype_dflt_new, target_is_singleton_dflt_new=target_is_singleton_dflt_new, target_is_reverse_unique_dflt_new=target_is_reverse_unique_dflt_new, dnspython_rdata_target_attribute_name_new=dnspython_rdata_target_attribute_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'dnscfg.record_type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, is_internal_old: bool = None, fetch_offset_old: int = None, is_addr_based_old: bool = None, is_name_based_old: bool = None, force_auto_dml_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_internal_old is not None and not (isinstance(is_internal_old, bool)):
			raise ValueError(f"'is_internal' of incorrect type. Expected bool, got {type(is_internal_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_addr_based_old is not None and not (isinstance(is_addr_based_old, bool)):
			raise ValueError(f"'is_addr_based' of incorrect type. Expected bool, got {type(is_addr_based_old)}")
		if is_name_based_old is not None and not (isinstance(is_name_based_old, bool)):
			raise ValueError(f"'is_name_based' of incorrect type. Expected bool, got {type(is_name_based_old)}")
		if force_auto_dml_old is not None and not (isinstance(force_auto_dml_old, bool)):
			raise ValueError(f"'force_auto_dml' of incorrect type. Expected bool, got {type(force_auto_dml_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dnscfg.record_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'is_internal': is_internal_old, 'fetch_offset': fetch_offset_old, 'is_addr_based': is_addr_based_old, 'is_name_based': is_name_based_old, 'force_auto_dml': force_auto_dml_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, is_internal_old: bool = None, fetch_offset_old: int = None, is_addr_based_old: bool = None, is_name_based_old: bool = None, force_auto_dml_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_internal_old is not None and not (isinstance(is_internal_old, bool)):
			raise ValueError(f"'is_internal' of incorrect type. Expected bool, got {type(is_internal_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_addr_based_old is not None and not (isinstance(is_addr_based_old, bool)):
			raise ValueError(f"'is_addr_based' of incorrect type. Expected bool, got {type(is_addr_based_old)}")
		if is_name_based_old is not None and not (isinstance(is_name_based_old, bool)):
			raise ValueError(f"'is_name_based' of incorrect type. Expected bool, got {type(is_name_based_old)}")
		if force_auto_dml_old is not None and not (isinstance(force_auto_dml_old, bool)):
			raise ValueError(f"'force_auto_dml' of incorrect type. Expected bool, got {type(force_auto_dml_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, is_internal_old=is_internal_old, fetch_offset_old=fetch_offset_old, is_addr_based_old=is_addr_based_old, is_name_based_old=is_name_based_old, force_auto_dml_old=force_auto_dml_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, rfc_info_new: Union[str, ExplicitNull] = None, num_value_new: int = None, is_internal_new: bool = None, is_addr_based_new: bool = None, is_name_based_new: bool = None, force_auto_dml_new: bool = None, _fqdn_inttype_dflt_new: Union[str, ExplicitNull] = None, target_is_singleton_dflt_new: bool = None, target_is_reverse_unique_dflt_new: bool = None, dnspython_rdata_target_attribute_name_new: Union[str, ExplicitNull] = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if rfc_info_new is not None and not (isinstance(rfc_info_new, str) or isinstance(rfc_info_new, ExplicitNull)):
			raise ValueError(f"'rfc_info' of incorrect type. Expected str, got {type(rfc_info_new)}")
		if num_value_new is not None and not (isinstance(num_value_new, int)):
			raise ValueError(f"'num_value' of incorrect type. Expected int, got {type(num_value_new)}")
		if is_internal_new is not None and not (isinstance(is_internal_new, bool)):
			raise ValueError(f"'is_internal' of incorrect type. Expected bool, got {type(is_internal_new)}")
		if is_addr_based_new is not None and not (isinstance(is_addr_based_new, bool)):
			raise ValueError(f"'is_addr_based' of incorrect type. Expected bool, got {type(is_addr_based_new)}")
		if is_name_based_new is not None and not (isinstance(is_name_based_new, bool)):
			raise ValueError(f"'is_name_based' of incorrect type. Expected bool, got {type(is_name_based_new)}")
		if force_auto_dml_new is not None and not (isinstance(force_auto_dml_new, bool)):
			raise ValueError(f"'force_auto_dml' of incorrect type. Expected bool, got {type(force_auto_dml_new)}")
		if _fqdn_inttype_dflt_new is not None and not (isinstance(_fqdn_inttype_dflt_new, str) or isinstance(_fqdn_inttype_dflt_new, ExplicitNull)):
			raise ValueError(f"'_fqdn_inttype_dflt' of incorrect type. Expected str, got {type(_fqdn_inttype_dflt_new)}")
		if target_is_singleton_dflt_new is not None and not (isinstance(target_is_singleton_dflt_new, bool)):
			raise ValueError(f"'target_is_singleton_dflt' of incorrect type. Expected bool, got {type(target_is_singleton_dflt_new)}")
		if target_is_reverse_unique_dflt_new is not None and not (isinstance(target_is_reverse_unique_dflt_new, bool)):
			raise ValueError(f"'target_is_reverse_unique_dflt' of incorrect type. Expected bool, got {type(target_is_reverse_unique_dflt_new)}")
		if dnspython_rdata_target_attribute_name_new is not None and not (isinstance(dnspython_rdata_target_attribute_name_new, str) or isinstance(dnspython_rdata_target_attribute_name_new, ExplicitNull)):
			raise ValueError(f"'dnspython_rdata_target_attribute_name' of incorrect type. Expected str, got {type(dnspython_rdata_target_attribute_name_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'dnscfg.record_type.update', 'new': _denullify_dict({'name': name_new, 'rfc_info': rfc_info_new, 'num_value': num_value_new, 'is_internal': is_internal_new, 'is_addr_based': is_addr_based_new, 'is_name_based': is_name_based_new, 'force_auto_dml': force_auto_dml_new, '_fqdn_inttype_dflt': _fqdn_inttype_dflt_new, 'target_is_singleton_dflt': target_is_singleton_dflt_new, 'target_is_reverse_unique_dflt': target_is_reverse_unique_dflt_new, 'dnspython_rdata_target_attribute_name': dnspython_rdata_target_attribute_name_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, rfc_info_new: Union[str, ExplicitNull] = None, num_value_new: int = None, is_internal_new: bool = None, is_addr_based_new: bool = None, is_name_based_new: bool = None, force_auto_dml_new: bool = None, _fqdn_inttype_dflt_new: Union[str, ExplicitNull] = None, target_is_singleton_dflt_new: bool = None, target_is_reverse_unique_dflt_new: bool = None, dnspython_rdata_target_attribute_name_new: Union[str, ExplicitNull] = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if rfc_info_new is not None and not (isinstance(rfc_info_new, str) or isinstance(rfc_info_new, ExplicitNull)):
			raise ValueError(f"'rfc_info' of incorrect type. Expected str, got {type(rfc_info_new)}")
		if num_value_new is not None and not (isinstance(num_value_new, int)):
			raise ValueError(f"'num_value' of incorrect type. Expected int, got {type(num_value_new)}")
		if is_internal_new is not None and not (isinstance(is_internal_new, bool)):
			raise ValueError(f"'is_internal' of incorrect type. Expected bool, got {type(is_internal_new)}")
		if is_addr_based_new is not None and not (isinstance(is_addr_based_new, bool)):
			raise ValueError(f"'is_addr_based' of incorrect type. Expected bool, got {type(is_addr_based_new)}")
		if is_name_based_new is not None and not (isinstance(is_name_based_new, bool)):
			raise ValueError(f"'is_name_based' of incorrect type. Expected bool, got {type(is_name_based_new)}")
		if force_auto_dml_new is not None and not (isinstance(force_auto_dml_new, bool)):
			raise ValueError(f"'force_auto_dml' of incorrect type. Expected bool, got {type(force_auto_dml_new)}")
		if _fqdn_inttype_dflt_new is not None and not (isinstance(_fqdn_inttype_dflt_new, str) or isinstance(_fqdn_inttype_dflt_new, ExplicitNull)):
			raise ValueError(f"'_fqdn_inttype_dflt' of incorrect type. Expected str, got {type(_fqdn_inttype_dflt_new)}")
		if target_is_singleton_dflt_new is not None and not (isinstance(target_is_singleton_dflt_new, bool)):
			raise ValueError(f"'target_is_singleton_dflt' of incorrect type. Expected bool, got {type(target_is_singleton_dflt_new)}")
		if target_is_reverse_unique_dflt_new is not None and not (isinstance(target_is_reverse_unique_dflt_new, bool)):
			raise ValueError(f"'target_is_reverse_unique_dflt' of incorrect type. Expected bool, got {type(target_is_reverse_unique_dflt_new)}")
		if dnspython_rdata_target_attribute_name_new is not None and not (isinstance(dnspython_rdata_target_attribute_name_new, str) or isinstance(dnspython_rdata_target_attribute_name_new, ExplicitNull)):
			raise ValueError(f"'dnspython_rdata_target_attribute_name' of incorrect type. Expected str, got {type(dnspython_rdata_target_attribute_name_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, rfc_info_new=rfc_info_new, num_value_new=num_value_new, is_internal_new=is_internal_new, is_addr_based_new=is_addr_based_new, is_name_based_new=is_name_based_new, force_auto_dml_new=force_auto_dml_new, _fqdn_inttype_dflt_new=_fqdn_inttype_dflt_new, target_is_singleton_dflt_new=target_is_singleton_dflt_new, target_is_reverse_unique_dflt_new=target_is_reverse_unique_dflt_new, dnspython_rdata_target_attribute_name_new=dnspython_rdata_target_attribute_name_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class RecordInttype(APIObject):
	gpk: str
	is_own: bool
	_intname: str
	fqdn_type: str
	description: str
	record_type: str
	_fqdn_inttype: str
	target_fqdn_type: str
	version_def_dict: dict
	fqdn_is_singleton: bool
	permission_fq_name: str
	target_ipaddr_type: str
	target_is_singleton: bool
	_target_fqdn_inttype: str
	target_is_reverse_unique: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self._intname, str):
			raise ValueError(f"'_intname' of incorrect type. Expected str, got {type(self._intname)}")
		if not isinstance(self.fqdn_type, str):
			raise ValueError(f"'fqdn_type' of incorrect type. Expected str, got {type(self.fqdn_type)}")
		if not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.record_type, str):
			raise ValueError(f"'record_type' of incorrect type. Expected str, got {type(self.record_type)}")
		if not isinstance(self._fqdn_inttype, str):
			raise ValueError(f"'_fqdn_inttype' of incorrect type. Expected str, got {type(self._fqdn_inttype)}")
		if self.target_fqdn_type is not None and not isinstance(self.target_fqdn_type, str):
			raise ValueError(f"'target_fqdn_type' of incorrect type. Expected str, got {type(self.target_fqdn_type)}")
		if not isinstance(self.version_def_dict, dict):
			raise ValueError(f"'version_def_dict' of incorrect type. Expected dict, got {type(self.version_def_dict)}")
		if not isinstance(self.fqdn_is_singleton, bool):
			raise ValueError(f"'fqdn_is_singleton' of incorrect type. Expected bool, got {type(self.fqdn_is_singleton)}")
		if self.permission_fq_name is not None and not isinstance(self.permission_fq_name, str):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(self.permission_fq_name)}")
		if self.target_ipaddr_type is not None and not isinstance(self.target_ipaddr_type, str):
			raise ValueError(f"'target_ipaddr_type' of incorrect type. Expected str, got {type(self.target_ipaddr_type)}")
		if not isinstance(self.target_is_singleton, bool):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(self.target_is_singleton)}")
		if self._target_fqdn_inttype is not None and not isinstance(self._target_fqdn_inttype, str):
			raise ValueError(f"'_target_fqdn_inttype' of incorrect type. Expected str, got {type(self._target_fqdn_inttype)}")
		if not isinstance(self.target_is_reverse_unique, bool):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(self.target_is_reverse_unique)}")

	@staticmethod
	def create_ta(description_new: str, record_type_new: str, _fqdn_inttype_new: str, fqdn_is_singleton_new: bool, target_is_singleton_new: bool, target_is_reverse_unique_new: bool, do_include_release_new: bool = True, permission_fq_name_new: Union[str, ExplicitNull] = None, _target_fqdn_inttype_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(record_type_new, str)):
			raise ValueError(f"'record_type' of incorrect type. Expected str, got {type(record_type_new)}")
		if not (isinstance(_fqdn_inttype_new, str)):
			raise ValueError(f"'_fqdn_inttype' of incorrect type. Expected str, got {type(_fqdn_inttype_new)}")
		if not (isinstance(fqdn_is_singleton_new, bool)):
			raise ValueError(f"'fqdn_is_singleton' of incorrect type. Expected bool, got {type(fqdn_is_singleton_new)}")
		if do_include_release_new is not None and not (isinstance(do_include_release_new, bool)):
			raise ValueError(f"'do_include_release' of incorrect type. Expected bool, got {type(do_include_release_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if not (isinstance(target_is_singleton_new, bool)):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(target_is_singleton_new)}")
		if _target_fqdn_inttype_new is not None and not (isinstance(_target_fqdn_inttype_new, str) or isinstance(_target_fqdn_inttype_new, ExplicitNull)):
			raise ValueError(f"'_target_fqdn_inttype' of incorrect type. Expected str, got {type(_target_fqdn_inttype_new)}")
		if not (isinstance(target_is_reverse_unique_new, bool)):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(target_is_reverse_unique_new)}")

		return {'name': 'dnscfg.record_inttype.create', 'new': _denullify_dict({'description': description_new, 'record_type': record_type_new, '_fqdn_inttype': _fqdn_inttype_new, 'fqdn_is_singleton': fqdn_is_singleton_new, 'do_include_release': do_include_release_new, 'permission_fq_name': permission_fq_name_new, 'target_is_singleton': target_is_singleton_new, '_target_fqdn_inttype': _target_fqdn_inttype_new, 'target_is_reverse_unique': target_is_reverse_unique_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, description_new: str, record_type_new: str, _fqdn_inttype_new: str, fqdn_is_singleton_new: bool, target_is_singleton_new: bool, target_is_reverse_unique_new: bool, do_include_release_new: bool = True, permission_fq_name_new: Union[str, ExplicitNull] = None, _target_fqdn_inttype_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(record_type_new, str)):
			raise ValueError(f"'record_type' of incorrect type. Expected str, got {type(record_type_new)}")
		if not (isinstance(_fqdn_inttype_new, str)):
			raise ValueError(f"'_fqdn_inttype' of incorrect type. Expected str, got {type(_fqdn_inttype_new)}")
		if not (isinstance(fqdn_is_singleton_new, bool)):
			raise ValueError(f"'fqdn_is_singleton' of incorrect type. Expected bool, got {type(fqdn_is_singleton_new)}")
		if do_include_release_new is not None and not (isinstance(do_include_release_new, bool)):
			raise ValueError(f"'do_include_release' of incorrect type. Expected bool, got {type(do_include_release_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if not (isinstance(target_is_singleton_new, bool)):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(target_is_singleton_new)}")
		if _target_fqdn_inttype_new is not None and not (isinstance(_target_fqdn_inttype_new, str) or isinstance(_target_fqdn_inttype_new, ExplicitNull)):
			raise ValueError(f"'_target_fqdn_inttype' of incorrect type. Expected str, got {type(_target_fqdn_inttype_new)}")
		if not (isinstance(target_is_reverse_unique_new, bool)):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(target_is_reverse_unique_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(description_new=description_new, record_type_new=record_type_new, _fqdn_inttype_new=_fqdn_inttype_new, fqdn_is_singleton_new=fqdn_is_singleton_new, do_include_release_new=do_include_release_new, permission_fq_name_new=permission_fq_name_new, target_is_singleton_new=target_is_singleton_new, _target_fqdn_inttype_new=_target_fqdn_inttype_new, target_is_reverse_unique_new=target_is_reverse_unique_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(_intname_old: str) -> dict:
		if not (isinstance(_intname_old, str)):
			raise ValueError(f"'_intname' of incorrect type. Expected str, got {type(_intname_old)}")

		return {'name': 'dnscfg.record_inttype.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'_intname': _intname_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, _intname_old: str) -> list:
		if not (isinstance(_intname_old, str)):
			raise ValueError(f"'_intname' of incorrect type. Expected str, got {type(_intname_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(_intname_old=_intname_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, fqdn_type_list_old: list = None, record_type_list_old: list = None, fqdn_is_singleton_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, target_is_singleton_old: bool = None, target_fqdn_type_list_old: list = None, target_is_reverse_unique_old: bool = None, record_type_is_addr_based_old: bool = None, record_type_is_name_based_old: bool = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if fqdn_type_list_old is not None and not (isinstance(fqdn_type_list_old, list)):
			raise ValueError(f"'fqdn_type_list' of incorrect type. Expected list, got {type(fqdn_type_list_old)}")
		if record_type_list_old is not None and not (isinstance(record_type_list_old, list)):
			raise ValueError(f"'record_type_list' of incorrect type. Expected list, got {type(record_type_list_old)}")
		if fqdn_is_singleton_old is not None and not (isinstance(fqdn_is_singleton_old, bool)):
			raise ValueError(f"'fqdn_is_singleton' of incorrect type. Expected bool, got {type(fqdn_is_singleton_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if target_is_singleton_old is not None and not (isinstance(target_is_singleton_old, bool)):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(target_is_singleton_old)}")
		if target_fqdn_type_list_old is not None and not (isinstance(target_fqdn_type_list_old, list)):
			raise ValueError(f"'target_fqdn_type_list' of incorrect type. Expected list, got {type(target_fqdn_type_list_old)}")
		if target_is_reverse_unique_old is not None and not (isinstance(target_is_reverse_unique_old, bool)):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(target_is_reverse_unique_old)}")
		if record_type_is_addr_based_old is not None and not (isinstance(record_type_is_addr_based_old, bool)):
			raise ValueError(f"'record_type_is_addr_based' of incorrect type. Expected bool, got {type(record_type_is_addr_based_old)}")
		if record_type_is_name_based_old is not None and not (isinstance(record_type_is_name_based_old, bool)):
			raise ValueError(f"'record_type_is_name_based' of incorrect type. Expected bool, got {type(record_type_is_name_based_old)}")

		return {'name': 'dnscfg.record_inttype.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'fqdn_type_list': fqdn_type_list_old, 'record_type_list': record_type_list_old, 'fqdn_is_singleton': fqdn_is_singleton_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'target_is_singleton': target_is_singleton_old, 'target_fqdn_type_list': target_fqdn_type_list_old, 'target_is_reverse_unique': target_is_reverse_unique_old, 'record_type_is_addr_based': record_type_is_addr_based_old, 'record_type_is_name_based': record_type_is_name_based_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, fqdn_type_list_old: list = None, record_type_list_old: list = None, fqdn_is_singleton_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, target_is_singleton_old: bool = None, target_fqdn_type_list_old: list = None, target_is_reverse_unique_old: bool = None, record_type_is_addr_based_old: bool = None, record_type_is_name_based_old: bool = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if fqdn_type_list_old is not None and not (isinstance(fqdn_type_list_old, list)):
			raise ValueError(f"'fqdn_type_list' of incorrect type. Expected list, got {type(fqdn_type_list_old)}")
		if record_type_list_old is not None and not (isinstance(record_type_list_old, list)):
			raise ValueError(f"'record_type_list' of incorrect type. Expected list, got {type(record_type_list_old)}")
		if fqdn_is_singleton_old is not None and not (isinstance(fqdn_is_singleton_old, bool)):
			raise ValueError(f"'fqdn_is_singleton' of incorrect type. Expected bool, got {type(fqdn_is_singleton_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if target_is_singleton_old is not None and not (isinstance(target_is_singleton_old, bool)):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(target_is_singleton_old)}")
		if target_fqdn_type_list_old is not None and not (isinstance(target_fqdn_type_list_old, list)):
			raise ValueError(f"'target_fqdn_type_list' of incorrect type. Expected list, got {type(target_fqdn_type_list_old)}")
		if target_is_reverse_unique_old is not None and not (isinstance(target_is_reverse_unique_old, bool)):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(target_is_reverse_unique_old)}")
		if record_type_is_addr_based_old is not None and not (isinstance(record_type_is_addr_based_old, bool)):
			raise ValueError(f"'record_type_is_addr_based' of incorrect type. Expected bool, got {type(record_type_is_addr_based_old)}")
		if record_type_is_name_based_old is not None and not (isinstance(record_type_is_name_based_old, bool)):
			raise ValueError(f"'record_type_is_name_based' of incorrect type. Expected bool, got {type(record_type_is_name_based_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, fqdn_type_list_old=fqdn_type_list_old, record_type_list_old=record_type_list_old, fqdn_is_singleton_old=fqdn_is_singleton_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, target_is_singleton_old=target_is_singleton_old, target_fqdn_type_list_old=target_fqdn_type_list_old, target_is_reverse_unique_old=target_is_reverse_unique_old, record_type_is_addr_based_old=record_type_is_addr_based_old, record_type_is_name_based_old=record_type_is_name_based_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(_intname_old: str, description_new: str = None, record_type_new: str = None, _fqdn_inttype_new: str = None, version_def_dict_new: dict = None, fqdn_is_singleton_new: bool = None, permission_fq_name_new: Union[str, ExplicitNull] = None, target_is_singleton_new: bool = None, _target_fqdn_inttype_new: Union[str, ExplicitNull] = None, target_is_reverse_unique_new: bool = None) -> dict:
		if description_new is not None and not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if record_type_new is not None and not (isinstance(record_type_new, str)):
			raise ValueError(f"'record_type' of incorrect type. Expected str, got {type(record_type_new)}")
		if _fqdn_inttype_new is not None and not (isinstance(_fqdn_inttype_new, str)):
			raise ValueError(f"'_fqdn_inttype' of incorrect type. Expected str, got {type(_fqdn_inttype_new)}")
		if version_def_dict_new is not None and not (isinstance(version_def_dict_new, dict)):
			raise ValueError(f"'version_def_dict' of incorrect type. Expected dict, got {type(version_def_dict_new)}")
		if fqdn_is_singleton_new is not None and not (isinstance(fqdn_is_singleton_new, bool)):
			raise ValueError(f"'fqdn_is_singleton' of incorrect type. Expected bool, got {type(fqdn_is_singleton_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if target_is_singleton_new is not None and not (isinstance(target_is_singleton_new, bool)):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(target_is_singleton_new)}")
		if _target_fqdn_inttype_new is not None and not (isinstance(_target_fqdn_inttype_new, str) or isinstance(_target_fqdn_inttype_new, ExplicitNull)):
			raise ValueError(f"'_target_fqdn_inttype' of incorrect type. Expected str, got {type(_target_fqdn_inttype_new)}")
		if target_is_reverse_unique_new is not None and not (isinstance(target_is_reverse_unique_new, bool)):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(target_is_reverse_unique_new)}")
		if not (isinstance(_intname_old, str)):
			raise ValueError(f"'_intname' of incorrect type. Expected str, got {type(_intname_old)}")

		return {'name': 'dnscfg.record_inttype.update', 'new': _denullify_dict({'description': description_new, 'record_type': record_type_new, '_fqdn_inttype': _fqdn_inttype_new, 'version_def_dict': version_def_dict_new, 'fqdn_is_singleton': fqdn_is_singleton_new, 'permission_fq_name': permission_fq_name_new, 'target_is_singleton': target_is_singleton_new, '_target_fqdn_inttype': _target_fqdn_inttype_new, 'target_is_reverse_unique': target_is_reverse_unique_new}), 'old': _denullify_dict({'_intname': _intname_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, _intname_old: str, description_new: str = None, record_type_new: str = None, _fqdn_inttype_new: str = None, version_def_dict_new: dict = None, fqdn_is_singleton_new: bool = None, permission_fq_name_new: Union[str, ExplicitNull] = None, target_is_singleton_new: bool = None, _target_fqdn_inttype_new: Union[str, ExplicitNull] = None, target_is_reverse_unique_new: bool = None) -> list:
		if description_new is not None and not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if record_type_new is not None and not (isinstance(record_type_new, str)):
			raise ValueError(f"'record_type' of incorrect type. Expected str, got {type(record_type_new)}")
		if _fqdn_inttype_new is not None and not (isinstance(_fqdn_inttype_new, str)):
			raise ValueError(f"'_fqdn_inttype' of incorrect type. Expected str, got {type(_fqdn_inttype_new)}")
		if version_def_dict_new is not None and not (isinstance(version_def_dict_new, dict)):
			raise ValueError(f"'version_def_dict' of incorrect type. Expected dict, got {type(version_def_dict_new)}")
		if fqdn_is_singleton_new is not None and not (isinstance(fqdn_is_singleton_new, bool)):
			raise ValueError(f"'fqdn_is_singleton' of incorrect type. Expected bool, got {type(fqdn_is_singleton_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if target_is_singleton_new is not None and not (isinstance(target_is_singleton_new, bool)):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(target_is_singleton_new)}")
		if _target_fqdn_inttype_new is not None and not (isinstance(_target_fqdn_inttype_new, str) or isinstance(_target_fqdn_inttype_new, ExplicitNull)):
			raise ValueError(f"'_target_fqdn_inttype' of incorrect type. Expected str, got {type(_target_fqdn_inttype_new)}")
		if target_is_reverse_unique_new is not None and not (isinstance(target_is_reverse_unique_new, bool)):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(target_is_reverse_unique_new)}")
		if not (isinstance(_intname_old, str)):
			raise ValueError(f"'_intname' of incorrect type. Expected str, got {type(_intname_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(description_new=description_new, record_type_new=record_type_new, _fqdn_inttype_new=_fqdn_inttype_new, version_def_dict_new=version_def_dict_new, fqdn_is_singleton_new=fqdn_is_singleton_new, permission_fq_name_new=permission_fq_name_new, target_is_singleton_new=target_is_singleton_new, _target_fqdn_inttype_new=_target_fqdn_inttype_new, target_is_reverse_unique_new=target_is_reverse_unique_new, _intname_old=_intname_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class NsSet(APIObject):
	gpk: str
	name: str
	description: str
	soa_data_retry: int
	soa_data_expire: int
	soa_data_minimum: int
	soa_data_refresh: int
	soa_data_hostmaster: str
	members_are_exclusive: bool
	zone_data_is_external: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.soa_data_retry, int):
			raise ValueError(f"'soa_data_retry' of incorrect type. Expected int, got {type(self.soa_data_retry)}")
		if not isinstance(self.soa_data_expire, int):
			raise ValueError(f"'soa_data_expire' of incorrect type. Expected int, got {type(self.soa_data_expire)}")
		if not isinstance(self.soa_data_minimum, int):
			raise ValueError(f"'soa_data_minimum' of incorrect type. Expected int, got {type(self.soa_data_minimum)}")
		if not isinstance(self.soa_data_refresh, int):
			raise ValueError(f"'soa_data_refresh' of incorrect type. Expected int, got {type(self.soa_data_refresh)}")
		if not isinstance(self.soa_data_hostmaster, str):
			raise ValueError(f"'soa_data_hostmaster' of incorrect type. Expected str, got {type(self.soa_data_hostmaster)}")
		if not isinstance(self.members_are_exclusive, bool):
			raise ValueError(f"'members_are_exclusive' of incorrect type. Expected bool, got {type(self.members_are_exclusive)}")
		if not isinstance(self.zone_data_is_external, bool):
			raise ValueError(f"'zone_data_is_external' of incorrect type. Expected bool, got {type(self.zone_data_is_external)}")

	@staticmethod
	def create_ta(name_new: str, description_new: Union[str, ExplicitNull] = None, soa_data_retry_new: int = 1800, soa_data_expire_new: int = 2592000, soa_data_minimum_new: int = 600, soa_data_refresh_new: int = 10800, soa_data_hostmaster_new: str = 'hostmaster.kit.edu.', members_are_exclusive_new: bool = False, zone_data_is_external_new: bool = False) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if soa_data_retry_new is not None and not (isinstance(soa_data_retry_new, int)):
			raise ValueError(f"'soa_data_retry' of incorrect type. Expected int, got {type(soa_data_retry_new)}")
		if soa_data_expire_new is not None and not (isinstance(soa_data_expire_new, int)):
			raise ValueError(f"'soa_data_expire' of incorrect type. Expected int, got {type(soa_data_expire_new)}")
		if soa_data_minimum_new is not None and not (isinstance(soa_data_minimum_new, int)):
			raise ValueError(f"'soa_data_minimum' of incorrect type. Expected int, got {type(soa_data_minimum_new)}")
		if soa_data_refresh_new is not None and not (isinstance(soa_data_refresh_new, int)):
			raise ValueError(f"'soa_data_refresh' of incorrect type. Expected int, got {type(soa_data_refresh_new)}")
		if soa_data_hostmaster_new is not None and not (isinstance(soa_data_hostmaster_new, str)):
			raise ValueError(f"'soa_data_hostmaster' of incorrect type. Expected str, got {type(soa_data_hostmaster_new)}")
		if not (isinstance(members_are_exclusive_new, bool)):
			raise ValueError(f"'members_are_exclusive' of incorrect type. Expected bool, got {type(members_are_exclusive_new)}")
		if zone_data_is_external_new is not None and not (isinstance(zone_data_is_external_new, bool)):
			raise ValueError(f"'zone_data_is_external' of incorrect type. Expected bool, got {type(zone_data_is_external_new)}")

		return {'name': 'dnscfg.ns_set.create', 'new': _denullify_dict({'name': name_new, 'description': description_new, 'soa_data_retry': soa_data_retry_new, 'soa_data_expire': soa_data_expire_new, 'soa_data_minimum': soa_data_minimum_new, 'soa_data_refresh': soa_data_refresh_new, 'soa_data_hostmaster': soa_data_hostmaster_new, 'members_are_exclusive': members_are_exclusive_new, 'zone_data_is_external': zone_data_is_external_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, description_new: Union[str, ExplicitNull] = None, soa_data_retry_new: int = 1800, soa_data_expire_new: int = 2592000, soa_data_minimum_new: int = 600, soa_data_refresh_new: int = 10800, soa_data_hostmaster_new: str = 'hostmaster.kit.edu.', members_are_exclusive_new: bool = False, zone_data_is_external_new: bool = False) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if soa_data_retry_new is not None and not (isinstance(soa_data_retry_new, int)):
			raise ValueError(f"'soa_data_retry' of incorrect type. Expected int, got {type(soa_data_retry_new)}")
		if soa_data_expire_new is not None and not (isinstance(soa_data_expire_new, int)):
			raise ValueError(f"'soa_data_expire' of incorrect type. Expected int, got {type(soa_data_expire_new)}")
		if soa_data_minimum_new is not None and not (isinstance(soa_data_minimum_new, int)):
			raise ValueError(f"'soa_data_minimum' of incorrect type. Expected int, got {type(soa_data_minimum_new)}")
		if soa_data_refresh_new is not None and not (isinstance(soa_data_refresh_new, int)):
			raise ValueError(f"'soa_data_refresh' of incorrect type. Expected int, got {type(soa_data_refresh_new)}")
		if soa_data_hostmaster_new is not None and not (isinstance(soa_data_hostmaster_new, str)):
			raise ValueError(f"'soa_data_hostmaster' of incorrect type. Expected str, got {type(soa_data_hostmaster_new)}")
		if not (isinstance(members_are_exclusive_new, bool)):
			raise ValueError(f"'members_are_exclusive' of incorrect type. Expected bool, got {type(members_are_exclusive_new)}")
		if zone_data_is_external_new is not None and not (isinstance(zone_data_is_external_new, bool)):
			raise ValueError(f"'zone_data_is_external' of incorrect type. Expected bool, got {type(zone_data_is_external_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, description_new=description_new, soa_data_retry_new=soa_data_retry_new, soa_data_expire_new=soa_data_expire_new, soa_data_minimum_new=soa_data_minimum_new, soa_data_refresh_new=soa_data_refresh_new, soa_data_hostmaster_new=soa_data_hostmaster_new, members_are_exclusive_new=members_are_exclusive_new, zone_data_is_external_new=zone_data_is_external_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'dnscfg.ns_set.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, name_regexp_old: str = None, fetch_offset_old: int = None, soa_data_retry_old: int = None, soa_data_expire_old: int = None, soa_data_minimum_old: int = None, soa_data_refresh_old: int = None, filter_params_dict_old: dict = None, soa_data_hostmaster_old: str = None, sorting_params_list_old: list = None, members_are_exclusive_old: bool = None, zone_data_is_external_old: bool = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if name_regexp_old is not None and not (isinstance(name_regexp_old, str)):
			raise ValueError(f"'name_regexp' of incorrect type. Expected str, got {type(name_regexp_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if soa_data_retry_old is not None and not (isinstance(soa_data_retry_old, int)):
			raise ValueError(f"'soa_data_retry' of incorrect type. Expected int, got {type(soa_data_retry_old)}")
		if soa_data_expire_old is not None and not (isinstance(soa_data_expire_old, int)):
			raise ValueError(f"'soa_data_expire' of incorrect type. Expected int, got {type(soa_data_expire_old)}")
		if soa_data_minimum_old is not None and not (isinstance(soa_data_minimum_old, int)):
			raise ValueError(f"'soa_data_minimum' of incorrect type. Expected int, got {type(soa_data_minimum_old)}")
		if soa_data_refresh_old is not None and not (isinstance(soa_data_refresh_old, int)):
			raise ValueError(f"'soa_data_refresh' of incorrect type. Expected int, got {type(soa_data_refresh_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if soa_data_hostmaster_old is not None and not (isinstance(soa_data_hostmaster_old, str)):
			raise ValueError(f"'soa_data_hostmaster' of incorrect type. Expected str, got {type(soa_data_hostmaster_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if members_are_exclusive_old is not None and not (isinstance(members_are_exclusive_old, bool)):
			raise ValueError(f"'members_are_exclusive' of incorrect type. Expected bool, got {type(members_are_exclusive_old)}")
		if zone_data_is_external_old is not None and not (isinstance(zone_data_is_external_old, bool)):
			raise ValueError(f"'zone_data_is_external' of incorrect type. Expected bool, got {type(zone_data_is_external_old)}")

		return {'name': 'dnscfg.ns_set.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'name_regexp': name_regexp_old, 'fetch_offset': fetch_offset_old, 'soa_data_retry': soa_data_retry_old, 'soa_data_expire': soa_data_expire_old, 'soa_data_minimum': soa_data_minimum_old, 'soa_data_refresh': soa_data_refresh_old, 'filter_params_dict': filter_params_dict_old, 'soa_data_hostmaster': soa_data_hostmaster_old, 'sorting_params_list': sorting_params_list_old, 'members_are_exclusive': members_are_exclusive_old, 'zone_data_is_external': zone_data_is_external_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, name_regexp_old: str = None, fetch_offset_old: int = None, soa_data_retry_old: int = None, soa_data_expire_old: int = None, soa_data_minimum_old: int = None, soa_data_refresh_old: int = None, filter_params_dict_old: dict = None, soa_data_hostmaster_old: str = None, sorting_params_list_old: list = None, members_are_exclusive_old: bool = None, zone_data_is_external_old: bool = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if name_regexp_old is not None and not (isinstance(name_regexp_old, str)):
			raise ValueError(f"'name_regexp' of incorrect type. Expected str, got {type(name_regexp_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if soa_data_retry_old is not None and not (isinstance(soa_data_retry_old, int)):
			raise ValueError(f"'soa_data_retry' of incorrect type. Expected int, got {type(soa_data_retry_old)}")
		if soa_data_expire_old is not None and not (isinstance(soa_data_expire_old, int)):
			raise ValueError(f"'soa_data_expire' of incorrect type. Expected int, got {type(soa_data_expire_old)}")
		if soa_data_minimum_old is not None and not (isinstance(soa_data_minimum_old, int)):
			raise ValueError(f"'soa_data_minimum' of incorrect type. Expected int, got {type(soa_data_minimum_old)}")
		if soa_data_refresh_old is not None and not (isinstance(soa_data_refresh_old, int)):
			raise ValueError(f"'soa_data_refresh' of incorrect type. Expected int, got {type(soa_data_refresh_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if soa_data_hostmaster_old is not None and not (isinstance(soa_data_hostmaster_old, str)):
			raise ValueError(f"'soa_data_hostmaster' of incorrect type. Expected str, got {type(soa_data_hostmaster_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if members_are_exclusive_old is not None and not (isinstance(members_are_exclusive_old, bool)):
			raise ValueError(f"'members_are_exclusive' of incorrect type. Expected bool, got {type(members_are_exclusive_old)}")
		if zone_data_is_external_old is not None and not (isinstance(zone_data_is_external_old, bool)):
			raise ValueError(f"'zone_data_is_external' of incorrect type. Expected bool, got {type(zone_data_is_external_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, name_regexp_old=name_regexp_old, fetch_offset_old=fetch_offset_old, soa_data_retry_old=soa_data_retry_old, soa_data_expire_old=soa_data_expire_old, soa_data_minimum_old=soa_data_minimum_old, soa_data_refresh_old=soa_data_refresh_old, filter_params_dict_old=filter_params_dict_old, soa_data_hostmaster_old=soa_data_hostmaster_old, sorting_params_list_old=sorting_params_list_old, members_are_exclusive_old=members_are_exclusive_old, zone_data_is_external_old=zone_data_is_external_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, description_new: Union[str, ExplicitNull] = None, soa_data_retry_new: int = None, soa_data_expire_new: int = None, soa_data_minimum_new: int = None, soa_data_refresh_new: int = None, soa_data_hostmaster_new: str = None, members_are_exclusive_new: bool = None, zone_data_is_external_new: bool = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if soa_data_retry_new is not None and not (isinstance(soa_data_retry_new, int)):
			raise ValueError(f"'soa_data_retry' of incorrect type. Expected int, got {type(soa_data_retry_new)}")
		if soa_data_expire_new is not None and not (isinstance(soa_data_expire_new, int)):
			raise ValueError(f"'soa_data_expire' of incorrect type. Expected int, got {type(soa_data_expire_new)}")
		if soa_data_minimum_new is not None and not (isinstance(soa_data_minimum_new, int)):
			raise ValueError(f"'soa_data_minimum' of incorrect type. Expected int, got {type(soa_data_minimum_new)}")
		if soa_data_refresh_new is not None and not (isinstance(soa_data_refresh_new, int)):
			raise ValueError(f"'soa_data_refresh' of incorrect type. Expected int, got {type(soa_data_refresh_new)}")
		if soa_data_hostmaster_new is not None and not (isinstance(soa_data_hostmaster_new, str)):
			raise ValueError(f"'soa_data_hostmaster' of incorrect type. Expected str, got {type(soa_data_hostmaster_new)}")
		if members_are_exclusive_new is not None and not (isinstance(members_are_exclusive_new, bool)):
			raise ValueError(f"'members_are_exclusive' of incorrect type. Expected bool, got {type(members_are_exclusive_new)}")
		if zone_data_is_external_new is not None and not (isinstance(zone_data_is_external_new, bool)):
			raise ValueError(f"'zone_data_is_external' of incorrect type. Expected bool, got {type(zone_data_is_external_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'dnscfg.ns_set.update', 'new': _denullify_dict({'name': name_new, 'description': description_new, 'soa_data_retry': soa_data_retry_new, 'soa_data_expire': soa_data_expire_new, 'soa_data_minimum': soa_data_minimum_new, 'soa_data_refresh': soa_data_refresh_new, 'soa_data_hostmaster': soa_data_hostmaster_new, 'members_are_exclusive': members_are_exclusive_new, 'zone_data_is_external': zone_data_is_external_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, description_new: Union[str, ExplicitNull] = None, soa_data_retry_new: int = None, soa_data_expire_new: int = None, soa_data_minimum_new: int = None, soa_data_refresh_new: int = None, soa_data_hostmaster_new: str = None, members_are_exclusive_new: bool = None, zone_data_is_external_new: bool = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if soa_data_retry_new is not None and not (isinstance(soa_data_retry_new, int)):
			raise ValueError(f"'soa_data_retry' of incorrect type. Expected int, got {type(soa_data_retry_new)}")
		if soa_data_expire_new is not None and not (isinstance(soa_data_expire_new, int)):
			raise ValueError(f"'soa_data_expire' of incorrect type. Expected int, got {type(soa_data_expire_new)}")
		if soa_data_minimum_new is not None and not (isinstance(soa_data_minimum_new, int)):
			raise ValueError(f"'soa_data_minimum' of incorrect type. Expected int, got {type(soa_data_minimum_new)}")
		if soa_data_refresh_new is not None and not (isinstance(soa_data_refresh_new, int)):
			raise ValueError(f"'soa_data_refresh' of incorrect type. Expected int, got {type(soa_data_refresh_new)}")
		if soa_data_hostmaster_new is not None and not (isinstance(soa_data_hostmaster_new, str)):
			raise ValueError(f"'soa_data_hostmaster' of incorrect type. Expected str, got {type(soa_data_hostmaster_new)}")
		if members_are_exclusive_new is not None and not (isinstance(members_are_exclusive_new, bool)):
			raise ValueError(f"'members_are_exclusive' of incorrect type. Expected bool, got {type(members_are_exclusive_new)}")
		if zone_data_is_external_new is not None and not (isinstance(zone_data_is_external_new, bool)):
			raise ValueError(f"'zone_data_is_external' of incorrect type. Expected bool, got {type(zone_data_is_external_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, description_new=description_new, soa_data_retry_new=soa_data_retry_new, soa_data_expire_new=soa_data_expire_new, soa_data_minimum_new=soa_data_minimum_new, soa_data_refresh_new=soa_data_refresh_new, soa_data_hostmaster_new=soa_data_hostmaster_new, members_are_exclusive_new=members_are_exclusive_new, zone_data_is_external_new=zone_data_is_external_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class NsSetMember(APIObject):
	gpk: str
	ns_fqdn: str
	ns_set_name: str
	ns_is_master: bool
	ns_is_native: bool
	ns_is_primary: bool
	ns_is_registered: bool
	ns_xfer_master_fqdn: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.ns_fqdn, str):
			raise ValueError(f"'ns_fqdn' of incorrect type. Expected str, got {type(self.ns_fqdn)}")
		if not isinstance(self.ns_set_name, str):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(self.ns_set_name)}")
		if not isinstance(self.ns_is_master, bool):
			raise ValueError(f"'ns_is_master' of incorrect type. Expected bool, got {type(self.ns_is_master)}")
		if not isinstance(self.ns_is_native, bool):
			raise ValueError(f"'ns_is_native' of incorrect type. Expected bool, got {type(self.ns_is_native)}")
		if not isinstance(self.ns_is_primary, bool):
			raise ValueError(f"'ns_is_primary' of incorrect type. Expected bool, got {type(self.ns_is_primary)}")
		if not isinstance(self.ns_is_registered, bool):
			raise ValueError(f"'ns_is_registered' of incorrect type. Expected bool, got {type(self.ns_is_registered)}")
		if self.ns_xfer_master_fqdn is not None and not isinstance(self.ns_xfer_master_fqdn, str):
			raise ValueError(f"'ns_xfer_master_fqdn' of incorrect type. Expected str, got {type(self.ns_xfer_master_fqdn)}")

	@staticmethod
	def create_ta(ns_fqdn_new: str, ns_set_name_new: str, ns_is_master_new: bool, ns_is_native_new: bool, ns_is_primary_new: bool, ns_is_registered_new: bool, ns_xfer_master_fqdn_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(ns_fqdn_new, str)):
			raise ValueError(f"'ns_fqdn' of incorrect type. Expected str, got {type(ns_fqdn_new)}")
		if not (isinstance(ns_set_name_new, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_new)}")
		if not (isinstance(ns_is_master_new, bool)):
			raise ValueError(f"'ns_is_master' of incorrect type. Expected bool, got {type(ns_is_master_new)}")
		if not (isinstance(ns_is_native_new, bool)):
			raise ValueError(f"'ns_is_native' of incorrect type. Expected bool, got {type(ns_is_native_new)}")
		if not (isinstance(ns_is_primary_new, bool)):
			raise ValueError(f"'ns_is_primary' of incorrect type. Expected bool, got {type(ns_is_primary_new)}")
		if not (isinstance(ns_is_registered_new, bool)):
			raise ValueError(f"'ns_is_registered' of incorrect type. Expected bool, got {type(ns_is_registered_new)}")
		if ns_xfer_master_fqdn_new is not None and not (isinstance(ns_xfer_master_fqdn_new, str) or isinstance(ns_xfer_master_fqdn_new, ExplicitNull)):
			raise ValueError(f"'ns_xfer_master_fqdn' of incorrect type. Expected str, got {type(ns_xfer_master_fqdn_new)}")

		return {'name': 'dnscfg.ns_set_member.create', 'new': _denullify_dict({'ns_fqdn': ns_fqdn_new, 'ns_set_name': ns_set_name_new, 'ns_is_master': ns_is_master_new, 'ns_is_native': ns_is_native_new, 'ns_is_primary': ns_is_primary_new, 'ns_is_registered': ns_is_registered_new, 'ns_xfer_master_fqdn': ns_xfer_master_fqdn_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, ns_fqdn_new: str, ns_set_name_new: str, ns_is_master_new: bool, ns_is_native_new: bool, ns_is_primary_new: bool, ns_is_registered_new: bool, ns_xfer_master_fqdn_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(ns_fqdn_new, str)):
			raise ValueError(f"'ns_fqdn' of incorrect type. Expected str, got {type(ns_fqdn_new)}")
		if not (isinstance(ns_set_name_new, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_new)}")
		if not (isinstance(ns_is_master_new, bool)):
			raise ValueError(f"'ns_is_master' of incorrect type. Expected bool, got {type(ns_is_master_new)}")
		if not (isinstance(ns_is_native_new, bool)):
			raise ValueError(f"'ns_is_native' of incorrect type. Expected bool, got {type(ns_is_native_new)}")
		if not (isinstance(ns_is_primary_new, bool)):
			raise ValueError(f"'ns_is_primary' of incorrect type. Expected bool, got {type(ns_is_primary_new)}")
		if not (isinstance(ns_is_registered_new, bool)):
			raise ValueError(f"'ns_is_registered' of incorrect type. Expected bool, got {type(ns_is_registered_new)}")
		if ns_xfer_master_fqdn_new is not None and not (isinstance(ns_xfer_master_fqdn_new, str) or isinstance(ns_xfer_master_fqdn_new, ExplicitNull)):
			raise ValueError(f"'ns_xfer_master_fqdn' of incorrect type. Expected str, got {type(ns_xfer_master_fqdn_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(ns_fqdn_new=ns_fqdn_new, ns_set_name_new=ns_set_name_new, ns_is_master_new=ns_is_master_new, ns_is_native_new=ns_is_native_new, ns_is_primary_new=ns_is_primary_new, ns_is_registered_new=ns_is_registered_new, ns_xfer_master_fqdn_new=ns_xfer_master_fqdn_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(ns_fqdn_old: str, ns_set_name_old: str) -> dict:
		if not (isinstance(ns_fqdn_old, str)):
			raise ValueError(f"'ns_fqdn' of incorrect type. Expected str, got {type(ns_fqdn_old)}")
		if not (isinstance(ns_set_name_old, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_old)}")

		return {'name': 'dnscfg.ns_set_member.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'ns_fqdn': ns_fqdn_old, 'ns_set_name': ns_set_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, ns_fqdn_old: str, ns_set_name_old: str) -> list:
		if not (isinstance(ns_fqdn_old, str)):
			raise ValueError(f"'ns_fqdn' of incorrect type. Expected str, got {type(ns_fqdn_old)}")
		if not (isinstance(ns_set_name_old, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(ns_fqdn_old=ns_fqdn_old, ns_set_name_old=ns_set_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, ns_fqdn_old: str = None, gpk_list_old: list = None, fetch_limit_old: int = None, ns_set_name_old: str = None, fetch_offset_old: int = None, ns_fqdn_list_old: list = None, ns_set_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if ns_fqdn_old is not None and not (isinstance(ns_fqdn_old, str)):
			raise ValueError(f"'ns_fqdn' of incorrect type. Expected str, got {type(ns_fqdn_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if ns_set_name_old is not None and not (isinstance(ns_set_name_old, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if ns_fqdn_list_old is not None and not (isinstance(ns_fqdn_list_old, list)):
			raise ValueError(f"'ns_fqdn_list' of incorrect type. Expected list, got {type(ns_fqdn_list_old)}")
		if ns_set_name_list_old is not None and not (isinstance(ns_set_name_list_old, list)):
			raise ValueError(f"'ns_set_name_list' of incorrect type. Expected list, got {type(ns_set_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dnscfg.ns_set_member.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'ns_fqdn': ns_fqdn_old, 'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'ns_set_name': ns_set_name_old, 'fetch_offset': fetch_offset_old, 'ns_fqdn_list': ns_fqdn_list_old, 'ns_set_name_list': ns_set_name_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, ns_fqdn_old: str = None, gpk_list_old: list = None, fetch_limit_old: int = None, ns_set_name_old: str = None, fetch_offset_old: int = None, ns_fqdn_list_old: list = None, ns_set_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if ns_fqdn_old is not None and not (isinstance(ns_fqdn_old, str)):
			raise ValueError(f"'ns_fqdn' of incorrect type. Expected str, got {type(ns_fqdn_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if ns_set_name_old is not None and not (isinstance(ns_set_name_old, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if ns_fqdn_list_old is not None and not (isinstance(ns_fqdn_list_old, list)):
			raise ValueError(f"'ns_fqdn_list' of incorrect type. Expected list, got {type(ns_fqdn_list_old)}")
		if ns_set_name_list_old is not None and not (isinstance(ns_set_name_list_old, list)):
			raise ValueError(f"'ns_set_name_list' of incorrect type. Expected list, got {type(ns_set_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, ns_fqdn_old=ns_fqdn_old, gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, ns_set_name_old=ns_set_name_old, fetch_offset_old=fetch_offset_old, ns_fqdn_list_old=ns_fqdn_list_old, ns_set_name_list_old=ns_set_name_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(ns_fqdn_old: str, ns_set_name_old: str, ns_fqdn_new: str = None, ns_set_name_new: str = None, ns_is_master_new: bool = None, ns_is_native_new: bool = None, ns_is_primary_new: bool = None, ns_is_registered_new: bool = None, ns_xfer_master_fqdn_new: Union[str, ExplicitNull] = None) -> dict:
		if ns_fqdn_new is not None and not (isinstance(ns_fqdn_new, str)):
			raise ValueError(f"'ns_fqdn' of incorrect type. Expected str, got {type(ns_fqdn_new)}")
		if ns_set_name_new is not None and not (isinstance(ns_set_name_new, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_new)}")
		if ns_is_master_new is not None and not (isinstance(ns_is_master_new, bool)):
			raise ValueError(f"'ns_is_master' of incorrect type. Expected bool, got {type(ns_is_master_new)}")
		if ns_is_native_new is not None and not (isinstance(ns_is_native_new, bool)):
			raise ValueError(f"'ns_is_native' of incorrect type. Expected bool, got {type(ns_is_native_new)}")
		if ns_is_primary_new is not None and not (isinstance(ns_is_primary_new, bool)):
			raise ValueError(f"'ns_is_primary' of incorrect type. Expected bool, got {type(ns_is_primary_new)}")
		if ns_is_registered_new is not None and not (isinstance(ns_is_registered_new, bool)):
			raise ValueError(f"'ns_is_registered' of incorrect type. Expected bool, got {type(ns_is_registered_new)}")
		if ns_xfer_master_fqdn_new is not None and not (isinstance(ns_xfer_master_fqdn_new, str) or isinstance(ns_xfer_master_fqdn_new, ExplicitNull)):
			raise ValueError(f"'ns_xfer_master_fqdn' of incorrect type. Expected str, got {type(ns_xfer_master_fqdn_new)}")
		if not (isinstance(ns_fqdn_old, str)):
			raise ValueError(f"'ns_fqdn' of incorrect type. Expected str, got {type(ns_fqdn_old)}")
		if not (isinstance(ns_set_name_old, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_old)}")

		return {'name': 'dnscfg.ns_set_member.update', 'new': _denullify_dict({'ns_fqdn': ns_fqdn_new, 'ns_set_name': ns_set_name_new, 'ns_is_master': ns_is_master_new, 'ns_is_native': ns_is_native_new, 'ns_is_primary': ns_is_primary_new, 'ns_is_registered': ns_is_registered_new, 'ns_xfer_master_fqdn': ns_xfer_master_fqdn_new}), 'old': _denullify_dict({'ns_fqdn': ns_fqdn_old, 'ns_set_name': ns_set_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, ns_fqdn_old: str, ns_set_name_old: str, ns_fqdn_new: str = None, ns_set_name_new: str = None, ns_is_master_new: bool = None, ns_is_native_new: bool = None, ns_is_primary_new: bool = None, ns_is_registered_new: bool = None, ns_xfer_master_fqdn_new: Union[str, ExplicitNull] = None) -> list:
		if ns_fqdn_new is not None and not (isinstance(ns_fqdn_new, str)):
			raise ValueError(f"'ns_fqdn' of incorrect type. Expected str, got {type(ns_fqdn_new)}")
		if ns_set_name_new is not None and not (isinstance(ns_set_name_new, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_new)}")
		if ns_is_master_new is not None and not (isinstance(ns_is_master_new, bool)):
			raise ValueError(f"'ns_is_master' of incorrect type. Expected bool, got {type(ns_is_master_new)}")
		if ns_is_native_new is not None and not (isinstance(ns_is_native_new, bool)):
			raise ValueError(f"'ns_is_native' of incorrect type. Expected bool, got {type(ns_is_native_new)}")
		if ns_is_primary_new is not None and not (isinstance(ns_is_primary_new, bool)):
			raise ValueError(f"'ns_is_primary' of incorrect type. Expected bool, got {type(ns_is_primary_new)}")
		if ns_is_registered_new is not None and not (isinstance(ns_is_registered_new, bool)):
			raise ValueError(f"'ns_is_registered' of incorrect type. Expected bool, got {type(ns_is_registered_new)}")
		if ns_xfer_master_fqdn_new is not None and not (isinstance(ns_xfer_master_fqdn_new, str) or isinstance(ns_xfer_master_fqdn_new, ExplicitNull)):
			raise ValueError(f"'ns_xfer_master_fqdn' of incorrect type. Expected str, got {type(ns_xfer_master_fqdn_new)}")
		if not (isinstance(ns_fqdn_old, str)):
			raise ValueError(f"'ns_fqdn' of incorrect type. Expected str, got {type(ns_fqdn_old)}")
		if not (isinstance(ns_set_name_old, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(ns_fqdn_new=ns_fqdn_new, ns_set_name_new=ns_set_name_new, ns_is_master_new=ns_is_master_new, ns_is_native_new=ns_is_native_new, ns_is_primary_new=ns_is_primary_new, ns_is_registered_new=ns_is_registered_new, ns_xfer_master_fqdn_new=ns_xfer_master_fqdn_new, ns_fqdn_old=ns_fqdn_old, ns_set_name_old=ns_set_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Fqdn2perm(APIObject):
	gpk: str
	fqdn: str
	is_recursive: bool
	is_zone_bound: bool
	recursive_min_lvl: int
	permission_fq_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.fqdn, str):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(self.fqdn)}")
		if not isinstance(self.is_recursive, bool):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(self.is_recursive)}")
		if not isinstance(self.is_zone_bound, bool):
			raise ValueError(f"'is_zone_bound' of incorrect type. Expected bool, got {type(self.is_zone_bound)}")
		if not isinstance(self.recursive_min_lvl, int):
			raise ValueError(f"'recursive_min_lvl' of incorrect type. Expected int, got {type(self.recursive_min_lvl)}")
		if not isinstance(self.permission_fq_name, str):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(self.permission_fq_name)}")

	@staticmethod
	def create_ta(fqdn_new: str, is_recursive_new: bool, is_zone_bound_new: bool, recursive_min_lvl_new: int, permission_fq_name_new: str) -> dict:
		if not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if not (isinstance(is_recursive_new, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_new)}")
		if not (isinstance(is_zone_bound_new, bool)):
			raise ValueError(f"'is_zone_bound' of incorrect type. Expected bool, got {type(is_zone_bound_new)}")
		if not (isinstance(recursive_min_lvl_new, int)):
			raise ValueError(f"'recursive_min_lvl' of incorrect type. Expected int, got {type(recursive_min_lvl_new)}")
		if not (isinstance(permission_fq_name_new, str)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")

		return {'name': 'dnscfg.fqdn2perm.create', 'new': _denullify_dict({'fqdn': fqdn_new, 'is_recursive': is_recursive_new, 'is_zone_bound': is_zone_bound_new, 'recursive_min_lvl': recursive_min_lvl_new, 'permission_fq_name': permission_fq_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, fqdn_new: str, is_recursive_new: bool, is_zone_bound_new: bool, recursive_min_lvl_new: int, permission_fq_name_new: str) -> list:
		if not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if not (isinstance(is_recursive_new, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_new)}")
		if not (isinstance(is_zone_bound_new, bool)):
			raise ValueError(f"'is_zone_bound' of incorrect type. Expected bool, got {type(is_zone_bound_new)}")
		if not (isinstance(recursive_min_lvl_new, int)):
			raise ValueError(f"'recursive_min_lvl' of incorrect type. Expected int, got {type(recursive_min_lvl_new)}")
		if not (isinstance(permission_fq_name_new, str)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(fqdn_new=fqdn_new, is_recursive_new=is_recursive_new, is_zone_bound_new=is_zone_bound_new, recursive_min_lvl_new=recursive_min_lvl_new, permission_fq_name_new=permission_fq_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(permission_fq_name_old: str = None) -> dict:
		if permission_fq_name_old is not None and not (isinstance(permission_fq_name_old, str)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_old)}")

		return {'name': 'dnscfg.fqdn2perm.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'permission_fq_name': permission_fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, permission_fq_name_old: str = None) -> list:
		if permission_fq_name_old is not None and not (isinstance(permission_fq_name_old, str)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(permission_fq_name_old=permission_fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, permission_fq_name_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if permission_fq_name_list_old is not None and not (isinstance(permission_fq_name_list_old, list)):
			raise ValueError(f"'permission_fq_name_list' of incorrect type. Expected list, got {type(permission_fq_name_list_old)}")

		return {'name': 'dnscfg.fqdn2perm.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'permission_fq_name_list': permission_fq_name_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, permission_fq_name_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if permission_fq_name_list_old is not None and not (isinstance(permission_fq_name_list_old, list)):
			raise ValueError(f"'permission_fq_name_list' of incorrect type. Expected list, got {type(permission_fq_name_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, permission_fq_name_list_old=permission_fq_name_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(permission_fq_name_old: str, fqdn_new: str = None, is_recursive_new: bool = None, is_zone_bound_new: bool = None, recursive_min_lvl_new: int = None, permission_fq_name_new: str = None) -> dict:
		if fqdn_new is not None and not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if is_recursive_new is not None and not (isinstance(is_recursive_new, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_new)}")
		if is_zone_bound_new is not None and not (isinstance(is_zone_bound_new, bool)):
			raise ValueError(f"'is_zone_bound' of incorrect type. Expected bool, got {type(is_zone_bound_new)}")
		if recursive_min_lvl_new is not None and not (isinstance(recursive_min_lvl_new, int)):
			raise ValueError(f"'recursive_min_lvl' of incorrect type. Expected int, got {type(recursive_min_lvl_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if not (isinstance(permission_fq_name_old, str)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_old)}")

		return {'name': 'dnscfg.fqdn2perm.update', 'new': _denullify_dict({'fqdn': fqdn_new, 'is_recursive': is_recursive_new, 'is_zone_bound': is_zone_bound_new, 'recursive_min_lvl': recursive_min_lvl_new, 'permission_fq_name': permission_fq_name_new}), 'old': _denullify_dict({'permission_fq_name': permission_fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, permission_fq_name_old: str, fqdn_new: str = None, is_recursive_new: bool = None, is_zone_bound_new: bool = None, recursive_min_lvl_new: int = None, permission_fq_name_new: str = None) -> list:
		if fqdn_new is not None and not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if is_recursive_new is not None and not (isinstance(is_recursive_new, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_new)}")
		if is_zone_bound_new is not None and not (isinstance(is_zone_bound_new, bool)):
			raise ValueError(f"'is_zone_bound' of incorrect type. Expected bool, got {type(is_zone_bound_new)}")
		if recursive_min_lvl_new is not None and not (isinstance(recursive_min_lvl_new, int)):
			raise ValueError(f"'recursive_min_lvl' of incorrect type. Expected int, got {type(recursive_min_lvl_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if not (isinstance(permission_fq_name_old, str)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(fqdn_new=fqdn_new, is_recursive_new=is_recursive_new, is_zone_bound_new=is_zone_bound_new, recursive_min_lvl_new=recursive_min_lvl_new, permission_fq_name_new=permission_fq_name_new, permission_fq_name_old=permission_fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class FqdnTypeGroup(APIObject):
	gpk: str
	name: str
	description: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")

	@staticmethod
	def create_ta(name_new: str, description_new: str) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		return {'name': 'dnscfg.fqdn_type_group.create', 'new': _denullify_dict({'name': name_new, 'description': description_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, description_new: str) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, description_new=description_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'dnscfg.fqdn_type_group.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dnscfg.fqdn_type_group.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, description_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'dnscfg.fqdn_type_group.update', 'new': _denullify_dict({'name': name_new, 'description': description_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, description_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, description_new=description_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class NsSetHost(APIObject):
	gpk: str
	host_fqdn: str
	ns_set_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.host_fqdn, str):
			raise ValueError(f"'host_fqdn' of incorrect type. Expected str, got {type(self.host_fqdn)}")
		if not isinstance(self.ns_set_name, str):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(self.ns_set_name)}")

	@staticmethod
	def create_ta(host_fqdn_new: str, ns_set_name_new: str) -> dict:
		if not (isinstance(host_fqdn_new, str)):
			raise ValueError(f"'host_fqdn' of incorrect type. Expected str, got {type(host_fqdn_new)}")
		if not (isinstance(ns_set_name_new, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_new)}")

		return {'name': 'dnscfg.ns_set_host.create', 'new': _denullify_dict({'host_fqdn': host_fqdn_new, 'ns_set_name': ns_set_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, host_fqdn_new: str, ns_set_name_new: str) -> list:
		if not (isinstance(host_fqdn_new, str)):
			raise ValueError(f"'host_fqdn' of incorrect type. Expected str, got {type(host_fqdn_new)}")
		if not (isinstance(ns_set_name_new, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(host_fqdn_new=host_fqdn_new, ns_set_name_new=ns_set_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(host_fqdn_old: str, ns_set_name_old: str) -> dict:
		if not (isinstance(host_fqdn_old, str)):
			raise ValueError(f"'host_fqdn' of incorrect type. Expected str, got {type(host_fqdn_old)}")
		if not (isinstance(ns_set_name_old, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_old)}")

		return {'name': 'dnscfg.ns_set_host.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'host_fqdn': host_fqdn_old, 'ns_set_name': ns_set_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, host_fqdn_old: str, ns_set_name_old: str) -> list:
		if not (isinstance(host_fqdn_old, str)):
			raise ValueError(f"'host_fqdn' of incorrect type. Expected str, got {type(host_fqdn_old)}")
		if not (isinstance(ns_set_name_old, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(host_fqdn_old=host_fqdn_old, ns_set_name_old=ns_set_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, host_fqdn_old: str = None, fetch_limit_old: int = None, ns_set_name_old: str = None, fetch_offset_old: int = None, host_fqdn_list_old: list = None, ns_set_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if host_fqdn_old is not None and not (isinstance(host_fqdn_old, str)):
			raise ValueError(f"'host_fqdn' of incorrect type. Expected str, got {type(host_fqdn_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if ns_set_name_old is not None and not (isinstance(ns_set_name_old, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if host_fqdn_list_old is not None and not (isinstance(host_fqdn_list_old, list)):
			raise ValueError(f"'host_fqdn_list' of incorrect type. Expected list, got {type(host_fqdn_list_old)}")
		if ns_set_name_list_old is not None and not (isinstance(ns_set_name_list_old, list)):
			raise ValueError(f"'ns_set_name_list' of incorrect type. Expected list, got {type(ns_set_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dnscfg.ns_set_host.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'host_fqdn': host_fqdn_old, 'fetch_limit': fetch_limit_old, 'ns_set_name': ns_set_name_old, 'fetch_offset': fetch_offset_old, 'host_fqdn_list': host_fqdn_list_old, 'ns_set_name_list': ns_set_name_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, host_fqdn_old: str = None, fetch_limit_old: int = None, ns_set_name_old: str = None, fetch_offset_old: int = None, host_fqdn_list_old: list = None, ns_set_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if host_fqdn_old is not None and not (isinstance(host_fqdn_old, str)):
			raise ValueError(f"'host_fqdn' of incorrect type. Expected str, got {type(host_fqdn_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if ns_set_name_old is not None and not (isinstance(ns_set_name_old, str)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if host_fqdn_list_old is not None and not (isinstance(host_fqdn_list_old, list)):
			raise ValueError(f"'host_fqdn_list' of incorrect type. Expected list, got {type(host_fqdn_list_old)}")
		if ns_set_name_list_old is not None and not (isinstance(ns_set_name_list_old, list)):
			raise ValueError(f"'ns_set_name_list' of incorrect type. Expected list, got {type(ns_set_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, host_fqdn_old=host_fqdn_old, fetch_limit_old=fetch_limit_old, ns_set_name_old=ns_set_name_old, fetch_offset_old=fetch_offset_old, host_fqdn_list_old=host_fqdn_list_old, ns_set_name_list_old=ns_set_name_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
