### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class Zone(APIObject):
	gpk: str
	fqdn: str
	is_own: bool
	is_apex: bool
	nsec3_salt: str
	description: str
	ns_set_name: str
	nsec3_itcount: int
	dnssec_do_sign: bool
	soa_data_retry: int
	nsec3_hash_algo: int
	soa_data_expire: int
	soa_data_serial: int
	soa_data_minimum: int
	soa_data_refresh: int
	dnssec_do_enforce: bool
	dflt_ttl_rrt_dbext: int
	dflt_ttl_rrt_dbint: int
	soa_data_hostmaster: str
	dnssec_ksk_rrs_are_published: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.fqdn, str):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(self.fqdn)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.is_apex, bool):
			raise ValueError(f"'is_apex' of incorrect type. Expected bool, got {type(self.is_apex)}")
		if self.nsec3_salt is not None and not isinstance(self.nsec3_salt, str):
			raise ValueError(f"'nsec3_salt' of incorrect type. Expected str, got {type(self.nsec3_salt)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if self.ns_set_name is not None and not isinstance(self.ns_set_name, str):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(self.ns_set_name)}")
		if not isinstance(self.nsec3_itcount, int):
			raise ValueError(f"'nsec3_itcount' of incorrect type. Expected int, got {type(self.nsec3_itcount)}")
		if not isinstance(self.dnssec_do_sign, bool):
			raise ValueError(f"'dnssec_do_sign' of incorrect type. Expected bool, got {type(self.dnssec_do_sign)}")
		if self.soa_data_retry is not None and not isinstance(self.soa_data_retry, int):
			raise ValueError(f"'soa_data_retry' of incorrect type. Expected int, got {type(self.soa_data_retry)}")
		if not isinstance(self.nsec3_hash_algo, int):
			raise ValueError(f"'nsec3_hash_algo' of incorrect type. Expected int, got {type(self.nsec3_hash_algo)}")
		if self.soa_data_expire is not None and not isinstance(self.soa_data_expire, int):
			raise ValueError(f"'soa_data_expire' of incorrect type. Expected int, got {type(self.soa_data_expire)}")
		if not isinstance(self.soa_data_serial, int):
			raise ValueError(f"'soa_data_serial' of incorrect type. Expected int, got {type(self.soa_data_serial)}")
		if self.soa_data_minimum is not None and not isinstance(self.soa_data_minimum, int):
			raise ValueError(f"'soa_data_minimum' of incorrect type. Expected int, got {type(self.soa_data_minimum)}")
		if self.soa_data_refresh is not None and not isinstance(self.soa_data_refresh, int):
			raise ValueError(f"'soa_data_refresh' of incorrect type. Expected int, got {type(self.soa_data_refresh)}")
		if not isinstance(self.dnssec_do_enforce, bool):
			raise ValueError(f"'dnssec_do_enforce' of incorrect type. Expected bool, got {type(self.dnssec_do_enforce)}")
		if not isinstance(self.dflt_ttl_rrt_dbext, int):
			raise ValueError(f"'dflt_ttl_rrt_dbext' of incorrect type. Expected int, got {type(self.dflt_ttl_rrt_dbext)}")
		if not isinstance(self.dflt_ttl_rrt_dbint, int):
			raise ValueError(f"'dflt_ttl_rrt_dbint' of incorrect type. Expected int, got {type(self.dflt_ttl_rrt_dbint)}")
		if self.soa_data_hostmaster is not None and not isinstance(self.soa_data_hostmaster, str):
			raise ValueError(f"'soa_data_hostmaster' of incorrect type. Expected str, got {type(self.soa_data_hostmaster)}")
		if not isinstance(self.dnssec_ksk_rrs_are_published, bool):
			raise ValueError(f"'dnssec_ksk_rrs_are_published' of incorrect type. Expected bool, got {type(self.dnssec_ksk_rrs_are_published)}")

	@staticmethod
	def create_ta(fqdn_new: str, nsec3_salt_new: Union[str, ExplicitNull] = None, description_new: Union[str, ExplicitNull] = None, ns_set_name_new: Union[str, ExplicitNull] = None, nsec3_itcount_new: int = 0, dnssec_do_sign_new: bool = False, soa_data_retry_new: Union[int, ExplicitNull] = None, nsec3_hash_algo_new: int = 1, soa_data_expire_new: Union[int, ExplicitNull] = None, soa_data_minimum_new: Union[int, ExplicitNull] = None, soa_data_refresh_new: Union[int, ExplicitNull] = None, dnssec_do_enforce_new: bool = False, dflt_ttl_rrt_dbext_new: int = 900, dflt_ttl_rrt_dbint_new: int = 600, soa_data_hostmaster_new: Union[str, ExplicitNull] = None, dnssec_ksk_rrs_are_published_new: bool = False) -> dict:
		if not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if nsec3_salt_new is not None and not (isinstance(nsec3_salt_new, str) or isinstance(nsec3_salt_new, ExplicitNull)):
			raise ValueError(f"'nsec3_salt' of incorrect type. Expected str, got {type(nsec3_salt_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if ns_set_name_new is not None and not (isinstance(ns_set_name_new, str) or isinstance(ns_set_name_new, ExplicitNull)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_new)}")
		if nsec3_itcount_new is not None and not (isinstance(nsec3_itcount_new, int)):
			raise ValueError(f"'nsec3_itcount' of incorrect type. Expected int, got {type(nsec3_itcount_new)}")
		if dnssec_do_sign_new is not None and not (isinstance(dnssec_do_sign_new, bool)):
			raise ValueError(f"'dnssec_do_sign' of incorrect type. Expected bool, got {type(dnssec_do_sign_new)}")
		if soa_data_retry_new is not None and not (isinstance(soa_data_retry_new, int) or isinstance(soa_data_retry_new, ExplicitNull)):
			raise ValueError(f"'soa_data_retry' of incorrect type. Expected int, got {type(soa_data_retry_new)}")
		if nsec3_hash_algo_new is not None and not (isinstance(nsec3_hash_algo_new, int)):
			raise ValueError(f"'nsec3_hash_algo' of incorrect type. Expected int, got {type(nsec3_hash_algo_new)}")
		if soa_data_expire_new is not None and not (isinstance(soa_data_expire_new, int) or isinstance(soa_data_expire_new, ExplicitNull)):
			raise ValueError(f"'soa_data_expire' of incorrect type. Expected int, got {type(soa_data_expire_new)}")
		if soa_data_minimum_new is not None and not (isinstance(soa_data_minimum_new, int) or isinstance(soa_data_minimum_new, ExplicitNull)):
			raise ValueError(f"'soa_data_minimum' of incorrect type. Expected int, got {type(soa_data_minimum_new)}")
		if soa_data_refresh_new is not None and not (isinstance(soa_data_refresh_new, int) or isinstance(soa_data_refresh_new, ExplicitNull)):
			raise ValueError(f"'soa_data_refresh' of incorrect type. Expected int, got {type(soa_data_refresh_new)}")
		if dnssec_do_enforce_new is not None and not (isinstance(dnssec_do_enforce_new, bool)):
			raise ValueError(f"'dnssec_do_enforce' of incorrect type. Expected bool, got {type(dnssec_do_enforce_new)}")
		if dflt_ttl_rrt_dbext_new is not None and not (isinstance(dflt_ttl_rrt_dbext_new, int)):
			raise ValueError(f"'dflt_ttl_rrt_dbext' of incorrect type. Expected int, got {type(dflt_ttl_rrt_dbext_new)}")
		if dflt_ttl_rrt_dbint_new is not None and not (isinstance(dflt_ttl_rrt_dbint_new, int)):
			raise ValueError(f"'dflt_ttl_rrt_dbint' of incorrect type. Expected int, got {type(dflt_ttl_rrt_dbint_new)}")
		if soa_data_hostmaster_new is not None and not (isinstance(soa_data_hostmaster_new, str) or isinstance(soa_data_hostmaster_new, ExplicitNull)):
			raise ValueError(f"'soa_data_hostmaster' of incorrect type. Expected str, got {type(soa_data_hostmaster_new)}")
		if dnssec_ksk_rrs_are_published_new is not None and not (isinstance(dnssec_ksk_rrs_are_published_new, bool)):
			raise ValueError(f"'dnssec_ksk_rrs_are_published' of incorrect type. Expected bool, got {type(dnssec_ksk_rrs_are_published_new)}")

		return {'name': 'dns.zone.create', 'new': _denullify_dict({'fqdn': fqdn_new, 'nsec3_salt': nsec3_salt_new, 'description': description_new, 'ns_set_name': ns_set_name_new, 'nsec3_itcount': nsec3_itcount_new, 'dnssec_do_sign': dnssec_do_sign_new, 'soa_data_retry': soa_data_retry_new, 'nsec3_hash_algo': nsec3_hash_algo_new, 'soa_data_expire': soa_data_expire_new, 'soa_data_minimum': soa_data_minimum_new, 'soa_data_refresh': soa_data_refresh_new, 'dnssec_do_enforce': dnssec_do_enforce_new, 'dflt_ttl_rrt_dbext': dflt_ttl_rrt_dbext_new, 'dflt_ttl_rrt_dbint': dflt_ttl_rrt_dbint_new, 'soa_data_hostmaster': soa_data_hostmaster_new, 'dnssec_ksk_rrs_are_published': dnssec_ksk_rrs_are_published_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, fqdn_new: str, nsec3_salt_new: Union[str, ExplicitNull] = None, description_new: Union[str, ExplicitNull] = None, ns_set_name_new: Union[str, ExplicitNull] = None, nsec3_itcount_new: int = 0, dnssec_do_sign_new: bool = False, soa_data_retry_new: Union[int, ExplicitNull] = None, nsec3_hash_algo_new: int = 1, soa_data_expire_new: Union[int, ExplicitNull] = None, soa_data_minimum_new: Union[int, ExplicitNull] = None, soa_data_refresh_new: Union[int, ExplicitNull] = None, dnssec_do_enforce_new: bool = False, dflt_ttl_rrt_dbext_new: int = 900, dflt_ttl_rrt_dbint_new: int = 600, soa_data_hostmaster_new: Union[str, ExplicitNull] = None, dnssec_ksk_rrs_are_published_new: bool = False) -> list:
		if not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if nsec3_salt_new is not None and not (isinstance(nsec3_salt_new, str) or isinstance(nsec3_salt_new, ExplicitNull)):
			raise ValueError(f"'nsec3_salt' of incorrect type. Expected str, got {type(nsec3_salt_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if ns_set_name_new is not None and not (isinstance(ns_set_name_new, str) or isinstance(ns_set_name_new, ExplicitNull)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_new)}")
		if nsec3_itcount_new is not None and not (isinstance(nsec3_itcount_new, int)):
			raise ValueError(f"'nsec3_itcount' of incorrect type. Expected int, got {type(nsec3_itcount_new)}")
		if dnssec_do_sign_new is not None and not (isinstance(dnssec_do_sign_new, bool)):
			raise ValueError(f"'dnssec_do_sign' of incorrect type. Expected bool, got {type(dnssec_do_sign_new)}")
		if soa_data_retry_new is not None and not (isinstance(soa_data_retry_new, int) or isinstance(soa_data_retry_new, ExplicitNull)):
			raise ValueError(f"'soa_data_retry' of incorrect type. Expected int, got {type(soa_data_retry_new)}")
		if nsec3_hash_algo_new is not None and not (isinstance(nsec3_hash_algo_new, int)):
			raise ValueError(f"'nsec3_hash_algo' of incorrect type. Expected int, got {type(nsec3_hash_algo_new)}")
		if soa_data_expire_new is not None and not (isinstance(soa_data_expire_new, int) or isinstance(soa_data_expire_new, ExplicitNull)):
			raise ValueError(f"'soa_data_expire' of incorrect type. Expected int, got {type(soa_data_expire_new)}")
		if soa_data_minimum_new is not None and not (isinstance(soa_data_minimum_new, int) or isinstance(soa_data_minimum_new, ExplicitNull)):
			raise ValueError(f"'soa_data_minimum' of incorrect type. Expected int, got {type(soa_data_minimum_new)}")
		if soa_data_refresh_new is not None and not (isinstance(soa_data_refresh_new, int) or isinstance(soa_data_refresh_new, ExplicitNull)):
			raise ValueError(f"'soa_data_refresh' of incorrect type. Expected int, got {type(soa_data_refresh_new)}")
		if dnssec_do_enforce_new is not None and not (isinstance(dnssec_do_enforce_new, bool)):
			raise ValueError(f"'dnssec_do_enforce' of incorrect type. Expected bool, got {type(dnssec_do_enforce_new)}")
		if dflt_ttl_rrt_dbext_new is not None and not (isinstance(dflt_ttl_rrt_dbext_new, int)):
			raise ValueError(f"'dflt_ttl_rrt_dbext' of incorrect type. Expected int, got {type(dflt_ttl_rrt_dbext_new)}")
		if dflt_ttl_rrt_dbint_new is not None and not (isinstance(dflt_ttl_rrt_dbint_new, int)):
			raise ValueError(f"'dflt_ttl_rrt_dbint' of incorrect type. Expected int, got {type(dflt_ttl_rrt_dbint_new)}")
		if soa_data_hostmaster_new is not None and not (isinstance(soa_data_hostmaster_new, str) or isinstance(soa_data_hostmaster_new, ExplicitNull)):
			raise ValueError(f"'soa_data_hostmaster' of incorrect type. Expected str, got {type(soa_data_hostmaster_new)}")
		if dnssec_ksk_rrs_are_published_new is not None and not (isinstance(dnssec_ksk_rrs_are_published_new, bool)):
			raise ValueError(f"'dnssec_ksk_rrs_are_published' of incorrect type. Expected bool, got {type(dnssec_ksk_rrs_are_published_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(fqdn_new=fqdn_new, nsec3_salt_new=nsec3_salt_new, description_new=description_new, ns_set_name_new=ns_set_name_new, nsec3_itcount_new=nsec3_itcount_new, dnssec_do_sign_new=dnssec_do_sign_new, soa_data_retry_new=soa_data_retry_new, nsec3_hash_algo_new=nsec3_hash_algo_new, soa_data_expire_new=soa_data_expire_new, soa_data_minimum_new=soa_data_minimum_new, soa_data_refresh_new=soa_data_refresh_new, dnssec_do_enforce_new=dnssec_do_enforce_new, dflt_ttl_rrt_dbext_new=dflt_ttl_rrt_dbext_new, dflt_ttl_rrt_dbint_new=dflt_ttl_rrt_dbint_new, soa_data_hostmaster_new=soa_data_hostmaster_new, dnssec_ksk_rrs_are_published_new=dnssec_ksk_rrs_are_published_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(fqdn_old: str) -> dict:
		if not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")

		return {'name': 'dns.zone.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'fqdn': fqdn_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, fqdn_old: str) -> list:
		if not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(fqdn_old=fqdn_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(is_own_old: bool = None, is_apex_old: bool = None, gpk_list_old: list = None, sub_fqdn_old: str = None, fqdn_list_old: list = None, fetch_limit_old: int = None, ns_set_name_old: str = None, fetch_offset_old: int = None, dnssec_do_enforce_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_apex_old is not None and not (isinstance(is_apex_old, bool)):
			raise ValueError(f"'is_apex' of incorrect type. Expected bool, got {type(is_apex_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if sub_fqdn_old is not None and not (isinstance(sub_fqdn_old, str)):
			raise ValueError(f"'sub_fqdn' of incorrect type. Expected str, got {type(sub_fqdn_old)}")
		if fqdn_list_old is not None and not (isinstance(fqdn_list_old, list)):
			raise ValueError(f"'fqdn_list' of incorrect type. Expected list, got {type(fqdn_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if ns_set_name_old is not None and not (isinstance(ns_set_name_old, str) or isinstance(ns_set_name_old, ExplicitNull)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if dnssec_do_enforce_old is not None and not (isinstance(dnssec_do_enforce_old, bool)):
			raise ValueError(f"'dnssec_do_enforce' of incorrect type. Expected bool, got {type(dnssec_do_enforce_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dns.zone.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'is_own': is_own_old, 'is_apex': is_apex_old, 'gpk_list': gpk_list_old, 'sub_fqdn': sub_fqdn_old, 'fqdn_list': fqdn_list_old, 'fetch_limit': fetch_limit_old, 'ns_set_name': ns_set_name_old, 'fetch_offset': fetch_offset_old, 'dnssec_do_enforce': dnssec_do_enforce_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, is_own_old: bool = None, is_apex_old: bool = None, gpk_list_old: list = None, sub_fqdn_old: str = None, fqdn_list_old: list = None, fetch_limit_old: int = None, ns_set_name_old: str = None, fetch_offset_old: int = None, dnssec_do_enforce_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_apex_old is not None and not (isinstance(is_apex_old, bool)):
			raise ValueError(f"'is_apex' of incorrect type. Expected bool, got {type(is_apex_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if sub_fqdn_old is not None and not (isinstance(sub_fqdn_old, str)):
			raise ValueError(f"'sub_fqdn' of incorrect type. Expected str, got {type(sub_fqdn_old)}")
		if fqdn_list_old is not None and not (isinstance(fqdn_list_old, list)):
			raise ValueError(f"'fqdn_list' of incorrect type. Expected list, got {type(fqdn_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if ns_set_name_old is not None and not (isinstance(ns_set_name_old, str) or isinstance(ns_set_name_old, ExplicitNull)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if dnssec_do_enforce_old is not None and not (isinstance(dnssec_do_enforce_old, bool)):
			raise ValueError(f"'dnssec_do_enforce' of incorrect type. Expected bool, got {type(dnssec_do_enforce_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(is_own_old=is_own_old, is_apex_old=is_apex_old, gpk_list_old=gpk_list_old, sub_fqdn_old=sub_fqdn_old, fqdn_list_old=fqdn_list_old, fetch_limit_old=fetch_limit_old, ns_set_name_old=ns_set_name_old, fetch_offset_old=fetch_offset_old, dnssec_do_enforce_old=dnssec_do_enforce_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(fqdn_old: str, nsec3_salt_new: Union[str, ExplicitNull] = None, description_new: Union[str, ExplicitNull] = None, ns_set_name_new: Union[str, ExplicitNull] = None, nsec3_itcount_new: int = None, reset_rr_ttls_new: bool = False, dnssec_do_sign_new: bool = None, soa_data_retry_new: Union[int, ExplicitNull] = None, nsec3_hash_algo_new: int = None, soa_data_expire_new: Union[int, ExplicitNull] = None, soa_data_serial_new: int = None, soa_data_minimum_new: Union[int, ExplicitNull] = None, soa_data_refresh_new: Union[int, ExplicitNull] = None, dnssec_do_enforce_new: bool = None, dflt_ttl_rrt_dbext_new: int = None, dflt_ttl_rrt_dbint_new: int = None, soa_data_hostmaster_new: Union[str, ExplicitNull] = None, dnssec_ksk_rrs_are_published_new: bool = None) -> dict:
		if nsec3_salt_new is not None and not (isinstance(nsec3_salt_new, str) or isinstance(nsec3_salt_new, ExplicitNull)):
			raise ValueError(f"'nsec3_salt' of incorrect type. Expected str, got {type(nsec3_salt_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if ns_set_name_new is not None and not (isinstance(ns_set_name_new, str) or isinstance(ns_set_name_new, ExplicitNull)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_new)}")
		if nsec3_itcount_new is not None and not (isinstance(nsec3_itcount_new, int)):
			raise ValueError(f"'nsec3_itcount' of incorrect type. Expected int, got {type(nsec3_itcount_new)}")
		if reset_rr_ttls_new is not None and not (isinstance(reset_rr_ttls_new, bool)):
			raise ValueError(f"'reset_rr_ttls' of incorrect type. Expected bool, got {type(reset_rr_ttls_new)}")
		if dnssec_do_sign_new is not None and not (isinstance(dnssec_do_sign_new, bool)):
			raise ValueError(f"'dnssec_do_sign' of incorrect type. Expected bool, got {type(dnssec_do_sign_new)}")
		if soa_data_retry_new is not None and not (isinstance(soa_data_retry_new, int) or isinstance(soa_data_retry_new, ExplicitNull)):
			raise ValueError(f"'soa_data_retry' of incorrect type. Expected int, got {type(soa_data_retry_new)}")
		if nsec3_hash_algo_new is not None and not (isinstance(nsec3_hash_algo_new, int)):
			raise ValueError(f"'nsec3_hash_algo' of incorrect type. Expected int, got {type(nsec3_hash_algo_new)}")
		if soa_data_expire_new is not None and not (isinstance(soa_data_expire_new, int) or isinstance(soa_data_expire_new, ExplicitNull)):
			raise ValueError(f"'soa_data_expire' of incorrect type. Expected int, got {type(soa_data_expire_new)}")
		if soa_data_serial_new is not None and not (isinstance(soa_data_serial_new, int)):
			raise ValueError(f"'soa_data_serial' of incorrect type. Expected int, got {type(soa_data_serial_new)}")
		if soa_data_minimum_new is not None and not (isinstance(soa_data_minimum_new, int) or isinstance(soa_data_minimum_new, ExplicitNull)):
			raise ValueError(f"'soa_data_minimum' of incorrect type. Expected int, got {type(soa_data_minimum_new)}")
		if soa_data_refresh_new is not None and not (isinstance(soa_data_refresh_new, int) or isinstance(soa_data_refresh_new, ExplicitNull)):
			raise ValueError(f"'soa_data_refresh' of incorrect type. Expected int, got {type(soa_data_refresh_new)}")
		if dnssec_do_enforce_new is not None and not (isinstance(dnssec_do_enforce_new, bool)):
			raise ValueError(f"'dnssec_do_enforce' of incorrect type. Expected bool, got {type(dnssec_do_enforce_new)}")
		if dflt_ttl_rrt_dbext_new is not None and not (isinstance(dflt_ttl_rrt_dbext_new, int)):
			raise ValueError(f"'dflt_ttl_rrt_dbext' of incorrect type. Expected int, got {type(dflt_ttl_rrt_dbext_new)}")
		if dflt_ttl_rrt_dbint_new is not None and not (isinstance(dflt_ttl_rrt_dbint_new, int)):
			raise ValueError(f"'dflt_ttl_rrt_dbint' of incorrect type. Expected int, got {type(dflt_ttl_rrt_dbint_new)}")
		if soa_data_hostmaster_new is not None and not (isinstance(soa_data_hostmaster_new, str) or isinstance(soa_data_hostmaster_new, ExplicitNull)):
			raise ValueError(f"'soa_data_hostmaster' of incorrect type. Expected str, got {type(soa_data_hostmaster_new)}")
		if dnssec_ksk_rrs_are_published_new is not None and not (isinstance(dnssec_ksk_rrs_are_published_new, bool)):
			raise ValueError(f"'dnssec_ksk_rrs_are_published' of incorrect type. Expected bool, got {type(dnssec_ksk_rrs_are_published_new)}")
		if not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")

		return {'name': 'dns.zone.update', 'new': _denullify_dict({'nsec3_salt': nsec3_salt_new, 'description': description_new, 'ns_set_name': ns_set_name_new, 'nsec3_itcount': nsec3_itcount_new, 'reset_rr_ttls': reset_rr_ttls_new, 'dnssec_do_sign': dnssec_do_sign_new, 'soa_data_retry': soa_data_retry_new, 'nsec3_hash_algo': nsec3_hash_algo_new, 'soa_data_expire': soa_data_expire_new, 'soa_data_serial': soa_data_serial_new, 'soa_data_minimum': soa_data_minimum_new, 'soa_data_refresh': soa_data_refresh_new, 'dnssec_do_enforce': dnssec_do_enforce_new, 'dflt_ttl_rrt_dbext': dflt_ttl_rrt_dbext_new, 'dflt_ttl_rrt_dbint': dflt_ttl_rrt_dbint_new, 'soa_data_hostmaster': soa_data_hostmaster_new, 'dnssec_ksk_rrs_are_published': dnssec_ksk_rrs_are_published_new}), 'old': _denullify_dict({'fqdn': fqdn_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, fqdn_old: str, nsec3_salt_new: Union[str, ExplicitNull] = None, description_new: Union[str, ExplicitNull] = None, ns_set_name_new: Union[str, ExplicitNull] = None, nsec3_itcount_new: int = None, reset_rr_ttls_new: bool = False, dnssec_do_sign_new: bool = None, soa_data_retry_new: Union[int, ExplicitNull] = None, nsec3_hash_algo_new: int = None, soa_data_expire_new: Union[int, ExplicitNull] = None, soa_data_serial_new: int = None, soa_data_minimum_new: Union[int, ExplicitNull] = None, soa_data_refresh_new: Union[int, ExplicitNull] = None, dnssec_do_enforce_new: bool = None, dflt_ttl_rrt_dbext_new: int = None, dflt_ttl_rrt_dbint_new: int = None, soa_data_hostmaster_new: Union[str, ExplicitNull] = None, dnssec_ksk_rrs_are_published_new: bool = None) -> list:
		if nsec3_salt_new is not None and not (isinstance(nsec3_salt_new, str) or isinstance(nsec3_salt_new, ExplicitNull)):
			raise ValueError(f"'nsec3_salt' of incorrect type. Expected str, got {type(nsec3_salt_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if ns_set_name_new is not None and not (isinstance(ns_set_name_new, str) or isinstance(ns_set_name_new, ExplicitNull)):
			raise ValueError(f"'ns_set_name' of incorrect type. Expected str, got {type(ns_set_name_new)}")
		if nsec3_itcount_new is not None and not (isinstance(nsec3_itcount_new, int)):
			raise ValueError(f"'nsec3_itcount' of incorrect type. Expected int, got {type(nsec3_itcount_new)}")
		if reset_rr_ttls_new is not None and not (isinstance(reset_rr_ttls_new, bool)):
			raise ValueError(f"'reset_rr_ttls' of incorrect type. Expected bool, got {type(reset_rr_ttls_new)}")
		if dnssec_do_sign_new is not None and not (isinstance(dnssec_do_sign_new, bool)):
			raise ValueError(f"'dnssec_do_sign' of incorrect type. Expected bool, got {type(dnssec_do_sign_new)}")
		if soa_data_retry_new is not None and not (isinstance(soa_data_retry_new, int) or isinstance(soa_data_retry_new, ExplicitNull)):
			raise ValueError(f"'soa_data_retry' of incorrect type. Expected int, got {type(soa_data_retry_new)}")
		if nsec3_hash_algo_new is not None and not (isinstance(nsec3_hash_algo_new, int)):
			raise ValueError(f"'nsec3_hash_algo' of incorrect type. Expected int, got {type(nsec3_hash_algo_new)}")
		if soa_data_expire_new is not None and not (isinstance(soa_data_expire_new, int) or isinstance(soa_data_expire_new, ExplicitNull)):
			raise ValueError(f"'soa_data_expire' of incorrect type. Expected int, got {type(soa_data_expire_new)}")
		if soa_data_serial_new is not None and not (isinstance(soa_data_serial_new, int)):
			raise ValueError(f"'soa_data_serial' of incorrect type. Expected int, got {type(soa_data_serial_new)}")
		if soa_data_minimum_new is not None and not (isinstance(soa_data_minimum_new, int) or isinstance(soa_data_minimum_new, ExplicitNull)):
			raise ValueError(f"'soa_data_minimum' of incorrect type. Expected int, got {type(soa_data_minimum_new)}")
		if soa_data_refresh_new is not None and not (isinstance(soa_data_refresh_new, int) or isinstance(soa_data_refresh_new, ExplicitNull)):
			raise ValueError(f"'soa_data_refresh' of incorrect type. Expected int, got {type(soa_data_refresh_new)}")
		if dnssec_do_enforce_new is not None and not (isinstance(dnssec_do_enforce_new, bool)):
			raise ValueError(f"'dnssec_do_enforce' of incorrect type. Expected bool, got {type(dnssec_do_enforce_new)}")
		if dflt_ttl_rrt_dbext_new is not None and not (isinstance(dflt_ttl_rrt_dbext_new, int)):
			raise ValueError(f"'dflt_ttl_rrt_dbext' of incorrect type. Expected int, got {type(dflt_ttl_rrt_dbext_new)}")
		if dflt_ttl_rrt_dbint_new is not None and not (isinstance(dflt_ttl_rrt_dbint_new, int)):
			raise ValueError(f"'dflt_ttl_rrt_dbint' of incorrect type. Expected int, got {type(dflt_ttl_rrt_dbint_new)}")
		if soa_data_hostmaster_new is not None and not (isinstance(soa_data_hostmaster_new, str) or isinstance(soa_data_hostmaster_new, ExplicitNull)):
			raise ValueError(f"'soa_data_hostmaster' of incorrect type. Expected str, got {type(soa_data_hostmaster_new)}")
		if dnssec_ksk_rrs_are_published_new is not None and not (isinstance(dnssec_ksk_rrs_are_published_new, bool)):
			raise ValueError(f"'dnssec_ksk_rrs_are_published' of incorrect type. Expected bool, got {type(dnssec_ksk_rrs_are_published_new)}")
		if not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(nsec3_salt_new=nsec3_salt_new, description_new=description_new, ns_set_name_new=ns_set_name_new, nsec3_itcount_new=nsec3_itcount_new, reset_rr_ttls_new=reset_rr_ttls_new, dnssec_do_sign_new=dnssec_do_sign_new, soa_data_retry_new=soa_data_retry_new, nsec3_hash_algo_new=nsec3_hash_algo_new, soa_data_expire_new=soa_data_expire_new, soa_data_serial_new=soa_data_serial_new, soa_data_minimum_new=soa_data_minimum_new, soa_data_refresh_new=soa_data_refresh_new, dnssec_do_enforce_new=dnssec_do_enforce_new, dflt_ttl_rrt_dbext_new=dflt_ttl_rrt_dbext_new, dflt_ttl_rrt_dbint_new=dflt_ttl_rrt_dbint_new, soa_data_hostmaster_new=soa_data_hostmaster_new, dnssec_ksk_rrs_are_published_new=dnssec_ksk_rrs_are_published_new, fqdn_old=fqdn_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Fqdn(APIObject):
	gpk: str
	type: str
	zone: str
	label: str
	value: str
	is_own: bool
	label_idna: str
	parent_gfk: str
	tree_level: int
	value_idna: str
	description: str
	parent_value: str
	type_is_dhcp: bool
	type_is_host: bool
	type_rad_type: int
	type_is_wildcard: bool
	hierarchy_gfk_list: list
	type_is_nonterminal: bool
	is_empty_nonterminal: bool
	rr_chain_target_is_own: bool
	rr_chain_target_subnet_gfk_list: list

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if not isinstance(self.zone, str):
			raise ValueError(f"'zone' of incorrect type. Expected str, got {type(self.zone)}")
		if self.label is not None and not isinstance(self.label, str):
			raise ValueError(f"'label' of incorrect type. Expected str, got {type(self.label)}")
		if not isinstance(self.value, str):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(self.value)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if self.label_idna is not None and not isinstance(self.label_idna, str):
			raise ValueError(f"'label_idna' of incorrect type. Expected str, got {type(self.label_idna)}")
		if self.parent_gfk is not None and not isinstance(self.parent_gfk, str):
			raise ValueError(f"'parent_gfk' of incorrect type. Expected str, got {type(self.parent_gfk)}")
		if not isinstance(self.tree_level, int):
			raise ValueError(f"'tree_level' of incorrect type. Expected int, got {type(self.tree_level)}")
		if not isinstance(self.value_idna, str):
			raise ValueError(f"'value_idna' of incorrect type. Expected str, got {type(self.value_idna)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if self.parent_value is not None and not isinstance(self.parent_value, str):
			raise ValueError(f"'parent_value' of incorrect type. Expected str, got {type(self.parent_value)}")
		if not isinstance(self.type_is_dhcp, bool):
			raise ValueError(f"'type_is_dhcp' of incorrect type. Expected bool, got {type(self.type_is_dhcp)}")
		if not isinstance(self.type_is_host, bool):
			raise ValueError(f"'type_is_host' of incorrect type. Expected bool, got {type(self.type_is_host)}")
		if not isinstance(self.type_rad_type, int):
			raise ValueError(f"'type_rad_type' of incorrect type. Expected int, got {type(self.type_rad_type)}")
		if not isinstance(self.type_is_wildcard, bool):
			raise ValueError(f"'type_is_wildcard' of incorrect type. Expected bool, got {type(self.type_is_wildcard)}")
		if not isinstance(self.hierarchy_gfk_list, list):
			raise ValueError(f"'hierarchy_gfk_list' of incorrect type. Expected list, got {type(self.hierarchy_gfk_list)}")
		if not isinstance(self.type_is_nonterminal, bool):
			raise ValueError(f"'type_is_nonterminal' of incorrect type. Expected bool, got {type(self.type_is_nonterminal)}")
		if not isinstance(self.is_empty_nonterminal, bool):
			raise ValueError(f"'is_empty_nonterminal' of incorrect type. Expected bool, got {type(self.is_empty_nonterminal)}")
		if not isinstance(self.rr_chain_target_is_own, bool):
			raise ValueError(f"'rr_chain_target_is_own' of incorrect type. Expected bool, got {type(self.rr_chain_target_is_own)}")
		if self.rr_chain_target_subnet_gfk_list is not None and not isinstance(self.rr_chain_target_subnet_gfk_list, list):
			raise ValueError(f"'rr_chain_target_subnet_gfk_list' of incorrect type. Expected list, got {type(self.rr_chain_target_subnet_gfk_list)}")

	@staticmethod
	def create_ta(type_new: str, value_new: str, description_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if not (isinstance(value_new, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		return {'name': 'dns.fqdn.create', 'new': _denullify_dict({'type': type_new, 'value': value_new, 'description': description_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, type_new: str, value_new: str, description_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if not (isinstance(value_new, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(type_new=type_new, value_new=value_new, description_new=description_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(value_old: str, try_del_parent_old: bool = True, force_del_ref_records_old: bool = False) -> dict:
		if not (isinstance(value_old, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")
		if try_del_parent_old is not None and not (isinstance(try_del_parent_old, bool)):
			raise ValueError(f"'try_del_parent' of incorrect type. Expected bool, got {type(try_del_parent_old)}")
		if force_del_ref_records_old is not None and not (isinstance(force_del_ref_records_old, bool)):
			raise ValueError(f"'force_del_ref_records' of incorrect type. Expected bool, got {type(force_del_ref_records_old)}")

		return {'name': 'dns.fqdn.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'value': value_old, 'try_del_parent': try_del_parent_old, 'force_del_ref_records': force_del_ref_records_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, value_old: str, try_del_parent_old: bool = True, force_del_ref_records_old: bool = False) -> list:
		if not (isinstance(value_old, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")
		if try_del_parent_old is not None and not (isinstance(try_del_parent_old, bool)):
			raise ValueError(f"'try_del_parent' of incorrect type. Expected bool, got {type(try_del_parent_old)}")
		if force_del_ref_records_old is not None and not (isinstance(force_del_ref_records_old, bool)):
			raise ValueError(f"'force_del_ref_records' of incorrect type. Expected bool, got {type(force_del_ref_records_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(value_old=value_old, try_del_parent_old=try_del_parent_old, force_del_ref_records_old=force_del_ref_records_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(type_old: str = None, zone_old: str = None, is_own_old: bool = None, gpk_list_old: list = None, label_list_old: list = None, tree_level_old: int = None, value_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, label_regexp_old: str = None, parent_value_old: str = None, value_regexp_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, is_empty_nonterminal_old: bool = None, rr_chain_target_is_own_old: bool = None, rr_chain_target_subnet_gfk_list_old: list = None) -> dict:
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if zone_old is not None and not (isinstance(zone_old, str)):
			raise ValueError(f"'zone' of incorrect type. Expected str, got {type(zone_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if label_list_old is not None and not (isinstance(label_list_old, list)):
			raise ValueError(f"'label_list' of incorrect type. Expected list, got {type(label_list_old)}")
		if tree_level_old is not None and not (isinstance(tree_level_old, int)):
			raise ValueError(f"'tree_level' of incorrect type. Expected int, got {type(tree_level_old)}")
		if value_list_old is not None and not (isinstance(value_list_old, list)):
			raise ValueError(f"'value_list' of incorrect type. Expected list, got {type(value_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if label_regexp_old is not None and not (isinstance(label_regexp_old, str)):
			raise ValueError(f"'label_regexp' of incorrect type. Expected str, got {type(label_regexp_old)}")
		if parent_value_old is not None and not (isinstance(parent_value_old, str)):
			raise ValueError(f"'parent_value' of incorrect type. Expected str, got {type(parent_value_old)}")
		if value_regexp_old is not None and not (isinstance(value_regexp_old, str)):
			raise ValueError(f"'value_regexp' of incorrect type. Expected str, got {type(value_regexp_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if is_empty_nonterminal_old is not None and not (isinstance(is_empty_nonterminal_old, bool)):
			raise ValueError(f"'is_empty_nonterminal' of incorrect type. Expected bool, got {type(is_empty_nonterminal_old)}")
		if rr_chain_target_is_own_old is not None and not (isinstance(rr_chain_target_is_own_old, bool)):
			raise ValueError(f"'rr_chain_target_is_own' of incorrect type. Expected bool, got {type(rr_chain_target_is_own_old)}")
		if rr_chain_target_subnet_gfk_list_old is not None and not (isinstance(rr_chain_target_subnet_gfk_list_old, list) or isinstance(rr_chain_target_subnet_gfk_list_old, ExplicitNull)):
			raise ValueError(f"'rr_chain_target_subnet_gfk_list' of incorrect type. Expected list, got {type(rr_chain_target_subnet_gfk_list_old)}")

		return {'name': 'dns.fqdn.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'type': type_old, 'zone': zone_old, 'is_own': is_own_old, 'gpk_list': gpk_list_old, 'label_list': label_list_old, 'tree_level': tree_level_old, 'value_list': value_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'label_regexp': label_regexp_old, 'parent_value': parent_value_old, 'value_regexp': value_regexp_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'is_empty_nonterminal': is_empty_nonterminal_old, 'rr_chain_target_is_own': rr_chain_target_is_own_old, 'rr_chain_target_subnet_gfk_list': rr_chain_target_subnet_gfk_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, type_old: str = None, zone_old: str = None, is_own_old: bool = None, gpk_list_old: list = None, label_list_old: list = None, tree_level_old: int = None, value_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, label_regexp_old: str = None, parent_value_old: str = None, value_regexp_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, is_empty_nonterminal_old: bool = None, rr_chain_target_is_own_old: bool = None, rr_chain_target_subnet_gfk_list_old: list = None) -> list:
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if zone_old is not None and not (isinstance(zone_old, str)):
			raise ValueError(f"'zone' of incorrect type. Expected str, got {type(zone_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if label_list_old is not None and not (isinstance(label_list_old, list)):
			raise ValueError(f"'label_list' of incorrect type. Expected list, got {type(label_list_old)}")
		if tree_level_old is not None and not (isinstance(tree_level_old, int)):
			raise ValueError(f"'tree_level' of incorrect type. Expected int, got {type(tree_level_old)}")
		if value_list_old is not None and not (isinstance(value_list_old, list)):
			raise ValueError(f"'value_list' of incorrect type. Expected list, got {type(value_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if label_regexp_old is not None and not (isinstance(label_regexp_old, str)):
			raise ValueError(f"'label_regexp' of incorrect type. Expected str, got {type(label_regexp_old)}")
		if parent_value_old is not None and not (isinstance(parent_value_old, str)):
			raise ValueError(f"'parent_value' of incorrect type. Expected str, got {type(parent_value_old)}")
		if value_regexp_old is not None and not (isinstance(value_regexp_old, str)):
			raise ValueError(f"'value_regexp' of incorrect type. Expected str, got {type(value_regexp_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if is_empty_nonterminal_old is not None and not (isinstance(is_empty_nonterminal_old, bool)):
			raise ValueError(f"'is_empty_nonterminal' of incorrect type. Expected bool, got {type(is_empty_nonterminal_old)}")
		if rr_chain_target_is_own_old is not None and not (isinstance(rr_chain_target_is_own_old, bool)):
			raise ValueError(f"'rr_chain_target_is_own' of incorrect type. Expected bool, got {type(rr_chain_target_is_own_old)}")
		if rr_chain_target_subnet_gfk_list_old is not None and not (isinstance(rr_chain_target_subnet_gfk_list_old, list) or isinstance(rr_chain_target_subnet_gfk_list_old, ExplicitNull)):
			raise ValueError(f"'rr_chain_target_subnet_gfk_list' of incorrect type. Expected list, got {type(rr_chain_target_subnet_gfk_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(type_old=type_old, zone_old=zone_old, is_own_old=is_own_old, gpk_list_old=gpk_list_old, label_list_old=label_list_old, tree_level_old=tree_level_old, value_list_old=value_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, label_regexp_old=label_regexp_old, parent_value_old=parent_value_old, value_regexp_old=value_regexp_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, is_empty_nonterminal_old=is_empty_nonterminal_old, rr_chain_target_is_own_old=rr_chain_target_is_own_old, rr_chain_target_subnet_gfk_list_old=rr_chain_target_subnet_gfk_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(value_old: str, type_new: str = None, value_new: str = None, description_new: Union[str, ExplicitNull] = None, try_del_parent_old: bool = True) -> dict:
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if value_new is not None and not (isinstance(value_new, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(value_old, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")
		if try_del_parent_old is not None and not (isinstance(try_del_parent_old, bool)):
			raise ValueError(f"'try_del_parent' of incorrect type. Expected bool, got {type(try_del_parent_old)}")

		return {'name': 'dns.fqdn.update', 'new': _denullify_dict({'type': type_new, 'value': value_new, 'description': description_new}), 'old': _denullify_dict({'value': value_old, 'try_del_parent': try_del_parent_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, value_old: str, type_new: str = None, value_new: str = None, description_new: Union[str, ExplicitNull] = None, try_del_parent_old: bool = True) -> list:
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if value_new is not None and not (isinstance(value_new, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(value_old, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")
		if try_del_parent_old is not None and not (isinstance(try_del_parent_old, bool)):
			raise ValueError(f"'try_del_parent' of incorrect type. Expected bool, got {type(try_del_parent_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(type_new=type_new, value_new=value_new, description_new=description_new, value_old=value_old, try_del_parent_old=try_del_parent_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class IpAddr(APIObject):
	gpk: str
	cidr: str
	type: str
	value: str
	is_own: bool
	is_dhcp: bool
	is_reserved: bool
	is_rr_target: bool
	value_with_prefixlen: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.cidr, str):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(self.cidr)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if not isinstance(self.value, str):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(self.value)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.is_dhcp, bool):
			raise ValueError(f"'is_dhcp' of incorrect type. Expected bool, got {type(self.is_dhcp)}")
		if not isinstance(self.is_reserved, bool):
			raise ValueError(f"'is_reserved' of incorrect type. Expected bool, got {type(self.is_reserved)}")
		if not isinstance(self.is_rr_target, bool):
			raise ValueError(f"'is_rr_target' of incorrect type. Expected bool, got {type(self.is_rr_target)}")
		if not isinstance(self.value_with_prefixlen, str):
			raise ValueError(f"'value_with_prefixlen' of incorrect type. Expected str, got {type(self.value_with_prefixlen)}")

	@staticmethod
	def bulk_update_ta(cidr_new: str, cidr_old: str) -> dict:
		if not (isinstance(cidr_new, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_new)}")
		if not (isinstance(cidr_old, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_old)}")

		return {'name': 'dns.ip_addr.bulk_update', 'new': _denullify_dict({'cidr': cidr_new}), 'old': _denullify_dict({'cidr': cidr_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_update(cls, api_session: APISession, cidr_new: str, cidr_old: str) -> list:
		if not (isinstance(cidr_new, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_new)}")
		if not (isinstance(cidr_old, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_update_ta(cidr_new=cidr_new, cidr_old=cidr_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def create_ta(value_new: str, is_dhcp_new: bool = False, is_reserved_new: bool = False) -> dict:
		if not (isinstance(value_new, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_new)}")
		if is_dhcp_new is not None and not (isinstance(is_dhcp_new, bool)):
			raise ValueError(f"'is_dhcp' of incorrect type. Expected bool, got {type(is_dhcp_new)}")
		if is_reserved_new is not None and not (isinstance(is_reserved_new, bool)):
			raise ValueError(f"'is_reserved' of incorrect type. Expected bool, got {type(is_reserved_new)}")

		return {'name': 'dns.ip_addr.create', 'new': _denullify_dict({'value': value_new, 'is_dhcp': is_dhcp_new, 'is_reserved': is_reserved_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, value_new: str, is_dhcp_new: bool = False, is_reserved_new: bool = False) -> list:
		if not (isinstance(value_new, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_new)}")
		if is_dhcp_new is not None and not (isinstance(is_dhcp_new, bool)):
			raise ValueError(f"'is_dhcp' of incorrect type. Expected bool, got {type(is_dhcp_new)}")
		if is_reserved_new is not None and not (isinstance(is_reserved_new, bool)):
			raise ValueError(f"'is_reserved' of incorrect type. Expected bool, got {type(is_reserved_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(value_new=value_new, is_dhcp_new=is_dhcp_new, is_reserved_new=is_reserved_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(value_old: str) -> dict:
		if not (isinstance(value_old, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")

		return {'name': 'dns.ip_addr.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'value': value_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, value_old: str) -> list:
		if not (isinstance(value_old, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(value_old=value_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(cidr_old: str = None, type_old: str = None, is_own_old: bool = None, is_dhcp_old: bool = None, gpk_list_old: list = None, value_list_old: list = None, fetch_limit_old: int = None, is_reserved_old: bool = None, fetch_offset_old: int = None, is_rr_target_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if cidr_old is not None and not (isinstance(cidr_old, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_dhcp_old is not None and not (isinstance(is_dhcp_old, bool)):
			raise ValueError(f"'is_dhcp' of incorrect type. Expected bool, got {type(is_dhcp_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if value_list_old is not None and not (isinstance(value_list_old, list)):
			raise ValueError(f"'value_list' of incorrect type. Expected list, got {type(value_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_reserved_old is not None and not (isinstance(is_reserved_old, bool)):
			raise ValueError(f"'is_reserved' of incorrect type. Expected bool, got {type(is_reserved_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_rr_target_old is not None and not (isinstance(is_rr_target_old, bool)):
			raise ValueError(f"'is_rr_target' of incorrect type. Expected bool, got {type(is_rr_target_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dns.ip_addr.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'cidr': cidr_old, 'type': type_old, 'is_own': is_own_old, 'is_dhcp': is_dhcp_old, 'gpk_list': gpk_list_old, 'value_list': value_list_old, 'fetch_limit': fetch_limit_old, 'is_reserved': is_reserved_old, 'fetch_offset': fetch_offset_old, 'is_rr_target': is_rr_target_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, cidr_old: str = None, type_old: str = None, is_own_old: bool = None, is_dhcp_old: bool = None, gpk_list_old: list = None, value_list_old: list = None, fetch_limit_old: int = None, is_reserved_old: bool = None, fetch_offset_old: int = None, is_rr_target_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if cidr_old is not None and not (isinstance(cidr_old, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_dhcp_old is not None and not (isinstance(is_dhcp_old, bool)):
			raise ValueError(f"'is_dhcp' of incorrect type. Expected bool, got {type(is_dhcp_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if value_list_old is not None and not (isinstance(value_list_old, list)):
			raise ValueError(f"'value_list' of incorrect type. Expected list, got {type(value_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_reserved_old is not None and not (isinstance(is_reserved_old, bool)):
			raise ValueError(f"'is_reserved' of incorrect type. Expected bool, got {type(is_reserved_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_rr_target_old is not None and not (isinstance(is_rr_target_old, bool)):
			raise ValueError(f"'is_rr_target' of incorrect type. Expected bool, got {type(is_rr_target_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(cidr_old=cidr_old, type_old=type_old, is_own_old=is_own_old, is_dhcp_old=is_dhcp_old, gpk_list_old=gpk_list_old, value_list_old=value_list_old, fetch_limit_old=fetch_limit_old, is_reserved_old=is_reserved_old, fetch_offset_old=fetch_offset_old, is_rr_target_old=is_rr_target_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(is_dhcp_new: bool = None, is_reserved_new: bool = None, value_old: str = None) -> dict:
		if is_dhcp_new is not None and not (isinstance(is_dhcp_new, bool)):
			raise ValueError(f"'is_dhcp' of incorrect type. Expected bool, got {type(is_dhcp_new)}")
		if is_reserved_new is not None and not (isinstance(is_reserved_new, bool)):
			raise ValueError(f"'is_reserved' of incorrect type. Expected bool, got {type(is_reserved_new)}")
		if value_old is not None and not (isinstance(value_old, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")

		return {'name': 'dns.ip_addr.update', 'new': _denullify_dict({'is_dhcp': is_dhcp_new, 'is_reserved': is_reserved_new}), 'old': _denullify_dict({'value': value_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, is_dhcp_new: bool = None, is_reserved_new: bool = None, value_old: str = None) -> list:
		if is_dhcp_new is not None and not (isinstance(is_dhcp_new, bool)):
			raise ValueError(f"'is_dhcp' of incorrect type. Expected bool, got {type(is_dhcp_new)}")
		if is_reserved_new is not None and not (isinstance(is_reserved_new, bool)):
			raise ValueError(f"'is_reserved' of incorrect type. Expected bool, got {type(is_reserved_new)}")
		if value_old is not None and not (isinstance(value_old, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(is_dhcp_new=is_dhcp_new, is_reserved_new=is_reserved_new, value_old=value_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Record(APIObject):
	gpk: str
	ttl: int
	data: str
	fqdn: str
	type: str
	zone: str
	is_own: bool
	is_auth: bool
	fqdn_type: str
	host_is_nws: bool
	target_fqdn: str
	target_ipaddr: str
	ttl_reset_date: str
	ttl_reset_days: int
	fqdn_description: str
	target_fqdn_type: str
	ttl_zone_default: int
	target_ipaddr_type: str
	target_is_singleton: bool
	target_is_reverse_unique: bool
	rr_chain_target_subnet_gfk_list: list

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if self.ttl is not None and not isinstance(self.ttl, int):
			raise ValueError(f"'ttl' of incorrect type. Expected int, got {type(self.ttl)}")
		if self.data is not None and not isinstance(self.data, str):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(self.data)}")
		if not isinstance(self.fqdn, str):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(self.fqdn)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if not isinstance(self.zone, str):
			raise ValueError(f"'zone' of incorrect type. Expected str, got {type(self.zone)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.is_auth, bool):
			raise ValueError(f"'is_auth' of incorrect type. Expected bool, got {type(self.is_auth)}")
		if not isinstance(self.fqdn_type, str):
			raise ValueError(f"'fqdn_type' of incorrect type. Expected str, got {type(self.fqdn_type)}")
		if not isinstance(self.host_is_nws, bool):
			raise ValueError(f"'host_is_nws' of incorrect type. Expected bool, got {type(self.host_is_nws)}")
		if self.target_fqdn is not None and not isinstance(self.target_fqdn, str):
			raise ValueError(f"'target_fqdn' of incorrect type. Expected str, got {type(self.target_fqdn)}")
		if self.target_ipaddr is not None and not isinstance(self.target_ipaddr, str):
			raise ValueError(f"'target_ipaddr' of incorrect type. Expected str, got {type(self.target_ipaddr)}")
		if self.ttl_reset_date is not None and not isinstance(self.ttl_reset_date, str):
			raise ValueError(f"'ttl_reset_date' of incorrect type. Expected str, got {type(self.ttl_reset_date)}")
		if self.ttl_reset_days is not None and not isinstance(self.ttl_reset_days, int):
			raise ValueError(f"'ttl_reset_days' of incorrect type. Expected int, got {type(self.ttl_reset_days)}")
		if self.fqdn_description is not None and not isinstance(self.fqdn_description, str):
			raise ValueError(f"'fqdn_description' of incorrect type. Expected str, got {type(self.fqdn_description)}")
		if self.target_fqdn_type is not None and not isinstance(self.target_fqdn_type, str):
			raise ValueError(f"'target_fqdn_type' of incorrect type. Expected str, got {type(self.target_fqdn_type)}")
		if not isinstance(self.ttl_zone_default, int):
			raise ValueError(f"'ttl_zone_default' of incorrect type. Expected int, got {type(self.ttl_zone_default)}")
		if self.target_ipaddr_type is not None and not isinstance(self.target_ipaddr_type, str):
			raise ValueError(f"'target_ipaddr_type' of incorrect type. Expected str, got {type(self.target_ipaddr_type)}")
		if not isinstance(self.target_is_singleton, bool):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(self.target_is_singleton)}")
		if not isinstance(self.target_is_reverse_unique, bool):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(self.target_is_reverse_unique)}")
		if self.rr_chain_target_subnet_gfk_list is not None and not isinstance(self.rr_chain_target_subnet_gfk_list, list):
			raise ValueError(f"'rr_chain_target_subnet_gfk_list' of incorrect type. Expected list, got {type(self.rr_chain_target_subnet_gfk_list)}")

	@staticmethod
	def create_ta(fqdn_new: str, type_new: str, ttl_new: Union[int, ExplicitNull] = None, data_new: Union[str, ExplicitNull] = None, ttl_reset_days_new: int = None, target_is_singleton_new: bool = None, target_is_reverse_unique_new: bool = None) -> dict:
		if ttl_new is not None and not (isinstance(ttl_new, int) or isinstance(ttl_new, ExplicitNull)):
			raise ValueError(f"'ttl' of incorrect type. Expected int, got {type(ttl_new)}")
		if data_new is not None and not (isinstance(data_new, str) or isinstance(data_new, ExplicitNull)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if ttl_reset_days_new is not None and not (isinstance(ttl_reset_days_new, int)):
			raise ValueError(f"'ttl_reset_days' of incorrect type. Expected int, got {type(ttl_reset_days_new)}")
		if target_is_singleton_new is not None and not (isinstance(target_is_singleton_new, bool)):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(target_is_singleton_new)}")
		if target_is_reverse_unique_new is not None and not (isinstance(target_is_reverse_unique_new, bool)):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(target_is_reverse_unique_new)}")

		return {'name': 'dns.record.create', 'new': _denullify_dict({'ttl': ttl_new, 'data': data_new, 'fqdn': fqdn_new, 'type': type_new, 'ttl_reset_days': ttl_reset_days_new, 'target_is_singleton': target_is_singleton_new, 'target_is_reverse_unique': target_is_reverse_unique_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, fqdn_new: str, type_new: str, ttl_new: Union[int, ExplicitNull] = None, data_new: Union[str, ExplicitNull] = None, ttl_reset_days_new: int = None, target_is_singleton_new: bool = None, target_is_reverse_unique_new: bool = None) -> list:
		if ttl_new is not None and not (isinstance(ttl_new, int) or isinstance(ttl_new, ExplicitNull)):
			raise ValueError(f"'ttl' of incorrect type. Expected int, got {type(ttl_new)}")
		if data_new is not None and not (isinstance(data_new, str) or isinstance(data_new, ExplicitNull)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if ttl_reset_days_new is not None and not (isinstance(ttl_reset_days_new, int)):
			raise ValueError(f"'ttl_reset_days' of incorrect type. Expected int, got {type(ttl_reset_days_new)}")
		if target_is_singleton_new is not None and not (isinstance(target_is_singleton_new, bool)):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(target_is_singleton_new)}")
		if target_is_reverse_unique_new is not None and not (isinstance(target_is_reverse_unique_new, bool)):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(target_is_reverse_unique_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(ttl_new=ttl_new, data_new=data_new, fqdn_new=fqdn_new, type_new=type_new, ttl_reset_days_new=ttl_reset_days_new, target_is_singleton_new=target_is_singleton_new, target_is_reverse_unique_new=target_is_reverse_unique_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(data_old: str, fqdn_old: str, type_old: str, try_del_fqdn_old: bool = True, force_del_ref_records_old: bool = False) -> dict:
		if not (isinstance(data_old, str) or isinstance(data_old, ExplicitNull)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_old)}")
		if not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")
		if not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if try_del_fqdn_old is not None and not (isinstance(try_del_fqdn_old, bool)):
			raise ValueError(f"'try_del_fqdn' of incorrect type. Expected bool, got {type(try_del_fqdn_old)}")
		if force_del_ref_records_old is not None and not (isinstance(force_del_ref_records_old, bool)):
			raise ValueError(f"'force_del_ref_records' of incorrect type. Expected bool, got {type(force_del_ref_records_old)}")

		return {'name': 'dns.record.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'data': data_old, 'fqdn': fqdn_old, 'type': type_old, 'try_del_fqdn': try_del_fqdn_old, 'force_del_ref_records': force_del_ref_records_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, data_old: str, fqdn_old: str, type_old: str, try_del_fqdn_old: bool = True, force_del_ref_records_old: bool = False) -> list:
		if not (isinstance(data_old, str) or isinstance(data_old, ExplicitNull)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_old)}")
		if not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")
		if not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if try_del_fqdn_old is not None and not (isinstance(try_del_fqdn_old, bool)):
			raise ValueError(f"'try_del_fqdn' of incorrect type. Expected bool, got {type(try_del_fqdn_old)}")
		if force_del_ref_records_old is not None and not (isinstance(force_del_ref_records_old, bool)):
			raise ValueError(f"'force_del_ref_records' of incorrect type. Expected bool, got {type(force_del_ref_records_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(data_old=data_old, fqdn_old=fqdn_old, type_old=type_old, try_del_fqdn_old=try_del_fqdn_old, force_del_ref_records_old=force_del_ref_records_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def imp_ta(fqdn_new: str, import_data_new: dict, fqdn_type_new: str = None, strict_mode_new: bool = True, fqdn_description_new: Union[str, ExplicitNull] = None, fqdn_old: str = None) -> dict:
		if not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if fqdn_type_new is not None and not (isinstance(fqdn_type_new, str)):
			raise ValueError(f"'fqdn_type' of incorrect type. Expected str, got {type(fqdn_type_new)}")
		if not (isinstance(import_data_new, dict)):
			raise ValueError(f"'import_data' of incorrect type. Expected dict, got {type(import_data_new)}")
		if strict_mode_new is not None and not (isinstance(strict_mode_new, bool)):
			raise ValueError(f"'strict_mode' of incorrect type. Expected bool, got {type(strict_mode_new)}")
		if fqdn_description_new is not None and not (isinstance(fqdn_description_new, str) or isinstance(fqdn_description_new, ExplicitNull)):
			raise ValueError(f"'fqdn_description' of incorrect type. Expected str, got {type(fqdn_description_new)}")
		if fqdn_old is not None and not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")

		return {'name': 'dns.record.imp', 'new': _denullify_dict({'fqdn': fqdn_new, 'fqdn_type': fqdn_type_new, 'import_data': import_data_new, 'strict_mode': strict_mode_new, 'fqdn_description': fqdn_description_new}), 'old': _denullify_dict({'fqdn': fqdn_old})}

	# TODO: Consider is_returning
	@classmethod
	def imp(cls, api_session: APISession, fqdn_new: str, import_data_new: dict, fqdn_type_new: str = None, strict_mode_new: bool = True, fqdn_description_new: Union[str, ExplicitNull] = None, fqdn_old: str = None) -> list:
		if not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if fqdn_type_new is not None and not (isinstance(fqdn_type_new, str)):
			raise ValueError(f"'fqdn_type' of incorrect type. Expected str, got {type(fqdn_type_new)}")
		if not (isinstance(import_data_new, dict)):
			raise ValueError(f"'import_data' of incorrect type. Expected dict, got {type(import_data_new)}")
		if strict_mode_new is not None and not (isinstance(strict_mode_new, bool)):
			raise ValueError(f"'strict_mode' of incorrect type. Expected bool, got {type(strict_mode_new)}")
		if fqdn_description_new is not None and not (isinstance(fqdn_description_new, str) or isinstance(fqdn_description_new, ExplicitNull)):
			raise ValueError(f"'fqdn_description' of incorrect type. Expected str, got {type(fqdn_description_new)}")
		if fqdn_old is not None and not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.imp_ta(fqdn_new=fqdn_new, fqdn_type_new=fqdn_type_new, import_data_new=import_data_new, strict_mode_new=strict_mode_new, fqdn_description_new=fqdn_description_new, fqdn_old=fqdn_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(zone_old: str = None, is_own_old: bool = None, is_auth_old: bool = None, gpk_list_old: list = None, data_list_old: list = None, do_nn_ttl_old: bool = False, fqdn_list_old: list = None, type_list_old: list = None, data_regexp_old: str = None, fetch_limit_old: int = None, fqdn_regexp_old: str = None, fetch_offset_old: int = None, fqdn_label_list_old: list = None, fqdn_label_regexp_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, target_is_singleton_old: bool = None, target_is_reverse_unique_old: bool = None, rr_chain_target_subnet_gfk_list_old: list = None) -> dict:
		if zone_old is not None and not (isinstance(zone_old, str)):
			raise ValueError(f"'zone' of incorrect type. Expected str, got {type(zone_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_auth_old is not None and not (isinstance(is_auth_old, bool)):
			raise ValueError(f"'is_auth' of incorrect type. Expected bool, got {type(is_auth_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if data_list_old is not None and not (isinstance(data_list_old, list)):
			raise ValueError(f"'data_list' of incorrect type. Expected list, got {type(data_list_old)}")
		if do_nn_ttl_old is not None and not (isinstance(do_nn_ttl_old, bool)):
			raise ValueError(f"'do_nn_ttl' of incorrect type. Expected bool, got {type(do_nn_ttl_old)}")
		if fqdn_list_old is not None and not (isinstance(fqdn_list_old, list)):
			raise ValueError(f"'fqdn_list' of incorrect type. Expected list, got {type(fqdn_list_old)}")
		if type_list_old is not None and not (isinstance(type_list_old, list)):
			raise ValueError(f"'type_list' of incorrect type. Expected list, got {type(type_list_old)}")
		if data_regexp_old is not None and not (isinstance(data_regexp_old, str)):
			raise ValueError(f"'data_regexp' of incorrect type. Expected str, got {type(data_regexp_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fqdn_regexp_old is not None and not (isinstance(fqdn_regexp_old, str)):
			raise ValueError(f"'fqdn_regexp' of incorrect type. Expected str, got {type(fqdn_regexp_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if fqdn_label_list_old is not None and not (isinstance(fqdn_label_list_old, list)):
			raise ValueError(f"'fqdn_label_list' of incorrect type. Expected list, got {type(fqdn_label_list_old)}")
		if fqdn_label_regexp_old is not None and not (isinstance(fqdn_label_regexp_old, str)):
			raise ValueError(f"'fqdn_label_regexp' of incorrect type. Expected str, got {type(fqdn_label_regexp_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if target_is_singleton_old is not None and not (isinstance(target_is_singleton_old, bool)):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(target_is_singleton_old)}")
		if target_is_reverse_unique_old is not None and not (isinstance(target_is_reverse_unique_old, bool)):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(target_is_reverse_unique_old)}")
		if rr_chain_target_subnet_gfk_list_old is not None and not (isinstance(rr_chain_target_subnet_gfk_list_old, list) or isinstance(rr_chain_target_subnet_gfk_list_old, ExplicitNull)):
			raise ValueError(f"'rr_chain_target_subnet_gfk_list' of incorrect type. Expected list, got {type(rr_chain_target_subnet_gfk_list_old)}")

		return {'name': 'dns.record.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'zone': zone_old, 'is_own': is_own_old, 'is_auth': is_auth_old, 'gpk_list': gpk_list_old, 'data_list': data_list_old, 'do_nn_ttl': do_nn_ttl_old, 'fqdn_list': fqdn_list_old, 'type_list': type_list_old, 'data_regexp': data_regexp_old, 'fetch_limit': fetch_limit_old, 'fqdn_regexp': fqdn_regexp_old, 'fetch_offset': fetch_offset_old, 'fqdn_label_list': fqdn_label_list_old, 'fqdn_label_regexp': fqdn_label_regexp_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'target_is_singleton': target_is_singleton_old, 'target_is_reverse_unique': target_is_reverse_unique_old, 'rr_chain_target_subnet_gfk_list': rr_chain_target_subnet_gfk_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, zone_old: str = None, is_own_old: bool = None, is_auth_old: bool = None, gpk_list_old: list = None, data_list_old: list = None, do_nn_ttl_old: bool = False, fqdn_list_old: list = None, type_list_old: list = None, data_regexp_old: str = None, fetch_limit_old: int = None, fqdn_regexp_old: str = None, fetch_offset_old: int = None, fqdn_label_list_old: list = None, fqdn_label_regexp_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, target_is_singleton_old: bool = None, target_is_reverse_unique_old: bool = None, rr_chain_target_subnet_gfk_list_old: list = None) -> list:
		if zone_old is not None and not (isinstance(zone_old, str)):
			raise ValueError(f"'zone' of incorrect type. Expected str, got {type(zone_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_auth_old is not None and not (isinstance(is_auth_old, bool)):
			raise ValueError(f"'is_auth' of incorrect type. Expected bool, got {type(is_auth_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if data_list_old is not None and not (isinstance(data_list_old, list)):
			raise ValueError(f"'data_list' of incorrect type. Expected list, got {type(data_list_old)}")
		if do_nn_ttl_old is not None and not (isinstance(do_nn_ttl_old, bool)):
			raise ValueError(f"'do_nn_ttl' of incorrect type. Expected bool, got {type(do_nn_ttl_old)}")
		if fqdn_list_old is not None and not (isinstance(fqdn_list_old, list)):
			raise ValueError(f"'fqdn_list' of incorrect type. Expected list, got {type(fqdn_list_old)}")
		if type_list_old is not None and not (isinstance(type_list_old, list)):
			raise ValueError(f"'type_list' of incorrect type. Expected list, got {type(type_list_old)}")
		if data_regexp_old is not None and not (isinstance(data_regexp_old, str)):
			raise ValueError(f"'data_regexp' of incorrect type. Expected str, got {type(data_regexp_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fqdn_regexp_old is not None and not (isinstance(fqdn_regexp_old, str)):
			raise ValueError(f"'fqdn_regexp' of incorrect type. Expected str, got {type(fqdn_regexp_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if fqdn_label_list_old is not None and not (isinstance(fqdn_label_list_old, list)):
			raise ValueError(f"'fqdn_label_list' of incorrect type. Expected list, got {type(fqdn_label_list_old)}")
		if fqdn_label_regexp_old is not None and not (isinstance(fqdn_label_regexp_old, str)):
			raise ValueError(f"'fqdn_label_regexp' of incorrect type. Expected str, got {type(fqdn_label_regexp_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if target_is_singleton_old is not None and not (isinstance(target_is_singleton_old, bool)):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(target_is_singleton_old)}")
		if target_is_reverse_unique_old is not None and not (isinstance(target_is_reverse_unique_old, bool)):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(target_is_reverse_unique_old)}")
		if rr_chain_target_subnet_gfk_list_old is not None and not (isinstance(rr_chain_target_subnet_gfk_list_old, list) or isinstance(rr_chain_target_subnet_gfk_list_old, ExplicitNull)):
			raise ValueError(f"'rr_chain_target_subnet_gfk_list' of incorrect type. Expected list, got {type(rr_chain_target_subnet_gfk_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(zone_old=zone_old, is_own_old=is_own_old, is_auth_old=is_auth_old, gpk_list_old=gpk_list_old, data_list_old=data_list_old, do_nn_ttl_old=do_nn_ttl_old, fqdn_list_old=fqdn_list_old, type_list_old=type_list_old, data_regexp_old=data_regexp_old, fetch_limit_old=fetch_limit_old, fqdn_regexp_old=fqdn_regexp_old, fetch_offset_old=fetch_offset_old, fqdn_label_list_old=fqdn_label_list_old, fqdn_label_regexp_old=fqdn_label_regexp_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, target_is_singleton_old=target_is_singleton_old, target_is_reverse_unique_old=target_is_reverse_unique_old, rr_chain_target_subnet_gfk_list_old=rr_chain_target_subnet_gfk_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(data_old: str, fqdn_old: str, type_old: str, ttl_new: Union[int, ExplicitNull] = None, data_new: Union[str, ExplicitNull] = None, fqdn_new: str = None, type_new: str = None, ttl_reset_days_new: int = None, target_is_singleton_new: bool = None, target_is_reverse_unique_new: bool = None, try_del_fqdn_old: bool = True) -> dict:
		if ttl_new is not None and not (isinstance(ttl_new, int) or isinstance(ttl_new, ExplicitNull)):
			raise ValueError(f"'ttl' of incorrect type. Expected int, got {type(ttl_new)}")
		if data_new is not None and not (isinstance(data_new, str) or isinstance(data_new, ExplicitNull)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if fqdn_new is not None and not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if ttl_reset_days_new is not None and not (isinstance(ttl_reset_days_new, int)):
			raise ValueError(f"'ttl_reset_days' of incorrect type. Expected int, got {type(ttl_reset_days_new)}")
		if target_is_singleton_new is not None and not (isinstance(target_is_singleton_new, bool)):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(target_is_singleton_new)}")
		if target_is_reverse_unique_new is not None and not (isinstance(target_is_reverse_unique_new, bool)):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(target_is_reverse_unique_new)}")
		if not (isinstance(data_old, str) or isinstance(data_old, ExplicitNull)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_old)}")
		if not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")
		if not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if try_del_fqdn_old is not None and not (isinstance(try_del_fqdn_old, bool)):
			raise ValueError(f"'try_del_fqdn' of incorrect type. Expected bool, got {type(try_del_fqdn_old)}")

		return {'name': 'dns.record.update', 'new': _denullify_dict({'ttl': ttl_new, 'data': data_new, 'fqdn': fqdn_new, 'type': type_new, 'ttl_reset_days': ttl_reset_days_new, 'target_is_singleton': target_is_singleton_new, 'target_is_reverse_unique': target_is_reverse_unique_new}), 'old': _denullify_dict({'data': data_old, 'fqdn': fqdn_old, 'type': type_old, 'try_del_fqdn': try_del_fqdn_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, data_old: str, fqdn_old: str, type_old: str, ttl_new: Union[int, ExplicitNull] = None, data_new: Union[str, ExplicitNull] = None, fqdn_new: str = None, type_new: str = None, ttl_reset_days_new: int = None, target_is_singleton_new: bool = None, target_is_reverse_unique_new: bool = None, try_del_fqdn_old: bool = True) -> list:
		if ttl_new is not None and not (isinstance(ttl_new, int) or isinstance(ttl_new, ExplicitNull)):
			raise ValueError(f"'ttl' of incorrect type. Expected int, got {type(ttl_new)}")
		if data_new is not None and not (isinstance(data_new, str) or isinstance(data_new, ExplicitNull)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if fqdn_new is not None and not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if ttl_reset_days_new is not None and not (isinstance(ttl_reset_days_new, int)):
			raise ValueError(f"'ttl_reset_days' of incorrect type. Expected int, got {type(ttl_reset_days_new)}")
		if target_is_singleton_new is not None and not (isinstance(target_is_singleton_new, bool)):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(target_is_singleton_new)}")
		if target_is_reverse_unique_new is not None and not (isinstance(target_is_reverse_unique_new, bool)):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(target_is_reverse_unique_new)}")
		if not (isinstance(data_old, str) or isinstance(data_old, ExplicitNull)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_old)}")
		if not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")
		if not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if try_del_fqdn_old is not None and not (isinstance(try_del_fqdn_old, bool)):
			raise ValueError(f"'try_del_fqdn' of incorrect type. Expected bool, got {type(try_del_fqdn_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(ttl_new=ttl_new, data_new=data_new, fqdn_new=fqdn_new, type_new=type_new, ttl_reset_days_new=ttl_reset_days_new, target_is_singleton_new=target_is_singleton_new, target_is_reverse_unique_new=target_is_reverse_unique_new, data_old=data_old, fqdn_old=fqdn_old, type_old=type_old, try_del_fqdn_old=try_del_fqdn_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Fqdn2group(APIObject):
	gpk: str
	is_own: bool
	fqdn_value: str
	group_name: str
	parent_group_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.fqdn_value, str):
			raise ValueError(f"'fqdn_value' of incorrect type. Expected str, got {type(self.fqdn_value)}")
		if not isinstance(self.group_name, str):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(self.group_name)}")
		if not isinstance(self.parent_group_name, str):
			raise ValueError(f"'parent_group_name' of incorrect type. Expected str, got {type(self.parent_group_name)}")

	@staticmethod
	def create_ta(fqdn_value_new: str, group_name_new: str) -> dict:
		if not (isinstance(fqdn_value_new, str)):
			raise ValueError(f"'fqdn_value' of incorrect type. Expected str, got {type(fqdn_value_new)}")
		if not (isinstance(group_name_new, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_new)}")

		return {'name': 'dns.fqdn2group.create', 'new': _denullify_dict({'fqdn_value': fqdn_value_new, 'group_name': group_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, fqdn_value_new: str, group_name_new: str) -> list:
		if not (isinstance(fqdn_value_new, str)):
			raise ValueError(f"'fqdn_value' of incorrect type. Expected str, got {type(fqdn_value_new)}")
		if not (isinstance(group_name_new, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(fqdn_value_new=fqdn_value_new, group_name_new=group_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(fqdn_value_old: str, group_name_old: str) -> dict:
		if not (isinstance(fqdn_value_old, str)):
			raise ValueError(f"'fqdn_value' of incorrect type. Expected str, got {type(fqdn_value_old)}")
		if not (isinstance(group_name_old, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_old)}")

		return {'name': 'dns.fqdn2group.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'fqdn_value': fqdn_value_old, 'group_name': group_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, fqdn_value_old: str, group_name_old: str) -> list:
		if not (isinstance(fqdn_value_old, str)):
			raise ValueError(f"'fqdn_value' of incorrect type. Expected str, got {type(fqdn_value_old)}")
		if not (isinstance(group_name_old, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(fqdn_value_old=fqdn_value_old, group_name_old=group_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(is_own_old: bool = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, fqdn_value_list_old: list = None, group_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if fqdn_value_list_old is not None and not (isinstance(fqdn_value_list_old, list)):
			raise ValueError(f"'fqdn_value_list' of incorrect type. Expected list, got {type(fqdn_value_list_old)}")
		if group_name_list_old is not None and not (isinstance(group_name_list_old, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dns.fqdn2group.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'is_own': is_own_old, 'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'fqdn_value_list': fqdn_value_list_old, 'group_name_list': group_name_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, is_own_old: bool = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, fqdn_value_list_old: list = None, group_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if fqdn_value_list_old is not None and not (isinstance(fqdn_value_list_old, list)):
			raise ValueError(f"'fqdn_value_list' of incorrect type. Expected list, got {type(fqdn_value_list_old)}")
		if group_name_list_old is not None and not (isinstance(group_name_list_old, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(is_own_old=is_own_old, gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, fqdn_value_list_old=fqdn_value_list_old, group_name_list_old=group_name_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Fqdn2ou(APIObject):
	gpk: str
	is_own: bool
	fqdn_value: str
	is_recursive: bool
	ou_short_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.fqdn_value, str):
			raise ValueError(f"'fqdn_value' of incorrect type. Expected str, got {type(self.fqdn_value)}")
		if not isinstance(self.is_recursive, bool):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(self.is_recursive)}")
		if not isinstance(self.ou_short_name, str):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(self.ou_short_name)}")

	@staticmethod
	def create_ta(fqdn_value_new: str, ou_short_name_new: str, is_recursive_new: bool = False) -> dict:
		if not (isinstance(fqdn_value_new, str)):
			raise ValueError(f"'fqdn_value' of incorrect type. Expected str, got {type(fqdn_value_new)}")
		if is_recursive_new is not None and not (isinstance(is_recursive_new, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_new)}")
		if not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")

		return {'name': 'dns.fqdn2ou.create', 'new': _denullify_dict({'fqdn_value': fqdn_value_new, 'is_recursive': is_recursive_new, 'ou_short_name': ou_short_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, fqdn_value_new: str, ou_short_name_new: str, is_recursive_new: bool = False) -> list:
		if not (isinstance(fqdn_value_new, str)):
			raise ValueError(f"'fqdn_value' of incorrect type. Expected str, got {type(fqdn_value_new)}")
		if is_recursive_new is not None and not (isinstance(is_recursive_new, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_new)}")
		if not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(fqdn_value_new=fqdn_value_new, is_recursive_new=is_recursive_new, ou_short_name_new=ou_short_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(fqdn_value_old: str, ou_short_name_old: str) -> dict:
		if not (isinstance(fqdn_value_old, str)):
			raise ValueError(f"'fqdn_value' of incorrect type. Expected str, got {type(fqdn_value_old)}")
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")

		return {'name': 'dns.fqdn2ou.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'fqdn_value': fqdn_value_old, 'ou_short_name': ou_short_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, fqdn_value_old: str, ou_short_name_old: str) -> list:
		if not (isinstance(fqdn_value_old, str)):
			raise ValueError(f"'fqdn_value' of incorrect type. Expected str, got {type(fqdn_value_old)}")
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(fqdn_value_old=fqdn_value_old, ou_short_name_old=ou_short_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(is_own_old: bool = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_recursive_old: bool = None, fqdn_value_list_old: list = None, filter_params_dict_old: dict = None, ou_short_name_list_old: list = None, sorting_params_list_old: list = None) -> dict:
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_recursive_old is not None and not (isinstance(is_recursive_old, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_old)}")
		if fqdn_value_list_old is not None and not (isinstance(fqdn_value_list_old, list)):
			raise ValueError(f"'fqdn_value_list' of incorrect type. Expected list, got {type(fqdn_value_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if ou_short_name_list_old is not None and not (isinstance(ou_short_name_list_old, list)):
			raise ValueError(f"'ou_short_name_list' of incorrect type. Expected list, got {type(ou_short_name_list_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dns.fqdn2ou.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'is_own': is_own_old, 'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'is_recursive': is_recursive_old, 'fqdn_value_list': fqdn_value_list_old, 'filter_params_dict': filter_params_dict_old, 'ou_short_name_list': ou_short_name_list_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, is_own_old: bool = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_recursive_old: bool = None, fqdn_value_list_old: list = None, filter_params_dict_old: dict = None, ou_short_name_list_old: list = None, sorting_params_list_old: list = None) -> list:
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_recursive_old is not None and not (isinstance(is_recursive_old, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_old)}")
		if fqdn_value_list_old is not None and not (isinstance(fqdn_value_list_old, list)):
			raise ValueError(f"'fqdn_value_list' of incorrect type. Expected list, got {type(fqdn_value_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if ou_short_name_list_old is not None and not (isinstance(ou_short_name_list_old, list)):
			raise ValueError(f"'ou_short_name_list' of incorrect type. Expected list, got {type(ou_short_name_list_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(is_own_old=is_own_old, gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, is_recursive_old=is_recursive_old, fqdn_value_list_old=fqdn_value_list_old, filter_params_dict_old=filter_params_dict_old, ou_short_name_list_old=ou_short_name_list_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(fqdn_value_old: str, ou_short_name_old: str, is_recursive_new: bool = None, ou_short_name_new: str = None) -> dict:
		if is_recursive_new is not None and not (isinstance(is_recursive_new, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_new)}")
		if ou_short_name_new is not None and not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if not (isinstance(fqdn_value_old, str)):
			raise ValueError(f"'fqdn_value' of incorrect type. Expected str, got {type(fqdn_value_old)}")
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")

		return {'name': 'dns.fqdn2ou.update', 'new': _denullify_dict({'is_recursive': is_recursive_new, 'ou_short_name': ou_short_name_new}), 'old': _denullify_dict({'fqdn_value': fqdn_value_old, 'ou_short_name': ou_short_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, fqdn_value_old: str, ou_short_name_old: str, is_recursive_new: bool = None, ou_short_name_new: str = None) -> list:
		if is_recursive_new is not None and not (isinstance(is_recursive_new, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_new)}")
		if ou_short_name_new is not None and not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if not (isinstance(fqdn_value_old, str)):
			raise ValueError(f"'fqdn_value' of incorrect type. Expected str, got {type(fqdn_value_old)}")
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(is_recursive_new=is_recursive_new, ou_short_name_new=ou_short_name_new, fqdn_value_old=fqdn_value_old, ou_short_name_old=ou_short_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class RecordImp(APIObject):
	ttl: int
	type: str
	data_list: str
	ttl_reset_days: int
	target_is_singleton: bool
	target_is_reverse_unique: bool

	def __post_init__(self):
		if self.ttl is not None and not isinstance(self.ttl, int):
			raise ValueError(f"'ttl' of incorrect type. Expected int, got {type(self.ttl)}")
		if self.type is not None and not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if self.data_list is not None and not isinstance(self.data_list, str):
			raise ValueError(f"'data_list' of incorrect type. Expected str, got {type(self.data_list)}")
		if self.ttl_reset_days is not None and not isinstance(self.ttl_reset_days, int):
			raise ValueError(f"'ttl_reset_days' of incorrect type. Expected int, got {type(self.ttl_reset_days)}")
		if self.target_is_singleton is not None and not isinstance(self.target_is_singleton, bool):
			raise ValueError(f"'target_is_singleton' of incorrect type. Expected bool, got {type(self.target_is_singleton)}")
		if self.target_is_reverse_unique is not None and not isinstance(self.target_is_reverse_unique, bool):
			raise ValueError(f"'target_is_reverse_unique' of incorrect type. Expected bool, got {type(self.target_is_reverse_unique)}")

@dataclass()
class FqdnStatistic(APIObject):
	has_rr: bool
	fqdn_gfk: str
	fqdn_value: str
	sub_fqdn_count: int

	def __post_init__(self):
		if not isinstance(self.has_rr, bool):
			raise ValueError(f"'has_rr' of incorrect type. Expected bool, got {type(self.has_rr)}")
		if not isinstance(self.fqdn_gfk, str):
			raise ValueError(f"'fqdn_gfk' of incorrect type. Expected str, got {type(self.fqdn_gfk)}")
		if not isinstance(self.fqdn_value, str):
			raise ValueError(f"'fqdn_value' of incorrect type. Expected str, got {type(self.fqdn_value)}")
		if not isinstance(self.sub_fqdn_count, int):
			raise ValueError(f"'sub_fqdn_count' of incorrect type. Expected int, got {type(self.sub_fqdn_count)}")

	@staticmethod
	def list_ta(fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dns.fqdn_statistic.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
