### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class RecordType(APIObject):
	gpk: str
	short_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.short_name, str):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(self.short_name)}")

	@staticmethod
	def create_ta(short_name_new: str) -> dict:
		if not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")

		return {'name': 'evlog.record_type.create', 'new': _denullify_dict({'short_name': short_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, short_name_new: str) -> list:
		if not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(short_name_new=short_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(short_name_old: str) -> dict:
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		return {'name': 'evlog.record_type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'short_name': short_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, short_name_old: str) -> list:
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(short_name_old=short_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, short_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if short_name_list_old is not None and not (isinstance(short_name_list_old, list)):
			raise ValueError(f"'short_name_list' of incorrect type. Expected list, got {type(short_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'evlog.record_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'short_name_list': short_name_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, short_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if short_name_list_old is not None and not (isinstance(short_name_list_old, list)):
			raise ValueError(f"'short_name_list' of incorrect type. Expected list, got {type(short_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, short_name_list_old=short_name_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(short_name_old: str, short_name_new: str = None) -> dict:
		if short_name_new is not None and not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		return {'name': 'evlog.record_type.update', 'new': _denullify_dict({'short_name': short_name_new}), 'old': _denullify_dict({'short_name': short_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, short_name_old: str, short_name_new: str = None) -> list:
		if short_name_new is not None and not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(short_name_new=short_name_new, short_name_old=short_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Record(APIObject):
	data: str
	type: str
	log_params: list
	object_gfk: str
	language_tag: str
	ta_timestamp: str
	mgr_login_name: str
	object_type_fq_name: str

	def __post_init__(self):
		if self.data is not None and not isinstance(self.data, str):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(self.data)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if not isinstance(self.log_params, list):
			raise ValueError(f"'log_params' of incorrect type. Expected list, got {type(self.log_params)}")
		if not isinstance(self.object_gfk, str):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(self.object_gfk)}")
		if not isinstance(self.language_tag, str):
			raise ValueError(f"'language_tag' of incorrect type. Expected str, got {type(self.language_tag)}")
		if not isinstance(self.ta_timestamp, str):
			raise ValueError(f"'ta_timestamp' of incorrect type. Expected str, got {type(self.ta_timestamp)}")
		if self.mgr_login_name is not None and not isinstance(self.mgr_login_name, str):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(self.mgr_login_name)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")

	@staticmethod
	def create_ta(text_new: str, type_new: str = None, object_pk_new: int = None, object_gfk_new: str = None, ta_timestamp_new: str = None, object_type_fq_name_new: str = None) -> dict:
		if not (isinstance(text_new, str)):
			raise ValueError(f"'text' of incorrect type. Expected str, got {type(text_new)}")
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if object_pk_new is not None and not (isinstance(object_pk_new, int)):
			raise ValueError(f"'object_pk' of incorrect type. Expected int, got {type(object_pk_new)}")
		if object_gfk_new is not None and not (isinstance(object_gfk_new, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_new)}")
		if ta_timestamp_new is not None and not (isinstance(ta_timestamp_new, str)):
			raise ValueError(f"'ta_timestamp' of incorrect type. Expected str, got {type(ta_timestamp_new)}")
		if object_type_fq_name_new is not None and not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")

		return {'name': 'evlog.record.create', 'new': _denullify_dict({'text': text_new, 'type': type_new, 'object_pk': object_pk_new, 'object_gfk': object_gfk_new, 'ta_timestamp': ta_timestamp_new, 'object_type_fq_name': object_type_fq_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, text_new: str, type_new: str = None, object_pk_new: int = None, object_gfk_new: str = None, ta_timestamp_new: str = None, object_type_fq_name_new: str = None) -> list:
		if not (isinstance(text_new, str)):
			raise ValueError(f"'text' of incorrect type. Expected str, got {type(text_new)}")
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if object_pk_new is not None and not (isinstance(object_pk_new, int)):
			raise ValueError(f"'object_pk' of incorrect type. Expected int, got {type(object_pk_new)}")
		if object_gfk_new is not None and not (isinstance(object_gfk_new, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_new)}")
		if ta_timestamp_new is not None and not (isinstance(ta_timestamp_new, str)):
			raise ValueError(f"'ta_timestamp' of incorrect type. Expected str, got {type(ta_timestamp_new)}")
		if object_type_fq_name_new is not None and not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(text_new=text_new, type_new=type_new, object_pk_new=object_pk_new, object_gfk_new=object_gfk_new, ta_timestamp_new=ta_timestamp_new, object_type_fq_name_new=object_type_fq_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(type_old: str = None, top_n_old: int = None, type_list_old: list = None, log_params_old: list = None, object_gfk_old: str = None, ta_interval_old: str = None, language_tag_old: str = None, ta_timestamp_old: str = None, mgr_login_name_old: str = None, top_n_from_newest_old: bool = True, filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None) -> dict:
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if top_n_old is not None and not (isinstance(top_n_old, int)):
			raise ValueError(f"'top_n' of incorrect type. Expected int, got {type(top_n_old)}")
		if type_list_old is not None and not (isinstance(type_list_old, list)):
			raise ValueError(f"'type_list' of incorrect type. Expected list, got {type(type_list_old)}")
		if log_params_old is not None and not (isinstance(log_params_old, list)):
			raise ValueError(f"'log_params' of incorrect type. Expected list, got {type(log_params_old)}")
		if object_gfk_old is not None and not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")
		if ta_interval_old is not None and not (isinstance(ta_interval_old, str)):
			raise ValueError(f"'ta_interval' of incorrect type. Expected str, got {type(ta_interval_old)}")
		if language_tag_old is not None and not (isinstance(language_tag_old, str)):
			raise ValueError(f"'language_tag' of incorrect type. Expected str, got {type(language_tag_old)}")
		if ta_timestamp_old is not None and not (isinstance(ta_timestamp_old, str)):
			raise ValueError(f"'ta_timestamp' of incorrect type. Expected str, got {type(ta_timestamp_old)}")
		if mgr_login_name_old is not None and not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")
		if top_n_from_newest_old is not None and not (isinstance(top_n_from_newest_old, bool)):
			raise ValueError(f"'top_n_from_newest' of incorrect type. Expected bool, got {type(top_n_from_newest_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'evlog.record.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'type': type_old, 'top_n': top_n_old, 'type_list': type_list_old, 'log_params': log_params_old, 'object_gfk': object_gfk_old, 'ta_interval': ta_interval_old, 'language_tag': language_tag_old, 'ta_timestamp': ta_timestamp_old, 'mgr_login_name': mgr_login_name_old, 'top_n_from_newest': top_n_from_newest_old, 'filter_params_dict': filter_params_dict_old, 'object_type_fq_name': object_type_fq_name_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, type_old: str = None, top_n_old: int = None, type_list_old: list = None, log_params_old: list = None, object_gfk_old: str = None, ta_interval_old: str = None, language_tag_old: str = None, ta_timestamp_old: str = None, mgr_login_name_old: str = None, top_n_from_newest_old: bool = True, filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None) -> list:
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if top_n_old is not None and not (isinstance(top_n_old, int)):
			raise ValueError(f"'top_n' of incorrect type. Expected int, got {type(top_n_old)}")
		if type_list_old is not None and not (isinstance(type_list_old, list)):
			raise ValueError(f"'type_list' of incorrect type. Expected list, got {type(type_list_old)}")
		if log_params_old is not None and not (isinstance(log_params_old, list)):
			raise ValueError(f"'log_params' of incorrect type. Expected list, got {type(log_params_old)}")
		if object_gfk_old is not None and not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")
		if ta_interval_old is not None and not (isinstance(ta_interval_old, str)):
			raise ValueError(f"'ta_interval' of incorrect type. Expected str, got {type(ta_interval_old)}")
		if language_tag_old is not None and not (isinstance(language_tag_old, str)):
			raise ValueError(f"'language_tag' of incorrect type. Expected str, got {type(language_tag_old)}")
		if ta_timestamp_old is not None and not (isinstance(ta_timestamp_old, str)):
			raise ValueError(f"'ta_timestamp' of incorrect type. Expected str, got {type(ta_timestamp_old)}")
		if mgr_login_name_old is not None and not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")
		if top_n_from_newest_old is not None and not (isinstance(top_n_from_newest_old, bool)):
			raise ValueError(f"'top_n_from_newest' of incorrect type. Expected bool, got {type(top_n_from_newest_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(type_old=type_old, top_n_old=top_n_old, type_list_old=type_list_old, log_params_old=log_params_old, object_gfk_old=object_gfk_old, ta_interval_old=ta_interval_old, language_tag_old=language_tag_old, ta_timestamp_old=ta_timestamp_old, mgr_login_name_old=mgr_login_name_old, top_n_from_newest_old=top_n_from_newest_old, filter_params_dict_old=filter_params_dict_old, object_type_fq_name_old=object_type_fq_name_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
