### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class GenericObject(APIObject):
	_dict: dict
	_dict_list: list

	def __post_init__(self):
		if not isinstance(self._dict, dict):
			raise ValueError(f"'_dict' of incorrect type. Expected dict, got {type(self._dict)}")
		if not isinstance(self._dict_list, list):
			raise ValueError(f"'_dict_list' of incorrect type. Expected list, got {type(self._dict_list)}")

	@staticmethod
	def create_ta(_dict_new: dict = {}) -> dict:
		if _dict_new is not None and not (isinstance(_dict_new, dict)):
			raise ValueError(f"'_dict' of incorrect type. Expected dict, got {type(_dict_new)}")

		return {'name': 'tmp.generic_object.create', 'new': _denullify_dict({'_dict': _dict_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, _dict_new: dict = {}) -> list:
		if _dict_new is not None and not (isinstance(_dict_new, dict)):
			raise ValueError(f"'_dict' of incorrect type. Expected dict, got {type(_dict_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(_dict_new=_dict_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(_dict_list_old: list = []) -> dict:
		if _dict_list_old is not None and not (isinstance(_dict_list_old, list)):
			raise ValueError(f"'_dict_list' of incorrect type. Expected list, got {type(_dict_list_old)}")

		return {'name': 'tmp.generic_object.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'_dict_list': _dict_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, _dict_list_old: list = []) -> list:
		if _dict_list_old is not None and not (isinstance(_dict_list_old, list)):
			raise ValueError(f"'_dict_list' of incorrect type. Expected list, got {type(_dict_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(_dict_list_old=_dict_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(_dict_new: dict = {}, _dict_old: dict = {}) -> dict:
		if _dict_new is not None and not (isinstance(_dict_new, dict)):
			raise ValueError(f"'_dict' of incorrect type. Expected dict, got {type(_dict_new)}")
		if _dict_old is not None and not (isinstance(_dict_old, dict)):
			raise ValueError(f"'_dict' of incorrect type. Expected dict, got {type(_dict_old)}")

		return {'name': 'tmp.generic_object.update', 'new': _denullify_dict({'_dict': _dict_new}), 'old': _denullify_dict({'_dict': _dict_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, _dict_new: dict = {}, _dict_old: dict = {}) -> list:
		if _dict_new is not None and not (isinstance(_dict_new, dict)):
			raise ValueError(f"'_dict' of incorrect type. Expected dict, got {type(_dict_new)}")
		if _dict_old is not None and not (isinstance(_dict_old, dict)):
			raise ValueError(f"'_dict' of incorrect type. Expected dict, got {type(_dict_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(_dict_new=_dict_new, _dict_old=_dict_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Diag4gpk(APIObject):
	object_gpk: str
	system_name: str
	object_type_name: str

	def __post_init__(self):
		if not isinstance(self.object_gpk, str):
			raise ValueError(f"'object_gpk' of incorrect type. Expected str, got {type(self.object_gpk)}")
		if not isinstance(self.system_name, str):
			raise ValueError(f"'system_name' of incorrect type. Expected str, got {type(self.system_name)}")
		if not isinstance(self.object_type_name, str):
			raise ValueError(f"'object_type_name' of incorrect type. Expected str, got {type(self.object_type_name)}")

	@staticmethod
	def list_ta(system_name_old: str = None, object_type_name_old: str = None) -> dict:
		if system_name_old is not None and not (isinstance(system_name_old, str)):
			raise ValueError(f"'system_name' of incorrect type. Expected str, got {type(system_name_old)}")
		if object_type_name_old is not None and not (isinstance(object_type_name_old, str)):
			raise ValueError(f"'object_type_name' of incorrect type. Expected str, got {type(object_type_name_old)}")

		return {'name': 'tmp.diag4gpk.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'system_name': system_name_old, 'object_type_name': object_type_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, system_name_old: str = None, object_type_name_old: str = None) -> list:
		if system_name_old is not None and not (isinstance(system_name_old, str)):
			raise ValueError(f"'system_name' of incorrect type. Expected str, got {type(system_name_old)}")
		if object_type_name_old is not None and not (isinstance(object_type_name_old, str)):
			raise ValueError(f"'object_type_name' of incorrect type. Expected str, got {type(object_type_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(system_name_old=system_name_old, object_type_name_old=object_type_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class CidrGenerator(APIObject):
	value: str
	base_value: str
	value_host: str
	value_masklen: int

	def __post_init__(self):
		if not isinstance(self.value, str):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(self.value)}")
		if not isinstance(self.base_value, str):
			raise ValueError(f"'base_value' of incorrect type. Expected str, got {type(self.base_value)}")
		if not isinstance(self.value_host, str):
			raise ValueError(f"'value_host' of incorrect type. Expected str, got {type(self.value_host)}")
		if not isinstance(self.value_masklen, int):
			raise ValueError(f"'value_masklen' of incorrect type. Expected int, got {type(self.value_masklen)}")

	@staticmethod
	def list_ta(base_value_list_old: list = None, fetch_limit_list_old: list = None, fetch_offset_list_old: list = None, default_fetch_limit_old: int = None, default_fetch_offset_old: int = None, masklen_summand_list_old: list = None, default_masklen_summand_old: int = 0) -> dict:
		if base_value_list_old is not None and not (isinstance(base_value_list_old, list)):
			raise ValueError(f"'base_value_list' of incorrect type. Expected list, got {type(base_value_list_old)}")
		if fetch_limit_list_old is not None and not (isinstance(fetch_limit_list_old, list)):
			raise ValueError(f"'fetch_limit_list' of incorrect type. Expected list, got {type(fetch_limit_list_old)}")
		if fetch_offset_list_old is not None and not (isinstance(fetch_offset_list_old, list)):
			raise ValueError(f"'fetch_offset_list' of incorrect type. Expected list, got {type(fetch_offset_list_old)}")
		if default_fetch_limit_old is not None and not (isinstance(default_fetch_limit_old, int) or isinstance(default_fetch_limit_old, ExplicitNull)):
			raise ValueError(f"'default_fetch_limit' of incorrect type. Expected int, got {type(default_fetch_limit_old)}")
		if default_fetch_offset_old is not None and not (isinstance(default_fetch_offset_old, int) or isinstance(default_fetch_offset_old, ExplicitNull)):
			raise ValueError(f"'default_fetch_offset' of incorrect type. Expected int, got {type(default_fetch_offset_old)}")
		if masklen_summand_list_old is not None and not (isinstance(masklen_summand_list_old, list)):
			raise ValueError(f"'masklen_summand_list' of incorrect type. Expected list, got {type(masklen_summand_list_old)}")
		if default_masklen_summand_old is not None and not (isinstance(default_masklen_summand_old, int)):
			raise ValueError(f"'default_masklen_summand' of incorrect type. Expected int, got {type(default_masklen_summand_old)}")

		return {'name': 'tmp.cidr_generator.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'base_value_list': base_value_list_old, 'fetch_limit_list': fetch_limit_list_old, 'fetch_offset_list': fetch_offset_list_old, 'default_fetch_limit': default_fetch_limit_old, 'default_fetch_offset': default_fetch_offset_old, 'masklen_summand_list': masklen_summand_list_old, 'default_masklen_summand': default_masklen_summand_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, base_value_list_old: list = None, fetch_limit_list_old: list = None, fetch_offset_list_old: list = None, default_fetch_limit_old: int = None, default_fetch_offset_old: int = None, masklen_summand_list_old: list = None, default_masklen_summand_old: int = 0) -> list:
		if base_value_list_old is not None and not (isinstance(base_value_list_old, list)):
			raise ValueError(f"'base_value_list' of incorrect type. Expected list, got {type(base_value_list_old)}")
		if fetch_limit_list_old is not None and not (isinstance(fetch_limit_list_old, list)):
			raise ValueError(f"'fetch_limit_list' of incorrect type. Expected list, got {type(fetch_limit_list_old)}")
		if fetch_offset_list_old is not None and not (isinstance(fetch_offset_list_old, list)):
			raise ValueError(f"'fetch_offset_list' of incorrect type. Expected list, got {type(fetch_offset_list_old)}")
		if default_fetch_limit_old is not None and not (isinstance(default_fetch_limit_old, int) or isinstance(default_fetch_limit_old, ExplicitNull)):
			raise ValueError(f"'default_fetch_limit' of incorrect type. Expected int, got {type(default_fetch_limit_old)}")
		if default_fetch_offset_old is not None and not (isinstance(default_fetch_offset_old, int) or isinstance(default_fetch_offset_old, ExplicitNull)):
			raise ValueError(f"'default_fetch_offset' of incorrect type. Expected int, got {type(default_fetch_offset_old)}")
		if masklen_summand_list_old is not None and not (isinstance(masklen_summand_list_old, list)):
			raise ValueError(f"'masklen_summand_list' of incorrect type. Expected list, got {type(masklen_summand_list_old)}")
		if default_masklen_summand_old is not None and not (isinstance(default_masklen_summand_old, int)):
			raise ValueError(f"'default_masklen_summand' of incorrect type. Expected int, got {type(default_masklen_summand_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(base_value_list_old=base_value_list_old, fetch_limit_list_old=fetch_limit_list_old, fetch_offset_list_old=fetch_offset_list_old, default_fetch_limit_old=default_fetch_limit_old, default_fetch_offset_old=default_fetch_offset_old, masklen_summand_list_old=masklen_summand_list_old, default_masklen_summand_old=default_masklen_summand_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
