### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class Module2slotType(APIObject):
	gpk: str
	slot_type: str
	module_type: str
	num_mode_name: str
	num_mode_level: int
	required_slot_width: int

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.slot_type, str):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(self.slot_type)}")
		if not isinstance(self.module_type, str):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(self.module_type)}")
		if not isinstance(self.num_mode_name, str):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(self.num_mode_name)}")
		if not isinstance(self.num_mode_level, int):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(self.num_mode_level)}")
		if not isinstance(self.required_slot_width, int):
			raise ValueError(f"'required_slot_width' of incorrect type. Expected int, got {type(self.required_slot_width)}")

	@staticmethod
	def create_ta(slot_type_new: str, module_type_new: str, num_mode_name_new: str, num_mode_level_new: int, required_slot_width_new: int = 1) -> dict:
		if not (isinstance(slot_type_new, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_new)}")
		if not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if not (isinstance(num_mode_name_new, str)):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(num_mode_name_new)}")
		if not (isinstance(num_mode_level_new, int)):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(num_mode_level_new)}")
		if required_slot_width_new is not None and not (isinstance(required_slot_width_new, int)):
			raise ValueError(f"'required_slot_width' of incorrect type. Expected int, got {type(required_slot_width_new)}")

		return {'name': 'ndcfg.module2slot_type.create', 'new': _denullify_dict({'slot_type': slot_type_new, 'module_type': module_type_new, 'num_mode_name': num_mode_name_new, 'num_mode_level': num_mode_level_new, 'required_slot_width': required_slot_width_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, slot_type_new: str, module_type_new: str, num_mode_name_new: str, num_mode_level_new: int, required_slot_width_new: int = 1) -> list:
		if not (isinstance(slot_type_new, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_new)}")
		if not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if not (isinstance(num_mode_name_new, str)):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(num_mode_name_new)}")
		if not (isinstance(num_mode_level_new, int)):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(num_mode_level_new)}")
		if required_slot_width_new is not None and not (isinstance(required_slot_width_new, int)):
			raise ValueError(f"'required_slot_width' of incorrect type. Expected int, got {type(required_slot_width_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(slot_type_new=slot_type_new, module_type_new=module_type_new, num_mode_name_new=num_mode_name_new, num_mode_level_new=num_mode_level_new, required_slot_width_new=required_slot_width_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(slot_type_old: str, module_type_old: str) -> dict:
		if not (isinstance(slot_type_old, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_old)}")
		if not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")

		return {'name': 'ndcfg.module2slot_type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'slot_type': slot_type_old, 'module_type': module_type_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, slot_type_old: str, module_type_old: str) -> list:
		if not (isinstance(slot_type_old, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_old)}")
		if not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(slot_type_old=slot_type_old, module_type_old=module_type_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, slot_type_old: str = None, fetch_limit_old: int = None, module_type_old: str = None, fetch_offset_old: int = None, slot_type_list_old: list = None, module_type_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if slot_type_old is not None and not (isinstance(slot_type_old, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if module_type_old is not None and not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if slot_type_list_old is not None and not (isinstance(slot_type_list_old, list)):
			raise ValueError(f"'slot_type_list' of incorrect type. Expected list, got {type(slot_type_list_old)}")
		if module_type_list_old is not None and not (isinstance(module_type_list_old, list)):
			raise ValueError(f"'module_type_list' of incorrect type. Expected list, got {type(module_type_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.module2slot_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'slot_type': slot_type_old, 'fetch_limit': fetch_limit_old, 'module_type': module_type_old, 'fetch_offset': fetch_offset_old, 'slot_type_list': slot_type_list_old, 'module_type_list': module_type_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, slot_type_old: str = None, fetch_limit_old: int = None, module_type_old: str = None, fetch_offset_old: int = None, slot_type_list_old: list = None, module_type_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if slot_type_old is not None and not (isinstance(slot_type_old, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if module_type_old is not None and not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if slot_type_list_old is not None and not (isinstance(slot_type_list_old, list)):
			raise ValueError(f"'slot_type_list' of incorrect type. Expected list, got {type(slot_type_list_old)}")
		if module_type_list_old is not None and not (isinstance(module_type_list_old, list)):
			raise ValueError(f"'module_type_list' of incorrect type. Expected list, got {type(module_type_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, slot_type_old=slot_type_old, fetch_limit_old=fetch_limit_old, module_type_old=module_type_old, fetch_offset_old=fetch_offset_old, slot_type_list_old=slot_type_list_old, module_type_list_old=module_type_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(slot_type_old: str, module_type_old: str, slot_type_new: str = None, module_type_new: str = None, num_mode_name_new: str = None, num_mode_level_new: int = None, required_slot_width_new: int = None) -> dict:
		if slot_type_new is not None and not (isinstance(slot_type_new, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_new)}")
		if module_type_new is not None and not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if num_mode_name_new is not None and not (isinstance(num_mode_name_new, str)):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(num_mode_name_new)}")
		if num_mode_level_new is not None and not (isinstance(num_mode_level_new, int)):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(num_mode_level_new)}")
		if required_slot_width_new is not None and not (isinstance(required_slot_width_new, int)):
			raise ValueError(f"'required_slot_width' of incorrect type. Expected int, got {type(required_slot_width_new)}")
		if not (isinstance(slot_type_old, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_old)}")
		if not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")

		return {'name': 'ndcfg.module2slot_type.update', 'new': _denullify_dict({'slot_type': slot_type_new, 'module_type': module_type_new, 'num_mode_name': num_mode_name_new, 'num_mode_level': num_mode_level_new, 'required_slot_width': required_slot_width_new}), 'old': _denullify_dict({'slot_type': slot_type_old, 'module_type': module_type_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, slot_type_old: str, module_type_old: str, slot_type_new: str = None, module_type_new: str = None, num_mode_name_new: str = None, num_mode_level_new: int = None, required_slot_width_new: int = None) -> list:
		if slot_type_new is not None and not (isinstance(slot_type_new, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_new)}")
		if module_type_new is not None and not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if num_mode_name_new is not None and not (isinstance(num_mode_name_new, str)):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(num_mode_name_new)}")
		if num_mode_level_new is not None and not (isinstance(num_mode_level_new, int)):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(num_mode_level_new)}")
		if required_slot_width_new is not None and not (isinstance(required_slot_width_new, int)):
			raise ValueError(f"'required_slot_width' of incorrect type. Expected int, got {type(required_slot_width_new)}")
		if not (isinstance(slot_type_old, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_old)}")
		if not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(slot_type_new=slot_type_new, module_type_new=module_type_new, num_mode_name_new=num_mode_name_new, num_mode_level_new=num_mode_level_new, required_slot_width_new=required_slot_width_new, slot_type_old=slot_type_old, module_type_old=module_type_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class ModuleTypeClass(APIObject):
	gpk: str
	name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")

	@staticmethod
	def create_ta(name_new: str) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")

		return {'name': 'ndcfg.module_type_class.create', 'new': _denullify_dict({'name': name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.module_type_class.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.module_type_class.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.module_type_class.update', 'new': _denullify_dict({'name': name_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class PPortProto(APIObject):
	gpk: str
	name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")

	@staticmethod
	def create_ta(name_new: str) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")

		return {'name': 'ndcfg.p_port_proto.create', 'new': _denullify_dict({'name': name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.p_port_proto.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.p_port_proto.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.p_port_proto.update', 'new': _denullify_dict({'name': name_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class PPort2moduleType(APIObject):
	gpk: str
	int_gfk: str
	port_type: str
	port_count: int
	port_name1: str
	port_proto: str
	port_speed: str
	module_type: str
	num_mode_name: str
	num_mode_level: int
	port_inc_count: int
	port_type_group: str
	port_type_order: int
	port_name_prefix: str
	port_name_suffix: str
	port_name_varprfx: str
	port_name_varprfx_join_dl: str
	port_name_varprfx_split_dl: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.int_gfk, str):
			raise ValueError(f"'int_gfk' of incorrect type. Expected str, got {type(self.int_gfk)}")
		if not isinstance(self.port_type, str):
			raise ValueError(f"'port_type' of incorrect type. Expected str, got {type(self.port_type)}")
		if not isinstance(self.port_count, int):
			raise ValueError(f"'port_count' of incorrect type. Expected int, got {type(self.port_count)}")
		if self.port_name1 is not None and not isinstance(self.port_name1, str):
			raise ValueError(f"'port_name1' of incorrect type. Expected str, got {type(self.port_name1)}")
		if not isinstance(self.port_proto, str):
			raise ValueError(f"'port_proto' of incorrect type. Expected str, got {type(self.port_proto)}")
		if not isinstance(self.port_speed, str):
			raise ValueError(f"'port_speed' of incorrect type. Expected str, got {type(self.port_speed)}")
		if not isinstance(self.module_type, str):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(self.module_type)}")
		if not isinstance(self.num_mode_name, str):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(self.num_mode_name)}")
		if not isinstance(self.num_mode_level, int):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(self.num_mode_level)}")
		if not isinstance(self.port_inc_count, int):
			raise ValueError(f"'port_inc_count' of incorrect type. Expected int, got {type(self.port_inc_count)}")
		if not isinstance(self.port_type_group, str):
			raise ValueError(f"'port_type_group' of incorrect type. Expected str, got {type(self.port_type_group)}")
		if not isinstance(self.port_type_order, int):
			raise ValueError(f"'port_type_order' of incorrect type. Expected int, got {type(self.port_type_order)}")
		if self.port_name_prefix is not None and not isinstance(self.port_name_prefix, str):
			raise ValueError(f"'port_name_prefix' of incorrect type. Expected str, got {type(self.port_name_prefix)}")
		if self.port_name_suffix is not None and not isinstance(self.port_name_suffix, str):
			raise ValueError(f"'port_name_suffix' of incorrect type. Expected str, got {type(self.port_name_suffix)}")
		if self.port_name_varprfx is not None and not isinstance(self.port_name_varprfx, str):
			raise ValueError(f"'port_name_varprfx' of incorrect type. Expected str, got {type(self.port_name_varprfx)}")
		if self.port_name_varprfx_join_dl is not None and not isinstance(self.port_name_varprfx_join_dl, str):
			raise ValueError(f"'port_name_varprfx_join_dl' of incorrect type. Expected str, got {type(self.port_name_varprfx_join_dl)}")
		if self.port_name_varprfx_split_dl is not None and not isinstance(self.port_name_varprfx_split_dl, str):
			raise ValueError(f"'port_name_varprfx_split_dl' of incorrect type. Expected str, got {type(self.port_name_varprfx_split_dl)}")

	@staticmethod
	def create_ta(port_type_new: str, port_count_new: int, port_proto_new: str, port_speed_new: str, module_type_new: str, num_mode_name_new: str, num_mode_level_new: int, port_name1_new: Union[str, ExplicitNull] = None, port_inc_count_new: int = 1, port_type_order_new: int = None, port_name_prefix_new: Union[str, ExplicitNull] = None, port_name_suffix_new: Union[str, ExplicitNull] = None, port_name_varprfx_new: Union[str, ExplicitNull] = None, port_name_varprfx_join_dl_new: Union[str, ExplicitNull] = None, port_name_varprfx_split_dl_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(port_type_new, str)):
			raise ValueError(f"'port_type' of incorrect type. Expected str, got {type(port_type_new)}")
		if not (isinstance(port_count_new, int)):
			raise ValueError(f"'port_count' of incorrect type. Expected int, got {type(port_count_new)}")
		if port_name1_new is not None and not (isinstance(port_name1_new, str) or isinstance(port_name1_new, ExplicitNull)):
			raise ValueError(f"'port_name1' of incorrect type. Expected str, got {type(port_name1_new)}")
		if not (isinstance(port_proto_new, str)):
			raise ValueError(f"'port_proto' of incorrect type. Expected str, got {type(port_proto_new)}")
		if not (isinstance(port_speed_new, str)):
			raise ValueError(f"'port_speed' of incorrect type. Expected str, got {type(port_speed_new)}")
		if not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if not (isinstance(num_mode_name_new, str)):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(num_mode_name_new)}")
		if not (isinstance(num_mode_level_new, int)):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(num_mode_level_new)}")
		if port_inc_count_new is not None and not (isinstance(port_inc_count_new, int)):
			raise ValueError(f"'port_inc_count' of incorrect type. Expected int, got {type(port_inc_count_new)}")
		if port_type_order_new is not None and not (isinstance(port_type_order_new, int)):
			raise ValueError(f"'port_type_order' of incorrect type. Expected int, got {type(port_type_order_new)}")
		if port_name_prefix_new is not None and not (isinstance(port_name_prefix_new, str) or isinstance(port_name_prefix_new, ExplicitNull)):
			raise ValueError(f"'port_name_prefix' of incorrect type. Expected str, got {type(port_name_prefix_new)}")
		if port_name_suffix_new is not None and not (isinstance(port_name_suffix_new, str) or isinstance(port_name_suffix_new, ExplicitNull)):
			raise ValueError(f"'port_name_suffix' of incorrect type. Expected str, got {type(port_name_suffix_new)}")
		if port_name_varprfx_new is not None and not (isinstance(port_name_varprfx_new, str) or isinstance(port_name_varprfx_new, ExplicitNull)):
			raise ValueError(f"'port_name_varprfx' of incorrect type. Expected str, got {type(port_name_varprfx_new)}")
		if port_name_varprfx_join_dl_new is not None and not (isinstance(port_name_varprfx_join_dl_new, str) or isinstance(port_name_varprfx_join_dl_new, ExplicitNull)):
			raise ValueError(f"'port_name_varprfx_join_dl' of incorrect type. Expected str, got {type(port_name_varprfx_join_dl_new)}")
		if port_name_varprfx_split_dl_new is not None and not (isinstance(port_name_varprfx_split_dl_new, str) or isinstance(port_name_varprfx_split_dl_new, ExplicitNull)):
			raise ValueError(f"'port_name_varprfx_split_dl' of incorrect type. Expected str, got {type(port_name_varprfx_split_dl_new)}")

		return {'name': 'ndcfg.p_port2module_type.create', 'new': _denullify_dict({'port_type': port_type_new, 'port_count': port_count_new, 'port_name1': port_name1_new, 'port_proto': port_proto_new, 'port_speed': port_speed_new, 'module_type': module_type_new, 'num_mode_name': num_mode_name_new, 'num_mode_level': num_mode_level_new, 'port_inc_count': port_inc_count_new, 'port_type_order': port_type_order_new, 'port_name_prefix': port_name_prefix_new, 'port_name_suffix': port_name_suffix_new, 'port_name_varprfx': port_name_varprfx_new, 'port_name_varprfx_join_dl': port_name_varprfx_join_dl_new, 'port_name_varprfx_split_dl': port_name_varprfx_split_dl_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, port_type_new: str, port_count_new: int, port_proto_new: str, port_speed_new: str, module_type_new: str, num_mode_name_new: str, num_mode_level_new: int, port_name1_new: Union[str, ExplicitNull] = None, port_inc_count_new: int = 1, port_type_order_new: int = None, port_name_prefix_new: Union[str, ExplicitNull] = None, port_name_suffix_new: Union[str, ExplicitNull] = None, port_name_varprfx_new: Union[str, ExplicitNull] = None, port_name_varprfx_join_dl_new: Union[str, ExplicitNull] = None, port_name_varprfx_split_dl_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(port_type_new, str)):
			raise ValueError(f"'port_type' of incorrect type. Expected str, got {type(port_type_new)}")
		if not (isinstance(port_count_new, int)):
			raise ValueError(f"'port_count' of incorrect type. Expected int, got {type(port_count_new)}")
		if port_name1_new is not None and not (isinstance(port_name1_new, str) or isinstance(port_name1_new, ExplicitNull)):
			raise ValueError(f"'port_name1' of incorrect type. Expected str, got {type(port_name1_new)}")
		if not (isinstance(port_proto_new, str)):
			raise ValueError(f"'port_proto' of incorrect type. Expected str, got {type(port_proto_new)}")
		if not (isinstance(port_speed_new, str)):
			raise ValueError(f"'port_speed' of incorrect type. Expected str, got {type(port_speed_new)}")
		if not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if not (isinstance(num_mode_name_new, str)):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(num_mode_name_new)}")
		if not (isinstance(num_mode_level_new, int)):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(num_mode_level_new)}")
		if port_inc_count_new is not None and not (isinstance(port_inc_count_new, int)):
			raise ValueError(f"'port_inc_count' of incorrect type. Expected int, got {type(port_inc_count_new)}")
		if port_type_order_new is not None and not (isinstance(port_type_order_new, int)):
			raise ValueError(f"'port_type_order' of incorrect type. Expected int, got {type(port_type_order_new)}")
		if port_name_prefix_new is not None and not (isinstance(port_name_prefix_new, str) or isinstance(port_name_prefix_new, ExplicitNull)):
			raise ValueError(f"'port_name_prefix' of incorrect type. Expected str, got {type(port_name_prefix_new)}")
		if port_name_suffix_new is not None and not (isinstance(port_name_suffix_new, str) or isinstance(port_name_suffix_new, ExplicitNull)):
			raise ValueError(f"'port_name_suffix' of incorrect type. Expected str, got {type(port_name_suffix_new)}")
		if port_name_varprfx_new is not None and not (isinstance(port_name_varprfx_new, str) or isinstance(port_name_varprfx_new, ExplicitNull)):
			raise ValueError(f"'port_name_varprfx' of incorrect type. Expected str, got {type(port_name_varprfx_new)}")
		if port_name_varprfx_join_dl_new is not None and not (isinstance(port_name_varprfx_join_dl_new, str) or isinstance(port_name_varprfx_join_dl_new, ExplicitNull)):
			raise ValueError(f"'port_name_varprfx_join_dl' of incorrect type. Expected str, got {type(port_name_varprfx_join_dl_new)}")
		if port_name_varprfx_split_dl_new is not None and not (isinstance(port_name_varprfx_split_dl_new, str) or isinstance(port_name_varprfx_split_dl_new, ExplicitNull)):
			raise ValueError(f"'port_name_varprfx_split_dl' of incorrect type. Expected str, got {type(port_name_varprfx_split_dl_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(port_type_new=port_type_new, port_count_new=port_count_new, port_name1_new=port_name1_new, port_proto_new=port_proto_new, port_speed_new=port_speed_new, module_type_new=module_type_new, num_mode_name_new=num_mode_name_new, num_mode_level_new=num_mode_level_new, port_inc_count_new=port_inc_count_new, port_type_order_new=port_type_order_new, port_name_prefix_new=port_name_prefix_new, port_name_suffix_new=port_name_suffix_new, port_name_varprfx_new=port_name_varprfx_new, port_name_varprfx_join_dl_new=port_name_varprfx_join_dl_new, port_name_varprfx_split_dl_new=port_name_varprfx_split_dl_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'ndcfg.p_port2module_type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, fetch_limit_old: int = None, module_type_old: str = None, fetch_offset_old: int = None, port_type_list_old: list = None, port_proto_list_old: list = None, port_speed_list_old: list = None, module_type_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, port_type_group_list_old: list = None, port_type_order_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if module_type_old is not None and not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if port_type_list_old is not None and not (isinstance(port_type_list_old, list)):
			raise ValueError(f"'port_type_list' of incorrect type. Expected list, got {type(port_type_list_old)}")
		if port_proto_list_old is not None and not (isinstance(port_proto_list_old, list)):
			raise ValueError(f"'port_proto_list' of incorrect type. Expected list, got {type(port_proto_list_old)}")
		if port_speed_list_old is not None and not (isinstance(port_speed_list_old, list)):
			raise ValueError(f"'port_speed_list' of incorrect type. Expected list, got {type(port_speed_list_old)}")
		if module_type_list_old is not None and not (isinstance(module_type_list_old, list)):
			raise ValueError(f"'module_type_list' of incorrect type. Expected list, got {type(module_type_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if port_type_group_list_old is not None and not (isinstance(port_type_group_list_old, list)):
			raise ValueError(f"'port_type_group_list' of incorrect type. Expected list, got {type(port_type_group_list_old)}")
		if port_type_order_list_old is not None and not (isinstance(port_type_order_list_old, list)):
			raise ValueError(f"'port_type_order_list' of incorrect type. Expected list, got {type(port_type_order_list_old)}")

		return {'name': 'ndcfg.p_port2module_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'module_type': module_type_old, 'fetch_offset': fetch_offset_old, 'port_type_list': port_type_list_old, 'port_proto_list': port_proto_list_old, 'port_speed_list': port_speed_list_old, 'module_type_list': module_type_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'port_type_group_list': port_type_group_list_old, 'port_type_order_list': port_type_order_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, fetch_limit_old: int = None, module_type_old: str = None, fetch_offset_old: int = None, port_type_list_old: list = None, port_proto_list_old: list = None, port_speed_list_old: list = None, module_type_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, port_type_group_list_old: list = None, port_type_order_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if module_type_old is not None and not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if port_type_list_old is not None and not (isinstance(port_type_list_old, list)):
			raise ValueError(f"'port_type_list' of incorrect type. Expected list, got {type(port_type_list_old)}")
		if port_proto_list_old is not None and not (isinstance(port_proto_list_old, list)):
			raise ValueError(f"'port_proto_list' of incorrect type. Expected list, got {type(port_proto_list_old)}")
		if port_speed_list_old is not None and not (isinstance(port_speed_list_old, list)):
			raise ValueError(f"'port_speed_list' of incorrect type. Expected list, got {type(port_speed_list_old)}")
		if module_type_list_old is not None and not (isinstance(module_type_list_old, list)):
			raise ValueError(f"'module_type_list' of incorrect type. Expected list, got {type(module_type_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if port_type_group_list_old is not None and not (isinstance(port_type_group_list_old, list)):
			raise ValueError(f"'port_type_group_list' of incorrect type. Expected list, got {type(port_type_group_list_old)}")
		if port_type_order_list_old is not None and not (isinstance(port_type_order_list_old, list)):
			raise ValueError(f"'port_type_order_list' of incorrect type. Expected list, got {type(port_type_order_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, module_type_old=module_type_old, fetch_offset_old=fetch_offset_old, port_type_list_old=port_type_list_old, port_proto_list_old=port_proto_list_old, port_speed_list_old=port_speed_list_old, module_type_list_old=module_type_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, port_type_group_list_old=port_type_group_list_old, port_type_order_list_old=port_type_order_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, int_gfk_new: str = None, port_type_new: str = None, port_count_new: int = None, port_name1_new: Union[str, ExplicitNull] = None, port_proto_new: str = None, port_speed_new: str = None, module_type_new: str = None, num_mode_name_new: str = None, num_mode_level_new: int = None, port_inc_count_new: int = None, port_type_order_new: int = None, port_name_prefix_new: Union[str, ExplicitNull] = None, port_name_suffix_new: Union[str, ExplicitNull] = None, port_name_varprfx_new: Union[str, ExplicitNull] = None, port_name_varprfx_join_dl_new: Union[str, ExplicitNull] = None, port_name_varprfx_split_dl_new: Union[str, ExplicitNull] = None) -> dict:
		if int_gfk_new is not None and not (isinstance(int_gfk_new, str)):
			raise ValueError(f"'int_gfk' of incorrect type. Expected str, got {type(int_gfk_new)}")
		if port_type_new is not None and not (isinstance(port_type_new, str)):
			raise ValueError(f"'port_type' of incorrect type. Expected str, got {type(port_type_new)}")
		if port_count_new is not None and not (isinstance(port_count_new, int)):
			raise ValueError(f"'port_count' of incorrect type. Expected int, got {type(port_count_new)}")
		if port_name1_new is not None and not (isinstance(port_name1_new, str) or isinstance(port_name1_new, ExplicitNull)):
			raise ValueError(f"'port_name1' of incorrect type. Expected str, got {type(port_name1_new)}")
		if port_proto_new is not None and not (isinstance(port_proto_new, str)):
			raise ValueError(f"'port_proto' of incorrect type. Expected str, got {type(port_proto_new)}")
		if port_speed_new is not None and not (isinstance(port_speed_new, str)):
			raise ValueError(f"'port_speed' of incorrect type. Expected str, got {type(port_speed_new)}")
		if module_type_new is not None and not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if num_mode_name_new is not None and not (isinstance(num_mode_name_new, str)):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(num_mode_name_new)}")
		if num_mode_level_new is not None and not (isinstance(num_mode_level_new, int)):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(num_mode_level_new)}")
		if port_inc_count_new is not None and not (isinstance(port_inc_count_new, int)):
			raise ValueError(f"'port_inc_count' of incorrect type. Expected int, got {type(port_inc_count_new)}")
		if port_type_order_new is not None and not (isinstance(port_type_order_new, int)):
			raise ValueError(f"'port_type_order' of incorrect type. Expected int, got {type(port_type_order_new)}")
		if port_name_prefix_new is not None and not (isinstance(port_name_prefix_new, str) or isinstance(port_name_prefix_new, ExplicitNull)):
			raise ValueError(f"'port_name_prefix' of incorrect type. Expected str, got {type(port_name_prefix_new)}")
		if port_name_suffix_new is not None and not (isinstance(port_name_suffix_new, str) or isinstance(port_name_suffix_new, ExplicitNull)):
			raise ValueError(f"'port_name_suffix' of incorrect type. Expected str, got {type(port_name_suffix_new)}")
		if port_name_varprfx_new is not None and not (isinstance(port_name_varprfx_new, str) or isinstance(port_name_varprfx_new, ExplicitNull)):
			raise ValueError(f"'port_name_varprfx' of incorrect type. Expected str, got {type(port_name_varprfx_new)}")
		if port_name_varprfx_join_dl_new is not None and not (isinstance(port_name_varprfx_join_dl_new, str) or isinstance(port_name_varprfx_join_dl_new, ExplicitNull)):
			raise ValueError(f"'port_name_varprfx_join_dl' of incorrect type. Expected str, got {type(port_name_varprfx_join_dl_new)}")
		if port_name_varprfx_split_dl_new is not None and not (isinstance(port_name_varprfx_split_dl_new, str) or isinstance(port_name_varprfx_split_dl_new, ExplicitNull)):
			raise ValueError(f"'port_name_varprfx_split_dl' of incorrect type. Expected str, got {type(port_name_varprfx_split_dl_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'ndcfg.p_port2module_type.update', 'new': _denullify_dict({'int_gfk': int_gfk_new, 'port_type': port_type_new, 'port_count': port_count_new, 'port_name1': port_name1_new, 'port_proto': port_proto_new, 'port_speed': port_speed_new, 'module_type': module_type_new, 'num_mode_name': num_mode_name_new, 'num_mode_level': num_mode_level_new, 'port_inc_count': port_inc_count_new, 'port_type_order': port_type_order_new, 'port_name_prefix': port_name_prefix_new, 'port_name_suffix': port_name_suffix_new, 'port_name_varprfx': port_name_varprfx_new, 'port_name_varprfx_join_dl': port_name_varprfx_join_dl_new, 'port_name_varprfx_split_dl': port_name_varprfx_split_dl_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, int_gfk_new: str = None, port_type_new: str = None, port_count_new: int = None, port_name1_new: Union[str, ExplicitNull] = None, port_proto_new: str = None, port_speed_new: str = None, module_type_new: str = None, num_mode_name_new: str = None, num_mode_level_new: int = None, port_inc_count_new: int = None, port_type_order_new: int = None, port_name_prefix_new: Union[str, ExplicitNull] = None, port_name_suffix_new: Union[str, ExplicitNull] = None, port_name_varprfx_new: Union[str, ExplicitNull] = None, port_name_varprfx_join_dl_new: Union[str, ExplicitNull] = None, port_name_varprfx_split_dl_new: Union[str, ExplicitNull] = None) -> list:
		if int_gfk_new is not None and not (isinstance(int_gfk_new, str)):
			raise ValueError(f"'int_gfk' of incorrect type. Expected str, got {type(int_gfk_new)}")
		if port_type_new is not None and not (isinstance(port_type_new, str)):
			raise ValueError(f"'port_type' of incorrect type. Expected str, got {type(port_type_new)}")
		if port_count_new is not None and not (isinstance(port_count_new, int)):
			raise ValueError(f"'port_count' of incorrect type. Expected int, got {type(port_count_new)}")
		if port_name1_new is not None and not (isinstance(port_name1_new, str) or isinstance(port_name1_new, ExplicitNull)):
			raise ValueError(f"'port_name1' of incorrect type. Expected str, got {type(port_name1_new)}")
		if port_proto_new is not None and not (isinstance(port_proto_new, str)):
			raise ValueError(f"'port_proto' of incorrect type. Expected str, got {type(port_proto_new)}")
		if port_speed_new is not None and not (isinstance(port_speed_new, str)):
			raise ValueError(f"'port_speed' of incorrect type. Expected str, got {type(port_speed_new)}")
		if module_type_new is not None and not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if num_mode_name_new is not None and not (isinstance(num_mode_name_new, str)):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(num_mode_name_new)}")
		if num_mode_level_new is not None and not (isinstance(num_mode_level_new, int)):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(num_mode_level_new)}")
		if port_inc_count_new is not None and not (isinstance(port_inc_count_new, int)):
			raise ValueError(f"'port_inc_count' of incorrect type. Expected int, got {type(port_inc_count_new)}")
		if port_type_order_new is not None and not (isinstance(port_type_order_new, int)):
			raise ValueError(f"'port_type_order' of incorrect type. Expected int, got {type(port_type_order_new)}")
		if port_name_prefix_new is not None and not (isinstance(port_name_prefix_new, str) or isinstance(port_name_prefix_new, ExplicitNull)):
			raise ValueError(f"'port_name_prefix' of incorrect type. Expected str, got {type(port_name_prefix_new)}")
		if port_name_suffix_new is not None and not (isinstance(port_name_suffix_new, str) or isinstance(port_name_suffix_new, ExplicitNull)):
			raise ValueError(f"'port_name_suffix' of incorrect type. Expected str, got {type(port_name_suffix_new)}")
		if port_name_varprfx_new is not None and not (isinstance(port_name_varprfx_new, str) or isinstance(port_name_varprfx_new, ExplicitNull)):
			raise ValueError(f"'port_name_varprfx' of incorrect type. Expected str, got {type(port_name_varprfx_new)}")
		if port_name_varprfx_join_dl_new is not None and not (isinstance(port_name_varprfx_join_dl_new, str) or isinstance(port_name_varprfx_join_dl_new, ExplicitNull)):
			raise ValueError(f"'port_name_varprfx_join_dl' of incorrect type. Expected str, got {type(port_name_varprfx_join_dl_new)}")
		if port_name_varprfx_split_dl_new is not None and not (isinstance(port_name_varprfx_split_dl_new, str) or isinstance(port_name_varprfx_split_dl_new, ExplicitNull)):
			raise ValueError(f"'port_name_varprfx_split_dl' of incorrect type. Expected str, got {type(port_name_varprfx_split_dl_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(int_gfk_new=int_gfk_new, port_type_new=port_type_new, port_count_new=port_count_new, port_name1_new=port_name1_new, port_proto_new=port_proto_new, port_speed_new=port_speed_new, module_type_new=module_type_new, num_mode_name_new=num_mode_name_new, num_mode_level_new=num_mode_level_new, port_inc_count_new=port_inc_count_new, port_type_order_new=port_type_order_new, port_name_prefix_new=port_name_prefix_new, port_name_suffix_new=port_name_suffix_new, port_name_varprfx_new=port_name_varprfx_new, port_name_varprfx_join_dl_new=port_name_varprfx_join_dl_new, port_name_varprfx_split_dl_new=port_name_varprfx_split_dl_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Slot2moduleType(APIObject):
	gpk: str
	slot_type: str
	module_type: str
	num_mode_name: str
	subslot_count: int
	subslot_name1: str
	num_mode_level: int
	subslot_prefix: str
	subslot_inc_count: int
	subslot_type_order: int
	backplane_port_descr: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.slot_type, str):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(self.slot_type)}")
		if not isinstance(self.module_type, str):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(self.module_type)}")
		if not isinstance(self.num_mode_name, str):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(self.num_mode_name)}")
		if not isinstance(self.subslot_count, int):
			raise ValueError(f"'subslot_count' of incorrect type. Expected int, got {type(self.subslot_count)}")
		if self.subslot_name1 is not None and not isinstance(self.subslot_name1, str):
			raise ValueError(f"'subslot_name1' of incorrect type. Expected str, got {type(self.subslot_name1)}")
		if not isinstance(self.num_mode_level, int):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(self.num_mode_level)}")
		if self.subslot_prefix is not None and not isinstance(self.subslot_prefix, str):
			raise ValueError(f"'subslot_prefix' of incorrect type. Expected str, got {type(self.subslot_prefix)}")
		if not isinstance(self.subslot_inc_count, int):
			raise ValueError(f"'subslot_inc_count' of incorrect type. Expected int, got {type(self.subslot_inc_count)}")
		if not isinstance(self.subslot_type_order, int):
			raise ValueError(f"'subslot_type_order' of incorrect type. Expected int, got {type(self.subslot_type_order)}")
		if self.backplane_port_descr is not None and not isinstance(self.backplane_port_descr, str):
			raise ValueError(f"'backplane_port_descr' of incorrect type. Expected str, got {type(self.backplane_port_descr)}")

	@staticmethod
	def create_ta(slot_type_new: str, module_type_new: str, num_mode_name_new: str, subslot_count_new: int, num_mode_level_new: int, subslot_name1_new: Union[str, ExplicitNull] = None, subslot_prefix_new: Union[str, ExplicitNull] = None, subslot_inc_count_new: int = 1, subslot_type_order_new: int = None, backplane_port_descr_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(slot_type_new, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_new)}")
		if not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if not (isinstance(num_mode_name_new, str)):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(num_mode_name_new)}")
		if not (isinstance(subslot_count_new, int)):
			raise ValueError(f"'subslot_count' of incorrect type. Expected int, got {type(subslot_count_new)}")
		if subslot_name1_new is not None and not (isinstance(subslot_name1_new, str) or isinstance(subslot_name1_new, ExplicitNull)):
			raise ValueError(f"'subslot_name1' of incorrect type. Expected str, got {type(subslot_name1_new)}")
		if not (isinstance(num_mode_level_new, int)):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(num_mode_level_new)}")
		if subslot_prefix_new is not None and not (isinstance(subslot_prefix_new, str) or isinstance(subslot_prefix_new, ExplicitNull)):
			raise ValueError(f"'subslot_prefix' of incorrect type. Expected str, got {type(subslot_prefix_new)}")
		if subslot_inc_count_new is not None and not (isinstance(subslot_inc_count_new, int)):
			raise ValueError(f"'subslot_inc_count' of incorrect type. Expected int, got {type(subslot_inc_count_new)}")
		if subslot_type_order_new is not None and not (isinstance(subslot_type_order_new, int)):
			raise ValueError(f"'subslot_type_order' of incorrect type. Expected int, got {type(subslot_type_order_new)}")
		if backplane_port_descr_new is not None and not (isinstance(backplane_port_descr_new, str) or isinstance(backplane_port_descr_new, ExplicitNull)):
			raise ValueError(f"'backplane_port_descr' of incorrect type. Expected str, got {type(backplane_port_descr_new)}")

		return {'name': 'ndcfg.slot2module_type.create', 'new': _denullify_dict({'slot_type': slot_type_new, 'module_type': module_type_new, 'num_mode_name': num_mode_name_new, 'subslot_count': subslot_count_new, 'subslot_name1': subslot_name1_new, 'num_mode_level': num_mode_level_new, 'subslot_prefix': subslot_prefix_new, 'subslot_inc_count': subslot_inc_count_new, 'subslot_type_order': subslot_type_order_new, 'backplane_port_descr': backplane_port_descr_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, slot_type_new: str, module_type_new: str, num_mode_name_new: str, subslot_count_new: int, num_mode_level_new: int, subslot_name1_new: Union[str, ExplicitNull] = None, subslot_prefix_new: Union[str, ExplicitNull] = None, subslot_inc_count_new: int = 1, subslot_type_order_new: int = None, backplane_port_descr_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(slot_type_new, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_new)}")
		if not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if not (isinstance(num_mode_name_new, str)):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(num_mode_name_new)}")
		if not (isinstance(subslot_count_new, int)):
			raise ValueError(f"'subslot_count' of incorrect type. Expected int, got {type(subslot_count_new)}")
		if subslot_name1_new is not None and not (isinstance(subslot_name1_new, str) or isinstance(subslot_name1_new, ExplicitNull)):
			raise ValueError(f"'subslot_name1' of incorrect type. Expected str, got {type(subslot_name1_new)}")
		if not (isinstance(num_mode_level_new, int)):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(num_mode_level_new)}")
		if subslot_prefix_new is not None and not (isinstance(subslot_prefix_new, str) or isinstance(subslot_prefix_new, ExplicitNull)):
			raise ValueError(f"'subslot_prefix' of incorrect type. Expected str, got {type(subslot_prefix_new)}")
		if subslot_inc_count_new is not None and not (isinstance(subslot_inc_count_new, int)):
			raise ValueError(f"'subslot_inc_count' of incorrect type. Expected int, got {type(subslot_inc_count_new)}")
		if subslot_type_order_new is not None and not (isinstance(subslot_type_order_new, int)):
			raise ValueError(f"'subslot_type_order' of incorrect type. Expected int, got {type(subslot_type_order_new)}")
		if backplane_port_descr_new is not None and not (isinstance(backplane_port_descr_new, str) or isinstance(backplane_port_descr_new, ExplicitNull)):
			raise ValueError(f"'backplane_port_descr' of incorrect type. Expected str, got {type(backplane_port_descr_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(slot_type_new=slot_type_new, module_type_new=module_type_new, num_mode_name_new=num_mode_name_new, subslot_count_new=subslot_count_new, subslot_name1_new=subslot_name1_new, num_mode_level_new=num_mode_level_new, subslot_prefix_new=subslot_prefix_new, subslot_inc_count_new=subslot_inc_count_new, subslot_type_order_new=subslot_type_order_new, backplane_port_descr_new=backplane_port_descr_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(slot_type_old: str, module_type_old: str) -> dict:
		if not (isinstance(slot_type_old, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_old)}")
		if not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")

		return {'name': 'ndcfg.slot2module_type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'slot_type': slot_type_old, 'module_type': module_type_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, slot_type_old: str, module_type_old: str) -> list:
		if not (isinstance(slot_type_old, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_old)}")
		if not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(slot_type_old=slot_type_old, module_type_old=module_type_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, slot_type_old: str = None, fetch_limit_old: int = None, module_type_old: str = None, fetch_offset_old: int = None, slot_type_list_old: list = None, module_type_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if slot_type_old is not None and not (isinstance(slot_type_old, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if module_type_old is not None and not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if slot_type_list_old is not None and not (isinstance(slot_type_list_old, list)):
			raise ValueError(f"'slot_type_list' of incorrect type. Expected list, got {type(slot_type_list_old)}")
		if module_type_list_old is not None and not (isinstance(module_type_list_old, list)):
			raise ValueError(f"'module_type_list' of incorrect type. Expected list, got {type(module_type_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.slot2module_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'slot_type': slot_type_old, 'fetch_limit': fetch_limit_old, 'module_type': module_type_old, 'fetch_offset': fetch_offset_old, 'slot_type_list': slot_type_list_old, 'module_type_list': module_type_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, slot_type_old: str = None, fetch_limit_old: int = None, module_type_old: str = None, fetch_offset_old: int = None, slot_type_list_old: list = None, module_type_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if slot_type_old is not None and not (isinstance(slot_type_old, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if module_type_old is not None and not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if slot_type_list_old is not None and not (isinstance(slot_type_list_old, list)):
			raise ValueError(f"'slot_type_list' of incorrect type. Expected list, got {type(slot_type_list_old)}")
		if module_type_list_old is not None and not (isinstance(module_type_list_old, list)):
			raise ValueError(f"'module_type_list' of incorrect type. Expected list, got {type(module_type_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, slot_type_old=slot_type_old, fetch_limit_old=fetch_limit_old, module_type_old=module_type_old, fetch_offset_old=fetch_offset_old, slot_type_list_old=slot_type_list_old, module_type_list_old=module_type_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(slot_type_old: str, module_type_old: str, slot_type_new: str = None, module_type_new: str = None, num_mode_name_new: str = None, subslot_count_new: int = None, subslot_name1_new: Union[str, ExplicitNull] = None, num_mode_level_new: int = None, subslot_prefix_new: Union[str, ExplicitNull] = None, subslot_inc_count_new: int = None, subslot_type_order_new: int = None, backplane_port_descr_new: Union[str, ExplicitNull] = None) -> dict:
		if slot_type_new is not None and not (isinstance(slot_type_new, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_new)}")
		if module_type_new is not None and not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if num_mode_name_new is not None and not (isinstance(num_mode_name_new, str)):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(num_mode_name_new)}")
		if subslot_count_new is not None and not (isinstance(subslot_count_new, int)):
			raise ValueError(f"'subslot_count' of incorrect type. Expected int, got {type(subslot_count_new)}")
		if subslot_name1_new is not None and not (isinstance(subslot_name1_new, str) or isinstance(subslot_name1_new, ExplicitNull)):
			raise ValueError(f"'subslot_name1' of incorrect type. Expected str, got {type(subslot_name1_new)}")
		if num_mode_level_new is not None and not (isinstance(num_mode_level_new, int)):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(num_mode_level_new)}")
		if subslot_prefix_new is not None and not (isinstance(subslot_prefix_new, str) or isinstance(subslot_prefix_new, ExplicitNull)):
			raise ValueError(f"'subslot_prefix' of incorrect type. Expected str, got {type(subslot_prefix_new)}")
		if subslot_inc_count_new is not None and not (isinstance(subslot_inc_count_new, int)):
			raise ValueError(f"'subslot_inc_count' of incorrect type. Expected int, got {type(subslot_inc_count_new)}")
		if subslot_type_order_new is not None and not (isinstance(subslot_type_order_new, int)):
			raise ValueError(f"'subslot_type_order' of incorrect type. Expected int, got {type(subslot_type_order_new)}")
		if backplane_port_descr_new is not None and not (isinstance(backplane_port_descr_new, str) or isinstance(backplane_port_descr_new, ExplicitNull)):
			raise ValueError(f"'backplane_port_descr' of incorrect type. Expected str, got {type(backplane_port_descr_new)}")
		if not (isinstance(slot_type_old, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_old)}")
		if not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")

		return {'name': 'ndcfg.slot2module_type.update', 'new': _denullify_dict({'slot_type': slot_type_new, 'module_type': module_type_new, 'num_mode_name': num_mode_name_new, 'subslot_count': subslot_count_new, 'subslot_name1': subslot_name1_new, 'num_mode_level': num_mode_level_new, 'subslot_prefix': subslot_prefix_new, 'subslot_inc_count': subslot_inc_count_new, 'subslot_type_order': subslot_type_order_new, 'backplane_port_descr': backplane_port_descr_new}), 'old': _denullify_dict({'slot_type': slot_type_old, 'module_type': module_type_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, slot_type_old: str, module_type_old: str, slot_type_new: str = None, module_type_new: str = None, num_mode_name_new: str = None, subslot_count_new: int = None, subslot_name1_new: Union[str, ExplicitNull] = None, num_mode_level_new: int = None, subslot_prefix_new: Union[str, ExplicitNull] = None, subslot_inc_count_new: int = None, subslot_type_order_new: int = None, backplane_port_descr_new: Union[str, ExplicitNull] = None) -> list:
		if slot_type_new is not None and not (isinstance(slot_type_new, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_new)}")
		if module_type_new is not None and not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if num_mode_name_new is not None and not (isinstance(num_mode_name_new, str)):
			raise ValueError(f"'num_mode_name' of incorrect type. Expected str, got {type(num_mode_name_new)}")
		if subslot_count_new is not None and not (isinstance(subslot_count_new, int)):
			raise ValueError(f"'subslot_count' of incorrect type. Expected int, got {type(subslot_count_new)}")
		if subslot_name1_new is not None and not (isinstance(subslot_name1_new, str) or isinstance(subslot_name1_new, ExplicitNull)):
			raise ValueError(f"'subslot_name1' of incorrect type. Expected str, got {type(subslot_name1_new)}")
		if num_mode_level_new is not None and not (isinstance(num_mode_level_new, int)):
			raise ValueError(f"'num_mode_level' of incorrect type. Expected int, got {type(num_mode_level_new)}")
		if subslot_prefix_new is not None and not (isinstance(subslot_prefix_new, str) or isinstance(subslot_prefix_new, ExplicitNull)):
			raise ValueError(f"'subslot_prefix' of incorrect type. Expected str, got {type(subslot_prefix_new)}")
		if subslot_inc_count_new is not None and not (isinstance(subslot_inc_count_new, int)):
			raise ValueError(f"'subslot_inc_count' of incorrect type. Expected int, got {type(subslot_inc_count_new)}")
		if subslot_type_order_new is not None and not (isinstance(subslot_type_order_new, int)):
			raise ValueError(f"'subslot_type_order' of incorrect type. Expected int, got {type(subslot_type_order_new)}")
		if backplane_port_descr_new is not None and not (isinstance(backplane_port_descr_new, str) or isinstance(backplane_port_descr_new, ExplicitNull)):
			raise ValueError(f"'backplane_port_descr' of incorrect type. Expected str, got {type(backplane_port_descr_new)}")
		if not (isinstance(slot_type_old, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_old)}")
		if not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(slot_type_new=slot_type_new, module_type_new=module_type_new, num_mode_name_new=num_mode_name_new, subslot_count_new=subslot_count_new, subslot_name1_new=subslot_name1_new, num_mode_level_new=num_mode_level_new, subslot_prefix_new=subslot_prefix_new, subslot_inc_count_new=subslot_inc_count_new, subslot_type_order_new=subslot_type_order_new, backplane_port_descr_new=backplane_port_descr_new, slot_type_old=slot_type_old, module_type_old=module_type_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class PPortType(APIObject):
	gpk: str
	name: str
	is_internal: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.is_internal, bool):
			raise ValueError(f"'is_internal' of incorrect type. Expected bool, got {type(self.is_internal)}")

	@staticmethod
	def create_ta(name_new: str, is_internal_new: bool) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(is_internal_new, bool)):
			raise ValueError(f"'is_internal' of incorrect type. Expected bool, got {type(is_internal_new)}")

		return {'name': 'ndcfg.p_port_type.create', 'new': _denullify_dict({'name': name_new, 'is_internal': is_internal_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, is_internal_new: bool) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(is_internal_new, bool)):
			raise ValueError(f"'is_internal' of incorrect type. Expected bool, got {type(is_internal_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, is_internal_new=is_internal_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.p_port_type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, is_internal_old: bool = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_internal_old is not None and not (isinstance(is_internal_old, bool)):
			raise ValueError(f"'is_internal' of incorrect type. Expected bool, got {type(is_internal_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.p_port_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'is_internal': is_internal_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, is_internal_old: bool = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_internal_old is not None and not (isinstance(is_internal_old, bool)):
			raise ValueError(f"'is_internal' of incorrect type. Expected bool, got {type(is_internal_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, is_internal_old=is_internal_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, is_internal_new: bool = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if is_internal_new is not None and not (isinstance(is_internal_new, bool)):
			raise ValueError(f"'is_internal' of incorrect type. Expected bool, got {type(is_internal_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.p_port_type.update', 'new': _denullify_dict({'name': name_new, 'is_internal': is_internal_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, is_internal_new: bool = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if is_internal_new is not None and not (isinstance(is_internal_new, bool)):
			raise ValueError(f"'is_internal' of incorrect type. Expected bool, got {type(is_internal_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, is_internal_new=is_internal_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class SlotType(APIObject):
	gpk: str
	name: str
	cls: str
	slot_width: int
	submt_count: int

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.cls, str):
			raise ValueError(f"'cls' of incorrect type. Expected str, got {type(self.cls)}")
		if not isinstance(self.slot_width, int):
			raise ValueError(f"'slot_width' of incorrect type. Expected int, got {type(self.slot_width)}")
		if not isinstance(self.submt_count, int):
			raise ValueError(f"'submt_count' of incorrect type. Expected int, got {type(self.submt_count)}")

	@staticmethod
	def create_ta(name_new: str, cls_new: str, slot_width_new: int = 1) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(cls_new, str)):
			raise ValueError(f"'cls' of incorrect type. Expected str, got {type(cls_new)}")
		if slot_width_new is not None and not (isinstance(slot_width_new, int)):
			raise ValueError(f"'slot_width' of incorrect type. Expected int, got {type(slot_width_new)}")

		return {'name': 'ndcfg.slot_type.create', 'new': _denullify_dict({'name': name_new, 'cls': cls_new, 'slot_width': slot_width_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, cls_new: str, slot_width_new: int = 1) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(cls_new, str)):
			raise ValueError(f"'cls' of incorrect type. Expected str, got {type(cls_new)}")
		if slot_width_new is not None and not (isinstance(slot_width_new, int)):
			raise ValueError(f"'slot_width' of incorrect type. Expected int, got {type(slot_width_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, cls_new=cls_new, slot_width_new=slot_width_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.slot_type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, cls_old: str = None, gpk_list_old: list = None, name_list_old: list = None, slot_width_old: int = None, fetch_limit_old: int = None, submt_count_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if cls_old is not None and not (isinstance(cls_old, str)):
			raise ValueError(f"'cls' of incorrect type. Expected str, got {type(cls_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if slot_width_old is not None and not (isinstance(slot_width_old, int)):
			raise ValueError(f"'slot_width' of incorrect type. Expected int, got {type(slot_width_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if submt_count_old is not None and not (isinstance(submt_count_old, int)):
			raise ValueError(f"'submt_count' of incorrect type. Expected int, got {type(submt_count_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.slot_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'cls': cls_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'slot_width': slot_width_old, 'fetch_limit': fetch_limit_old, 'submt_count': submt_count_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, cls_old: str = None, gpk_list_old: list = None, name_list_old: list = None, slot_width_old: int = None, fetch_limit_old: int = None, submt_count_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if cls_old is not None and not (isinstance(cls_old, str)):
			raise ValueError(f"'cls' of incorrect type. Expected str, got {type(cls_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if slot_width_old is not None and not (isinstance(slot_width_old, int)):
			raise ValueError(f"'slot_width' of incorrect type. Expected int, got {type(slot_width_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if submt_count_old is not None and not (isinstance(submt_count_old, int)):
			raise ValueError(f"'submt_count' of incorrect type. Expected int, got {type(submt_count_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, cls_old=cls_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, slot_width_old=slot_width_old, fetch_limit_old=fetch_limit_old, submt_count_old=submt_count_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, cls_new: str = None, slot_width_new: int = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if cls_new is not None and not (isinstance(cls_new, str)):
			raise ValueError(f"'cls' of incorrect type. Expected str, got {type(cls_new)}")
		if slot_width_new is not None and not (isinstance(slot_width_new, int)):
			raise ValueError(f"'slot_width' of incorrect type. Expected int, got {type(slot_width_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.slot_type.update', 'new': _denullify_dict({'name': name_new, 'cls': cls_new, 'slot_width': slot_width_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, cls_new: str = None, slot_width_new: int = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if cls_new is not None and not (isinstance(cls_new, str)):
			raise ValueError(f"'cls' of incorrect type. Expected str, got {type(cls_new)}")
		if slot_width_new is not None and not (isinstance(slot_width_new, int)):
			raise ValueError(f"'slot_width' of incorrect type. Expected int, got {type(slot_width_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, cls_new=cls_new, slot_width_new=slot_width_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class PPortTypeGroup(APIObject):
	gpk: str
	name: str
	is_permanent: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.is_permanent, bool):
			raise ValueError(f"'is_permanent' of incorrect type. Expected bool, got {type(self.is_permanent)}")

	@staticmethod
	def create_ta(name_new: str, is_permanent_new: bool) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(is_permanent_new, bool)):
			raise ValueError(f"'is_permanent' of incorrect type. Expected bool, got {type(is_permanent_new)}")

		return {'name': 'ndcfg.p_port_type_group.create', 'new': _denullify_dict({'name': name_new, 'is_permanent': is_permanent_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, is_permanent_new: bool) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(is_permanent_new, bool)):
			raise ValueError(f"'is_permanent' of incorrect type. Expected bool, got {type(is_permanent_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, is_permanent_new=is_permanent_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.p_port_type_group.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_permanent_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_permanent_old is not None and not (isinstance(is_permanent_old, bool)):
			raise ValueError(f"'is_permanent' of incorrect type. Expected bool, got {type(is_permanent_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.p_port_type_group.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'is_permanent': is_permanent_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_permanent_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_permanent_old is not None and not (isinstance(is_permanent_old, bool)):
			raise ValueError(f"'is_permanent' of incorrect type. Expected bool, got {type(is_permanent_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, is_permanent_old=is_permanent_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, is_permanent_new: bool = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if is_permanent_new is not None and not (isinstance(is_permanent_new, bool)):
			raise ValueError(f"'is_permanent' of incorrect type. Expected bool, got {type(is_permanent_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.p_port_type_group.update', 'new': _denullify_dict({'name': name_new, 'is_permanent': is_permanent_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, is_permanent_new: bool = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if is_permanent_new is not None and not (isinstance(is_permanent_new, bool)):
			raise ValueError(f"'is_permanent' of incorrect type. Expected bool, got {type(is_permanent_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, is_permanent_new=is_permanent_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class NetInstnc(APIObject):
	gpk: str
	name: str
	description: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")

	@staticmethod
	def create_ta(name_new: str, description_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		return {'name': 'ndcfg.net_instnc.create', 'new': _denullify_dict({'name': name_new, 'description': description_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, description_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, description_new=description_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.net_instnc.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.net_instnc.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, description_new: Union[str, ExplicitNull] = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.net_instnc.update', 'new': _denullify_dict({'name': name_new, 'description': description_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, description_new: Union[str, ExplicitNull] = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, description_new=description_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class PPortTypeData(APIObject):
	gpk: str
	port_type: str
	port_group: str
	port_proto: str
	port_speed: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.port_type, str):
			raise ValueError(f"'port_type' of incorrect type. Expected str, got {type(self.port_type)}")
		if not isinstance(self.port_group, str):
			raise ValueError(f"'port_group' of incorrect type. Expected str, got {type(self.port_group)}")
		if not isinstance(self.port_proto, str):
			raise ValueError(f"'port_proto' of incorrect type. Expected str, got {type(self.port_proto)}")
		if not isinstance(self.port_speed, str):
			raise ValueError(f"'port_speed' of incorrect type. Expected str, got {type(self.port_speed)}")

	@staticmethod
	def create_ta(port_type_new: str, port_group_new: str, port_proto_new: str, port_speed_new: str) -> dict:
		if not (isinstance(port_type_new, str)):
			raise ValueError(f"'port_type' of incorrect type. Expected str, got {type(port_type_new)}")
		if not (isinstance(port_group_new, str)):
			raise ValueError(f"'port_group' of incorrect type. Expected str, got {type(port_group_new)}")
		if not (isinstance(port_proto_new, str)):
			raise ValueError(f"'port_proto' of incorrect type. Expected str, got {type(port_proto_new)}")
		if not (isinstance(port_speed_new, str)):
			raise ValueError(f"'port_speed' of incorrect type. Expected str, got {type(port_speed_new)}")

		return {'name': 'ndcfg.p_port_type_data.create', 'new': _denullify_dict({'port_type': port_type_new, 'port_group': port_group_new, 'port_proto': port_proto_new, 'port_speed': port_speed_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, port_type_new: str, port_group_new: str, port_proto_new: str, port_speed_new: str) -> list:
		if not (isinstance(port_type_new, str)):
			raise ValueError(f"'port_type' of incorrect type. Expected str, got {type(port_type_new)}")
		if not (isinstance(port_group_new, str)):
			raise ValueError(f"'port_group' of incorrect type. Expected str, got {type(port_group_new)}")
		if not (isinstance(port_proto_new, str)):
			raise ValueError(f"'port_proto' of incorrect type. Expected str, got {type(port_proto_new)}")
		if not (isinstance(port_speed_new, str)):
			raise ValueError(f"'port_speed' of incorrect type. Expected str, got {type(port_speed_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(port_type_new=port_type_new, port_group_new=port_group_new, port_proto_new=port_proto_new, port_speed_new=port_speed_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(port_type_old: str, port_proto_old: str, port_speed_old: str) -> dict:
		if not (isinstance(port_type_old, str)):
			raise ValueError(f"'port_type' of incorrect type. Expected str, got {type(port_type_old)}")
		if not (isinstance(port_proto_old, str)):
			raise ValueError(f"'port_proto' of incorrect type. Expected str, got {type(port_proto_old)}")
		if not (isinstance(port_speed_old, str)):
			raise ValueError(f"'port_speed' of incorrect type. Expected str, got {type(port_speed_old)}")

		return {'name': 'ndcfg.p_port_type_data.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'port_type': port_type_old, 'port_proto': port_proto_old, 'port_speed': port_speed_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, port_type_old: str, port_proto_old: str, port_speed_old: str) -> list:
		if not (isinstance(port_type_old, str)):
			raise ValueError(f"'port_type' of incorrect type. Expected str, got {type(port_type_old)}")
		if not (isinstance(port_proto_old, str)):
			raise ValueError(f"'port_proto' of incorrect type. Expected str, got {type(port_proto_old)}")
		if not (isinstance(port_speed_old, str)):
			raise ValueError(f"'port_speed' of incorrect type. Expected str, got {type(port_speed_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(port_type_old=port_type_old, port_proto_old=port_proto_old, port_speed_old=port_speed_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, port_type_list_old: list = None, port_proto_list_old: list = None, port_speed_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if port_type_list_old is not None and not (isinstance(port_type_list_old, list)):
			raise ValueError(f"'port_type_list' of incorrect type. Expected list, got {type(port_type_list_old)}")
		if port_proto_list_old is not None and not (isinstance(port_proto_list_old, list)):
			raise ValueError(f"'port_proto_list' of incorrect type. Expected list, got {type(port_proto_list_old)}")
		if port_speed_list_old is not None and not (isinstance(port_speed_list_old, list)):
			raise ValueError(f"'port_speed_list' of incorrect type. Expected list, got {type(port_speed_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.p_port_type_data.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'port_type_list': port_type_list_old, 'port_proto_list': port_proto_list_old, 'port_speed_list': port_speed_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, port_type_list_old: list = None, port_proto_list_old: list = None, port_speed_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if port_type_list_old is not None and not (isinstance(port_type_list_old, list)):
			raise ValueError(f"'port_type_list' of incorrect type. Expected list, got {type(port_type_list_old)}")
		if port_proto_list_old is not None and not (isinstance(port_proto_list_old, list)):
			raise ValueError(f"'port_proto_list' of incorrect type. Expected list, got {type(port_proto_list_old)}")
		if port_speed_list_old is not None and not (isinstance(port_speed_list_old, list)):
			raise ValueError(f"'port_speed_list' of incorrect type. Expected list, got {type(port_speed_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, port_type_list_old=port_type_list_old, port_proto_list_old=port_proto_list_old, port_speed_list_old=port_speed_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(port_type_old: str, port_proto_old: str, port_speed_old: str, port_type_new: str = None, port_group_new: str = None, port_proto_new: str = None, port_speed_new: str = None) -> dict:
		if port_type_new is not None and not (isinstance(port_type_new, str)):
			raise ValueError(f"'port_type' of incorrect type. Expected str, got {type(port_type_new)}")
		if port_group_new is not None and not (isinstance(port_group_new, str)):
			raise ValueError(f"'port_group' of incorrect type. Expected str, got {type(port_group_new)}")
		if port_proto_new is not None and not (isinstance(port_proto_new, str)):
			raise ValueError(f"'port_proto' of incorrect type. Expected str, got {type(port_proto_new)}")
		if port_speed_new is not None and not (isinstance(port_speed_new, str)):
			raise ValueError(f"'port_speed' of incorrect type. Expected str, got {type(port_speed_new)}")
		if not (isinstance(port_type_old, str)):
			raise ValueError(f"'port_type' of incorrect type. Expected str, got {type(port_type_old)}")
		if not (isinstance(port_proto_old, str)):
			raise ValueError(f"'port_proto' of incorrect type. Expected str, got {type(port_proto_old)}")
		if not (isinstance(port_speed_old, str)):
			raise ValueError(f"'port_speed' of incorrect type. Expected str, got {type(port_speed_old)}")

		return {'name': 'ndcfg.p_port_type_data.update', 'new': _denullify_dict({'port_type': port_type_new, 'port_group': port_group_new, 'port_proto': port_proto_new, 'port_speed': port_speed_new}), 'old': _denullify_dict({'port_type': port_type_old, 'port_proto': port_proto_old, 'port_speed': port_speed_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, port_type_old: str, port_proto_old: str, port_speed_old: str, port_type_new: str = None, port_group_new: str = None, port_proto_new: str = None, port_speed_new: str = None) -> list:
		if port_type_new is not None and not (isinstance(port_type_new, str)):
			raise ValueError(f"'port_type' of incorrect type. Expected str, got {type(port_type_new)}")
		if port_group_new is not None and not (isinstance(port_group_new, str)):
			raise ValueError(f"'port_group' of incorrect type. Expected str, got {type(port_group_new)}")
		if port_proto_new is not None and not (isinstance(port_proto_new, str)):
			raise ValueError(f"'port_proto' of incorrect type. Expected str, got {type(port_proto_new)}")
		if port_speed_new is not None and not (isinstance(port_speed_new, str)):
			raise ValueError(f"'port_speed' of incorrect type. Expected str, got {type(port_speed_new)}")
		if not (isinstance(port_type_old, str)):
			raise ValueError(f"'port_type' of incorrect type. Expected str, got {type(port_type_old)}")
		if not (isinstance(port_proto_old, str)):
			raise ValueError(f"'port_proto' of incorrect type. Expected str, got {type(port_proto_old)}")
		if not (isinstance(port_speed_old, str)):
			raise ValueError(f"'port_speed' of incorrect type. Expected str, got {type(port_speed_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(port_type_new=port_type_new, port_group_new=port_group_new, port_proto_new=port_proto_new, port_speed_new=port_speed_new, port_type_old=port_type_old, port_proto_old=port_proto_old, port_speed_old=port_speed_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class ModuleType(APIObject):
	gpk: str
	name: str
	cls: str
	is_child: bool
	is_active: bool
	is_parent: bool
	has_unq_name: bool
	is_forwarding: bool
	is_loc_depdnt: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.cls, str):
			raise ValueError(f"'cls' of incorrect type. Expected str, got {type(self.cls)}")
		if not isinstance(self.is_child, bool):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(self.is_child)}")
		if not isinstance(self.is_active, bool):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(self.is_active)}")
		if not isinstance(self.is_parent, bool):
			raise ValueError(f"'is_parent' of incorrect type. Expected bool, got {type(self.is_parent)}")
		if not isinstance(self.has_unq_name, bool):
			raise ValueError(f"'has_unq_name' of incorrect type. Expected bool, got {type(self.has_unq_name)}")
		if not isinstance(self.is_forwarding, bool):
			raise ValueError(f"'is_forwarding' of incorrect type. Expected bool, got {type(self.is_forwarding)}")
		if not isinstance(self.is_loc_depdnt, bool):
			raise ValueError(f"'is_loc_depdnt' of incorrect type. Expected bool, got {type(self.is_loc_depdnt)}")

	@staticmethod
	def create_ta(name_new: str, cls_new: str = None, is_child_new: bool = None, is_active_new: bool = None, is_parent_new: bool = None, has_unq_name_new: bool = None, is_forwarding_new: bool = None, is_loc_depdnt_new: bool = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if cls_new is not None and not (isinstance(cls_new, str)):
			raise ValueError(f"'cls' of incorrect type. Expected str, got {type(cls_new)}")
		if is_child_new is not None and not (isinstance(is_child_new, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_new)}")
		if is_active_new is not None and not (isinstance(is_active_new, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_new)}")
		if is_parent_new is not None and not (isinstance(is_parent_new, bool)):
			raise ValueError(f"'is_parent' of incorrect type. Expected bool, got {type(is_parent_new)}")
		if has_unq_name_new is not None and not (isinstance(has_unq_name_new, bool)):
			raise ValueError(f"'has_unq_name' of incorrect type. Expected bool, got {type(has_unq_name_new)}")
		if is_forwarding_new is not None and not (isinstance(is_forwarding_new, bool)):
			raise ValueError(f"'is_forwarding' of incorrect type. Expected bool, got {type(is_forwarding_new)}")
		if is_loc_depdnt_new is not None and not (isinstance(is_loc_depdnt_new, bool)):
			raise ValueError(f"'is_loc_depdnt' of incorrect type. Expected bool, got {type(is_loc_depdnt_new)}")

		return {'name': 'ndcfg.module_type.create', 'new': _denullify_dict({'name': name_new, 'cls': cls_new, 'is_child': is_child_new, 'is_active': is_active_new, 'is_parent': is_parent_new, 'has_unq_name': has_unq_name_new, 'is_forwarding': is_forwarding_new, 'is_loc_depdnt': is_loc_depdnt_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, cls_new: str = None, is_child_new: bool = None, is_active_new: bool = None, is_parent_new: bool = None, has_unq_name_new: bool = None, is_forwarding_new: bool = None, is_loc_depdnt_new: bool = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if cls_new is not None and not (isinstance(cls_new, str)):
			raise ValueError(f"'cls' of incorrect type. Expected str, got {type(cls_new)}")
		if is_child_new is not None and not (isinstance(is_child_new, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_new)}")
		if is_active_new is not None and not (isinstance(is_active_new, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_new)}")
		if is_parent_new is not None and not (isinstance(is_parent_new, bool)):
			raise ValueError(f"'is_parent' of incorrect type. Expected bool, got {type(is_parent_new)}")
		if has_unq_name_new is not None and not (isinstance(has_unq_name_new, bool)):
			raise ValueError(f"'has_unq_name' of incorrect type. Expected bool, got {type(has_unq_name_new)}")
		if is_forwarding_new is not None and not (isinstance(is_forwarding_new, bool)):
			raise ValueError(f"'is_forwarding' of incorrect type. Expected bool, got {type(is_forwarding_new)}")
		if is_loc_depdnt_new is not None and not (isinstance(is_loc_depdnt_new, bool)):
			raise ValueError(f"'is_loc_depdnt' of incorrect type. Expected bool, got {type(is_loc_depdnt_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, cls_new=cls_new, is_child_new=is_child_new, is_active_new=is_active_new, is_parent_new=is_parent_new, has_unq_name_new=has_unq_name_new, is_forwarding_new=is_forwarding_new, is_loc_depdnt_new=is_loc_depdnt_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.module_type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, cls_old: str = None, gpk_list_old: list = None, is_child_old: bool = None, is_active_old: bool = None, is_parent_old: bool = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, has_unq_name_old: bool = None, is_forwarding_old: bool = None, is_loc_depdnt_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if cls_old is not None and not (isinstance(cls_old, str)):
			raise ValueError(f"'cls' of incorrect type. Expected str, got {type(cls_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if is_child_old is not None and not (isinstance(is_child_old, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_old)}")
		if is_active_old is not None and not (isinstance(is_active_old, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_old)}")
		if is_parent_old is not None and not (isinstance(is_parent_old, bool)):
			raise ValueError(f"'is_parent' of incorrect type. Expected bool, got {type(is_parent_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if has_unq_name_old is not None and not (isinstance(has_unq_name_old, bool)):
			raise ValueError(f"'has_unq_name' of incorrect type. Expected bool, got {type(has_unq_name_old)}")
		if is_forwarding_old is not None and not (isinstance(is_forwarding_old, bool)):
			raise ValueError(f"'is_forwarding' of incorrect type. Expected bool, got {type(is_forwarding_old)}")
		if is_loc_depdnt_old is not None and not (isinstance(is_loc_depdnt_old, bool)):
			raise ValueError(f"'is_loc_depdnt' of incorrect type. Expected bool, got {type(is_loc_depdnt_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.module_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'cls': cls_old, 'gpk_list': gpk_list_old, 'is_child': is_child_old, 'is_active': is_active_old, 'is_parent': is_parent_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'has_unq_name': has_unq_name_old, 'is_forwarding': is_forwarding_old, 'is_loc_depdnt': is_loc_depdnt_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, cls_old: str = None, gpk_list_old: list = None, is_child_old: bool = None, is_active_old: bool = None, is_parent_old: bool = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, has_unq_name_old: bool = None, is_forwarding_old: bool = None, is_loc_depdnt_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if cls_old is not None and not (isinstance(cls_old, str)):
			raise ValueError(f"'cls' of incorrect type. Expected str, got {type(cls_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if is_child_old is not None and not (isinstance(is_child_old, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_old)}")
		if is_active_old is not None and not (isinstance(is_active_old, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_old)}")
		if is_parent_old is not None and not (isinstance(is_parent_old, bool)):
			raise ValueError(f"'is_parent' of incorrect type. Expected bool, got {type(is_parent_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if has_unq_name_old is not None and not (isinstance(has_unq_name_old, bool)):
			raise ValueError(f"'has_unq_name' of incorrect type. Expected bool, got {type(has_unq_name_old)}")
		if is_forwarding_old is not None and not (isinstance(is_forwarding_old, bool)):
			raise ValueError(f"'is_forwarding' of incorrect type. Expected bool, got {type(is_forwarding_old)}")
		if is_loc_depdnt_old is not None and not (isinstance(is_loc_depdnt_old, bool)):
			raise ValueError(f"'is_loc_depdnt' of incorrect type. Expected bool, got {type(is_loc_depdnt_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, cls_old=cls_old, gpk_list_old=gpk_list_old, is_child_old=is_child_old, is_active_old=is_active_old, is_parent_old=is_parent_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, has_unq_name_old=has_unq_name_old, is_forwarding_old=is_forwarding_old, is_loc_depdnt_old=is_loc_depdnt_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, cls_new: str = None, is_child_new: bool = None, is_active_new: bool = None, is_parent_new: bool = None, has_unq_name_new: bool = None, is_forwarding_new: bool = None, is_loc_depdnt_new: bool = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if cls_new is not None and not (isinstance(cls_new, str)):
			raise ValueError(f"'cls' of incorrect type. Expected str, got {type(cls_new)}")
		if is_child_new is not None and not (isinstance(is_child_new, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_new)}")
		if is_active_new is not None and not (isinstance(is_active_new, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_new)}")
		if is_parent_new is not None and not (isinstance(is_parent_new, bool)):
			raise ValueError(f"'is_parent' of incorrect type. Expected bool, got {type(is_parent_new)}")
		if has_unq_name_new is not None and not (isinstance(has_unq_name_new, bool)):
			raise ValueError(f"'has_unq_name' of incorrect type. Expected bool, got {type(has_unq_name_new)}")
		if is_forwarding_new is not None and not (isinstance(is_forwarding_new, bool)):
			raise ValueError(f"'is_forwarding' of incorrect type. Expected bool, got {type(is_forwarding_new)}")
		if is_loc_depdnt_new is not None and not (isinstance(is_loc_depdnt_new, bool)):
			raise ValueError(f"'is_loc_depdnt' of incorrect type. Expected bool, got {type(is_loc_depdnt_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.module_type.update', 'new': _denullify_dict({'name': name_new, 'cls': cls_new, 'is_child': is_child_new, 'is_active': is_active_new, 'is_parent': is_parent_new, 'has_unq_name': has_unq_name_new, 'is_forwarding': is_forwarding_new, 'is_loc_depdnt': is_loc_depdnt_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, cls_new: str = None, is_child_new: bool = None, is_active_new: bool = None, is_parent_new: bool = None, has_unq_name_new: bool = None, is_forwarding_new: bool = None, is_loc_depdnt_new: bool = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if cls_new is not None and not (isinstance(cls_new, str)):
			raise ValueError(f"'cls' of incorrect type. Expected str, got {type(cls_new)}")
		if is_child_new is not None and not (isinstance(is_child_new, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_new)}")
		if is_active_new is not None and not (isinstance(is_active_new, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_new)}")
		if is_parent_new is not None and not (isinstance(is_parent_new, bool)):
			raise ValueError(f"'is_parent' of incorrect type. Expected bool, got {type(is_parent_new)}")
		if has_unq_name_new is not None and not (isinstance(has_unq_name_new, bool)):
			raise ValueError(f"'has_unq_name' of incorrect type. Expected bool, got {type(has_unq_name_new)}")
		if is_forwarding_new is not None and not (isinstance(is_forwarding_new, bool)):
			raise ValueError(f"'is_forwarding' of incorrect type. Expected bool, got {type(is_forwarding_new)}")
		if is_loc_depdnt_new is not None and not (isinstance(is_loc_depdnt_new, bool)):
			raise ValueError(f"'is_loc_depdnt' of incorrect type. Expected bool, got {type(is_loc_depdnt_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, cls_new=cls_new, is_child_new=is_child_new, is_active_new=is_active_new, is_parent_new=is_parent_new, has_unq_name_new=has_unq_name_new, is_forwarding_new=is_forwarding_new, is_loc_depdnt_new=is_loc_depdnt_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class DeviceType(APIObject):
	gpk: str
	name: str
	description: str
	nw_fwd_level: int

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.nw_fwd_level, int):
			raise ValueError(f"'nw_fwd_level' of incorrect type. Expected int, got {type(self.nw_fwd_level)}")

	@staticmethod
	def create_ta(name_new: str, description_new: str, nw_fwd_level_new: int) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(nw_fwd_level_new, int)):
			raise ValueError(f"'nw_fwd_level' of incorrect type. Expected int, got {type(nw_fwd_level_new)}")

		return {'name': 'ndcfg.device_type.create', 'new': _denullify_dict({'name': name_new, 'description': description_new, 'nw_fwd_level': nw_fwd_level_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, description_new: str, nw_fwd_level_new: int) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(nw_fwd_level_new, int)):
			raise ValueError(f"'nw_fwd_level' of incorrect type. Expected int, got {type(nw_fwd_level_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, description_new=description_new, nw_fwd_level_new=nw_fwd_level_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.device_type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, nw_fwd_level_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if nw_fwd_level_old is not None and not (isinstance(nw_fwd_level_old, int)):
			raise ValueError(f"'nw_fwd_level' of incorrect type. Expected int, got {type(nw_fwd_level_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.device_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'nw_fwd_level': nw_fwd_level_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, nw_fwd_level_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if nw_fwd_level_old is not None and not (isinstance(nw_fwd_level_old, int)):
			raise ValueError(f"'nw_fwd_level' of incorrect type. Expected int, got {type(nw_fwd_level_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, nw_fwd_level_old=nw_fwd_level_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_new: str = None, description_new: str = None, nw_fwd_level_new: int = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if nw_fwd_level_new is not None and not (isinstance(nw_fwd_level_new, int)):
			raise ValueError(f"'nw_fwd_level' of incorrect type. Expected int, got {type(nw_fwd_level_new)}")

		return {'name': 'ndcfg.device_type.update', 'new': _denullify_dict({'name': name_new, 'description': description_new, 'nw_fwd_level': nw_fwd_level_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_new: str = None, description_new: str = None, nw_fwd_level_new: int = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if nw_fwd_level_new is not None and not (isinstance(nw_fwd_level_new, int)):
			raise ValueError(f"'nw_fwd_level' of incorrect type. Expected int, got {type(nw_fwd_level_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, description_new=description_new, nw_fwd_level_new=nw_fwd_level_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Parser(APIObject):
	gpk: str
	name: str
	exec_args: dict
	description: str
	access_group: str
	is_executable: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.exec_args, dict):
			raise ValueError(f"'exec_args' of incorrect type. Expected dict, got {type(self.exec_args)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.access_group, str):
			raise ValueError(f"'access_group' of incorrect type. Expected str, got {type(self.access_group)}")
		if not isinstance(self.is_executable, bool):
			raise ValueError(f"'is_executable' of incorrect type. Expected bool, got {type(self.is_executable)}")

	@staticmethod
	def create_ta(name_new: str, access_group_new: str, exec_args_new: dict = {}, description_new: Union[str, ExplicitNull] = None, is_executable_new: bool = True) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if exec_args_new is not None and not (isinstance(exec_args_new, dict)):
			raise ValueError(f"'exec_args' of incorrect type. Expected dict, got {type(exec_args_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(access_group_new, str)):
			raise ValueError(f"'access_group' of incorrect type. Expected str, got {type(access_group_new)}")
		if is_executable_new is not None and not (isinstance(is_executable_new, bool)):
			raise ValueError(f"'is_executable' of incorrect type. Expected bool, got {type(is_executable_new)}")

		return {'name': 'ndcfg.parser.create', 'new': _denullify_dict({'name': name_new, 'exec_args': exec_args_new, 'description': description_new, 'access_group': access_group_new, 'is_executable': is_executable_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, access_group_new: str, exec_args_new: dict = {}, description_new: Union[str, ExplicitNull] = None, is_executable_new: bool = True) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if exec_args_new is not None and not (isinstance(exec_args_new, dict)):
			raise ValueError(f"'exec_args' of incorrect type. Expected dict, got {type(exec_args_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(access_group_new, str)):
			raise ValueError(f"'access_group' of incorrect type. Expected str, got {type(access_group_new)}")
		if is_executable_new is not None and not (isinstance(is_executable_new, bool)):
			raise ValueError(f"'is_executable' of incorrect type. Expected bool, got {type(is_executable_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, exec_args_new=exec_args_new, description_new=description_new, access_group_new=access_group_new, is_executable_new=is_executable_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.parser.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, access_group_old: str = None, fetch_offset_old: int = None, is_executable_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if access_group_old is not None and not (isinstance(access_group_old, str)):
			raise ValueError(f"'access_group' of incorrect type. Expected str, got {type(access_group_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_executable_old is not None and not (isinstance(is_executable_old, bool)):
			raise ValueError(f"'is_executable' of incorrect type. Expected bool, got {type(is_executable_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.parser.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'access_group': access_group_old, 'fetch_offset': fetch_offset_old, 'is_executable': is_executable_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, access_group_old: str = None, fetch_offset_old: int = None, is_executable_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if access_group_old is not None and not (isinstance(access_group_old, str)):
			raise ValueError(f"'access_group' of incorrect type. Expected str, got {type(access_group_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_executable_old is not None and not (isinstance(is_executable_old, bool)):
			raise ValueError(f"'is_executable' of incorrect type. Expected bool, got {type(is_executable_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, access_group_old=access_group_old, fetch_offset_old=fetch_offset_old, is_executable_old=is_executable_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, exec_args_new: dict = None, description_new: Union[str, ExplicitNull] = None, access_group_new: str = None, is_executable_new: bool = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if exec_args_new is not None and not (isinstance(exec_args_new, dict)):
			raise ValueError(f"'exec_args' of incorrect type. Expected dict, got {type(exec_args_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if access_group_new is not None and not (isinstance(access_group_new, str)):
			raise ValueError(f"'access_group' of incorrect type. Expected str, got {type(access_group_new)}")
		if is_executable_new is not None and not (isinstance(is_executable_new, bool)):
			raise ValueError(f"'is_executable' of incorrect type. Expected bool, got {type(is_executable_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.parser.update', 'new': _denullify_dict({'name': name_new, 'exec_args': exec_args_new, 'description': description_new, 'access_group': access_group_new, 'is_executable': is_executable_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, exec_args_new: dict = None, description_new: Union[str, ExplicitNull] = None, access_group_new: str = None, is_executable_new: bool = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if exec_args_new is not None and not (isinstance(exec_args_new, dict)):
			raise ValueError(f"'exec_args' of incorrect type. Expected dict, got {type(exec_args_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if access_group_new is not None and not (isinstance(access_group_new, str)):
			raise ValueError(f"'access_group' of incorrect type. Expected str, got {type(access_group_new)}")
		if is_executable_new is not None and not (isinstance(is_executable_new, bool)):
			raise ValueError(f"'is_executable' of incorrect type. Expected bool, got {type(is_executable_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, exec_args_new=exec_args_new, description_new=description_new, access_group_new=access_group_new, is_executable_new=is_executable_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class NetCmpnd(APIObject):
	gpk: str
	name: str
	description: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")

	@staticmethod
	def create_ta(name_new: str, description_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		return {'name': 'ndcfg.net_cmpnd.create', 'new': _denullify_dict({'name': name_new, 'description': description_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, description_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, description_new=description_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.net_cmpnd.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.net_cmpnd.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, description_new: Union[str, ExplicitNull] = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.net_cmpnd.update', 'new': _denullify_dict({'name': name_new, 'description': description_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, description_new: Union[str, ExplicitNull] = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, description_new=description_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class NumMode(APIObject):
	gpk: str
	name: str
	level: int

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.level, int):
			raise ValueError(f"'level' of incorrect type. Expected int, got {type(self.level)}")

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, name_list_old: list = None, level_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if level_list_old is not None and not (isinstance(level_list_old, list)):
			raise ValueError(f"'level_list' of incorrect type. Expected list, got {type(level_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.num_mode.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'level_list': level_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, name_list_old: list = None, level_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if level_list_old is not None and not (isinstance(level_list_old, list)):
			raise ValueError(f"'level_list' of incorrect type. Expected list, got {type(level_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, level_list_old=level_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class PPortSpeed(APIObject):
	gpk: str
	name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")

	@staticmethod
	def create_ta(name_new: str) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")

		return {'name': 'ndcfg.p_port_speed.create', 'new': _denullify_dict({'name': name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.p_port_speed.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.p_port_speed.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.p_port_speed.update', 'new': _denullify_dict({'name': name_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class BcdCateg(APIObject):
	gpk: str
	name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")

	@staticmethod
	def create_ta(name_new: str) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")

		return {'name': 'ndcfg.bcd_categ.create', 'new': _denullify_dict({'name': name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.bcd_categ.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.bcd_categ.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.bcd_categ.update', 'new': _denullify_dict({'name': name_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class BcdSeclvl(APIObject):
	gpk: str
	value: int

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.value, int):
			raise ValueError(f"'value' of incorrect type. Expected int, got {type(self.value)}")

	@staticmethod
	def create_ta(value_new: int) -> dict:
		if not (isinstance(value_new, int)):
			raise ValueError(f"'value' of incorrect type. Expected int, got {type(value_new)}")

		return {'name': 'ndcfg.bcd_seclvl.create', 'new': _denullify_dict({'value': value_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, value_new: int) -> list:
		if not (isinstance(value_new, int)):
			raise ValueError(f"'value' of incorrect type. Expected int, got {type(value_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(value_new=value_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(value_old: int) -> dict:
		if not (isinstance(value_old, int)):
			raise ValueError(f"'value' of incorrect type. Expected int, got {type(value_old)}")

		return {'name': 'ndcfg.bcd_seclvl.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'value': value_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, value_old: int) -> list:
		if not (isinstance(value_old, int)):
			raise ValueError(f"'value' of incorrect type. Expected int, got {type(value_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(value_old=value_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, value_old: int = None, gpk_list_old: list = None, value_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if value_old is not None and not (isinstance(value_old, int)):
			raise ValueError(f"'value' of incorrect type. Expected int, got {type(value_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if value_list_old is not None and not (isinstance(value_list_old, list)):
			raise ValueError(f"'value_list' of incorrect type. Expected list, got {type(value_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.bcd_seclvl.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'value': value_old, 'gpk_list': gpk_list_old, 'value_list': value_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, value_old: int = None, gpk_list_old: list = None, value_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if value_old is not None and not (isinstance(value_old, int)):
			raise ValueError(f"'value' of incorrect type. Expected int, got {type(value_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if value_list_old is not None and not (isinstance(value_list_old, list)):
			raise ValueError(f"'value_list' of incorrect type. Expected list, got {type(value_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, value_old=value_old, gpk_list_old=gpk_list_old, value_list_old=value_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(value_old: int, value_new: int = None) -> dict:
		if value_new is not None and not (isinstance(value_new, int)):
			raise ValueError(f"'value' of incorrect type. Expected int, got {type(value_new)}")
		if not (isinstance(value_old, int)):
			raise ValueError(f"'value' of incorrect type. Expected int, got {type(value_old)}")

		return {'name': 'ndcfg.bcd_seclvl.update', 'new': _denullify_dict({'value': value_new}), 'old': _denullify_dict({'value': value_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, value_old: int, value_new: int = None) -> list:
		if value_new is not None and not (isinstance(value_new, int)):
			raise ValueError(f"'value' of incorrect type. Expected int, got {type(value_new)}")
		if not (isinstance(value_old, int)):
			raise ValueError(f"'value' of incorrect type. Expected int, got {type(value_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(value_new=value_new, value_old=value_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class NetCmpnd2instnc(APIObject):
	gpk: str
	net_cmpnd: str
	net_instnc: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.net_cmpnd, str):
			raise ValueError(f"'net_cmpnd' of incorrect type. Expected str, got {type(self.net_cmpnd)}")
		if not isinstance(self.net_instnc, str):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(self.net_instnc)}")

	@staticmethod
	def create_ta(net_cmpnd_new: str, net_instnc_new: str) -> dict:
		if not (isinstance(net_cmpnd_new, str)):
			raise ValueError(f"'net_cmpnd' of incorrect type. Expected str, got {type(net_cmpnd_new)}")
		if not (isinstance(net_instnc_new, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_new)}")

		return {'name': 'ndcfg.net_cmpnd2instnc.create', 'new': _denullify_dict({'net_cmpnd': net_cmpnd_new, 'net_instnc': net_instnc_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, net_cmpnd_new: str, net_instnc_new: str) -> list:
		if not (isinstance(net_cmpnd_new, str)):
			raise ValueError(f"'net_cmpnd' of incorrect type. Expected str, got {type(net_cmpnd_new)}")
		if not (isinstance(net_instnc_new, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(net_cmpnd_new=net_cmpnd_new, net_instnc_new=net_instnc_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(net_cmpnd_old: str, net_instnc_old: str) -> dict:
		if not (isinstance(net_cmpnd_old, str)):
			raise ValueError(f"'net_cmpnd' of incorrect type. Expected str, got {type(net_cmpnd_old)}")
		if not (isinstance(net_instnc_old, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_old)}")

		return {'name': 'ndcfg.net_cmpnd2instnc.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'net_cmpnd': net_cmpnd_old, 'net_instnc': net_instnc_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, net_cmpnd_old: str, net_instnc_old: str) -> list:
		if not (isinstance(net_cmpnd_old, str)):
			raise ValueError(f"'net_cmpnd' of incorrect type. Expected str, got {type(net_cmpnd_old)}")
		if not (isinstance(net_instnc_old, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(net_cmpnd_old=net_cmpnd_old, net_instnc_old=net_instnc_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, net_cmpnd_old: str = None, net_instnc_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, net_cmpnd_list_old: list = None, net_instnc_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if net_cmpnd_old is not None and not (isinstance(net_cmpnd_old, str)):
			raise ValueError(f"'net_cmpnd' of incorrect type. Expected str, got {type(net_cmpnd_old)}")
		if net_instnc_old is not None and not (isinstance(net_instnc_old, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if net_cmpnd_list_old is not None and not (isinstance(net_cmpnd_list_old, list)):
			raise ValueError(f"'net_cmpnd_list' of incorrect type. Expected list, got {type(net_cmpnd_list_old)}")
		if net_instnc_list_old is not None and not (isinstance(net_instnc_list_old, list)):
			raise ValueError(f"'net_instnc_list' of incorrect type. Expected list, got {type(net_instnc_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.net_cmpnd2instnc.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'net_cmpnd': net_cmpnd_old, 'net_instnc': net_instnc_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'net_cmpnd_list': net_cmpnd_list_old, 'net_instnc_list': net_instnc_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, net_cmpnd_old: str = None, net_instnc_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, net_cmpnd_list_old: list = None, net_instnc_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if net_cmpnd_old is not None and not (isinstance(net_cmpnd_old, str)):
			raise ValueError(f"'net_cmpnd' of incorrect type. Expected str, got {type(net_cmpnd_old)}")
		if net_instnc_old is not None and not (isinstance(net_instnc_old, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if net_cmpnd_list_old is not None and not (isinstance(net_cmpnd_list_old, list)):
			raise ValueError(f"'net_cmpnd_list' of incorrect type. Expected list, got {type(net_cmpnd_list_old)}")
		if net_instnc_list_old is not None and not (isinstance(net_instnc_list_old, list)):
			raise ValueError(f"'net_instnc_list' of incorrect type. Expected list, got {type(net_instnc_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, net_cmpnd_old=net_cmpnd_old, net_instnc_old=net_instnc_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, net_cmpnd_list_old=net_cmpnd_list_old, net_instnc_list_old=net_instnc_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(net_cmpnd_old: str, net_instnc_old: str, net_cmpnd_new: str = None, net_instnc_new: str = None) -> dict:
		if net_cmpnd_new is not None and not (isinstance(net_cmpnd_new, str)):
			raise ValueError(f"'net_cmpnd' of incorrect type. Expected str, got {type(net_cmpnd_new)}")
		if net_instnc_new is not None and not (isinstance(net_instnc_new, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_new)}")
		if not (isinstance(net_cmpnd_old, str)):
			raise ValueError(f"'net_cmpnd' of incorrect type. Expected str, got {type(net_cmpnd_old)}")
		if not (isinstance(net_instnc_old, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_old)}")

		return {'name': 'ndcfg.net_cmpnd2instnc.update', 'new': _denullify_dict({'net_cmpnd': net_cmpnd_new, 'net_instnc': net_instnc_new}), 'old': _denullify_dict({'net_cmpnd': net_cmpnd_old, 'net_instnc': net_instnc_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, net_cmpnd_old: str, net_instnc_old: str, net_cmpnd_new: str = None, net_instnc_new: str = None) -> list:
		if net_cmpnd_new is not None and not (isinstance(net_cmpnd_new, str)):
			raise ValueError(f"'net_cmpnd' of incorrect type. Expected str, got {type(net_cmpnd_new)}")
		if net_instnc_new is not None and not (isinstance(net_instnc_new, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_new)}")
		if not (isinstance(net_cmpnd_old, str)):
			raise ValueError(f"'net_cmpnd' of incorrect type. Expected str, got {type(net_cmpnd_old)}")
		if not (isinstance(net_instnc_old, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(net_cmpnd_new=net_cmpnd_new, net_instnc_new=net_instnc_new, net_cmpnd_old=net_cmpnd_old, net_instnc_old=net_instnc_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Parser2sysdescr(APIObject):
	gpk: str
	parser: str
	sysdescr: str
	is_executable: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.parser, str):
			raise ValueError(f"'parser' of incorrect type. Expected str, got {type(self.parser)}")
		if not isinstance(self.sysdescr, str):
			raise ValueError(f"'sysdescr' of incorrect type. Expected str, got {type(self.sysdescr)}")
		if not isinstance(self.is_executable, bool):
			raise ValueError(f"'is_executable' of incorrect type. Expected bool, got {type(self.is_executable)}")

	@staticmethod
	def create_ta(parser_new: str, sysdescr_new: str) -> dict:
		if not (isinstance(parser_new, str)):
			raise ValueError(f"'parser' of incorrect type. Expected str, got {type(parser_new)}")
		if not (isinstance(sysdescr_new, str)):
			raise ValueError(f"'sysdescr' of incorrect type. Expected str, got {type(sysdescr_new)}")

		return {'name': 'ndcfg.parser2sysdescr.create', 'new': _denullify_dict({'parser': parser_new, 'sysdescr': sysdescr_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, parser_new: str, sysdescr_new: str) -> list:
		if not (isinstance(parser_new, str)):
			raise ValueError(f"'parser' of incorrect type. Expected str, got {type(parser_new)}")
		if not (isinstance(sysdescr_new, str)):
			raise ValueError(f"'sysdescr' of incorrect type. Expected str, got {type(sysdescr_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(parser_new=parser_new, sysdescr_new=sysdescr_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(sysdescr_old: str) -> dict:
		if not (isinstance(sysdescr_old, str)):
			raise ValueError(f"'sysdescr' of incorrect type. Expected str, got {type(sysdescr_old)}")

		return {'name': 'ndcfg.parser2sysdescr.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'sysdescr': sysdescr_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, sysdescr_old: str) -> list:
		if not (isinstance(sysdescr_old, str)):
			raise ValueError(f"'sysdescr' of incorrect type. Expected str, got {type(sysdescr_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(sysdescr_old=sysdescr_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, parser_old: str = None, gpk_list_old: list = None, sysdescr_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, sysdescr_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if parser_old is not None and not (isinstance(parser_old, str)):
			raise ValueError(f"'parser' of incorrect type. Expected str, got {type(parser_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if sysdescr_old is not None and not (isinstance(sysdescr_old, str)):
			raise ValueError(f"'sysdescr' of incorrect type. Expected str, got {type(sysdescr_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if sysdescr_list_old is not None and not (isinstance(sysdescr_list_old, list)):
			raise ValueError(f"'sysdescr_list' of incorrect type. Expected list, got {type(sysdescr_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.parser2sysdescr.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'parser': parser_old, 'gpk_list': gpk_list_old, 'sysdescr': sysdescr_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'sysdescr_list': sysdescr_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, parser_old: str = None, gpk_list_old: list = None, sysdescr_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, sysdescr_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if parser_old is not None and not (isinstance(parser_old, str)):
			raise ValueError(f"'parser' of incorrect type. Expected str, got {type(parser_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if sysdescr_old is not None and not (isinstance(sysdescr_old, str)):
			raise ValueError(f"'sysdescr' of incorrect type. Expected str, got {type(sysdescr_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if sysdescr_list_old is not None and not (isinstance(sysdescr_list_old, list)):
			raise ValueError(f"'sysdescr_list' of incorrect type. Expected list, got {type(sysdescr_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, parser_old=parser_old, gpk_list_old=gpk_list_old, sysdescr_old=sysdescr_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, sysdescr_list_old=sysdescr_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(sysdescr_old: str, parser_new: str = None, sysdescr_new: str = None) -> dict:
		if parser_new is not None and not (isinstance(parser_new, str)):
			raise ValueError(f"'parser' of incorrect type. Expected str, got {type(parser_new)}")
		if sysdescr_new is not None and not (isinstance(sysdescr_new, str)):
			raise ValueError(f"'sysdescr' of incorrect type. Expected str, got {type(sysdescr_new)}")
		if not (isinstance(sysdescr_old, str)):
			raise ValueError(f"'sysdescr' of incorrect type. Expected str, got {type(sysdescr_old)}")

		return {'name': 'ndcfg.parser2sysdescr.update', 'new': _denullify_dict({'parser': parser_new, 'sysdescr': sysdescr_new}), 'old': _denullify_dict({'sysdescr': sysdescr_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, sysdescr_old: str, parser_new: str = None, sysdescr_new: str = None) -> list:
		if parser_new is not None and not (isinstance(parser_new, str)):
			raise ValueError(f"'parser' of incorrect type. Expected str, got {type(parser_new)}")
		if sysdescr_new is not None and not (isinstance(sysdescr_new, str)):
			raise ValueError(f"'sysdescr' of incorrect type. Expected str, got {type(sysdescr_new)}")
		if not (isinstance(sysdescr_old, str)):
			raise ValueError(f"'sysdescr' of incorrect type. Expected str, got {type(sysdescr_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(parser_new=parser_new, sysdescr_new=sysdescr_new, sysdescr_old=sysdescr_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class SlotTypeClass(APIObject):
	gpk: str
	name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")

	@staticmethod
	def create_ta(name_new: str) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")

		return {'name': 'ndcfg.slot_type_class.create', 'new': _denullify_dict({'name': name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.slot_type_class.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.slot_type_class.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'ndcfg.slot_type_class.update', 'new': _denullify_dict({'name': name_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Slot2moduleTypeTree(APIObject):
	gpk: str
	slot_type: str
	parent_gfk: str
	tree_level: int
	module_type: str
	slot_varname1: str
	subport_prefix: str
	subport_varprfx: str
	subport_varname1: str
	hierarchy_gfk_list: list
	subport_varprfx_join_dl: str
	subport_varprfx_split_dl: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.slot_type, str):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(self.slot_type)}")
		if self.parent_gfk is not None and not isinstance(self.parent_gfk, str):
			raise ValueError(f"'parent_gfk' of incorrect type. Expected str, got {type(self.parent_gfk)}")
		if not isinstance(self.tree_level, int):
			raise ValueError(f"'tree_level' of incorrect type. Expected int, got {type(self.tree_level)}")
		if not isinstance(self.module_type, str):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(self.module_type)}")
		if self.slot_varname1 is not None and not isinstance(self.slot_varname1, str):
			raise ValueError(f"'slot_varname1' of incorrect type. Expected str, got {type(self.slot_varname1)}")
		if self.subport_prefix is not None and not isinstance(self.subport_prefix, str):
			raise ValueError(f"'subport_prefix' of incorrect type. Expected str, got {type(self.subport_prefix)}")
		if self.subport_varprfx is not None and not isinstance(self.subport_varprfx, str):
			raise ValueError(f"'subport_varprfx' of incorrect type. Expected str, got {type(self.subport_varprfx)}")
		if self.subport_varname1 is not None and not isinstance(self.subport_varname1, str):
			raise ValueError(f"'subport_varname1' of incorrect type. Expected str, got {type(self.subport_varname1)}")
		if not isinstance(self.hierarchy_gfk_list, list):
			raise ValueError(f"'hierarchy_gfk_list' of incorrect type. Expected list, got {type(self.hierarchy_gfk_list)}")
		if self.subport_varprfx_join_dl is not None and not isinstance(self.subport_varprfx_join_dl, str):
			raise ValueError(f"'subport_varprfx_join_dl' of incorrect type. Expected str, got {type(self.subport_varprfx_join_dl)}")
		if self.subport_varprfx_split_dl is not None and not isinstance(self.subport_varprfx_split_dl, str):
			raise ValueError(f"'subport_varprfx_split_dl' of incorrect type. Expected str, got {type(self.subport_varprfx_split_dl)}")

	@staticmethod
	def create_ta(slot_type_new: str, module_type_new: str, parent_gfk_new: Union[str, ExplicitNull] = None, slot_varname1_new: Union[str, ExplicitNull] = None, subport_prefix_new: Union[str, ExplicitNull] = None, subport_varprfx_new: Union[str, ExplicitNull] = None, subport_varname1_new: Union[str, ExplicitNull] = None, subport_varprfx_join_dl_new: Union[str, ExplicitNull] = None, subport_varprfx_split_dl_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(slot_type_new, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_new)}")
		if parent_gfk_new is not None and not (isinstance(parent_gfk_new, str) or isinstance(parent_gfk_new, ExplicitNull)):
			raise ValueError(f"'parent_gfk' of incorrect type. Expected str, got {type(parent_gfk_new)}")
		if not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if slot_varname1_new is not None and not (isinstance(slot_varname1_new, str) or isinstance(slot_varname1_new, ExplicitNull)):
			raise ValueError(f"'slot_varname1' of incorrect type. Expected str, got {type(slot_varname1_new)}")
		if subport_prefix_new is not None and not (isinstance(subport_prefix_new, str) or isinstance(subport_prefix_new, ExplicitNull)):
			raise ValueError(f"'subport_prefix' of incorrect type. Expected str, got {type(subport_prefix_new)}")
		if subport_varprfx_new is not None and not (isinstance(subport_varprfx_new, str) or isinstance(subport_varprfx_new, ExplicitNull)):
			raise ValueError(f"'subport_varprfx' of incorrect type. Expected str, got {type(subport_varprfx_new)}")
		if subport_varname1_new is not None and not (isinstance(subport_varname1_new, str) or isinstance(subport_varname1_new, ExplicitNull)):
			raise ValueError(f"'subport_varname1' of incorrect type. Expected str, got {type(subport_varname1_new)}")
		if subport_varprfx_join_dl_new is not None and not (isinstance(subport_varprfx_join_dl_new, str) or isinstance(subport_varprfx_join_dl_new, ExplicitNull)):
			raise ValueError(f"'subport_varprfx_join_dl' of incorrect type. Expected str, got {type(subport_varprfx_join_dl_new)}")
		if subport_varprfx_split_dl_new is not None and not (isinstance(subport_varprfx_split_dl_new, str) or isinstance(subport_varprfx_split_dl_new, ExplicitNull)):
			raise ValueError(f"'subport_varprfx_split_dl' of incorrect type. Expected str, got {type(subport_varprfx_split_dl_new)}")

		return {'name': 'ndcfg.slot2module_type_tree.create', 'new': _denullify_dict({'slot_type': slot_type_new, 'parent_gfk': parent_gfk_new, 'module_type': module_type_new, 'slot_varname1': slot_varname1_new, 'subport_prefix': subport_prefix_new, 'subport_varprfx': subport_varprfx_new, 'subport_varname1': subport_varname1_new, 'subport_varprfx_join_dl': subport_varprfx_join_dl_new, 'subport_varprfx_split_dl': subport_varprfx_split_dl_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, slot_type_new: str, module_type_new: str, parent_gfk_new: Union[str, ExplicitNull] = None, slot_varname1_new: Union[str, ExplicitNull] = None, subport_prefix_new: Union[str, ExplicitNull] = None, subport_varprfx_new: Union[str, ExplicitNull] = None, subport_varname1_new: Union[str, ExplicitNull] = None, subport_varprfx_join_dl_new: Union[str, ExplicitNull] = None, subport_varprfx_split_dl_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(slot_type_new, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_new)}")
		if parent_gfk_new is not None and not (isinstance(parent_gfk_new, str) or isinstance(parent_gfk_new, ExplicitNull)):
			raise ValueError(f"'parent_gfk' of incorrect type. Expected str, got {type(parent_gfk_new)}")
		if not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if slot_varname1_new is not None and not (isinstance(slot_varname1_new, str) or isinstance(slot_varname1_new, ExplicitNull)):
			raise ValueError(f"'slot_varname1' of incorrect type. Expected str, got {type(slot_varname1_new)}")
		if subport_prefix_new is not None and not (isinstance(subport_prefix_new, str) or isinstance(subport_prefix_new, ExplicitNull)):
			raise ValueError(f"'subport_prefix' of incorrect type. Expected str, got {type(subport_prefix_new)}")
		if subport_varprfx_new is not None and not (isinstance(subport_varprfx_new, str) or isinstance(subport_varprfx_new, ExplicitNull)):
			raise ValueError(f"'subport_varprfx' of incorrect type. Expected str, got {type(subport_varprfx_new)}")
		if subport_varname1_new is not None and not (isinstance(subport_varname1_new, str) or isinstance(subport_varname1_new, ExplicitNull)):
			raise ValueError(f"'subport_varname1' of incorrect type. Expected str, got {type(subport_varname1_new)}")
		if subport_varprfx_join_dl_new is not None and not (isinstance(subport_varprfx_join_dl_new, str) or isinstance(subport_varprfx_join_dl_new, ExplicitNull)):
			raise ValueError(f"'subport_varprfx_join_dl' of incorrect type. Expected str, got {type(subport_varprfx_join_dl_new)}")
		if subport_varprfx_split_dl_new is not None and not (isinstance(subport_varprfx_split_dl_new, str) or isinstance(subport_varprfx_split_dl_new, ExplicitNull)):
			raise ValueError(f"'subport_varprfx_split_dl' of incorrect type. Expected str, got {type(subport_varprfx_split_dl_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(slot_type_new=slot_type_new, parent_gfk_new=parent_gfk_new, module_type_new=module_type_new, slot_varname1_new=slot_varname1_new, subport_prefix_new=subport_prefix_new, subport_varprfx_new=subport_varprfx_new, subport_varname1_new=subport_varname1_new, subport_varprfx_join_dl_new=subport_varprfx_join_dl_new, subport_varprfx_split_dl_new=subport_varprfx_split_dl_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'ndcfg.slot2module_type_tree.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, slot_type_old: str = None, tree_level_old: int = None, fetch_limit_old: int = None, module_type_old: str = None, fetch_offset_old: int = None, slot_type_list_old: list = None, parent_gfk_list_old: list = None, module_type_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if slot_type_old is not None and not (isinstance(slot_type_old, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_old)}")
		if tree_level_old is not None and not (isinstance(tree_level_old, int)):
			raise ValueError(f"'tree_level' of incorrect type. Expected int, got {type(tree_level_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if module_type_old is not None and not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if slot_type_list_old is not None and not (isinstance(slot_type_list_old, list)):
			raise ValueError(f"'slot_type_list' of incorrect type. Expected list, got {type(slot_type_list_old)}")
		if parent_gfk_list_old is not None and not (isinstance(parent_gfk_list_old, list)):
			raise ValueError(f"'parent_gfk_list' of incorrect type. Expected list, got {type(parent_gfk_list_old)}")
		if module_type_list_old is not None and not (isinstance(module_type_list_old, list)):
			raise ValueError(f"'module_type_list' of incorrect type. Expected list, got {type(module_type_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.slot2module_type_tree.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'slot_type': slot_type_old, 'tree_level': tree_level_old, 'fetch_limit': fetch_limit_old, 'module_type': module_type_old, 'fetch_offset': fetch_offset_old, 'slot_type_list': slot_type_list_old, 'parent_gfk_list': parent_gfk_list_old, 'module_type_list': module_type_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, slot_type_old: str = None, tree_level_old: int = None, fetch_limit_old: int = None, module_type_old: str = None, fetch_offset_old: int = None, slot_type_list_old: list = None, parent_gfk_list_old: list = None, module_type_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if slot_type_old is not None and not (isinstance(slot_type_old, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_old)}")
		if tree_level_old is not None and not (isinstance(tree_level_old, int)):
			raise ValueError(f"'tree_level' of incorrect type. Expected int, got {type(tree_level_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if module_type_old is not None and not (isinstance(module_type_old, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if slot_type_list_old is not None and not (isinstance(slot_type_list_old, list)):
			raise ValueError(f"'slot_type_list' of incorrect type. Expected list, got {type(slot_type_list_old)}")
		if parent_gfk_list_old is not None and not (isinstance(parent_gfk_list_old, list)):
			raise ValueError(f"'parent_gfk_list' of incorrect type. Expected list, got {type(parent_gfk_list_old)}")
		if module_type_list_old is not None and not (isinstance(module_type_list_old, list)):
			raise ValueError(f"'module_type_list' of incorrect type. Expected list, got {type(module_type_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, slot_type_old=slot_type_old, tree_level_old=tree_level_old, fetch_limit_old=fetch_limit_old, module_type_old=module_type_old, fetch_offset_old=fetch_offset_old, slot_type_list_old=slot_type_list_old, parent_gfk_list_old=parent_gfk_list_old, module_type_list_old=module_type_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, slot_type_new: str = None, parent_gfk_new: Union[str, ExplicitNull] = None, module_type_new: str = None, slot_varname1_new: Union[str, ExplicitNull] = None, subport_prefix_new: Union[str, ExplicitNull] = None, subport_varprfx_new: Union[str, ExplicitNull] = None, subport_varname1_new: Union[str, ExplicitNull] = None, subport_varprfx_join_dl_new: Union[str, ExplicitNull] = None, subport_varprfx_split_dl_new: Union[str, ExplicitNull] = None) -> dict:
		if slot_type_new is not None and not (isinstance(slot_type_new, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_new)}")
		if parent_gfk_new is not None and not (isinstance(parent_gfk_new, str) or isinstance(parent_gfk_new, ExplicitNull)):
			raise ValueError(f"'parent_gfk' of incorrect type. Expected str, got {type(parent_gfk_new)}")
		if module_type_new is not None and not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if slot_varname1_new is not None and not (isinstance(slot_varname1_new, str) or isinstance(slot_varname1_new, ExplicitNull)):
			raise ValueError(f"'slot_varname1' of incorrect type. Expected str, got {type(slot_varname1_new)}")
		if subport_prefix_new is not None and not (isinstance(subport_prefix_new, str) or isinstance(subport_prefix_new, ExplicitNull)):
			raise ValueError(f"'subport_prefix' of incorrect type. Expected str, got {type(subport_prefix_new)}")
		if subport_varprfx_new is not None and not (isinstance(subport_varprfx_new, str) or isinstance(subport_varprfx_new, ExplicitNull)):
			raise ValueError(f"'subport_varprfx' of incorrect type. Expected str, got {type(subport_varprfx_new)}")
		if subport_varname1_new is not None and not (isinstance(subport_varname1_new, str) or isinstance(subport_varname1_new, ExplicitNull)):
			raise ValueError(f"'subport_varname1' of incorrect type. Expected str, got {type(subport_varname1_new)}")
		if subport_varprfx_join_dl_new is not None and not (isinstance(subport_varprfx_join_dl_new, str) or isinstance(subport_varprfx_join_dl_new, ExplicitNull)):
			raise ValueError(f"'subport_varprfx_join_dl' of incorrect type. Expected str, got {type(subport_varprfx_join_dl_new)}")
		if subport_varprfx_split_dl_new is not None and not (isinstance(subport_varprfx_split_dl_new, str) or isinstance(subport_varprfx_split_dl_new, ExplicitNull)):
			raise ValueError(f"'subport_varprfx_split_dl' of incorrect type. Expected str, got {type(subport_varprfx_split_dl_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'ndcfg.slot2module_type_tree.update', 'new': _denullify_dict({'slot_type': slot_type_new, 'parent_gfk': parent_gfk_new, 'module_type': module_type_new, 'slot_varname1': slot_varname1_new, 'subport_prefix': subport_prefix_new, 'subport_varprfx': subport_varprfx_new, 'subport_varname1': subport_varname1_new, 'subport_varprfx_join_dl': subport_varprfx_join_dl_new, 'subport_varprfx_split_dl': subport_varprfx_split_dl_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, slot_type_new: str = None, parent_gfk_new: Union[str, ExplicitNull] = None, module_type_new: str = None, slot_varname1_new: Union[str, ExplicitNull] = None, subport_prefix_new: Union[str, ExplicitNull] = None, subport_varprfx_new: Union[str, ExplicitNull] = None, subport_varname1_new: Union[str, ExplicitNull] = None, subport_varprfx_join_dl_new: Union[str, ExplicitNull] = None, subport_varprfx_split_dl_new: Union[str, ExplicitNull] = None) -> list:
		if slot_type_new is not None and not (isinstance(slot_type_new, str)):
			raise ValueError(f"'slot_type' of incorrect type. Expected str, got {type(slot_type_new)}")
		if parent_gfk_new is not None and not (isinstance(parent_gfk_new, str) or isinstance(parent_gfk_new, ExplicitNull)):
			raise ValueError(f"'parent_gfk' of incorrect type. Expected str, got {type(parent_gfk_new)}")
		if module_type_new is not None and not (isinstance(module_type_new, str)):
			raise ValueError(f"'module_type' of incorrect type. Expected str, got {type(module_type_new)}")
		if slot_varname1_new is not None and not (isinstance(slot_varname1_new, str) or isinstance(slot_varname1_new, ExplicitNull)):
			raise ValueError(f"'slot_varname1' of incorrect type. Expected str, got {type(slot_varname1_new)}")
		if subport_prefix_new is not None and not (isinstance(subport_prefix_new, str) or isinstance(subport_prefix_new, ExplicitNull)):
			raise ValueError(f"'subport_prefix' of incorrect type. Expected str, got {type(subport_prefix_new)}")
		if subport_varprfx_new is not None and not (isinstance(subport_varprfx_new, str) or isinstance(subport_varprfx_new, ExplicitNull)):
			raise ValueError(f"'subport_varprfx' of incorrect type. Expected str, got {type(subport_varprfx_new)}")
		if subport_varname1_new is not None and not (isinstance(subport_varname1_new, str) or isinstance(subport_varname1_new, ExplicitNull)):
			raise ValueError(f"'subport_varname1' of incorrect type. Expected str, got {type(subport_varname1_new)}")
		if subport_varprfx_join_dl_new is not None and not (isinstance(subport_varprfx_join_dl_new, str) or isinstance(subport_varprfx_join_dl_new, ExplicitNull)):
			raise ValueError(f"'subport_varprfx_join_dl' of incorrect type. Expected str, got {type(subport_varprfx_join_dl_new)}")
		if subport_varprfx_split_dl_new is not None and not (isinstance(subport_varprfx_split_dl_new, str) or isinstance(subport_varprfx_split_dl_new, ExplicitNull)):
			raise ValueError(f"'subport_varprfx_split_dl' of incorrect type. Expected str, got {type(subport_varprfx_split_dl_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(slot_type_new=slot_type_new, parent_gfk_new=parent_gfk_new, module_type_new=module_type_new, slot_varname1_new=slot_varname1_new, subport_prefix_new=subport_prefix_new, subport_varprfx_new=subport_varprfx_new, subport_varname1_new=subport_varname1_new, subport_varprfx_join_dl_new=subport_varprfx_join_dl_new, subport_varprfx_split_dl_new=subport_varprfx_split_dl_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class SiteType(APIObject):
	gpk: str
	is_child: bool
	is_parent: bool
	short_name: str
	force_is_child: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_child, bool):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(self.is_child)}")
		if not isinstance(self.is_parent, bool):
			raise ValueError(f"'is_parent' of incorrect type. Expected bool, got {type(self.is_parent)}")
		if not isinstance(self.short_name, str):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(self.short_name)}")
		if not isinstance(self.force_is_child, bool):
			raise ValueError(f"'force_is_child' of incorrect type. Expected bool, got {type(self.force_is_child)}")

	@staticmethod
	def create_ta(is_child_new: bool, is_parent_new: bool, short_name_new: str, force_is_child_new: bool) -> dict:
		if not (isinstance(is_child_new, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_new)}")
		if not (isinstance(is_parent_new, bool)):
			raise ValueError(f"'is_parent' of incorrect type. Expected bool, got {type(is_parent_new)}")
		if not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")
		if not (isinstance(force_is_child_new, bool)):
			raise ValueError(f"'force_is_child' of incorrect type. Expected bool, got {type(force_is_child_new)}")

		return {'name': 'ndcfg.site_type.create', 'new': _denullify_dict({'is_child': is_child_new, 'is_parent': is_parent_new, 'short_name': short_name_new, 'force_is_child': force_is_child_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, is_child_new: bool, is_parent_new: bool, short_name_new: str, force_is_child_new: bool) -> list:
		if not (isinstance(is_child_new, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_new)}")
		if not (isinstance(is_parent_new, bool)):
			raise ValueError(f"'is_parent' of incorrect type. Expected bool, got {type(is_parent_new)}")
		if not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")
		if not (isinstance(force_is_child_new, bool)):
			raise ValueError(f"'force_is_child' of incorrect type. Expected bool, got {type(force_is_child_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(is_child_new=is_child_new, is_parent_new=is_parent_new, short_name_new=short_name_new, force_is_child_new=force_is_child_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(short_name_old: str) -> dict:
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		return {'name': 'ndcfg.site_type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'short_name': short_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, short_name_old: str) -> list:
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(short_name_old=short_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, is_child_old: bool = None, is_parent_old: bool = None, short_name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, force_is_child_old: bool = None, short_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if is_child_old is not None and not (isinstance(is_child_old, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_old)}")
		if is_parent_old is not None and not (isinstance(is_parent_old, bool)):
			raise ValueError(f"'is_parent' of incorrect type. Expected bool, got {type(is_parent_old)}")
		if short_name_old is not None and not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if force_is_child_old is not None and not (isinstance(force_is_child_old, bool)):
			raise ValueError(f"'force_is_child' of incorrect type. Expected bool, got {type(force_is_child_old)}")
		if short_name_list_old is not None and not (isinstance(short_name_list_old, list)):
			raise ValueError(f"'short_name_list' of incorrect type. Expected list, got {type(short_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.site_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'is_child': is_child_old, 'is_parent': is_parent_old, 'short_name': short_name_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'force_is_child': force_is_child_old, 'short_name_list': short_name_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, is_child_old: bool = None, is_parent_old: bool = None, short_name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, force_is_child_old: bool = None, short_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if is_child_old is not None and not (isinstance(is_child_old, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_old)}")
		if is_parent_old is not None and not (isinstance(is_parent_old, bool)):
			raise ValueError(f"'is_parent' of incorrect type. Expected bool, got {type(is_parent_old)}")
		if short_name_old is not None and not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if force_is_child_old is not None and not (isinstance(force_is_child_old, bool)):
			raise ValueError(f"'force_is_child' of incorrect type. Expected bool, got {type(force_is_child_old)}")
		if short_name_list_old is not None and not (isinstance(short_name_list_old, list)):
			raise ValueError(f"'short_name_list' of incorrect type. Expected list, got {type(short_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, is_child_old=is_child_old, is_parent_old=is_parent_old, short_name_old=short_name_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, force_is_child_old=force_is_child_old, short_name_list_old=short_name_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(short_name_old: str, is_child_new: bool = None, is_parent_new: bool = None, short_name_new: str = None, force_is_child_new: bool = None) -> dict:
		if is_child_new is not None and not (isinstance(is_child_new, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_new)}")
		if is_parent_new is not None and not (isinstance(is_parent_new, bool)):
			raise ValueError(f"'is_parent' of incorrect type. Expected bool, got {type(is_parent_new)}")
		if short_name_new is not None and not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")
		if force_is_child_new is not None and not (isinstance(force_is_child_new, bool)):
			raise ValueError(f"'force_is_child' of incorrect type. Expected bool, got {type(force_is_child_new)}")
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		return {'name': 'ndcfg.site_type.update', 'new': _denullify_dict({'is_child': is_child_new, 'is_parent': is_parent_new, 'short_name': short_name_new, 'force_is_child': force_is_child_new}), 'old': _denullify_dict({'short_name': short_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, short_name_old: str, is_child_new: bool = None, is_parent_new: bool = None, short_name_new: str = None, force_is_child_new: bool = None) -> list:
		if is_child_new is not None and not (isinstance(is_child_new, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_new)}")
		if is_parent_new is not None and not (isinstance(is_parent_new, bool)):
			raise ValueError(f"'is_parent' of incorrect type. Expected bool, got {type(is_parent_new)}")
		if short_name_new is not None and not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")
		if force_is_child_new is not None and not (isinstance(force_is_child_new, bool)):
			raise ValueError(f"'force_is_child' of incorrect type. Expected bool, got {type(force_is_child_new)}")
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(is_child_new=is_child_new, is_parent_new=is_parent_new, short_name_new=short_name_new, force_is_child_new=force_is_child_new, short_name_old=short_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class SiteType2type(APIObject):
	gpk: str
	child_short_name: str
	parent_short_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.child_short_name, str):
			raise ValueError(f"'child_short_name' of incorrect type. Expected str, got {type(self.child_short_name)}")
		if not isinstance(self.parent_short_name, str):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(self.parent_short_name)}")

	@staticmethod
	def create_ta(child_short_name_new: str, parent_short_name_new: str) -> dict:
		if not (isinstance(child_short_name_new, str)):
			raise ValueError(f"'child_short_name' of incorrect type. Expected str, got {type(child_short_name_new)}")
		if not (isinstance(parent_short_name_new, str)):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(parent_short_name_new)}")

		return {'name': 'ndcfg.site_type2type.create', 'new': _denullify_dict({'child_short_name': child_short_name_new, 'parent_short_name': parent_short_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, child_short_name_new: str, parent_short_name_new: str) -> list:
		if not (isinstance(child_short_name_new, str)):
			raise ValueError(f"'child_short_name' of incorrect type. Expected str, got {type(child_short_name_new)}")
		if not (isinstance(parent_short_name_new, str)):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(parent_short_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(child_short_name_new=child_short_name_new, parent_short_name_new=parent_short_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(child_short_name_old: str, parent_short_name_old: str) -> dict:
		if not (isinstance(child_short_name_old, str)):
			raise ValueError(f"'child_short_name' of incorrect type. Expected str, got {type(child_short_name_old)}")
		if not (isinstance(parent_short_name_old, str)):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(parent_short_name_old)}")

		return {'name': 'ndcfg.site_type2type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'child_short_name': child_short_name_old, 'parent_short_name': parent_short_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, child_short_name_old: str, parent_short_name_old: str) -> list:
		if not (isinstance(child_short_name_old, str)):
			raise ValueError(f"'child_short_name' of incorrect type. Expected str, got {type(child_short_name_old)}")
		if not (isinstance(parent_short_name_old, str)):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(parent_short_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(child_short_name_old=child_short_name_old, parent_short_name_old=parent_short_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, child_short_name_old: str = None, parent_short_name_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, child_short_name_list_old: list = None, parent_short_name_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if child_short_name_old is not None and not (isinstance(child_short_name_old, str)):
			raise ValueError(f"'child_short_name' of incorrect type. Expected str, got {type(child_short_name_old)}")
		if parent_short_name_old is not None and not (isinstance(parent_short_name_old, str)):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(parent_short_name_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if child_short_name_list_old is not None and not (isinstance(child_short_name_list_old, list)):
			raise ValueError(f"'child_short_name_list' of incorrect type. Expected list, got {type(child_short_name_list_old)}")
		if parent_short_name_list_old is not None and not (isinstance(parent_short_name_list_old, list)):
			raise ValueError(f"'parent_short_name_list' of incorrect type. Expected list, got {type(parent_short_name_list_old)}")

		return {'name': 'ndcfg.site_type2type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'child_short_name': child_short_name_old, 'parent_short_name': parent_short_name_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'child_short_name_list': child_short_name_list_old, 'parent_short_name_list': parent_short_name_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, child_short_name_old: str = None, parent_short_name_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, child_short_name_list_old: list = None, parent_short_name_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if child_short_name_old is not None and not (isinstance(child_short_name_old, str)):
			raise ValueError(f"'child_short_name' of incorrect type. Expected str, got {type(child_short_name_old)}")
		if parent_short_name_old is not None and not (isinstance(parent_short_name_old, str)):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(parent_short_name_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if child_short_name_list_old is not None and not (isinstance(child_short_name_list_old, list)):
			raise ValueError(f"'child_short_name_list' of incorrect type. Expected list, got {type(child_short_name_list_old)}")
		if parent_short_name_list_old is not None and not (isinstance(parent_short_name_list_old, list)):
			raise ValueError(f"'parent_short_name_list' of incorrect type. Expected list, got {type(parent_short_name_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, child_short_name_old=child_short_name_old, parent_short_name_old=parent_short_name_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, child_short_name_list_old=child_short_name_list_old, parent_short_name_list_old=parent_short_name_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(child_short_name_old: str, parent_short_name_old: str, child_short_name_new: str = None, parent_short_name_new: str = None) -> dict:
		if child_short_name_new is not None and not (isinstance(child_short_name_new, str)):
			raise ValueError(f"'child_short_name' of incorrect type. Expected str, got {type(child_short_name_new)}")
		if parent_short_name_new is not None and not (isinstance(parent_short_name_new, str)):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(parent_short_name_new)}")
		if not (isinstance(child_short_name_old, str)):
			raise ValueError(f"'child_short_name' of incorrect type. Expected str, got {type(child_short_name_old)}")
		if not (isinstance(parent_short_name_old, str)):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(parent_short_name_old)}")

		return {'name': 'ndcfg.site_type2type.update', 'new': _denullify_dict({'child_short_name': child_short_name_new, 'parent_short_name': parent_short_name_new}), 'old': _denullify_dict({'child_short_name': child_short_name_old, 'parent_short_name': parent_short_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, child_short_name_old: str, parent_short_name_old: str, child_short_name_new: str = None, parent_short_name_new: str = None) -> list:
		if child_short_name_new is not None and not (isinstance(child_short_name_new, str)):
			raise ValueError(f"'child_short_name' of incorrect type. Expected str, got {type(child_short_name_new)}")
		if parent_short_name_new is not None and not (isinstance(parent_short_name_new, str)):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(parent_short_name_new)}")
		if not (isinstance(child_short_name_old, str)):
			raise ValueError(f"'child_short_name' of incorrect type. Expected str, got {type(child_short_name_old)}")
		if not (isinstance(parent_short_name_old, str)):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(parent_short_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(child_short_name_new=child_short_name_new, parent_short_name_new=parent_short_name_new, child_short_name_old=child_short_name_old, parent_short_name_old=parent_short_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class LPortTag(APIObject):
	gpk: str
	value: str
	level_list: list
	description: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.value, str):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(self.value)}")
		if not isinstance(self.level_list, list):
			raise ValueError(f"'level_list' of incorrect type. Expected list, got {type(self.level_list)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")

	@staticmethod
	def create_ta(value_new: str, level_list_new: list = None, description_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(value_new, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_new)}")
		if level_list_new is not None and not (isinstance(level_list_new, list)):
			raise ValueError(f"'level_list' of incorrect type. Expected list, got {type(level_list_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		return {'name': 'ndcfg.l_port_tag.create', 'new': _denullify_dict({'value': value_new, 'level_list': level_list_new, 'description': description_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, value_new: str, level_list_new: list = None, description_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(value_new, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_new)}")
		if level_list_new is not None and not (isinstance(level_list_new, list)):
			raise ValueError(f"'level_list' of incorrect type. Expected list, got {type(level_list_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(value_new=value_new, level_list_new=level_list_new, description_new=description_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(value_old: str) -> dict:
		if not (isinstance(value_old, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")

		return {'name': 'ndcfg.l_port_tag.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'value': value_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, value_old: str) -> list:
		if not (isinstance(value_old, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(value_old=value_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, value_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if value_list_old is not None and not (isinstance(value_list_old, list)):
			raise ValueError(f"'value_list' of incorrect type. Expected list, got {type(value_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'ndcfg.l_port_tag.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'value_list': value_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, value_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if value_list_old is not None and not (isinstance(value_list_old, list)):
			raise ValueError(f"'value_list' of incorrect type. Expected list, got {type(value_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, value_list_old=value_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(value_old: str, value_new: str = None, level_list_new: list = None, description_new: Union[str, ExplicitNull] = None) -> dict:
		if value_new is not None and not (isinstance(value_new, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_new)}")
		if level_list_new is not None and not (isinstance(level_list_new, list)):
			raise ValueError(f"'level_list' of incorrect type. Expected list, got {type(level_list_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(value_old, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")

		return {'name': 'ndcfg.l_port_tag.update', 'new': _denullify_dict({'value': value_new, 'level_list': level_list_new, 'description': description_new}), 'old': _denullify_dict({'value': value_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, value_old: str, value_new: str = None, level_list_new: list = None, description_new: Union[str, ExplicitNull] = None) -> list:
		if value_new is not None and not (isinstance(value_new, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_new)}")
		if level_list_new is not None and not (isinstance(level_list_new, list)):
			raise ValueError(f"'level_list' of incorrect type. Expected list, got {type(level_list_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(value_old, str)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(value_new=value_new, level_list_new=level_list_new, description_new=description_new, value_old=value_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
