### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class System(APIObject):
	gpk: str
	name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")

	@staticmethod
	def create_ta(name_new: str) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")

		return {'name': 'cntl.system.create', 'new': _denullify_dict({'name': name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'cntl.system.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.system.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk_list': gpk_list_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_list_old: list = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_list_old=gpk_list_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'cntl.system.update', 'new': _denullify_dict({'name': name_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Mgr(APIObject):
	gpk: str
	email: str
	is_own: bool
	is_sub: bool
	is_svc: bool
	sub_id: str
	svc_id: str
	is_self: bool
	last_name: str
	first_name: str
	kit_status: int
	login_name: str
	description: str
	is_deletable: bool
	is_adm_locked: bool
	parent_login_name: str
	allow_data_manipulation: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if self.email is not None and not isinstance(self.email, str):
			raise ValueError(f"'email' of incorrect type. Expected str, got {type(self.email)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.is_sub, bool):
			raise ValueError(f"'is_sub' of incorrect type. Expected bool, got {type(self.is_sub)}")
		if not isinstance(self.is_svc, bool):
			raise ValueError(f"'is_svc' of incorrect type. Expected bool, got {type(self.is_svc)}")
		if self.sub_id is not None and not isinstance(self.sub_id, str):
			raise ValueError(f"'sub_id' of incorrect type. Expected str, got {type(self.sub_id)}")
		if self.svc_id is not None and not isinstance(self.svc_id, str):
			raise ValueError(f"'svc_id' of incorrect type. Expected str, got {type(self.svc_id)}")
		if not isinstance(self.is_self, bool):
			raise ValueError(f"'is_self' of incorrect type. Expected bool, got {type(self.is_self)}")
		if self.last_name is not None and not isinstance(self.last_name, str):
			raise ValueError(f"'last_name' of incorrect type. Expected str, got {type(self.last_name)}")
		if self.first_name is not None and not isinstance(self.first_name, str):
			raise ValueError(f"'first_name' of incorrect type. Expected str, got {type(self.first_name)}")
		if not isinstance(self.kit_status, int):
			raise ValueError(f"'kit_status' of incorrect type. Expected int, got {type(self.kit_status)}")
		if not isinstance(self.login_name, str):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(self.login_name)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.is_deletable, bool):
			raise ValueError(f"'is_deletable' of incorrect type. Expected bool, got {type(self.is_deletable)}")
		if not isinstance(self.is_adm_locked, bool):
			raise ValueError(f"'is_adm_locked' of incorrect type. Expected bool, got {type(self.is_adm_locked)}")
		if not isinstance(self.parent_login_name, str):
			raise ValueError(f"'parent_login_name' of incorrect type. Expected str, got {type(self.parent_login_name)}")
		if not isinstance(self.allow_data_manipulation, bool):
			raise ValueError(f"'allow_data_manipulation' of incorrect type. Expected bool, got {type(self.allow_data_manipulation)}")

	@staticmethod
	def create_ta(is_svc_new: bool = False, sub_id_new: Union[str, ExplicitNull] = None, svc_id_new: str = None, kit_status_new: int = None, login_name_new: str = None, description_new: Union[str, ExplicitNull] = None, do_copy_roles_new: bool = True, is_adm_locked_new: bool = None, allow_data_manipulation_new: bool = True) -> dict:
		if is_svc_new is not None and not (isinstance(is_svc_new, bool)):
			raise ValueError(f"'is_svc' of incorrect type. Expected bool, got {type(is_svc_new)}")
		if sub_id_new is not None and not (isinstance(sub_id_new, str) or isinstance(sub_id_new, ExplicitNull)):
			raise ValueError(f"'sub_id' of incorrect type. Expected str, got {type(sub_id_new)}")
		if svc_id_new is not None and not (isinstance(svc_id_new, str)):
			raise ValueError(f"'svc_id' of incorrect type. Expected str, got {type(svc_id_new)}")
		if kit_status_new is not None and not (isinstance(kit_status_new, int)):
			raise ValueError(f"'kit_status' of incorrect type. Expected int, got {type(kit_status_new)}")
		if login_name_new is not None and not (isinstance(login_name_new, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_copy_roles_new is not None and not (isinstance(do_copy_roles_new, bool)):
			raise ValueError(f"'do_copy_roles' of incorrect type. Expected bool, got {type(do_copy_roles_new)}")
		if is_adm_locked_new is not None and not (isinstance(is_adm_locked_new, bool)):
			raise ValueError(f"'is_adm_locked' of incorrect type. Expected bool, got {type(is_adm_locked_new)}")
		if allow_data_manipulation_new is not None and not (isinstance(allow_data_manipulation_new, bool)):
			raise ValueError(f"'allow_data_manipulation' of incorrect type. Expected bool, got {type(allow_data_manipulation_new)}")

		return {'name': 'cntl.mgr.create', 'new': _denullify_dict({'is_svc': is_svc_new, 'sub_id': sub_id_new, 'svc_id': svc_id_new, 'kit_status': kit_status_new, 'login_name': login_name_new, 'description': description_new, 'do_copy_roles': do_copy_roles_new, 'is_adm_locked': is_adm_locked_new, 'allow_data_manipulation': allow_data_manipulation_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, is_svc_new: bool = False, sub_id_new: Union[str, ExplicitNull] = None, svc_id_new: str = None, kit_status_new: int = None, login_name_new: str = None, description_new: Union[str, ExplicitNull] = None, do_copy_roles_new: bool = True, is_adm_locked_new: bool = None, allow_data_manipulation_new: bool = True) -> list:
		if is_svc_new is not None and not (isinstance(is_svc_new, bool)):
			raise ValueError(f"'is_svc' of incorrect type. Expected bool, got {type(is_svc_new)}")
		if sub_id_new is not None and not (isinstance(sub_id_new, str) or isinstance(sub_id_new, ExplicitNull)):
			raise ValueError(f"'sub_id' of incorrect type. Expected str, got {type(sub_id_new)}")
		if svc_id_new is not None and not (isinstance(svc_id_new, str)):
			raise ValueError(f"'svc_id' of incorrect type. Expected str, got {type(svc_id_new)}")
		if kit_status_new is not None and not (isinstance(kit_status_new, int)):
			raise ValueError(f"'kit_status' of incorrect type. Expected int, got {type(kit_status_new)}")
		if login_name_new is not None and not (isinstance(login_name_new, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_copy_roles_new is not None and not (isinstance(do_copy_roles_new, bool)):
			raise ValueError(f"'do_copy_roles' of incorrect type. Expected bool, got {type(do_copy_roles_new)}")
		if is_adm_locked_new is not None and not (isinstance(is_adm_locked_new, bool)):
			raise ValueError(f"'is_adm_locked' of incorrect type. Expected bool, got {type(is_adm_locked_new)}")
		if allow_data_manipulation_new is not None and not (isinstance(allow_data_manipulation_new, bool)):
			raise ValueError(f"'allow_data_manipulation' of incorrect type. Expected bool, got {type(allow_data_manipulation_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(is_svc_new=is_svc_new, sub_id_new=sub_id_new, svc_id_new=svc_id_new, kit_status_new=kit_status_new, login_name_new=login_name_new, description_new=description_new, do_copy_roles_new=do_copy_roles_new, is_adm_locked_new=is_adm_locked_new, allow_data_manipulation_new=allow_data_manipulation_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(login_name_old: str) -> dict:
		if not (isinstance(login_name_old, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_old)}")

		return {'name': 'cntl.mgr.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'login_name': login_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, login_name_old: str) -> list:
		if not (isinstance(login_name_old, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(login_name_old=login_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(is_own_old: bool = None, is_sub_old: bool = None, is_svc_old: bool = None, sub_id_old: str = None, svc_id_old: str = None, is_self_old: bool = None, gpk_list_old: list = None, kit_status_old: int = None, fetch_limit_old: int = None, sub_id_list_old: list = None, svc_id_list_old: list = None, email_regexp_old: str = None, fetch_offset_old: int = None, is_deletable_old: bool = None, is_adm_locked_old: bool = None, sub_id_regexp_old: str = None, svc_id_regexp_old: str = None, login_name_list_old: list = None, login_name_regexp_old: str = None, filter_params_dict_old: dict = None, full_name_regexp_ic_old: str = None, last_name_regexp_ic_old: str = None, sorting_params_list_old: list = None, first_name_regexp_ic_old: str = None, parent_login_name_list_old: list = None, allow_data_manipulation_old: bool = None) -> dict:
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_sub_old is not None and not (isinstance(is_sub_old, bool)):
			raise ValueError(f"'is_sub' of incorrect type. Expected bool, got {type(is_sub_old)}")
		if is_svc_old is not None and not (isinstance(is_svc_old, bool)):
			raise ValueError(f"'is_svc' of incorrect type. Expected bool, got {type(is_svc_old)}")
		if sub_id_old is not None and not (isinstance(sub_id_old, str) or isinstance(sub_id_old, ExplicitNull)):
			raise ValueError(f"'sub_id' of incorrect type. Expected str, got {type(sub_id_old)}")
		if svc_id_old is not None and not (isinstance(svc_id_old, str) or isinstance(svc_id_old, ExplicitNull)):
			raise ValueError(f"'svc_id' of incorrect type. Expected str, got {type(svc_id_old)}")
		if is_self_old is not None and not (isinstance(is_self_old, bool)):
			raise ValueError(f"'is_self' of incorrect type. Expected bool, got {type(is_self_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if kit_status_old is not None and not (isinstance(kit_status_old, int)):
			raise ValueError(f"'kit_status' of incorrect type. Expected int, got {type(kit_status_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if sub_id_list_old is not None and not (isinstance(sub_id_list_old, list)):
			raise ValueError(f"'sub_id_list' of incorrect type. Expected list, got {type(sub_id_list_old)}")
		if svc_id_list_old is not None and not (isinstance(svc_id_list_old, list)):
			raise ValueError(f"'svc_id_list' of incorrect type. Expected list, got {type(svc_id_list_old)}")
		if email_regexp_old is not None and not (isinstance(email_regexp_old, str)):
			raise ValueError(f"'email_regexp' of incorrect type. Expected str, got {type(email_regexp_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_deletable_old is not None and not (isinstance(is_deletable_old, bool)):
			raise ValueError(f"'is_deletable' of incorrect type. Expected bool, got {type(is_deletable_old)}")
		if is_adm_locked_old is not None and not (isinstance(is_adm_locked_old, bool)):
			raise ValueError(f"'is_adm_locked' of incorrect type. Expected bool, got {type(is_adm_locked_old)}")
		if sub_id_regexp_old is not None and not (isinstance(sub_id_regexp_old, str)):
			raise ValueError(f"'sub_id_regexp' of incorrect type. Expected str, got {type(sub_id_regexp_old)}")
		if svc_id_regexp_old is not None and not (isinstance(svc_id_regexp_old, str)):
			raise ValueError(f"'svc_id_regexp' of incorrect type. Expected str, got {type(svc_id_regexp_old)}")
		if login_name_list_old is not None and not (isinstance(login_name_list_old, list)):
			raise ValueError(f"'login_name_list' of incorrect type. Expected list, got {type(login_name_list_old)}")
		if login_name_regexp_old is not None and not (isinstance(login_name_regexp_old, str)):
			raise ValueError(f"'login_name_regexp' of incorrect type. Expected str, got {type(login_name_regexp_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if full_name_regexp_ic_old is not None and not (isinstance(full_name_regexp_ic_old, str)):
			raise ValueError(f"'full_name_regexp_ic' of incorrect type. Expected str, got {type(full_name_regexp_ic_old)}")
		if last_name_regexp_ic_old is not None and not (isinstance(last_name_regexp_ic_old, str)):
			raise ValueError(f"'last_name_regexp_ic' of incorrect type. Expected str, got {type(last_name_regexp_ic_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if first_name_regexp_ic_old is not None and not (isinstance(first_name_regexp_ic_old, str)):
			raise ValueError(f"'first_name_regexp_ic' of incorrect type. Expected str, got {type(first_name_regexp_ic_old)}")
		if parent_login_name_list_old is not None and not (isinstance(parent_login_name_list_old, list)):
			raise ValueError(f"'parent_login_name_list' of incorrect type. Expected list, got {type(parent_login_name_list_old)}")
		if allow_data_manipulation_old is not None and not (isinstance(allow_data_manipulation_old, bool)):
			raise ValueError(f"'allow_data_manipulation' of incorrect type. Expected bool, got {type(allow_data_manipulation_old)}")

		return {'name': 'cntl.mgr.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'is_own': is_own_old, 'is_sub': is_sub_old, 'is_svc': is_svc_old, 'sub_id': sub_id_old, 'svc_id': svc_id_old, 'is_self': is_self_old, 'gpk_list': gpk_list_old, 'kit_status': kit_status_old, 'fetch_limit': fetch_limit_old, 'sub_id_list': sub_id_list_old, 'svc_id_list': svc_id_list_old, 'email_regexp': email_regexp_old, 'fetch_offset': fetch_offset_old, 'is_deletable': is_deletable_old, 'is_adm_locked': is_adm_locked_old, 'sub_id_regexp': sub_id_regexp_old, 'svc_id_regexp': svc_id_regexp_old, 'login_name_list': login_name_list_old, 'login_name_regexp': login_name_regexp_old, 'filter_params_dict': filter_params_dict_old, 'full_name_regexp_ic': full_name_regexp_ic_old, 'last_name_regexp_ic': last_name_regexp_ic_old, 'sorting_params_list': sorting_params_list_old, 'first_name_regexp_ic': first_name_regexp_ic_old, 'parent_login_name_list': parent_login_name_list_old, 'allow_data_manipulation': allow_data_manipulation_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, is_own_old: bool = None, is_sub_old: bool = None, is_svc_old: bool = None, sub_id_old: str = None, svc_id_old: str = None, is_self_old: bool = None, gpk_list_old: list = None, kit_status_old: int = None, fetch_limit_old: int = None, sub_id_list_old: list = None, svc_id_list_old: list = None, email_regexp_old: str = None, fetch_offset_old: int = None, is_deletable_old: bool = None, is_adm_locked_old: bool = None, sub_id_regexp_old: str = None, svc_id_regexp_old: str = None, login_name_list_old: list = None, login_name_regexp_old: str = None, filter_params_dict_old: dict = None, full_name_regexp_ic_old: str = None, last_name_regexp_ic_old: str = None, sorting_params_list_old: list = None, first_name_regexp_ic_old: str = None, parent_login_name_list_old: list = None, allow_data_manipulation_old: bool = None) -> list:
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_sub_old is not None and not (isinstance(is_sub_old, bool)):
			raise ValueError(f"'is_sub' of incorrect type. Expected bool, got {type(is_sub_old)}")
		if is_svc_old is not None and not (isinstance(is_svc_old, bool)):
			raise ValueError(f"'is_svc' of incorrect type. Expected bool, got {type(is_svc_old)}")
		if sub_id_old is not None and not (isinstance(sub_id_old, str) or isinstance(sub_id_old, ExplicitNull)):
			raise ValueError(f"'sub_id' of incorrect type. Expected str, got {type(sub_id_old)}")
		if svc_id_old is not None and not (isinstance(svc_id_old, str) or isinstance(svc_id_old, ExplicitNull)):
			raise ValueError(f"'svc_id' of incorrect type. Expected str, got {type(svc_id_old)}")
		if is_self_old is not None and not (isinstance(is_self_old, bool)):
			raise ValueError(f"'is_self' of incorrect type. Expected bool, got {type(is_self_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if kit_status_old is not None and not (isinstance(kit_status_old, int)):
			raise ValueError(f"'kit_status' of incorrect type. Expected int, got {type(kit_status_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if sub_id_list_old is not None and not (isinstance(sub_id_list_old, list)):
			raise ValueError(f"'sub_id_list' of incorrect type. Expected list, got {type(sub_id_list_old)}")
		if svc_id_list_old is not None and not (isinstance(svc_id_list_old, list)):
			raise ValueError(f"'svc_id_list' of incorrect type. Expected list, got {type(svc_id_list_old)}")
		if email_regexp_old is not None and not (isinstance(email_regexp_old, str)):
			raise ValueError(f"'email_regexp' of incorrect type. Expected str, got {type(email_regexp_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_deletable_old is not None and not (isinstance(is_deletable_old, bool)):
			raise ValueError(f"'is_deletable' of incorrect type. Expected bool, got {type(is_deletable_old)}")
		if is_adm_locked_old is not None and not (isinstance(is_adm_locked_old, bool)):
			raise ValueError(f"'is_adm_locked' of incorrect type. Expected bool, got {type(is_adm_locked_old)}")
		if sub_id_regexp_old is not None and not (isinstance(sub_id_regexp_old, str)):
			raise ValueError(f"'sub_id_regexp' of incorrect type. Expected str, got {type(sub_id_regexp_old)}")
		if svc_id_regexp_old is not None and not (isinstance(svc_id_regexp_old, str)):
			raise ValueError(f"'svc_id_regexp' of incorrect type. Expected str, got {type(svc_id_regexp_old)}")
		if login_name_list_old is not None and not (isinstance(login_name_list_old, list)):
			raise ValueError(f"'login_name_list' of incorrect type. Expected list, got {type(login_name_list_old)}")
		if login_name_regexp_old is not None and not (isinstance(login_name_regexp_old, str)):
			raise ValueError(f"'login_name_regexp' of incorrect type. Expected str, got {type(login_name_regexp_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if full_name_regexp_ic_old is not None and not (isinstance(full_name_regexp_ic_old, str)):
			raise ValueError(f"'full_name_regexp_ic' of incorrect type. Expected str, got {type(full_name_regexp_ic_old)}")
		if last_name_regexp_ic_old is not None and not (isinstance(last_name_regexp_ic_old, str)):
			raise ValueError(f"'last_name_regexp_ic' of incorrect type. Expected str, got {type(last_name_regexp_ic_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if first_name_regexp_ic_old is not None and not (isinstance(first_name_regexp_ic_old, str)):
			raise ValueError(f"'first_name_regexp_ic' of incorrect type. Expected str, got {type(first_name_regexp_ic_old)}")
		if parent_login_name_list_old is not None and not (isinstance(parent_login_name_list_old, list)):
			raise ValueError(f"'parent_login_name_list' of incorrect type. Expected list, got {type(parent_login_name_list_old)}")
		if allow_data_manipulation_old is not None and not (isinstance(allow_data_manipulation_old, bool)):
			raise ValueError(f"'allow_data_manipulation' of incorrect type. Expected bool, got {type(allow_data_manipulation_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(is_own_old=is_own_old, is_sub_old=is_sub_old, is_svc_old=is_svc_old, sub_id_old=sub_id_old, svc_id_old=svc_id_old, is_self_old=is_self_old, gpk_list_old=gpk_list_old, kit_status_old=kit_status_old, fetch_limit_old=fetch_limit_old, sub_id_list_old=sub_id_list_old, svc_id_list_old=svc_id_list_old, email_regexp_old=email_regexp_old, fetch_offset_old=fetch_offset_old, is_deletable_old=is_deletable_old, is_adm_locked_old=is_adm_locked_old, sub_id_regexp_old=sub_id_regexp_old, svc_id_regexp_old=svc_id_regexp_old, login_name_list_old=login_name_list_old, login_name_regexp_old=login_name_regexp_old, filter_params_dict_old=filter_params_dict_old, full_name_regexp_ic_old=full_name_regexp_ic_old, last_name_regexp_ic_old=last_name_regexp_ic_old, sorting_params_list_old=sorting_params_list_old, first_name_regexp_ic_old=first_name_regexp_ic_old, parent_login_name_list_old=parent_login_name_list_old, allow_data_manipulation_old=allow_data_manipulation_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(login_name_old: str, sub_id_new: Union[str, ExplicitNull] = None, svc_id_new: str = None, kit_status_new: int = None, login_name_new: str = None, description_new: Union[str, ExplicitNull] = None, is_adm_locked_new: bool = None, allow_data_manipulation_new: bool = None) -> dict:
		if sub_id_new is not None and not (isinstance(sub_id_new, str) or isinstance(sub_id_new, ExplicitNull)):
			raise ValueError(f"'sub_id' of incorrect type. Expected str, got {type(sub_id_new)}")
		if svc_id_new is not None and not (isinstance(svc_id_new, str)):
			raise ValueError(f"'svc_id' of incorrect type. Expected str, got {type(svc_id_new)}")
		if kit_status_new is not None and not (isinstance(kit_status_new, int)):
			raise ValueError(f"'kit_status' of incorrect type. Expected int, got {type(kit_status_new)}")
		if login_name_new is not None and not (isinstance(login_name_new, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_adm_locked_new is not None and not (isinstance(is_adm_locked_new, bool)):
			raise ValueError(f"'is_adm_locked' of incorrect type. Expected bool, got {type(is_adm_locked_new)}")
		if allow_data_manipulation_new is not None and not (isinstance(allow_data_manipulation_new, bool)):
			raise ValueError(f"'allow_data_manipulation' of incorrect type. Expected bool, got {type(allow_data_manipulation_new)}")
		if not (isinstance(login_name_old, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_old)}")

		return {'name': 'cntl.mgr.update', 'new': _denullify_dict({'sub_id': sub_id_new, 'svc_id': svc_id_new, 'kit_status': kit_status_new, 'login_name': login_name_new, 'description': description_new, 'is_adm_locked': is_adm_locked_new, 'allow_data_manipulation': allow_data_manipulation_new}), 'old': _denullify_dict({'login_name': login_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, login_name_old: str, sub_id_new: Union[str, ExplicitNull] = None, svc_id_new: str = None, kit_status_new: int = None, login_name_new: str = None, description_new: Union[str, ExplicitNull] = None, is_adm_locked_new: bool = None, allow_data_manipulation_new: bool = None) -> list:
		if sub_id_new is not None and not (isinstance(sub_id_new, str) or isinstance(sub_id_new, ExplicitNull)):
			raise ValueError(f"'sub_id' of incorrect type. Expected str, got {type(sub_id_new)}")
		if svc_id_new is not None and not (isinstance(svc_id_new, str)):
			raise ValueError(f"'svc_id' of incorrect type. Expected str, got {type(svc_id_new)}")
		if kit_status_new is not None and not (isinstance(kit_status_new, int)):
			raise ValueError(f"'kit_status' of incorrect type. Expected int, got {type(kit_status_new)}")
		if login_name_new is not None and not (isinstance(login_name_new, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_adm_locked_new is not None and not (isinstance(is_adm_locked_new, bool)):
			raise ValueError(f"'is_adm_locked' of incorrect type. Expected bool, got {type(is_adm_locked_new)}")
		if allow_data_manipulation_new is not None and not (isinstance(allow_data_manipulation_new, bool)):
			raise ValueError(f"'allow_data_manipulation' of incorrect type. Expected bool, got {type(allow_data_manipulation_new)}")
		if not (isinstance(login_name_old, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(sub_id_new=sub_id_new, svc_id_new=svc_id_new, kit_status_new=kit_status_new, login_name_new=login_name_new, description_new=description_new, is_adm_locked_new=is_adm_locked_new, allow_data_manipulation_new=allow_data_manipulation_new, login_name_old=login_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Error(APIObject):
	gpk: str
	code: int
	type: int
	system: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.code, int):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(self.code)}")
		if not isinstance(self.type, int):
			raise ValueError(f"'type' of incorrect type. Expected int, got {type(self.type)}")
		if not isinstance(self.system, str):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(self.system)}")

	@staticmethod
	def create_ta(code_new: int, type_new: int, system_new: str) -> dict:
		if not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if not (isinstance(type_new, int)):
			raise ValueError(f"'type' of incorrect type. Expected int, got {type(type_new)}")
		if not (isinstance(system_new, str)):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(system_new)}")

		return {'name': 'cntl.error.create', 'new': _denullify_dict({'code': code_new, 'type': type_new, 'system': system_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, code_new: int, type_new: int, system_new: str) -> list:
		if not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if not (isinstance(type_new, int)):
			raise ValueError(f"'type' of incorrect type. Expected int, got {type(type_new)}")
		if not (isinstance(system_new, str)):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(system_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(code_new=code_new, type_new=type_new, system_new=system_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(code_old: int, type_old: int) -> dict:
		if not (isinstance(code_old, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_old)}")
		if not (isinstance(type_old, int)):
			raise ValueError(f"'type' of incorrect type. Expected int, got {type(type_old)}")

		return {'name': 'cntl.error.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'code': code_old, 'type': type_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, code_old: int, type_old: int) -> list:
		if not (isinstance(code_old, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_old)}")
		if not (isinstance(type_old, int)):
			raise ValueError(f"'type' of incorrect type. Expected int, got {type(type_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(code_old=code_old, type_old=type_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(system_old: str = None, gpk_list_old: list = None, code_list_old: list = None, type_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if system_old is not None and not (isinstance(system_old, str)):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(system_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if code_list_old is not None and not (isinstance(code_list_old, list)):
			raise ValueError(f"'code_list' of incorrect type. Expected list, got {type(code_list_old)}")
		if type_list_old is not None and not (isinstance(type_list_old, list)):
			raise ValueError(f"'type_list' of incorrect type. Expected list, got {type(type_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.error.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'system': system_old, 'gpk_list': gpk_list_old, 'code_list': code_list_old, 'type_list': type_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, system_old: str = None, gpk_list_old: list = None, code_list_old: list = None, type_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if system_old is not None and not (isinstance(system_old, str)):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(system_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if code_list_old is not None and not (isinstance(code_list_old, list)):
			raise ValueError(f"'code_list' of incorrect type. Expected list, got {type(code_list_old)}")
		if type_list_old is not None and not (isinstance(type_list_old, list)):
			raise ValueError(f"'type_list' of incorrect type. Expected list, got {type(type_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(system_old=system_old, gpk_list_old=gpk_list_old, code_list_old=code_list_old, type_list_old=type_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(code_old: int, type_old: int, code_new: int = None, type_new: int = None, system_new: str = None) -> dict:
		if code_new is not None and not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if type_new is not None and not (isinstance(type_new, int)):
			raise ValueError(f"'type' of incorrect type. Expected int, got {type(type_new)}")
		if system_new is not None and not (isinstance(system_new, str)):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(system_new)}")
		if not (isinstance(code_old, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_old)}")
		if not (isinstance(type_old, int)):
			raise ValueError(f"'type' of incorrect type. Expected int, got {type(type_old)}")

		return {'name': 'cntl.error.update', 'new': _denullify_dict({'code': code_new, 'type': type_new, 'system': system_new}), 'old': _denullify_dict({'code': code_old, 'type': type_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, code_old: int, type_old: int, code_new: int = None, type_new: int = None, system_new: str = None) -> list:
		if code_new is not None and not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if type_new is not None and not (isinstance(type_new, int)):
			raise ValueError(f"'type' of incorrect type. Expected int, got {type(type_new)}")
		if system_new is not None and not (isinstance(system_new, str)):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(system_new)}")
		if not (isinstance(code_old, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_old)}")
		if not (isinstance(type_old, int)):
			raise ValueError(f"'type' of incorrect type. Expected int, got {type(type_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(code_new=code_new, type_new=type_new, system_new=system_new, code_old=code_old, type_old=type_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Column(APIObject):
	gpk: str
	name: str
	is_wapi: bool
	ref_gfk: str
	data_type: str
	table_gfk: str
	table_name: str
	is_nullable: bool
	is_required: bool
	is_deprecated: bool
	attribute_name: str
	ref_target_gfk: str
	is_ot_global_ref: bool
	object_type_fq_name: str
	pg_attribute_exists: bool
	use_ref_column_language_attributes: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.is_wapi, bool):
			raise ValueError(f"'is_wapi' of incorrect type. Expected bool, got {type(self.is_wapi)}")
		if self.ref_gfk is not None and not isinstance(self.ref_gfk, str):
			raise ValueError(f"'ref_gfk' of incorrect type. Expected str, got {type(self.ref_gfk)}")
		if not isinstance(self.data_type, str):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(self.data_type)}")
		if not isinstance(self.table_gfk, str):
			raise ValueError(f"'table_gfk' of incorrect type. Expected str, got {type(self.table_gfk)}")
		if not isinstance(self.table_name, str):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(self.table_name)}")
		if not isinstance(self.is_nullable, bool):
			raise ValueError(f"'is_nullable' of incorrect type. Expected bool, got {type(self.is_nullable)}")
		if not isinstance(self.is_required, bool):
			raise ValueError(f"'is_required' of incorrect type. Expected bool, got {type(self.is_required)}")
		if not isinstance(self.is_deprecated, bool):
			raise ValueError(f"'is_deprecated' of incorrect type. Expected bool, got {type(self.is_deprecated)}")
		if not isinstance(self.attribute_name, str):
			raise ValueError(f"'attribute_name' of incorrect type. Expected str, got {type(self.attribute_name)}")
		if self.ref_target_gfk is not None and not isinstance(self.ref_target_gfk, str):
			raise ValueError(f"'ref_target_gfk' of incorrect type. Expected str, got {type(self.ref_target_gfk)}")
		if not isinstance(self.is_ot_global_ref, bool):
			raise ValueError(f"'is_ot_global_ref' of incorrect type. Expected bool, got {type(self.is_ot_global_ref)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")
		if not isinstance(self.pg_attribute_exists, bool):
			raise ValueError(f"'pg_attribute_exists' of incorrect type. Expected bool, got {type(self.pg_attribute_exists)}")
		if not isinstance(self.use_ref_column_language_attributes, bool):
			raise ValueError(f"'use_ref_column_language_attributes' of incorrect type. Expected bool, got {type(self.use_ref_column_language_attributes)}")

	@staticmethod
	def create_ta(name_new: str, is_wapi_new: bool, data_type_new: str, table_name_new: str, is_nullable_new: bool, is_required_new: bool, ref_gfk_new: Union[str, ExplicitNull] = None, is_deprecated_new: bool = False, attribute_name_new: str = None, is_ot_global_ref_new: bool = False, use_ref_column_language_attributes_new: bool = False) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(is_wapi_new, bool)):
			raise ValueError(f"'is_wapi' of incorrect type. Expected bool, got {type(is_wapi_new)}")
		if ref_gfk_new is not None and not (isinstance(ref_gfk_new, str) or isinstance(ref_gfk_new, ExplicitNull)):
			raise ValueError(f"'ref_gfk' of incorrect type. Expected str, got {type(ref_gfk_new)}")
		if not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if not (isinstance(is_nullable_new, bool)):
			raise ValueError(f"'is_nullable' of incorrect type. Expected bool, got {type(is_nullable_new)}")
		if not (isinstance(is_required_new, bool)):
			raise ValueError(f"'is_required' of incorrect type. Expected bool, got {type(is_required_new)}")
		if is_deprecated_new is not None and not (isinstance(is_deprecated_new, bool)):
			raise ValueError(f"'is_deprecated' of incorrect type. Expected bool, got {type(is_deprecated_new)}")
		if attribute_name_new is not None and not (isinstance(attribute_name_new, str)):
			raise ValueError(f"'attribute_name' of incorrect type. Expected str, got {type(attribute_name_new)}")
		if is_ot_global_ref_new is not None and not (isinstance(is_ot_global_ref_new, bool)):
			raise ValueError(f"'is_ot_global_ref' of incorrect type. Expected bool, got {type(is_ot_global_ref_new)}")
		if use_ref_column_language_attributes_new is not None and not (isinstance(use_ref_column_language_attributes_new, bool)):
			raise ValueError(f"'use_ref_column_language_attributes' of incorrect type. Expected bool, got {type(use_ref_column_language_attributes_new)}")

		return {'name': 'cntl.column.create', 'new': _denullify_dict({'name': name_new, 'is_wapi': is_wapi_new, 'ref_gfk': ref_gfk_new, 'data_type': data_type_new, 'table_name': table_name_new, 'is_nullable': is_nullable_new, 'is_required': is_required_new, 'is_deprecated': is_deprecated_new, 'attribute_name': attribute_name_new, 'is_ot_global_ref': is_ot_global_ref_new, 'use_ref_column_language_attributes': use_ref_column_language_attributes_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, is_wapi_new: bool, data_type_new: str, table_name_new: str, is_nullable_new: bool, is_required_new: bool, ref_gfk_new: Union[str, ExplicitNull] = None, is_deprecated_new: bool = False, attribute_name_new: str = None, is_ot_global_ref_new: bool = False, use_ref_column_language_attributes_new: bool = False) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(is_wapi_new, bool)):
			raise ValueError(f"'is_wapi' of incorrect type. Expected bool, got {type(is_wapi_new)}")
		if ref_gfk_new is not None and not (isinstance(ref_gfk_new, str) or isinstance(ref_gfk_new, ExplicitNull)):
			raise ValueError(f"'ref_gfk' of incorrect type. Expected str, got {type(ref_gfk_new)}")
		if not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if not (isinstance(is_nullable_new, bool)):
			raise ValueError(f"'is_nullable' of incorrect type. Expected bool, got {type(is_nullable_new)}")
		if not (isinstance(is_required_new, bool)):
			raise ValueError(f"'is_required' of incorrect type. Expected bool, got {type(is_required_new)}")
		if is_deprecated_new is not None and not (isinstance(is_deprecated_new, bool)):
			raise ValueError(f"'is_deprecated' of incorrect type. Expected bool, got {type(is_deprecated_new)}")
		if attribute_name_new is not None and not (isinstance(attribute_name_new, str)):
			raise ValueError(f"'attribute_name' of incorrect type. Expected str, got {type(attribute_name_new)}")
		if is_ot_global_ref_new is not None and not (isinstance(is_ot_global_ref_new, bool)):
			raise ValueError(f"'is_ot_global_ref' of incorrect type. Expected bool, got {type(is_ot_global_ref_new)}")
		if use_ref_column_language_attributes_new is not None and not (isinstance(use_ref_column_language_attributes_new, bool)):
			raise ValueError(f"'use_ref_column_language_attributes' of incorrect type. Expected bool, got {type(use_ref_column_language_attributes_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, is_wapi_new=is_wapi_new, ref_gfk_new=ref_gfk_new, data_type_new=data_type_new, table_name_new=table_name_new, is_nullable_new=is_nullable_new, is_required_new=is_required_new, is_deprecated_new=is_deprecated_new, attribute_name_new=attribute_name_new, is_ot_global_ref_new=is_ot_global_ref_new, use_ref_column_language_attributes_new=use_ref_column_language_attributes_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str, table_name_old: str, do_ref_set_null_old: bool = None) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")
		if do_ref_set_null_old is not None and not (isinstance(do_ref_set_null_old, bool)):
			raise ValueError(f"'do_ref_set_null' of incorrect type. Expected bool, got {type(do_ref_set_null_old)}")

		return {'name': 'cntl.column.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old, 'table_name': table_name_old, 'do_ref_set_null': do_ref_set_null_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str, table_name_old: str, do_ref_set_null_old: bool = None) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")
		if do_ref_set_null_old is not None and not (isinstance(do_ref_set_null_old, bool)):
			raise ValueError(f"'do_ref_set_null' of incorrect type. Expected bool, got {type(do_ref_set_null_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old, table_name_old=table_name_old, do_ref_set_null_old=do_ref_set_null_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(is_wapi_old: bool = None, gpk_list_old: list = None, data_type_old: str = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_deprecated_old: bool = None, table_name_list_old: list = None, is_ot_global_ref_old: bool = None, filter_params_dict_old: dict = None, pg_attribute_exists_old: bool = None, sorting_params_list_old: list = None, use_ref_column_language_attributes_old: bool = None) -> dict:
		if is_wapi_old is not None and not (isinstance(is_wapi_old, bool)):
			raise ValueError(f"'is_wapi' of incorrect type. Expected bool, got {type(is_wapi_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if data_type_old is not None and not (isinstance(data_type_old, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_deprecated_old is not None and not (isinstance(is_deprecated_old, bool)):
			raise ValueError(f"'is_deprecated' of incorrect type. Expected bool, got {type(is_deprecated_old)}")
		if table_name_list_old is not None and not (isinstance(table_name_list_old, list)):
			raise ValueError(f"'table_name_list' of incorrect type. Expected list, got {type(table_name_list_old)}")
		if is_ot_global_ref_old is not None and not (isinstance(is_ot_global_ref_old, bool)):
			raise ValueError(f"'is_ot_global_ref' of incorrect type. Expected bool, got {type(is_ot_global_ref_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if pg_attribute_exists_old is not None and not (isinstance(pg_attribute_exists_old, bool)):
			raise ValueError(f"'pg_attribute_exists' of incorrect type. Expected bool, got {type(pg_attribute_exists_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if use_ref_column_language_attributes_old is not None and not (isinstance(use_ref_column_language_attributes_old, bool)):
			raise ValueError(f"'use_ref_column_language_attributes' of incorrect type. Expected bool, got {type(use_ref_column_language_attributes_old)}")

		return {'name': 'cntl.column.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'is_wapi': is_wapi_old, 'gpk_list': gpk_list_old, 'data_type': data_type_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'is_deprecated': is_deprecated_old, 'table_name_list': table_name_list_old, 'is_ot_global_ref': is_ot_global_ref_old, 'filter_params_dict': filter_params_dict_old, 'pg_attribute_exists': pg_attribute_exists_old, 'sorting_params_list': sorting_params_list_old, 'use_ref_column_language_attributes': use_ref_column_language_attributes_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, is_wapi_old: bool = None, gpk_list_old: list = None, data_type_old: str = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_deprecated_old: bool = None, table_name_list_old: list = None, is_ot_global_ref_old: bool = None, filter_params_dict_old: dict = None, pg_attribute_exists_old: bool = None, sorting_params_list_old: list = None, use_ref_column_language_attributes_old: bool = None) -> list:
		if is_wapi_old is not None and not (isinstance(is_wapi_old, bool)):
			raise ValueError(f"'is_wapi' of incorrect type. Expected bool, got {type(is_wapi_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if data_type_old is not None and not (isinstance(data_type_old, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_deprecated_old is not None and not (isinstance(is_deprecated_old, bool)):
			raise ValueError(f"'is_deprecated' of incorrect type. Expected bool, got {type(is_deprecated_old)}")
		if table_name_list_old is not None and not (isinstance(table_name_list_old, list)):
			raise ValueError(f"'table_name_list' of incorrect type. Expected list, got {type(table_name_list_old)}")
		if is_ot_global_ref_old is not None and not (isinstance(is_ot_global_ref_old, bool)):
			raise ValueError(f"'is_ot_global_ref' of incorrect type. Expected bool, got {type(is_ot_global_ref_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if pg_attribute_exists_old is not None and not (isinstance(pg_attribute_exists_old, bool)):
			raise ValueError(f"'pg_attribute_exists' of incorrect type. Expected bool, got {type(pg_attribute_exists_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if use_ref_column_language_attributes_old is not None and not (isinstance(use_ref_column_language_attributes_old, bool)):
			raise ValueError(f"'use_ref_column_language_attributes' of incorrect type. Expected bool, got {type(use_ref_column_language_attributes_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(is_wapi_old=is_wapi_old, gpk_list_old=gpk_list_old, data_type_old=data_type_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, is_deprecated_old=is_deprecated_old, table_name_list_old=table_name_list_old, is_ot_global_ref_old=is_ot_global_ref_old, filter_params_dict_old=filter_params_dict_old, pg_attribute_exists_old=pg_attribute_exists_old, sorting_params_list_old=sorting_params_list_old, use_ref_column_language_attributes_old=use_ref_column_language_attributes_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, table_name_old: str, name_new: str = None, is_wapi_new: bool = None, ref_gfk_new: Union[str, ExplicitNull] = None, data_type_new: str = None, table_name_new: str = None, is_nullable_new: bool = None, is_required_new: bool = None, is_deprecated_new: bool = None, attribute_name_new: str = None, is_ot_global_ref_new: bool = None, use_ref_column_language_attributes_new: bool = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if is_wapi_new is not None and not (isinstance(is_wapi_new, bool)):
			raise ValueError(f"'is_wapi' of incorrect type. Expected bool, got {type(is_wapi_new)}")
		if ref_gfk_new is not None and not (isinstance(ref_gfk_new, str) or isinstance(ref_gfk_new, ExplicitNull)):
			raise ValueError(f"'ref_gfk' of incorrect type. Expected str, got {type(ref_gfk_new)}")
		if data_type_new is not None and not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if table_name_new is not None and not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if is_nullable_new is not None and not (isinstance(is_nullable_new, bool)):
			raise ValueError(f"'is_nullable' of incorrect type. Expected bool, got {type(is_nullable_new)}")
		if is_required_new is not None and not (isinstance(is_required_new, bool)):
			raise ValueError(f"'is_required' of incorrect type. Expected bool, got {type(is_required_new)}")
		if is_deprecated_new is not None and not (isinstance(is_deprecated_new, bool)):
			raise ValueError(f"'is_deprecated' of incorrect type. Expected bool, got {type(is_deprecated_new)}")
		if attribute_name_new is not None and not (isinstance(attribute_name_new, str)):
			raise ValueError(f"'attribute_name' of incorrect type. Expected str, got {type(attribute_name_new)}")
		if is_ot_global_ref_new is not None and not (isinstance(is_ot_global_ref_new, bool)):
			raise ValueError(f"'is_ot_global_ref' of incorrect type. Expected bool, got {type(is_ot_global_ref_new)}")
		if use_ref_column_language_attributes_new is not None and not (isinstance(use_ref_column_language_attributes_new, bool)):
			raise ValueError(f"'use_ref_column_language_attributes' of incorrect type. Expected bool, got {type(use_ref_column_language_attributes_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")

		return {'name': 'cntl.column.update', 'new': _denullify_dict({'name': name_new, 'is_wapi': is_wapi_new, 'ref_gfk': ref_gfk_new, 'data_type': data_type_new, 'table_name': table_name_new, 'is_nullable': is_nullable_new, 'is_required': is_required_new, 'is_deprecated': is_deprecated_new, 'attribute_name': attribute_name_new, 'is_ot_global_ref': is_ot_global_ref_new, 'use_ref_column_language_attributes': use_ref_column_language_attributes_new}), 'old': _denullify_dict({'name': name_old, 'table_name': table_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, table_name_old: str, name_new: str = None, is_wapi_new: bool = None, ref_gfk_new: Union[str, ExplicitNull] = None, data_type_new: str = None, table_name_new: str = None, is_nullable_new: bool = None, is_required_new: bool = None, is_deprecated_new: bool = None, attribute_name_new: str = None, is_ot_global_ref_new: bool = None, use_ref_column_language_attributes_new: bool = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if is_wapi_new is not None and not (isinstance(is_wapi_new, bool)):
			raise ValueError(f"'is_wapi' of incorrect type. Expected bool, got {type(is_wapi_new)}")
		if ref_gfk_new is not None and not (isinstance(ref_gfk_new, str) or isinstance(ref_gfk_new, ExplicitNull)):
			raise ValueError(f"'ref_gfk' of incorrect type. Expected str, got {type(ref_gfk_new)}")
		if data_type_new is not None and not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if table_name_new is not None and not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if is_nullable_new is not None and not (isinstance(is_nullable_new, bool)):
			raise ValueError(f"'is_nullable' of incorrect type. Expected bool, got {type(is_nullable_new)}")
		if is_required_new is not None and not (isinstance(is_required_new, bool)):
			raise ValueError(f"'is_required' of incorrect type. Expected bool, got {type(is_required_new)}")
		if is_deprecated_new is not None and not (isinstance(is_deprecated_new, bool)):
			raise ValueError(f"'is_deprecated' of incorrect type. Expected bool, got {type(is_deprecated_new)}")
		if attribute_name_new is not None and not (isinstance(attribute_name_new, str)):
			raise ValueError(f"'attribute_name' of incorrect type. Expected str, got {type(attribute_name_new)}")
		if is_ot_global_ref_new is not None and not (isinstance(is_ot_global_ref_new, bool)):
			raise ValueError(f"'is_ot_global_ref' of incorrect type. Expected bool, got {type(is_ot_global_ref_new)}")
		if use_ref_column_language_attributes_new is not None and not (isinstance(use_ref_column_language_attributes_new, bool)):
			raise ValueError(f"'use_ref_column_language_attributes' of incorrect type. Expected bool, got {type(use_ref_column_language_attributes_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, is_wapi_new=is_wapi_new, ref_gfk_new=ref_gfk_new, data_type_new=data_type_new, table_name_new=table_name_new, is_nullable_new=is_nullable_new, is_required_new=is_required_new, is_deprecated_new=is_deprecated_new, attribute_name_new=attribute_name_new, is_ot_global_ref_new=is_ot_global_ref_new, use_ref_column_language_attributes_new=use_ref_column_language_attributes_new, name_old=name_old, table_name_old=table_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Constraint(APIObject):
	gpk: str
	name: str
	type: str
	ref_name: str
	dblvl_name: str
	table_name: str
	is_function: bool
	is_api_level: bool
	col_name_list: list
	join_operator: str
	is_referencing: bool
	is_join_default: bool
	dblvl_table_name: str
	is_referenceable: bool
	col_data_type_list: list
	join_operands_exchange: bool
	join_grants_read_access_from_child: bool
	join_left_function_format_template: str
	join_grants_read_access_from_parent: bool
	join_right_function_format_template: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if self.ref_name is not None and not isinstance(self.ref_name, str):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(self.ref_name)}")
		if self.dblvl_name is not None and not isinstance(self.dblvl_name, str):
			raise ValueError(f"'dblvl_name' of incorrect type. Expected str, got {type(self.dblvl_name)}")
		if not isinstance(self.table_name, str):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(self.table_name)}")
		if not isinstance(self.is_function, bool):
			raise ValueError(f"'is_function' of incorrect type. Expected bool, got {type(self.is_function)}")
		if not isinstance(self.is_api_level, bool):
			raise ValueError(f"'is_api_level' of incorrect type. Expected bool, got {type(self.is_api_level)}")
		if not isinstance(self.col_name_list, list):
			raise ValueError(f"'col_name_list' of incorrect type. Expected list, got {type(self.col_name_list)}")
		if not isinstance(self.join_operator, str):
			raise ValueError(f"'join_operator' of incorrect type. Expected str, got {type(self.join_operator)}")
		if not isinstance(self.is_referencing, bool):
			raise ValueError(f"'is_referencing' of incorrect type. Expected bool, got {type(self.is_referencing)}")
		if not isinstance(self.is_join_default, bool):
			raise ValueError(f"'is_join_default' of incorrect type. Expected bool, got {type(self.is_join_default)}")
		if self.dblvl_table_name is not None and not isinstance(self.dblvl_table_name, str):
			raise ValueError(f"'dblvl_table_name' of incorrect type. Expected str, got {type(self.dblvl_table_name)}")
		if not isinstance(self.is_referenceable, bool):
			raise ValueError(f"'is_referenceable' of incorrect type. Expected bool, got {type(self.is_referenceable)}")
		if not isinstance(self.col_data_type_list, list):
			raise ValueError(f"'col_data_type_list' of incorrect type. Expected list, got {type(self.col_data_type_list)}")
		if not isinstance(self.join_operands_exchange, bool):
			raise ValueError(f"'join_operands_exchange' of incorrect type. Expected bool, got {type(self.join_operands_exchange)}")
		if not isinstance(self.join_grants_read_access_from_child, bool):
			raise ValueError(f"'join_grants_read_access_from_child' of incorrect type. Expected bool, got {type(self.join_grants_read_access_from_child)}")
		if not isinstance(self.join_left_function_format_template, str):
			raise ValueError(f"'join_left_function_format_template' of incorrect type. Expected str, got {type(self.join_left_function_format_template)}")
		if not isinstance(self.join_grants_read_access_from_parent, bool):
			raise ValueError(f"'join_grants_read_access_from_parent' of incorrect type. Expected bool, got {type(self.join_grants_read_access_from_parent)}")
		if not isinstance(self.join_right_function_format_template, str):
			raise ValueError(f"'join_right_function_format_template' of incorrect type. Expected str, got {type(self.join_right_function_format_template)}")

	@staticmethod
	def create_ta(name_new: str, type_new: str, table_name_new: str, col_name_list_new: list, ref_name_new: Union[str, ExplicitNull] = None, dblvl_name_new: Union[str, ExplicitNull] = None, join_operator_new: str = '=', is_join_default_new: bool = False, dblvl_table_name_new: Union[str, ExplicitNull] = None, join_operands_exchange_new: bool = False, join_grants_read_access_from_child_new: bool = False, join_left_function_format_template_new: str = '%s', join_grants_read_access_from_parent_new: bool = False, join_right_function_format_template_new: str = '%s') -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if ref_name_new is not None and not (isinstance(ref_name_new, str) or isinstance(ref_name_new, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_new)}")
		if dblvl_name_new is not None and not (isinstance(dblvl_name_new, str) or isinstance(dblvl_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_name' of incorrect type. Expected str, got {type(dblvl_name_new)}")
		if not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if not (isinstance(col_name_list_new, list)):
			raise ValueError(f"'col_name_list' of incorrect type. Expected list, got {type(col_name_list_new)}")
		if join_operator_new is not None and not (isinstance(join_operator_new, str)):
			raise ValueError(f"'join_operator' of incorrect type. Expected str, got {type(join_operator_new)}")
		if is_join_default_new is not None and not (isinstance(is_join_default_new, bool)):
			raise ValueError(f"'is_join_default' of incorrect type. Expected bool, got {type(is_join_default_new)}")
		if dblvl_table_name_new is not None and not (isinstance(dblvl_table_name_new, str) or isinstance(dblvl_table_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_table_name' of incorrect type. Expected str, got {type(dblvl_table_name_new)}")
		if join_operands_exchange_new is not None and not (isinstance(join_operands_exchange_new, bool)):
			raise ValueError(f"'join_operands_exchange' of incorrect type. Expected bool, got {type(join_operands_exchange_new)}")
		if join_grants_read_access_from_child_new is not None and not (isinstance(join_grants_read_access_from_child_new, bool)):
			raise ValueError(f"'join_grants_read_access_from_child' of incorrect type. Expected bool, got {type(join_grants_read_access_from_child_new)}")
		if join_left_function_format_template_new is not None and not (isinstance(join_left_function_format_template_new, str)):
			raise ValueError(f"'join_left_function_format_template' of incorrect type. Expected str, got {type(join_left_function_format_template_new)}")
		if join_grants_read_access_from_parent_new is not None and not (isinstance(join_grants_read_access_from_parent_new, bool)):
			raise ValueError(f"'join_grants_read_access_from_parent' of incorrect type. Expected bool, got {type(join_grants_read_access_from_parent_new)}")
		if join_right_function_format_template_new is not None and not (isinstance(join_right_function_format_template_new, str)):
			raise ValueError(f"'join_right_function_format_template' of incorrect type. Expected str, got {type(join_right_function_format_template_new)}")

		return {'name': 'cntl.constraint.create', 'new': _denullify_dict({'name': name_new, 'type': type_new, 'ref_name': ref_name_new, 'dblvl_name': dblvl_name_new, 'table_name': table_name_new, 'col_name_list': col_name_list_new, 'join_operator': join_operator_new, 'is_join_default': is_join_default_new, 'dblvl_table_name': dblvl_table_name_new, 'join_operands_exchange': join_operands_exchange_new, 'join_grants_read_access_from_child': join_grants_read_access_from_child_new, 'join_left_function_format_template': join_left_function_format_template_new, 'join_grants_read_access_from_parent': join_grants_read_access_from_parent_new, 'join_right_function_format_template': join_right_function_format_template_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, type_new: str, table_name_new: str, col_name_list_new: list, ref_name_new: Union[str, ExplicitNull] = None, dblvl_name_new: Union[str, ExplicitNull] = None, join_operator_new: str = '=', is_join_default_new: bool = False, dblvl_table_name_new: Union[str, ExplicitNull] = None, join_operands_exchange_new: bool = False, join_grants_read_access_from_child_new: bool = False, join_left_function_format_template_new: str = '%s', join_grants_read_access_from_parent_new: bool = False, join_right_function_format_template_new: str = '%s') -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if ref_name_new is not None and not (isinstance(ref_name_new, str) or isinstance(ref_name_new, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_new)}")
		if dblvl_name_new is not None and not (isinstance(dblvl_name_new, str) or isinstance(dblvl_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_name' of incorrect type. Expected str, got {type(dblvl_name_new)}")
		if not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if not (isinstance(col_name_list_new, list)):
			raise ValueError(f"'col_name_list' of incorrect type. Expected list, got {type(col_name_list_new)}")
		if join_operator_new is not None and not (isinstance(join_operator_new, str)):
			raise ValueError(f"'join_operator' of incorrect type. Expected str, got {type(join_operator_new)}")
		if is_join_default_new is not None and not (isinstance(is_join_default_new, bool)):
			raise ValueError(f"'is_join_default' of incorrect type. Expected bool, got {type(is_join_default_new)}")
		if dblvl_table_name_new is not None and not (isinstance(dblvl_table_name_new, str) or isinstance(dblvl_table_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_table_name' of incorrect type. Expected str, got {type(dblvl_table_name_new)}")
		if join_operands_exchange_new is not None and not (isinstance(join_operands_exchange_new, bool)):
			raise ValueError(f"'join_operands_exchange' of incorrect type. Expected bool, got {type(join_operands_exchange_new)}")
		if join_grants_read_access_from_child_new is not None and not (isinstance(join_grants_read_access_from_child_new, bool)):
			raise ValueError(f"'join_grants_read_access_from_child' of incorrect type. Expected bool, got {type(join_grants_read_access_from_child_new)}")
		if join_left_function_format_template_new is not None and not (isinstance(join_left_function_format_template_new, str)):
			raise ValueError(f"'join_left_function_format_template' of incorrect type. Expected str, got {type(join_left_function_format_template_new)}")
		if join_grants_read_access_from_parent_new is not None and not (isinstance(join_grants_read_access_from_parent_new, bool)):
			raise ValueError(f"'join_grants_read_access_from_parent' of incorrect type. Expected bool, got {type(join_grants_read_access_from_parent_new)}")
		if join_right_function_format_template_new is not None and not (isinstance(join_right_function_format_template_new, str)):
			raise ValueError(f"'join_right_function_format_template' of incorrect type. Expected str, got {type(join_right_function_format_template_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, type_new=type_new, ref_name_new=ref_name_new, dblvl_name_new=dblvl_name_new, table_name_new=table_name_new, col_name_list_new=col_name_list_new, join_operator_new=join_operator_new, is_join_default_new=is_join_default_new, dblvl_table_name_new=dblvl_table_name_new, join_operands_exchange_new=join_operands_exchange_new, join_grants_read_access_from_child_new=join_grants_read_access_from_child_new, join_left_function_format_template_new=join_left_function_format_template_new, join_grants_read_access_from_parent_new=join_grants_read_access_from_parent_new, join_right_function_format_template_new=join_right_function_format_template_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str, table_name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")

		return {'name': 'cntl.constraint.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old, 'table_name': table_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str, table_name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old, table_name_old=table_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(type_old: str = None, gpk_list_old: list = None, ref_name_old: str = None, name_list_old: list = None, fetch_limit_old: int = None, is_function_old: bool = None, fetch_offset_old: int = None, is_api_level_old: bool = None, is_referencing_old: bool = None, is_join_default_old: bool = None, table_name_list_old: list = None, is_referenceable_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, join_grants_read_access_from_child_old: bool = None, join_grants_read_access_from_parent_old: bool = None) -> dict:
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if ref_name_old is not None and not (isinstance(ref_name_old, str) or isinstance(ref_name_old, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_function_old is not None and not (isinstance(is_function_old, bool)):
			raise ValueError(f"'is_function' of incorrect type. Expected bool, got {type(is_function_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_api_level_old is not None and not (isinstance(is_api_level_old, bool)):
			raise ValueError(f"'is_api_level' of incorrect type. Expected bool, got {type(is_api_level_old)}")
		if is_referencing_old is not None and not (isinstance(is_referencing_old, bool)):
			raise ValueError(f"'is_referencing' of incorrect type. Expected bool, got {type(is_referencing_old)}")
		if is_join_default_old is not None and not (isinstance(is_join_default_old, bool)):
			raise ValueError(f"'is_join_default' of incorrect type. Expected bool, got {type(is_join_default_old)}")
		if table_name_list_old is not None and not (isinstance(table_name_list_old, list)):
			raise ValueError(f"'table_name_list' of incorrect type. Expected list, got {type(table_name_list_old)}")
		if is_referenceable_old is not None and not (isinstance(is_referenceable_old, bool)):
			raise ValueError(f"'is_referenceable' of incorrect type. Expected bool, got {type(is_referenceable_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if join_grants_read_access_from_child_old is not None and not (isinstance(join_grants_read_access_from_child_old, bool)):
			raise ValueError(f"'join_grants_read_access_from_child' of incorrect type. Expected bool, got {type(join_grants_read_access_from_child_old)}")
		if join_grants_read_access_from_parent_old is not None and not (isinstance(join_grants_read_access_from_parent_old, bool)):
			raise ValueError(f"'join_grants_read_access_from_parent' of incorrect type. Expected bool, got {type(join_grants_read_access_from_parent_old)}")

		return {'name': 'cntl.constraint.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'type': type_old, 'gpk_list': gpk_list_old, 'ref_name': ref_name_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'is_function': is_function_old, 'fetch_offset': fetch_offset_old, 'is_api_level': is_api_level_old, 'is_referencing': is_referencing_old, 'is_join_default': is_join_default_old, 'table_name_list': table_name_list_old, 'is_referenceable': is_referenceable_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'join_grants_read_access_from_child': join_grants_read_access_from_child_old, 'join_grants_read_access_from_parent': join_grants_read_access_from_parent_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, type_old: str = None, gpk_list_old: list = None, ref_name_old: str = None, name_list_old: list = None, fetch_limit_old: int = None, is_function_old: bool = None, fetch_offset_old: int = None, is_api_level_old: bool = None, is_referencing_old: bool = None, is_join_default_old: bool = None, table_name_list_old: list = None, is_referenceable_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, join_grants_read_access_from_child_old: bool = None, join_grants_read_access_from_parent_old: bool = None) -> list:
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if ref_name_old is not None and not (isinstance(ref_name_old, str) or isinstance(ref_name_old, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_function_old is not None and not (isinstance(is_function_old, bool)):
			raise ValueError(f"'is_function' of incorrect type. Expected bool, got {type(is_function_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_api_level_old is not None and not (isinstance(is_api_level_old, bool)):
			raise ValueError(f"'is_api_level' of incorrect type. Expected bool, got {type(is_api_level_old)}")
		if is_referencing_old is not None and not (isinstance(is_referencing_old, bool)):
			raise ValueError(f"'is_referencing' of incorrect type. Expected bool, got {type(is_referencing_old)}")
		if is_join_default_old is not None and not (isinstance(is_join_default_old, bool)):
			raise ValueError(f"'is_join_default' of incorrect type. Expected bool, got {type(is_join_default_old)}")
		if table_name_list_old is not None and not (isinstance(table_name_list_old, list)):
			raise ValueError(f"'table_name_list' of incorrect type. Expected list, got {type(table_name_list_old)}")
		if is_referenceable_old is not None and not (isinstance(is_referenceable_old, bool)):
			raise ValueError(f"'is_referenceable' of incorrect type. Expected bool, got {type(is_referenceable_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if join_grants_read_access_from_child_old is not None and not (isinstance(join_grants_read_access_from_child_old, bool)):
			raise ValueError(f"'join_grants_read_access_from_child' of incorrect type. Expected bool, got {type(join_grants_read_access_from_child_old)}")
		if join_grants_read_access_from_parent_old is not None and not (isinstance(join_grants_read_access_from_parent_old, bool)):
			raise ValueError(f"'join_grants_read_access_from_parent' of incorrect type. Expected bool, got {type(join_grants_read_access_from_parent_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(type_old=type_old, gpk_list_old=gpk_list_old, ref_name_old=ref_name_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, is_function_old=is_function_old, fetch_offset_old=fetch_offset_old, is_api_level_old=is_api_level_old, is_referencing_old=is_referencing_old, is_join_default_old=is_join_default_old, table_name_list_old=table_name_list_old, is_referenceable_old=is_referenceable_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, join_grants_read_access_from_child_old=join_grants_read_access_from_child_old, join_grants_read_access_from_parent_old=join_grants_read_access_from_parent_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, table_name_old: str, name_new: str = None, type_new: str = None, ref_name_new: Union[str, ExplicitNull] = None, dblvl_name_new: Union[str, ExplicitNull] = None, table_name_new: str = None, col_name_list_new: list = None, join_operator_new: str = None, is_join_default_new: bool = None, dblvl_table_name_new: Union[str, ExplicitNull] = None, join_operands_exchange_new: bool = None, join_grants_read_access_from_child_new: bool = None, join_left_function_format_template_new: str = None, join_grants_read_access_from_parent_new: bool = None, join_right_function_format_template_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if ref_name_new is not None and not (isinstance(ref_name_new, str) or isinstance(ref_name_new, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_new)}")
		if dblvl_name_new is not None and not (isinstance(dblvl_name_new, str) or isinstance(dblvl_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_name' of incorrect type. Expected str, got {type(dblvl_name_new)}")
		if table_name_new is not None and not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if col_name_list_new is not None and not (isinstance(col_name_list_new, list)):
			raise ValueError(f"'col_name_list' of incorrect type. Expected list, got {type(col_name_list_new)}")
		if join_operator_new is not None and not (isinstance(join_operator_new, str)):
			raise ValueError(f"'join_operator' of incorrect type. Expected str, got {type(join_operator_new)}")
		if is_join_default_new is not None and not (isinstance(is_join_default_new, bool)):
			raise ValueError(f"'is_join_default' of incorrect type. Expected bool, got {type(is_join_default_new)}")
		if dblvl_table_name_new is not None and not (isinstance(dblvl_table_name_new, str) or isinstance(dblvl_table_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_table_name' of incorrect type. Expected str, got {type(dblvl_table_name_new)}")
		if join_operands_exchange_new is not None and not (isinstance(join_operands_exchange_new, bool)):
			raise ValueError(f"'join_operands_exchange' of incorrect type. Expected bool, got {type(join_operands_exchange_new)}")
		if join_grants_read_access_from_child_new is not None and not (isinstance(join_grants_read_access_from_child_new, bool)):
			raise ValueError(f"'join_grants_read_access_from_child' of incorrect type. Expected bool, got {type(join_grants_read_access_from_child_new)}")
		if join_left_function_format_template_new is not None and not (isinstance(join_left_function_format_template_new, str)):
			raise ValueError(f"'join_left_function_format_template' of incorrect type. Expected str, got {type(join_left_function_format_template_new)}")
		if join_grants_read_access_from_parent_new is not None and not (isinstance(join_grants_read_access_from_parent_new, bool)):
			raise ValueError(f"'join_grants_read_access_from_parent' of incorrect type. Expected bool, got {type(join_grants_read_access_from_parent_new)}")
		if join_right_function_format_template_new is not None and not (isinstance(join_right_function_format_template_new, str)):
			raise ValueError(f"'join_right_function_format_template' of incorrect type. Expected str, got {type(join_right_function_format_template_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")

		return {'name': 'cntl.constraint.update', 'new': _denullify_dict({'name': name_new, 'type': type_new, 'ref_name': ref_name_new, 'dblvl_name': dblvl_name_new, 'table_name': table_name_new, 'col_name_list': col_name_list_new, 'join_operator': join_operator_new, 'is_join_default': is_join_default_new, 'dblvl_table_name': dblvl_table_name_new, 'join_operands_exchange': join_operands_exchange_new, 'join_grants_read_access_from_child': join_grants_read_access_from_child_new, 'join_left_function_format_template': join_left_function_format_template_new, 'join_grants_read_access_from_parent': join_grants_read_access_from_parent_new, 'join_right_function_format_template': join_right_function_format_template_new}), 'old': _denullify_dict({'name': name_old, 'table_name': table_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, table_name_old: str, name_new: str = None, type_new: str = None, ref_name_new: Union[str, ExplicitNull] = None, dblvl_name_new: Union[str, ExplicitNull] = None, table_name_new: str = None, col_name_list_new: list = None, join_operator_new: str = None, is_join_default_new: bool = None, dblvl_table_name_new: Union[str, ExplicitNull] = None, join_operands_exchange_new: bool = None, join_grants_read_access_from_child_new: bool = None, join_left_function_format_template_new: str = None, join_grants_read_access_from_parent_new: bool = None, join_right_function_format_template_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if ref_name_new is not None and not (isinstance(ref_name_new, str) or isinstance(ref_name_new, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_new)}")
		if dblvl_name_new is not None and not (isinstance(dblvl_name_new, str) or isinstance(dblvl_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_name' of incorrect type. Expected str, got {type(dblvl_name_new)}")
		if table_name_new is not None and not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if col_name_list_new is not None and not (isinstance(col_name_list_new, list)):
			raise ValueError(f"'col_name_list' of incorrect type. Expected list, got {type(col_name_list_new)}")
		if join_operator_new is not None and not (isinstance(join_operator_new, str)):
			raise ValueError(f"'join_operator' of incorrect type. Expected str, got {type(join_operator_new)}")
		if is_join_default_new is not None and not (isinstance(is_join_default_new, bool)):
			raise ValueError(f"'is_join_default' of incorrect type. Expected bool, got {type(is_join_default_new)}")
		if dblvl_table_name_new is not None and not (isinstance(dblvl_table_name_new, str) or isinstance(dblvl_table_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_table_name' of incorrect type. Expected str, got {type(dblvl_table_name_new)}")
		if join_operands_exchange_new is not None and not (isinstance(join_operands_exchange_new, bool)):
			raise ValueError(f"'join_operands_exchange' of incorrect type. Expected bool, got {type(join_operands_exchange_new)}")
		if join_grants_read_access_from_child_new is not None and not (isinstance(join_grants_read_access_from_child_new, bool)):
			raise ValueError(f"'join_grants_read_access_from_child' of incorrect type. Expected bool, got {type(join_grants_read_access_from_child_new)}")
		if join_left_function_format_template_new is not None and not (isinstance(join_left_function_format_template_new, str)):
			raise ValueError(f"'join_left_function_format_template' of incorrect type. Expected str, got {type(join_left_function_format_template_new)}")
		if join_grants_read_access_from_parent_new is not None and not (isinstance(join_grants_read_access_from_parent_new, bool)):
			raise ValueError(f"'join_grants_read_access_from_parent' of incorrect type. Expected bool, got {type(join_grants_read_access_from_parent_new)}")
		if join_right_function_format_template_new is not None and not (isinstance(join_right_function_format_template_new, str)):
			raise ValueError(f"'join_right_function_format_template' of incorrect type. Expected str, got {type(join_right_function_format_template_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, type_new=type_new, ref_name_new=ref_name_new, dblvl_name_new=dblvl_name_new, table_name_new=table_name_new, col_name_list_new=col_name_list_new, join_operator_new=join_operator_new, is_join_default_new=is_join_default_new, dblvl_table_name_new=dblvl_table_name_new, join_operands_exchange_new=join_operands_exchange_new, join_grants_read_access_from_child_new=join_grants_read_access_from_child_new, join_left_function_format_template_new=join_left_function_format_template_new, join_grants_read_access_from_parent_new=join_grants_read_access_from_parent_new, join_right_function_format_template_new=join_right_function_format_template_new, name_old=name_old, table_name_old=table_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class ErrorType(APIObject):
	gpk: str
	code: int
	name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.code, int):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(self.code)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")

	@staticmethod
	def create_ta(code_new: int, name_new: str) -> dict:
		if not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")

		return {'name': 'cntl.error_type.create', 'new': _denullify_dict({'code': code_new, 'name': name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, code_new: int, name_new: str) -> list:
		if not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(code_new=code_new, name_new=name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(code_old: int) -> dict:
		if not (isinstance(code_old, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_old)}")

		return {'name': 'cntl.error_type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'code': code_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, code_old: int) -> list:
		if not (isinstance(code_old, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(code_old=code_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_list_old: list = None, code_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if code_list_old is not None and not (isinstance(code_list_old, list)):
			raise ValueError(f"'code_list' of incorrect type. Expected list, got {type(code_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.error_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk_list': gpk_list_old, 'code_list': code_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_list_old: list = None, code_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if code_list_old is not None and not (isinstance(code_list_old, list)):
			raise ValueError(f"'code_list' of incorrect type. Expected list, got {type(code_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_list_old=gpk_list_old, code_list_old=code_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(code_old: int, code_new: int = None, name_new: str = None) -> dict:
		if code_new is not None and not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(code_old, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_old)}")

		return {'name': 'cntl.error_type.update', 'new': _denullify_dict({'code': code_new, 'name': name_new}), 'old': _denullify_dict({'code': code_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, code_old: int, code_new: int = None, name_new: str = None) -> list:
		if code_new is not None and not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(code_old, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(code_new=code_new, name_new=name_new, code_old=code_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Table(APIObject):
	gpk: str
	name: str
	system: str
	is_log_dst: bool
	is_log_src: bool
	is_lang_dst: bool
	is_lang_src: bool
	is_otattr_dst: bool
	is_otattr_src: bool
	content_gender: str
	pg_cls_exists: bool
	object_type_fq_name: str
	do_activate_global_pk2obj: bool
	object_type_grants_read_access: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.system, str):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(self.system)}")
		if not isinstance(self.is_log_dst, bool):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(self.is_log_dst)}")
		if not isinstance(self.is_log_src, bool):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(self.is_log_src)}")
		if not isinstance(self.is_lang_dst, bool):
			raise ValueError(f"'is_lang_dst' of incorrect type. Expected bool, got {type(self.is_lang_dst)}")
		if not isinstance(self.is_lang_src, bool):
			raise ValueError(f"'is_lang_src' of incorrect type. Expected bool, got {type(self.is_lang_src)}")
		if not isinstance(self.is_otattr_dst, bool):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(self.is_otattr_dst)}")
		if not isinstance(self.is_otattr_src, bool):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(self.is_otattr_src)}")
		if not isinstance(self.content_gender, str):
			raise ValueError(f"'content_gender' of incorrect type. Expected str, got {type(self.content_gender)}")
		if not isinstance(self.pg_cls_exists, bool):
			raise ValueError(f"'pg_cls_exists' of incorrect type. Expected bool, got {type(self.pg_cls_exists)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")
		if not isinstance(self.do_activate_global_pk2obj, bool):
			raise ValueError(f"'do_activate_global_pk2obj' of incorrect type. Expected bool, got {type(self.do_activate_global_pk2obj)}")
		if not isinstance(self.object_type_grants_read_access, bool):
			raise ValueError(f"'object_type_grants_read_access' of incorrect type. Expected bool, got {type(self.object_type_grants_read_access)}")

	@staticmethod
	def create_ta(name_new: str, system_new: str, is_lang_dst_new: bool, is_lang_src_new: bool, content_gender_new: str, do_activate_global_pk2obj_new: bool, is_log_dst_new: bool = False, is_log_src_new: bool = False, is_otattr_dst_new: bool = False, is_otattr_src_new: bool = False, do_imp_from_dd_new: bool = True, object_type_name_new: str = None, do_create_global_ref_params_new: bool = True, object_type_grants_read_access_new: bool = False) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(system_new, str)):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(system_new)}")
		if is_log_dst_new is not None and not (isinstance(is_log_dst_new, bool)):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(is_log_dst_new)}")
		if is_log_src_new is not None and not (isinstance(is_log_src_new, bool)):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(is_log_src_new)}")
		if not (isinstance(is_lang_dst_new, bool)):
			raise ValueError(f"'is_lang_dst' of incorrect type. Expected bool, got {type(is_lang_dst_new)}")
		if not (isinstance(is_lang_src_new, bool)):
			raise ValueError(f"'is_lang_src' of incorrect type. Expected bool, got {type(is_lang_src_new)}")
		if is_otattr_dst_new is not None and not (isinstance(is_otattr_dst_new, bool)):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(is_otattr_dst_new)}")
		if is_otattr_src_new is not None and not (isinstance(is_otattr_src_new, bool)):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(is_otattr_src_new)}")
		if not (isinstance(content_gender_new, str)):
			raise ValueError(f"'content_gender' of incorrect type. Expected str, got {type(content_gender_new)}")
		if do_imp_from_dd_new is not None and not (isinstance(do_imp_from_dd_new, bool)):
			raise ValueError(f"'do_imp_from_dd' of incorrect type. Expected bool, got {type(do_imp_from_dd_new)}")
		if object_type_name_new is not None and not (isinstance(object_type_name_new, str)):
			raise ValueError(f"'object_type_name' of incorrect type. Expected str, got {type(object_type_name_new)}")
		if not (isinstance(do_activate_global_pk2obj_new, bool)):
			raise ValueError(f"'do_activate_global_pk2obj' of incorrect type. Expected bool, got {type(do_activate_global_pk2obj_new)}")
		if do_create_global_ref_params_new is not None and not (isinstance(do_create_global_ref_params_new, bool)):
			raise ValueError(f"'do_create_global_ref_params' of incorrect type. Expected bool, got {type(do_create_global_ref_params_new)}")
		if object_type_grants_read_access_new is not None and not (isinstance(object_type_grants_read_access_new, bool)):
			raise ValueError(f"'object_type_grants_read_access' of incorrect type. Expected bool, got {type(object_type_grants_read_access_new)}")

		return {'name': 'cntl.table.create', 'new': _denullify_dict({'name': name_new, 'system': system_new, 'is_log_dst': is_log_dst_new, 'is_log_src': is_log_src_new, 'is_lang_dst': is_lang_dst_new, 'is_lang_src': is_lang_src_new, 'is_otattr_dst': is_otattr_dst_new, 'is_otattr_src': is_otattr_src_new, 'content_gender': content_gender_new, 'do_imp_from_dd': do_imp_from_dd_new, 'object_type_name': object_type_name_new, 'do_activate_global_pk2obj': do_activate_global_pk2obj_new, 'do_create_global_ref_params': do_create_global_ref_params_new, 'object_type_grants_read_access': object_type_grants_read_access_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, system_new: str, is_lang_dst_new: bool, is_lang_src_new: bool, content_gender_new: str, do_activate_global_pk2obj_new: bool, is_log_dst_new: bool = False, is_log_src_new: bool = False, is_otattr_dst_new: bool = False, is_otattr_src_new: bool = False, do_imp_from_dd_new: bool = True, object_type_name_new: str = None, do_create_global_ref_params_new: bool = True, object_type_grants_read_access_new: bool = False) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(system_new, str)):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(system_new)}")
		if is_log_dst_new is not None and not (isinstance(is_log_dst_new, bool)):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(is_log_dst_new)}")
		if is_log_src_new is not None and not (isinstance(is_log_src_new, bool)):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(is_log_src_new)}")
		if not (isinstance(is_lang_dst_new, bool)):
			raise ValueError(f"'is_lang_dst' of incorrect type. Expected bool, got {type(is_lang_dst_new)}")
		if not (isinstance(is_lang_src_new, bool)):
			raise ValueError(f"'is_lang_src' of incorrect type. Expected bool, got {type(is_lang_src_new)}")
		if is_otattr_dst_new is not None and not (isinstance(is_otattr_dst_new, bool)):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(is_otattr_dst_new)}")
		if is_otattr_src_new is not None and not (isinstance(is_otattr_src_new, bool)):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(is_otattr_src_new)}")
		if not (isinstance(content_gender_new, str)):
			raise ValueError(f"'content_gender' of incorrect type. Expected str, got {type(content_gender_new)}")
		if do_imp_from_dd_new is not None and not (isinstance(do_imp_from_dd_new, bool)):
			raise ValueError(f"'do_imp_from_dd' of incorrect type. Expected bool, got {type(do_imp_from_dd_new)}")
		if object_type_name_new is not None and not (isinstance(object_type_name_new, str)):
			raise ValueError(f"'object_type_name' of incorrect type. Expected str, got {type(object_type_name_new)}")
		if not (isinstance(do_activate_global_pk2obj_new, bool)):
			raise ValueError(f"'do_activate_global_pk2obj' of incorrect type. Expected bool, got {type(do_activate_global_pk2obj_new)}")
		if do_create_global_ref_params_new is not None and not (isinstance(do_create_global_ref_params_new, bool)):
			raise ValueError(f"'do_create_global_ref_params' of incorrect type. Expected bool, got {type(do_create_global_ref_params_new)}")
		if object_type_grants_read_access_new is not None and not (isinstance(object_type_grants_read_access_new, bool)):
			raise ValueError(f"'object_type_grants_read_access' of incorrect type. Expected bool, got {type(object_type_grants_read_access_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, system_new=system_new, is_log_dst_new=is_log_dst_new, is_log_src_new=is_log_src_new, is_lang_dst_new=is_lang_dst_new, is_lang_src_new=is_lang_src_new, is_otattr_dst_new=is_otattr_dst_new, is_otattr_src_new=is_otattr_src_new, content_gender_new=content_gender_new, do_imp_from_dd_new=do_imp_from_dd_new, object_type_name_new=object_type_name_new, do_activate_global_pk2obj_new=do_activate_global_pk2obj_new, do_create_global_ref_params_new=do_create_global_ref_params_new, object_type_grants_read_access_new=object_type_grants_read_access_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str, do_del_cols_old: bool = False) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if do_del_cols_old is not None and not (isinstance(do_del_cols_old, bool)):
			raise ValueError(f"'do_del_cols' of incorrect type. Expected bool, got {type(do_del_cols_old)}")

		return {'name': 'cntl.table.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old, 'do_del_cols': do_del_cols_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str, do_del_cols_old: bool = False) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if do_del_cols_old is not None and not (isinstance(do_del_cols_old, bool)):
			raise ValueError(f"'do_del_cols' of incorrect type. Expected bool, got {type(do_del_cols_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old, do_del_cols_old=do_del_cols_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(system_old: str = None, gpk_list_old: list = None, name_list_old: list = None, is_log_dst_old: bool = None, is_log_src_old: bool = None, fetch_limit_old: int = None, is_lang_dst_old: bool = None, is_lang_src_old: bool = None, fetch_offset_old: int = None, is_otattr_dst_old: bool = None, is_otattr_src_old: bool = None, pg_cls_exists_old: bool = None, filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None, do_activate_global_pk2obj_old: bool = None, object_type_grants_read_access_old: bool = None) -> dict:
		if system_old is not None and not (isinstance(system_old, str)):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(system_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if is_log_dst_old is not None and not (isinstance(is_log_dst_old, bool)):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(is_log_dst_old)}")
		if is_log_src_old is not None and not (isinstance(is_log_src_old, bool)):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(is_log_src_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_lang_dst_old is not None and not (isinstance(is_lang_dst_old, bool)):
			raise ValueError(f"'is_lang_dst' of incorrect type. Expected bool, got {type(is_lang_dst_old)}")
		if is_lang_src_old is not None and not (isinstance(is_lang_src_old, bool)):
			raise ValueError(f"'is_lang_src' of incorrect type. Expected bool, got {type(is_lang_src_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_otattr_dst_old is not None and not (isinstance(is_otattr_dst_old, bool)):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(is_otattr_dst_old)}")
		if is_otattr_src_old is not None and not (isinstance(is_otattr_src_old, bool)):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(is_otattr_src_old)}")
		if pg_cls_exists_old is not None and not (isinstance(pg_cls_exists_old, bool)):
			raise ValueError(f"'pg_cls_exists' of incorrect type. Expected bool, got {type(pg_cls_exists_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if do_activate_global_pk2obj_old is not None and not (isinstance(do_activate_global_pk2obj_old, bool)):
			raise ValueError(f"'do_activate_global_pk2obj' of incorrect type. Expected bool, got {type(do_activate_global_pk2obj_old)}")
		if object_type_grants_read_access_old is not None and not (isinstance(object_type_grants_read_access_old, bool)):
			raise ValueError(f"'object_type_grants_read_access' of incorrect type. Expected bool, got {type(object_type_grants_read_access_old)}")

		return {'name': 'cntl.table.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'system': system_old, 'gpk_list': gpk_list_old, 'name_list': name_list_old, 'is_log_dst': is_log_dst_old, 'is_log_src': is_log_src_old, 'fetch_limit': fetch_limit_old, 'is_lang_dst': is_lang_dst_old, 'is_lang_src': is_lang_src_old, 'fetch_offset': fetch_offset_old, 'is_otattr_dst': is_otattr_dst_old, 'is_otattr_src': is_otattr_src_old, 'pg_cls_exists': pg_cls_exists_old, 'filter_params_dict': filter_params_dict_old, 'object_type_fq_name': object_type_fq_name_old, 'sorting_params_list': sorting_params_list_old, 'do_activate_global_pk2obj': do_activate_global_pk2obj_old, 'object_type_grants_read_access': object_type_grants_read_access_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, system_old: str = None, gpk_list_old: list = None, name_list_old: list = None, is_log_dst_old: bool = None, is_log_src_old: bool = None, fetch_limit_old: int = None, is_lang_dst_old: bool = None, is_lang_src_old: bool = None, fetch_offset_old: int = None, is_otattr_dst_old: bool = None, is_otattr_src_old: bool = None, pg_cls_exists_old: bool = None, filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None, do_activate_global_pk2obj_old: bool = None, object_type_grants_read_access_old: bool = None) -> list:
		if system_old is not None and not (isinstance(system_old, str)):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(system_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if is_log_dst_old is not None and not (isinstance(is_log_dst_old, bool)):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(is_log_dst_old)}")
		if is_log_src_old is not None and not (isinstance(is_log_src_old, bool)):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(is_log_src_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_lang_dst_old is not None and not (isinstance(is_lang_dst_old, bool)):
			raise ValueError(f"'is_lang_dst' of incorrect type. Expected bool, got {type(is_lang_dst_old)}")
		if is_lang_src_old is not None and not (isinstance(is_lang_src_old, bool)):
			raise ValueError(f"'is_lang_src' of incorrect type. Expected bool, got {type(is_lang_src_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_otattr_dst_old is not None and not (isinstance(is_otattr_dst_old, bool)):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(is_otattr_dst_old)}")
		if is_otattr_src_old is not None and not (isinstance(is_otattr_src_old, bool)):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(is_otattr_src_old)}")
		if pg_cls_exists_old is not None and not (isinstance(pg_cls_exists_old, bool)):
			raise ValueError(f"'pg_cls_exists' of incorrect type. Expected bool, got {type(pg_cls_exists_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if do_activate_global_pk2obj_old is not None and not (isinstance(do_activate_global_pk2obj_old, bool)):
			raise ValueError(f"'do_activate_global_pk2obj' of incorrect type. Expected bool, got {type(do_activate_global_pk2obj_old)}")
		if object_type_grants_read_access_old is not None and not (isinstance(object_type_grants_read_access_old, bool)):
			raise ValueError(f"'object_type_grants_read_access' of incorrect type. Expected bool, got {type(object_type_grants_read_access_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(system_old=system_old, gpk_list_old=gpk_list_old, name_list_old=name_list_old, is_log_dst_old=is_log_dst_old, is_log_src_old=is_log_src_old, fetch_limit_old=fetch_limit_old, is_lang_dst_old=is_lang_dst_old, is_lang_src_old=is_lang_src_old, fetch_offset_old=fetch_offset_old, is_otattr_dst_old=is_otattr_dst_old, is_otattr_src_old=is_otattr_src_old, pg_cls_exists_old=pg_cls_exists_old, filter_params_dict_old=filter_params_dict_old, object_type_fq_name_old=object_type_fq_name_old, sorting_params_list_old=sorting_params_list_old, do_activate_global_pk2obj_old=do_activate_global_pk2obj_old, object_type_grants_read_access_old=object_type_grants_read_access_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, system_new: str = None, is_log_dst_new: bool = None, is_log_src_new: bool = None, is_lang_dst_new: bool = None, is_lang_src_new: bool = None, is_otattr_dst_new: bool = None, is_otattr_src_new: bool = None, content_gender_new: str = None, do_imp_from_dd_new: bool = None, object_type_name_new: str = None, do_imp_from_dd_upd_cols_new: bool = None, do_activate_global_pk2obj_new: bool = None, do_create_global_ref_params_new: bool = None, object_type_grants_read_access_new: bool = None, make_generic_object_type_permissions_new: bool = True) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if system_new is not None and not (isinstance(system_new, str)):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(system_new)}")
		if is_log_dst_new is not None and not (isinstance(is_log_dst_new, bool)):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(is_log_dst_new)}")
		if is_log_src_new is not None and not (isinstance(is_log_src_new, bool)):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(is_log_src_new)}")
		if is_lang_dst_new is not None and not (isinstance(is_lang_dst_new, bool)):
			raise ValueError(f"'is_lang_dst' of incorrect type. Expected bool, got {type(is_lang_dst_new)}")
		if is_lang_src_new is not None and not (isinstance(is_lang_src_new, bool)):
			raise ValueError(f"'is_lang_src' of incorrect type. Expected bool, got {type(is_lang_src_new)}")
		if is_otattr_dst_new is not None and not (isinstance(is_otattr_dst_new, bool)):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(is_otattr_dst_new)}")
		if is_otattr_src_new is not None and not (isinstance(is_otattr_src_new, bool)):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(is_otattr_src_new)}")
		if content_gender_new is not None and not (isinstance(content_gender_new, str)):
			raise ValueError(f"'content_gender' of incorrect type. Expected str, got {type(content_gender_new)}")
		if do_imp_from_dd_new is not None and not (isinstance(do_imp_from_dd_new, bool)):
			raise ValueError(f"'do_imp_from_dd' of incorrect type. Expected bool, got {type(do_imp_from_dd_new)}")
		if object_type_name_new is not None and not (isinstance(object_type_name_new, str)):
			raise ValueError(f"'object_type_name' of incorrect type. Expected str, got {type(object_type_name_new)}")
		if do_imp_from_dd_upd_cols_new is not None and not (isinstance(do_imp_from_dd_upd_cols_new, bool)):
			raise ValueError(f"'do_imp_from_dd_upd_cols' of incorrect type. Expected bool, got {type(do_imp_from_dd_upd_cols_new)}")
		if do_activate_global_pk2obj_new is not None and not (isinstance(do_activate_global_pk2obj_new, bool)):
			raise ValueError(f"'do_activate_global_pk2obj' of incorrect type. Expected bool, got {type(do_activate_global_pk2obj_new)}")
		if do_create_global_ref_params_new is not None and not (isinstance(do_create_global_ref_params_new, bool)):
			raise ValueError(f"'do_create_global_ref_params' of incorrect type. Expected bool, got {type(do_create_global_ref_params_new)}")
		if object_type_grants_read_access_new is not None and not (isinstance(object_type_grants_read_access_new, bool)):
			raise ValueError(f"'object_type_grants_read_access' of incorrect type. Expected bool, got {type(object_type_grants_read_access_new)}")
		if make_generic_object_type_permissions_new is not None and not (isinstance(make_generic_object_type_permissions_new, bool)):
			raise ValueError(f"'make_generic_object_type_permissions' of incorrect type. Expected bool, got {type(make_generic_object_type_permissions_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'cntl.table.update', 'new': _denullify_dict({'name': name_new, 'system': system_new, 'is_log_dst': is_log_dst_new, 'is_log_src': is_log_src_new, 'is_lang_dst': is_lang_dst_new, 'is_lang_src': is_lang_src_new, 'is_otattr_dst': is_otattr_dst_new, 'is_otattr_src': is_otattr_src_new, 'content_gender': content_gender_new, 'do_imp_from_dd': do_imp_from_dd_new, 'object_type_name': object_type_name_new, 'do_imp_from_dd_upd_cols': do_imp_from_dd_upd_cols_new, 'do_activate_global_pk2obj': do_activate_global_pk2obj_new, 'do_create_global_ref_params': do_create_global_ref_params_new, 'object_type_grants_read_access': object_type_grants_read_access_new, 'make_generic_object_type_permissions': make_generic_object_type_permissions_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, system_new: str = None, is_log_dst_new: bool = None, is_log_src_new: bool = None, is_lang_dst_new: bool = None, is_lang_src_new: bool = None, is_otattr_dst_new: bool = None, is_otattr_src_new: bool = None, content_gender_new: str = None, do_imp_from_dd_new: bool = None, object_type_name_new: str = None, do_imp_from_dd_upd_cols_new: bool = None, do_activate_global_pk2obj_new: bool = None, do_create_global_ref_params_new: bool = None, object_type_grants_read_access_new: bool = None, make_generic_object_type_permissions_new: bool = True) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if system_new is not None and not (isinstance(system_new, str)):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(system_new)}")
		if is_log_dst_new is not None and not (isinstance(is_log_dst_new, bool)):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(is_log_dst_new)}")
		if is_log_src_new is not None and not (isinstance(is_log_src_new, bool)):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(is_log_src_new)}")
		if is_lang_dst_new is not None and not (isinstance(is_lang_dst_new, bool)):
			raise ValueError(f"'is_lang_dst' of incorrect type. Expected bool, got {type(is_lang_dst_new)}")
		if is_lang_src_new is not None and not (isinstance(is_lang_src_new, bool)):
			raise ValueError(f"'is_lang_src' of incorrect type. Expected bool, got {type(is_lang_src_new)}")
		if is_otattr_dst_new is not None and not (isinstance(is_otattr_dst_new, bool)):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(is_otattr_dst_new)}")
		if is_otattr_src_new is not None and not (isinstance(is_otattr_src_new, bool)):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(is_otattr_src_new)}")
		if content_gender_new is not None and not (isinstance(content_gender_new, str)):
			raise ValueError(f"'content_gender' of incorrect type. Expected str, got {type(content_gender_new)}")
		if do_imp_from_dd_new is not None and not (isinstance(do_imp_from_dd_new, bool)):
			raise ValueError(f"'do_imp_from_dd' of incorrect type. Expected bool, got {type(do_imp_from_dd_new)}")
		if object_type_name_new is not None and not (isinstance(object_type_name_new, str)):
			raise ValueError(f"'object_type_name' of incorrect type. Expected str, got {type(object_type_name_new)}")
		if do_imp_from_dd_upd_cols_new is not None and not (isinstance(do_imp_from_dd_upd_cols_new, bool)):
			raise ValueError(f"'do_imp_from_dd_upd_cols' of incorrect type. Expected bool, got {type(do_imp_from_dd_upd_cols_new)}")
		if do_activate_global_pk2obj_new is not None and not (isinstance(do_activate_global_pk2obj_new, bool)):
			raise ValueError(f"'do_activate_global_pk2obj' of incorrect type. Expected bool, got {type(do_activate_global_pk2obj_new)}")
		if do_create_global_ref_params_new is not None and not (isinstance(do_create_global_ref_params_new, bool)):
			raise ValueError(f"'do_create_global_ref_params' of incorrect type. Expected bool, got {type(do_create_global_ref_params_new)}")
		if object_type_grants_read_access_new is not None and not (isinstance(object_type_grants_read_access_new, bool)):
			raise ValueError(f"'object_type_grants_read_access' of incorrect type. Expected bool, got {type(object_type_grants_read_access_new)}")
		if make_generic_object_type_permissions_new is not None and not (isinstance(make_generic_object_type_permissions_new, bool)):
			raise ValueError(f"'make_generic_object_type_permissions' of incorrect type. Expected bool, got {type(make_generic_object_type_permissions_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, system_new=system_new, is_log_dst_new=is_log_dst_new, is_log_src_new=is_log_src_new, is_lang_dst_new=is_lang_dst_new, is_lang_src_new=is_lang_src_new, is_otattr_dst_new=is_otattr_dst_new, is_otattr_src_new=is_otattr_src_new, content_gender_new=content_gender_new, do_imp_from_dd_new=do_imp_from_dd_new, object_type_name_new=object_type_name_new, do_imp_from_dd_upd_cols_new=do_imp_from_dd_upd_cols_new, do_activate_global_pk2obj_new=do_activate_global_pk2obj_new, do_create_global_ref_params_new=do_create_global_ref_params_new, object_type_grants_read_access_new=object_type_grants_read_access_new, make_generic_object_type_permissions_new=make_generic_object_type_permissions_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Role(APIObject):
	gpk: str
	name: str
	system: str
	fq_name: str
	is_role: bool
	position: int
	is_admin_role: bool
	hierarchy_gfk_list: list
	is_directly_assigned: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.system, str):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(self.system)}")
		if not isinstance(self.fq_name, str):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(self.fq_name)}")
		if not isinstance(self.is_role, bool):
			raise ValueError(f"'is_role' of incorrect type. Expected bool, got {type(self.is_role)}")
		if not isinstance(self.position, int):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(self.position)}")
		if not isinstance(self.is_admin_role, bool):
			raise ValueError(f"'is_admin_role' of incorrect type. Expected bool, got {type(self.is_admin_role)}")
		if not isinstance(self.hierarchy_gfk_list, list):
			raise ValueError(f"'hierarchy_gfk_list' of incorrect type. Expected list, got {type(self.hierarchy_gfk_list)}")
		if not isinstance(self.is_directly_assigned, bool):
			raise ValueError(f"'is_directly_assigned' of incorrect type. Expected bool, got {type(self.is_directly_assigned)}")

	@staticmethod
	def create_ta(fq_name_new: str, is_role_new: bool, is_admin_role_new: bool, position_new: int = None) -> dict:
		if not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if not (isinstance(is_role_new, bool)):
			raise ValueError(f"'is_role' of incorrect type. Expected bool, got {type(is_role_new)}")
		if position_new is not None and not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if not (isinstance(is_admin_role_new, bool)):
			raise ValueError(f"'is_admin_role' of incorrect type. Expected bool, got {type(is_admin_role_new)}")

		return {'name': 'cntl.role.create', 'new': _denullify_dict({'fq_name': fq_name_new, 'is_role': is_role_new, 'position': position_new, 'is_admin_role': is_admin_role_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, fq_name_new: str, is_role_new: bool, is_admin_role_new: bool, position_new: int = None) -> list:
		if not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if not (isinstance(is_role_new, bool)):
			raise ValueError(f"'is_role' of incorrect type. Expected bool, got {type(is_role_new)}")
		if position_new is not None and not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if not (isinstance(is_admin_role_new, bool)):
			raise ValueError(f"'is_admin_role' of incorrect type. Expected bool, got {type(is_admin_role_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(fq_name_new=fq_name_new, is_role_new=is_role_new, position_new=position_new, is_admin_role_new=is_admin_role_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(fq_name_old: str) -> dict:
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")

		return {'name': 'cntl.role.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'fq_name': fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, fq_name_old: str) -> list:
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(fq_name_old=fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(is_role_old: bool = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, fq_name_list_old: list = None, is_admin_role_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, is_directly_assigned_old: bool = None) -> dict:
		if is_role_old is not None and not (isinstance(is_role_old, bool)):
			raise ValueError(f"'is_role' of incorrect type. Expected bool, got {type(is_role_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if fq_name_list_old is not None and not (isinstance(fq_name_list_old, list)):
			raise ValueError(f"'fq_name_list' of incorrect type. Expected list, got {type(fq_name_list_old)}")
		if is_admin_role_old is not None and not (isinstance(is_admin_role_old, bool)):
			raise ValueError(f"'is_admin_role' of incorrect type. Expected bool, got {type(is_admin_role_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if is_directly_assigned_old is not None and not (isinstance(is_directly_assigned_old, bool)):
			raise ValueError(f"'is_directly_assigned' of incorrect type. Expected bool, got {type(is_directly_assigned_old)}")

		return {'name': 'cntl.role.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'is_role': is_role_old, 'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'fq_name_list': fq_name_list_old, 'is_admin_role': is_admin_role_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'is_directly_assigned': is_directly_assigned_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, is_role_old: bool = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, fq_name_list_old: list = None, is_admin_role_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, is_directly_assigned_old: bool = None) -> list:
		if is_role_old is not None and not (isinstance(is_role_old, bool)):
			raise ValueError(f"'is_role' of incorrect type. Expected bool, got {type(is_role_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if fq_name_list_old is not None and not (isinstance(fq_name_list_old, list)):
			raise ValueError(f"'fq_name_list' of incorrect type. Expected list, got {type(fq_name_list_old)}")
		if is_admin_role_old is not None and not (isinstance(is_admin_role_old, bool)):
			raise ValueError(f"'is_admin_role' of incorrect type. Expected bool, got {type(is_admin_role_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if is_directly_assigned_old is not None and not (isinstance(is_directly_assigned_old, bool)):
			raise ValueError(f"'is_directly_assigned' of incorrect type. Expected bool, got {type(is_directly_assigned_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(is_role_old=is_role_old, gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, fq_name_list_old=fq_name_list_old, is_admin_role_old=is_admin_role_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, is_directly_assigned_old=is_directly_assigned_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(fq_name_old: str, fq_name_new: str = None, is_role_new: bool = None, position_new: int = None, is_admin_role_new: bool = None) -> dict:
		if fq_name_new is not None and not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if is_role_new is not None and not (isinstance(is_role_new, bool)):
			raise ValueError(f"'is_role' of incorrect type. Expected bool, got {type(is_role_new)}")
		if position_new is not None and not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if is_admin_role_new is not None and not (isinstance(is_admin_role_new, bool)):
			raise ValueError(f"'is_admin_role' of incorrect type. Expected bool, got {type(is_admin_role_new)}")
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")

		return {'name': 'cntl.role.update', 'new': _denullify_dict({'fq_name': fq_name_new, 'is_role': is_role_new, 'position': position_new, 'is_admin_role': is_admin_role_new}), 'old': _denullify_dict({'fq_name': fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, fq_name_old: str, fq_name_new: str = None, is_role_new: bool = None, position_new: int = None, is_admin_role_new: bool = None) -> list:
		if fq_name_new is not None and not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if is_role_new is not None and not (isinstance(is_role_new, bool)):
			raise ValueError(f"'is_role' of incorrect type. Expected bool, got {type(is_role_new)}")
		if position_new is not None and not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if is_admin_role_new is not None and not (isinstance(is_admin_role_new, bool)):
			raise ValueError(f"'is_admin_role' of incorrect type. Expected bool, got {type(is_admin_role_new)}")
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(fq_name_new=fq_name_new, is_role_new=is_role_new, position_new=position_new, is_admin_role_new=is_admin_role_new, fq_name_old=fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Mgr2role(APIObject):
	gpk: str
	role: str
	system: str
	role_fq_name: str
	mgr_login_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.role, str):
			raise ValueError(f"'role' of incorrect type. Expected str, got {type(self.role)}")
		if not isinstance(self.system, str):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(self.system)}")
		if not isinstance(self.role_fq_name, str):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(self.role_fq_name)}")
		if not isinstance(self.mgr_login_name, str):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(self.mgr_login_name)}")

	@staticmethod
	def create_ta(role_fq_name_new: str, mgr_login_name_new: str) -> dict:
		if not (isinstance(role_fq_name_new, str)):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(role_fq_name_new)}")
		if not (isinstance(mgr_login_name_new, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_new)}")

		return {'name': 'cntl.mgr2role.create', 'new': _denullify_dict({'role_fq_name': role_fq_name_new, 'mgr_login_name': mgr_login_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, role_fq_name_new: str, mgr_login_name_new: str) -> list:
		if not (isinstance(role_fq_name_new, str)):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(role_fq_name_new)}")
		if not (isinstance(mgr_login_name_new, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(role_fq_name_new=role_fq_name_new, mgr_login_name_new=mgr_login_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(role_fq_name_old: str, mgr_login_name_old: str, do_preserve_contained_on_delete_old: bool = None) -> dict:
		if not (isinstance(role_fq_name_old, str)):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(role_fq_name_old)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")
		if do_preserve_contained_on_delete_old is not None and not (isinstance(do_preserve_contained_on_delete_old, bool)):
			raise ValueError(f"'do_preserve_contained_on_delete' of incorrect type. Expected bool, got {type(do_preserve_contained_on_delete_old)}")

		return {'name': 'cntl.mgr2role.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'role_fq_name': role_fq_name_old, 'mgr_login_name': mgr_login_name_old, 'do_preserve_contained_on_delete': do_preserve_contained_on_delete_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, role_fq_name_old: str, mgr_login_name_old: str, do_preserve_contained_on_delete_old: bool = None) -> list:
		if not (isinstance(role_fq_name_old, str)):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(role_fq_name_old)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")
		if do_preserve_contained_on_delete_old is not None and not (isinstance(do_preserve_contained_on_delete_old, bool)):
			raise ValueError(f"'do_preserve_contained_on_delete' of incorrect type. Expected bool, got {type(do_preserve_contained_on_delete_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(role_fq_name_old=role_fq_name_old, mgr_login_name_old=mgr_login_name_old, do_preserve_contained_on_delete_old=do_preserve_contained_on_delete_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, role_fq_name_list_old: list = None, filter_params_dict_old: dict = None, mgr_login_name_list_old: list = None, sorting_params_list_old: list = None) -> dict:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if role_fq_name_list_old is not None and not (isinstance(role_fq_name_list_old, list)):
			raise ValueError(f"'role_fq_name_list' of incorrect type. Expected list, got {type(role_fq_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if mgr_login_name_list_old is not None and not (isinstance(mgr_login_name_list_old, list)):
			raise ValueError(f"'mgr_login_name_list' of incorrect type. Expected list, got {type(mgr_login_name_list_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.mgr2role.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'role_fq_name_list': role_fq_name_list_old, 'filter_params_dict': filter_params_dict_old, 'mgr_login_name_list': mgr_login_name_list_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, role_fq_name_list_old: list = None, filter_params_dict_old: dict = None, mgr_login_name_list_old: list = None, sorting_params_list_old: list = None) -> list:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if role_fq_name_list_old is not None and not (isinstance(role_fq_name_list_old, list)):
			raise ValueError(f"'role_fq_name_list' of incorrect type. Expected list, got {type(role_fq_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if mgr_login_name_list_old is not None and not (isinstance(mgr_login_name_list_old, list)):
			raise ValueError(f"'mgr_login_name_list' of incorrect type. Expected list, got {type(mgr_login_name_list_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, role_fq_name_list_old=role_fq_name_list_old, filter_params_dict_old=filter_params_dict_old, mgr_login_name_list_old=mgr_login_name_list_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Role2role(APIObject):
	gpk: str
	role_fq_name: str
	role_is_role: bool
	contained_role_fq_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.role_fq_name, str):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(self.role_fq_name)}")
		if not isinstance(self.role_is_role, bool):
			raise ValueError(f"'role_is_role' of incorrect type. Expected bool, got {type(self.role_is_role)}")
		if not isinstance(self.contained_role_fq_name, str):
			raise ValueError(f"'contained_role_fq_name' of incorrect type. Expected str, got {type(self.contained_role_fq_name)}")

	@staticmethod
	def create_ta(role_fq_name_new: str, contained_role_fq_name_new: str) -> dict:
		if not (isinstance(role_fq_name_new, str)):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(role_fq_name_new)}")
		if not (isinstance(contained_role_fq_name_new, str)):
			raise ValueError(f"'contained_role_fq_name' of incorrect type. Expected str, got {type(contained_role_fq_name_new)}")

		return {'name': 'cntl.role2role.create', 'new': _denullify_dict({'role_fq_name': role_fq_name_new, 'contained_role_fq_name': contained_role_fq_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, role_fq_name_new: str, contained_role_fq_name_new: str) -> list:
		if not (isinstance(role_fq_name_new, str)):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(role_fq_name_new)}")
		if not (isinstance(contained_role_fq_name_new, str)):
			raise ValueError(f"'contained_role_fq_name' of incorrect type. Expected str, got {type(contained_role_fq_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(role_fq_name_new=role_fq_name_new, contained_role_fq_name_new=contained_role_fq_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(role_fq_name_old: str, contained_role_fq_name_old: str, do_preserve_contained_on_delete_old: bool = None) -> dict:
		if not (isinstance(role_fq_name_old, str)):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(role_fq_name_old)}")
		if not (isinstance(contained_role_fq_name_old, str)):
			raise ValueError(f"'contained_role_fq_name' of incorrect type. Expected str, got {type(contained_role_fq_name_old)}")
		if do_preserve_contained_on_delete_old is not None and not (isinstance(do_preserve_contained_on_delete_old, bool)):
			raise ValueError(f"'do_preserve_contained_on_delete' of incorrect type. Expected bool, got {type(do_preserve_contained_on_delete_old)}")

		return {'name': 'cntl.role2role.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'role_fq_name': role_fq_name_old, 'contained_role_fq_name': contained_role_fq_name_old, 'do_preserve_contained_on_delete': do_preserve_contained_on_delete_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, role_fq_name_old: str, contained_role_fq_name_old: str, do_preserve_contained_on_delete_old: bool = None) -> list:
		if not (isinstance(role_fq_name_old, str)):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(role_fq_name_old)}")
		if not (isinstance(contained_role_fq_name_old, str)):
			raise ValueError(f"'contained_role_fq_name' of incorrect type. Expected str, got {type(contained_role_fq_name_old)}")
		if do_preserve_contained_on_delete_old is not None and not (isinstance(do_preserve_contained_on_delete_old, bool)):
			raise ValueError(f"'do_preserve_contained_on_delete' of incorrect type. Expected bool, got {type(do_preserve_contained_on_delete_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(role_fq_name_old=role_fq_name_old, contained_role_fq_name_old=contained_role_fq_name_old, do_preserve_contained_on_delete_old=do_preserve_contained_on_delete_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, role_fq_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, contained_role_fq_name_list_old: list = None) -> dict:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if role_fq_name_list_old is not None and not (isinstance(role_fq_name_list_old, list)):
			raise ValueError(f"'role_fq_name_list' of incorrect type. Expected list, got {type(role_fq_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if contained_role_fq_name_list_old is not None and not (isinstance(contained_role_fq_name_list_old, list)):
			raise ValueError(f"'contained_role_fq_name_list' of incorrect type. Expected list, got {type(contained_role_fq_name_list_old)}")

		return {'name': 'cntl.role2role.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'role_fq_name_list': role_fq_name_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'contained_role_fq_name_list': contained_role_fq_name_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, role_fq_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, contained_role_fq_name_list_old: list = None) -> list:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if role_fq_name_list_old is not None and not (isinstance(role_fq_name_list_old, list)):
			raise ValueError(f"'role_fq_name_list' of incorrect type. Expected list, got {type(role_fq_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if contained_role_fq_name_list_old is not None and not (isinstance(contained_role_fq_name_list_old, list)):
			raise ValueError(f"'contained_role_fq_name_list' of incorrect type. Expected list, got {type(contained_role_fq_name_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, role_fq_name_list_old=role_fq_name_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, contained_role_fq_name_list_old=contained_role_fq_name_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class GlobalPk2obj(APIObject):
	gpk: str
	object_dict: dict
	object_type_fq_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.object_dict, dict):
			raise ValueError(f"'object_dict' of incorrect type. Expected dict, got {type(self.object_dict)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")

	@staticmethod
	def list_ta(gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, do_only_unqpr_object_attrs_old: bool = False) -> dict:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if do_only_unqpr_object_attrs_old is not None and not (isinstance(do_only_unqpr_object_attrs_old, bool)):
			raise ValueError(f"'do_only_unqpr_object_attrs' of incorrect type. Expected bool, got {type(do_only_unqpr_object_attrs_old)}")

		return {'name': 'cntl.global_pk2obj.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'do_only_unqpr_object_attrs': do_only_unqpr_object_attrs_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, do_only_unqpr_object_attrs_old: bool = False) -> list:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if do_only_unqpr_object_attrs_old is not None and not (isinstance(do_only_unqpr_object_attrs_old, bool)):
			raise ValueError(f"'do_only_unqpr_object_attrs' of incorrect type. Expected bool, got {type(do_only_unqpr_object_attrs_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, do_only_unqpr_object_attrs_old=do_only_unqpr_object_attrs_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Constraint2error(APIObject):
	gpk: str
	sqlstate: str
	error_code: int
	constraint_name: str
	error_type_code: int
	constraint_table: str
	parent_key_not_found: bool
	constraint_is_api_level: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.sqlstate, str):
			raise ValueError(f"'sqlstate' of incorrect type. Expected str, got {type(self.sqlstate)}")
		if not isinstance(self.error_code, int):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(self.error_code)}")
		if not isinstance(self.constraint_name, str):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(self.constraint_name)}")
		if not isinstance(self.error_type_code, int):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(self.error_type_code)}")
		if not isinstance(self.constraint_table, str):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(self.constraint_table)}")
		if self.parent_key_not_found is not None and not isinstance(self.parent_key_not_found, bool):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(self.parent_key_not_found)}")
		if not isinstance(self.constraint_is_api_level, bool):
			raise ValueError(f"'constraint_is_api_level' of incorrect type. Expected bool, got {type(self.constraint_is_api_level)}")

	@staticmethod
	def create_ta(sqlstate_new: str, error_code_new: int, constraint_name_new: str, error_type_code_new: int, constraint_table_new: Union[str, ExplicitNull], parent_key_not_found_new: Union[bool, ExplicitNull] = None) -> dict:
		if not (isinstance(sqlstate_new, str)):
			raise ValueError(f"'sqlstate' of incorrect type. Expected str, got {type(sqlstate_new)}")
		if not (isinstance(error_code_new, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_new)}")
		if not (isinstance(constraint_name_new, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_new)}")
		if not (isinstance(error_type_code_new, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_new)}")
		if not (isinstance(constraint_table_new, str) or isinstance(constraint_table_new, ExplicitNull)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_new)}")
		if parent_key_not_found_new is not None and not (isinstance(parent_key_not_found_new, bool) or isinstance(parent_key_not_found_new, ExplicitNull)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_new)}")

		return {'name': 'cntl.constraint2error.create', 'new': _denullify_dict({'sqlstate': sqlstate_new, 'error_code': error_code_new, 'constraint_name': constraint_name_new, 'error_type_code': error_type_code_new, 'constraint_table': constraint_table_new, 'parent_key_not_found': parent_key_not_found_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, sqlstate_new: str, error_code_new: int, constraint_name_new: str, error_type_code_new: int, constraint_table_new: Union[str, ExplicitNull], parent_key_not_found_new: Union[bool, ExplicitNull] = None) -> list:
		if not (isinstance(sqlstate_new, str)):
			raise ValueError(f"'sqlstate' of incorrect type. Expected str, got {type(sqlstate_new)}")
		if not (isinstance(error_code_new, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_new)}")
		if not (isinstance(constraint_name_new, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_new)}")
		if not (isinstance(error_type_code_new, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_new)}")
		if not (isinstance(constraint_table_new, str) or isinstance(constraint_table_new, ExplicitNull)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_new)}")
		if parent_key_not_found_new is not None and not (isinstance(parent_key_not_found_new, bool) or isinstance(parent_key_not_found_new, ExplicitNull)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(sqlstate_new=sqlstate_new, error_code_new=error_code_new, constraint_name_new=constraint_name_new, error_type_code_new=error_type_code_new, constraint_table_new=constraint_table_new, parent_key_not_found_new=parent_key_not_found_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(error_code_old: int, constraint_name_old: str, error_type_code_old: int, constraint_table_old: str) -> dict:
		if not (isinstance(error_code_old, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_old)}")
		if not (isinstance(constraint_name_old, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_old)}")
		if not (isinstance(error_type_code_old, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_old)}")
		if not (isinstance(constraint_table_old, str) or isinstance(constraint_table_old, ExplicitNull)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_old)}")

		return {'name': 'cntl.constraint2error.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'error_code': error_code_old, 'constraint_name': constraint_name_old, 'error_type_code': error_type_code_old, 'constraint_table': constraint_table_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, error_code_old: int, constraint_name_old: str, error_type_code_old: int, constraint_table_old: str) -> list:
		if not (isinstance(error_code_old, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_old)}")
		if not (isinstance(constraint_name_old, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_old)}")
		if not (isinstance(error_type_code_old, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_old)}")
		if not (isinstance(constraint_table_old, str) or isinstance(constraint_table_old, ExplicitNull)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(error_code_old=error_code_old, constraint_name_old=constraint_name_old, error_type_code_old=error_type_code_old, constraint_table_old=constraint_table_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_list_old: list = None, sqlstate_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, error_code_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, constraint_name_list_old: list = None, error_type_code_list_old: list = None, parent_key_not_found_old: bool = None, constraint_table_list_old: list = None) -> dict:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if sqlstate_old is not None and not (isinstance(sqlstate_old, str)):
			raise ValueError(f"'sqlstate' of incorrect type. Expected str, got {type(sqlstate_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if error_code_list_old is not None and not (isinstance(error_code_list_old, list)):
			raise ValueError(f"'error_code_list' of incorrect type. Expected list, got {type(error_code_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if constraint_name_list_old is not None and not (isinstance(constraint_name_list_old, list)):
			raise ValueError(f"'constraint_name_list' of incorrect type. Expected list, got {type(constraint_name_list_old)}")
		if error_type_code_list_old is not None and not (isinstance(error_type_code_list_old, list)):
			raise ValueError(f"'error_type_code_list' of incorrect type. Expected list, got {type(error_type_code_list_old)}")
		if parent_key_not_found_old is not None and not (isinstance(parent_key_not_found_old, bool)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_old)}")
		if constraint_table_list_old is not None and not (isinstance(constraint_table_list_old, list)):
			raise ValueError(f"'constraint_table_list' of incorrect type. Expected list, got {type(constraint_table_list_old)}")

		return {'name': 'cntl.constraint2error.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk_list': gpk_list_old, 'sqlstate': sqlstate_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'error_code_list': error_code_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'constraint_name_list': constraint_name_list_old, 'error_type_code_list': error_type_code_list_old, 'parent_key_not_found': parent_key_not_found_old, 'constraint_table_list': constraint_table_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_list_old: list = None, sqlstate_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, error_code_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, constraint_name_list_old: list = None, error_type_code_list_old: list = None, parent_key_not_found_old: bool = None, constraint_table_list_old: list = None) -> list:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if sqlstate_old is not None and not (isinstance(sqlstate_old, str)):
			raise ValueError(f"'sqlstate' of incorrect type. Expected str, got {type(sqlstate_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if error_code_list_old is not None and not (isinstance(error_code_list_old, list)):
			raise ValueError(f"'error_code_list' of incorrect type. Expected list, got {type(error_code_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if constraint_name_list_old is not None and not (isinstance(constraint_name_list_old, list)):
			raise ValueError(f"'constraint_name_list' of incorrect type. Expected list, got {type(constraint_name_list_old)}")
		if error_type_code_list_old is not None and not (isinstance(error_type_code_list_old, list)):
			raise ValueError(f"'error_type_code_list' of incorrect type. Expected list, got {type(error_type_code_list_old)}")
		if parent_key_not_found_old is not None and not (isinstance(parent_key_not_found_old, bool)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_old)}")
		if constraint_table_list_old is not None and not (isinstance(constraint_table_list_old, list)):
			raise ValueError(f"'constraint_table_list' of incorrect type. Expected list, got {type(constraint_table_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_list_old=gpk_list_old, sqlstate_old=sqlstate_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, error_code_list_old=error_code_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, constraint_name_list_old=constraint_name_list_old, error_type_code_list_old=error_type_code_list_old, parent_key_not_found_old=parent_key_not_found_old, constraint_table_list_old=constraint_table_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(error_code_old: int, constraint_name_old: str, error_type_code_old: int, constraint_table_old: str, sqlstate_new: str = None, error_code_new: int = None, constraint_name_new: str = None, error_type_code_new: int = None, constraint_table_new: Union[str, ExplicitNull] = None, parent_key_not_found_new: Union[bool, ExplicitNull] = None) -> dict:
		if sqlstate_new is not None and not (isinstance(sqlstate_new, str)):
			raise ValueError(f"'sqlstate' of incorrect type. Expected str, got {type(sqlstate_new)}")
		if error_code_new is not None and not (isinstance(error_code_new, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_new)}")
		if constraint_name_new is not None and not (isinstance(constraint_name_new, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_new)}")
		if error_type_code_new is not None and not (isinstance(error_type_code_new, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_new)}")
		if constraint_table_new is not None and not (isinstance(constraint_table_new, str) or isinstance(constraint_table_new, ExplicitNull)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_new)}")
		if parent_key_not_found_new is not None and not (isinstance(parent_key_not_found_new, bool) or isinstance(parent_key_not_found_new, ExplicitNull)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_new)}")
		if not (isinstance(error_code_old, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_old)}")
		if not (isinstance(constraint_name_old, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_old)}")
		if not (isinstance(error_type_code_old, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_old)}")
		if not (isinstance(constraint_table_old, str) or isinstance(constraint_table_old, ExplicitNull)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_old)}")

		return {'name': 'cntl.constraint2error.update', 'new': _denullify_dict({'sqlstate': sqlstate_new, 'error_code': error_code_new, 'constraint_name': constraint_name_new, 'error_type_code': error_type_code_new, 'constraint_table': constraint_table_new, 'parent_key_not_found': parent_key_not_found_new}), 'old': _denullify_dict({'error_code': error_code_old, 'constraint_name': constraint_name_old, 'error_type_code': error_type_code_old, 'constraint_table': constraint_table_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, error_code_old: int, constraint_name_old: str, error_type_code_old: int, constraint_table_old: str, sqlstate_new: str = None, error_code_new: int = None, constraint_name_new: str = None, error_type_code_new: int = None, constraint_table_new: Union[str, ExplicitNull] = None, parent_key_not_found_new: Union[bool, ExplicitNull] = None) -> list:
		if sqlstate_new is not None and not (isinstance(sqlstate_new, str)):
			raise ValueError(f"'sqlstate' of incorrect type. Expected str, got {type(sqlstate_new)}")
		if error_code_new is not None and not (isinstance(error_code_new, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_new)}")
		if constraint_name_new is not None and not (isinstance(constraint_name_new, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_new)}")
		if error_type_code_new is not None and not (isinstance(error_type_code_new, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_new)}")
		if constraint_table_new is not None and not (isinstance(constraint_table_new, str) or isinstance(constraint_table_new, ExplicitNull)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_new)}")
		if parent_key_not_found_new is not None and not (isinstance(parent_key_not_found_new, bool) or isinstance(parent_key_not_found_new, ExplicitNull)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_new)}")
		if not (isinstance(error_code_old, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_old)}")
		if not (isinstance(constraint_name_old, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_old)}")
		if not (isinstance(error_type_code_old, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_old)}")
		if not (isinstance(constraint_table_old, str) or isinstance(constraint_table_old, ExplicitNull)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(sqlstate_new=sqlstate_new, error_code_new=error_code_new, constraint_name_new=constraint_name_new, error_type_code_new=error_type_code_new, constraint_table_new=constraint_table_new, parent_key_not_found_new=parent_key_not_found_new, error_code_old=error_code_old, constraint_name_old=constraint_name_old, error_type_code_old=error_type_code_old, constraint_table_old=constraint_table_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class DataType(APIObject):
	pk: int
	gpk: str
	name: str
	base_name: str
	base_nspc: str
	json_name: str
	is_primary: bool
	text_length: int
	pg_type_name: str
	pg_type_nspc: str
	operator_list: list
	format_literal: str
	conv_daty_val_attname: str

	def __post_init__(self):
		if not isinstance(self.pk, int):
			raise ValueError(f"'pk' of incorrect type. Expected int, got {type(self.pk)}")
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.base_name, str):
			raise ValueError(f"'base_name' of incorrect type. Expected str, got {type(self.base_name)}")
		if self.base_nspc is not None and not isinstance(self.base_nspc, str):
			raise ValueError(f"'base_nspc' of incorrect type. Expected str, got {type(self.base_nspc)}")
		if not isinstance(self.json_name, str):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(self.json_name)}")
		if not isinstance(self.is_primary, bool):
			raise ValueError(f"'is_primary' of incorrect type. Expected bool, got {type(self.is_primary)}")
		if self.text_length is not None and not isinstance(self.text_length, int):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(self.text_length)}")
		if not isinstance(self.pg_type_name, str):
			raise ValueError(f"'pg_type_name' of incorrect type. Expected str, got {type(self.pg_type_name)}")
		if not isinstance(self.pg_type_nspc, str):
			raise ValueError(f"'pg_type_nspc' of incorrect type. Expected str, got {type(self.pg_type_nspc)}")
		if not isinstance(self.operator_list, list):
			raise ValueError(f"'operator_list' of incorrect type. Expected list, got {type(self.operator_list)}")
		if self.format_literal is not None and not isinstance(self.format_literal, str):
			raise ValueError(f"'format_literal' of incorrect type. Expected str, got {type(self.format_literal)}")
		if not isinstance(self.conv_daty_val_attname, str):
			raise ValueError(f"'conv_daty_val_attname' of incorrect type. Expected str, got {type(self.conv_daty_val_attname)}")

	@staticmethod
	def create_ta(name_new: str, base_name_new: str, json_name_new: str, is_primary_new: bool, pg_type_name_new: str, pg_type_nspc_new: str, conv_daty_val_attname_new: str, pk_new: int = None, base_nspc_new: Union[str, ExplicitNull] = None, text_length_new: Union[int, ExplicitNull] = None, format_literal_new: Union[str, ExplicitNull] = None) -> dict:
		if pk_new is not None and not (isinstance(pk_new, int)):
			raise ValueError(f"'pk' of incorrect type. Expected int, got {type(pk_new)}")
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(base_name_new, str)):
			raise ValueError(f"'base_name' of incorrect type. Expected str, got {type(base_name_new)}")
		if base_nspc_new is not None and not (isinstance(base_nspc_new, str) or isinstance(base_nspc_new, ExplicitNull)):
			raise ValueError(f"'base_nspc' of incorrect type. Expected str, got {type(base_nspc_new)}")
		if not (isinstance(json_name_new, str)):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(json_name_new)}")
		if not (isinstance(is_primary_new, bool)):
			raise ValueError(f"'is_primary' of incorrect type. Expected bool, got {type(is_primary_new)}")
		if text_length_new is not None and not (isinstance(text_length_new, int) or isinstance(text_length_new, ExplicitNull)):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(text_length_new)}")
		if not (isinstance(pg_type_name_new, str)):
			raise ValueError(f"'pg_type_name' of incorrect type. Expected str, got {type(pg_type_name_new)}")
		if not (isinstance(pg_type_nspc_new, str)):
			raise ValueError(f"'pg_type_nspc' of incorrect type. Expected str, got {type(pg_type_nspc_new)}")
		if format_literal_new is not None and not (isinstance(format_literal_new, str) or isinstance(format_literal_new, ExplicitNull)):
			raise ValueError(f"'format_literal' of incorrect type. Expected str, got {type(format_literal_new)}")
		if not (isinstance(conv_daty_val_attname_new, str)):
			raise ValueError(f"'conv_daty_val_attname' of incorrect type. Expected str, got {type(conv_daty_val_attname_new)}")

		return {'name': 'cntl.data_type.create', 'new': _denullify_dict({'pk': pk_new, 'name': name_new, 'base_name': base_name_new, 'base_nspc': base_nspc_new, 'json_name': json_name_new, 'is_primary': is_primary_new, 'text_length': text_length_new, 'pg_type_name': pg_type_name_new, 'pg_type_nspc': pg_type_nspc_new, 'format_literal': format_literal_new, 'conv_daty_val_attname': conv_daty_val_attname_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, base_name_new: str, json_name_new: str, is_primary_new: bool, pg_type_name_new: str, pg_type_nspc_new: str, conv_daty_val_attname_new: str, pk_new: int = None, base_nspc_new: Union[str, ExplicitNull] = None, text_length_new: Union[int, ExplicitNull] = None, format_literal_new: Union[str, ExplicitNull] = None) -> list:
		if pk_new is not None and not (isinstance(pk_new, int)):
			raise ValueError(f"'pk' of incorrect type. Expected int, got {type(pk_new)}")
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(base_name_new, str)):
			raise ValueError(f"'base_name' of incorrect type. Expected str, got {type(base_name_new)}")
		if base_nspc_new is not None and not (isinstance(base_nspc_new, str) or isinstance(base_nspc_new, ExplicitNull)):
			raise ValueError(f"'base_nspc' of incorrect type. Expected str, got {type(base_nspc_new)}")
		if not (isinstance(json_name_new, str)):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(json_name_new)}")
		if not (isinstance(is_primary_new, bool)):
			raise ValueError(f"'is_primary' of incorrect type. Expected bool, got {type(is_primary_new)}")
		if text_length_new is not None and not (isinstance(text_length_new, int) or isinstance(text_length_new, ExplicitNull)):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(text_length_new)}")
		if not (isinstance(pg_type_name_new, str)):
			raise ValueError(f"'pg_type_name' of incorrect type. Expected str, got {type(pg_type_name_new)}")
		if not (isinstance(pg_type_nspc_new, str)):
			raise ValueError(f"'pg_type_nspc' of incorrect type. Expected str, got {type(pg_type_nspc_new)}")
		if format_literal_new is not None and not (isinstance(format_literal_new, str) or isinstance(format_literal_new, ExplicitNull)):
			raise ValueError(f"'format_literal' of incorrect type. Expected str, got {type(format_literal_new)}")
		if not (isinstance(conv_daty_val_attname_new, str)):
			raise ValueError(f"'conv_daty_val_attname' of incorrect type. Expected str, got {type(conv_daty_val_attname_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(pk_new=pk_new, name_new=name_new, base_name_new=base_name_new, base_nspc_new=base_nspc_new, json_name_new=json_name_new, is_primary_new=is_primary_new, text_length_new=text_length_new, pg_type_name_new=pg_type_name_new, pg_type_nspc_new=pg_type_nspc_new, format_literal_new=format_literal_new, conv_daty_val_attname_new=conv_daty_val_attname_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(pk_old: int) -> dict:
		if not (isinstance(pk_old, int)):
			raise ValueError(f"'pk' of incorrect type. Expected int, got {type(pk_old)}")

		return {'name': 'cntl.data_type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'pk': pk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, pk_old: int) -> list:
		if not (isinstance(pk_old, int)):
			raise ValueError(f"'pk' of incorrect type. Expected int, got {type(pk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(pk_old=pk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(pk_old: int = None, gpk_list_old: list = None, json_name_old: str = None, name_list_old: list = None, fetch_limit_old: int = None, text_length_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if pk_old is not None and not (isinstance(pk_old, int)):
			raise ValueError(f"'pk' of incorrect type. Expected int, got {type(pk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if json_name_old is not None and not (isinstance(json_name_old, str)):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(json_name_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if text_length_old is not None and not (isinstance(text_length_old, int) or isinstance(text_length_old, ExplicitNull)):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(text_length_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.data_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'pk': pk_old, 'gpk_list': gpk_list_old, 'json_name': json_name_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'text_length': text_length_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, pk_old: int = None, gpk_list_old: list = None, json_name_old: str = None, name_list_old: list = None, fetch_limit_old: int = None, text_length_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if pk_old is not None and not (isinstance(pk_old, int)):
			raise ValueError(f"'pk' of incorrect type. Expected int, got {type(pk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if json_name_old is not None and not (isinstance(json_name_old, str)):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(json_name_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if text_length_old is not None and not (isinstance(text_length_old, int) or isinstance(text_length_old, ExplicitNull)):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(text_length_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(pk_old=pk_old, gpk_list_old=gpk_list_old, json_name_old=json_name_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, text_length_old=text_length_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(pk_old: int, pk_new: int = None, name_new: str = None, base_name_new: str = None, base_nspc_new: Union[str, ExplicitNull] = None, json_name_new: str = None, is_primary_new: bool = None, text_length_new: Union[int, ExplicitNull] = None, pg_type_name_new: str = None, pg_type_nspc_new: str = None, format_literal_new: Union[str, ExplicitNull] = None, conv_daty_val_attname_new: str = None) -> dict:
		if pk_new is not None and not (isinstance(pk_new, int)):
			raise ValueError(f"'pk' of incorrect type. Expected int, got {type(pk_new)}")
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if base_name_new is not None and not (isinstance(base_name_new, str)):
			raise ValueError(f"'base_name' of incorrect type. Expected str, got {type(base_name_new)}")
		if base_nspc_new is not None and not (isinstance(base_nspc_new, str) or isinstance(base_nspc_new, ExplicitNull)):
			raise ValueError(f"'base_nspc' of incorrect type. Expected str, got {type(base_nspc_new)}")
		if json_name_new is not None and not (isinstance(json_name_new, str)):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(json_name_new)}")
		if is_primary_new is not None and not (isinstance(is_primary_new, bool)):
			raise ValueError(f"'is_primary' of incorrect type. Expected bool, got {type(is_primary_new)}")
		if text_length_new is not None and not (isinstance(text_length_new, int) or isinstance(text_length_new, ExplicitNull)):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(text_length_new)}")
		if pg_type_name_new is not None and not (isinstance(pg_type_name_new, str)):
			raise ValueError(f"'pg_type_name' of incorrect type. Expected str, got {type(pg_type_name_new)}")
		if pg_type_nspc_new is not None and not (isinstance(pg_type_nspc_new, str)):
			raise ValueError(f"'pg_type_nspc' of incorrect type. Expected str, got {type(pg_type_nspc_new)}")
		if format_literal_new is not None and not (isinstance(format_literal_new, str) or isinstance(format_literal_new, ExplicitNull)):
			raise ValueError(f"'format_literal' of incorrect type. Expected str, got {type(format_literal_new)}")
		if conv_daty_val_attname_new is not None and not (isinstance(conv_daty_val_attname_new, str)):
			raise ValueError(f"'conv_daty_val_attname' of incorrect type. Expected str, got {type(conv_daty_val_attname_new)}")
		if not (isinstance(pk_old, int)):
			raise ValueError(f"'pk' of incorrect type. Expected int, got {type(pk_old)}")

		return {'name': 'cntl.data_type.update', 'new': _denullify_dict({'pk': pk_new, 'name': name_new, 'base_name': base_name_new, 'base_nspc': base_nspc_new, 'json_name': json_name_new, 'is_primary': is_primary_new, 'text_length': text_length_new, 'pg_type_name': pg_type_name_new, 'pg_type_nspc': pg_type_nspc_new, 'format_literal': format_literal_new, 'conv_daty_val_attname': conv_daty_val_attname_new}), 'old': _denullify_dict({'pk': pk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, pk_old: int, pk_new: int = None, name_new: str = None, base_name_new: str = None, base_nspc_new: Union[str, ExplicitNull] = None, json_name_new: str = None, is_primary_new: bool = None, text_length_new: Union[int, ExplicitNull] = None, pg_type_name_new: str = None, pg_type_nspc_new: str = None, format_literal_new: Union[str, ExplicitNull] = None, conv_daty_val_attname_new: str = None) -> list:
		if pk_new is not None and not (isinstance(pk_new, int)):
			raise ValueError(f"'pk' of incorrect type. Expected int, got {type(pk_new)}")
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if base_name_new is not None and not (isinstance(base_name_new, str)):
			raise ValueError(f"'base_name' of incorrect type. Expected str, got {type(base_name_new)}")
		if base_nspc_new is not None and not (isinstance(base_nspc_new, str) or isinstance(base_nspc_new, ExplicitNull)):
			raise ValueError(f"'base_nspc' of incorrect type. Expected str, got {type(base_nspc_new)}")
		if json_name_new is not None and not (isinstance(json_name_new, str)):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(json_name_new)}")
		if is_primary_new is not None and not (isinstance(is_primary_new, bool)):
			raise ValueError(f"'is_primary' of incorrect type. Expected bool, got {type(is_primary_new)}")
		if text_length_new is not None and not (isinstance(text_length_new, int) or isinstance(text_length_new, ExplicitNull)):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(text_length_new)}")
		if pg_type_name_new is not None and not (isinstance(pg_type_name_new, str)):
			raise ValueError(f"'pg_type_name' of incorrect type. Expected str, got {type(pg_type_name_new)}")
		if pg_type_nspc_new is not None and not (isinstance(pg_type_nspc_new, str)):
			raise ValueError(f"'pg_type_nspc' of incorrect type. Expected str, got {type(pg_type_nspc_new)}")
		if format_literal_new is not None and not (isinstance(format_literal_new, str) or isinstance(format_literal_new, ExplicitNull)):
			raise ValueError(f"'format_literal' of incorrect type. Expected str, got {type(format_literal_new)}")
		if conv_daty_val_attname_new is not None and not (isinstance(conv_daty_val_attname_new, str)):
			raise ValueError(f"'conv_daty_val_attname' of incorrect type. Expected str, got {type(conv_daty_val_attname_new)}")
		if not (isinstance(pk_old, int)):
			raise ValueError(f"'pk' of incorrect type. Expected int, got {type(pk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(pk_new=pk_new, name_new=name_new, base_name_new=base_name_new, base_nspc_new=base_nspc_new, json_name_new=json_name_new, is_primary_new=is_primary_new, text_length_new=text_length_new, pg_type_name_new=pg_type_name_new, pg_type_nspc_new=pg_type_nspc_new, format_literal_new=format_literal_new, conv_daty_val_attname_new=conv_daty_val_attname_new, pk_old=pk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class ColumnKvtab(APIObject):
	gpk: str
	key: str
	position: int
	table_name: str
	column_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.key, str):
			raise ValueError(f"'key' of incorrect type. Expected str, got {type(self.key)}")
		if self.position is not None and not isinstance(self.position, int):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(self.position)}")
		if not isinstance(self.table_name, str):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(self.table_name)}")
		if not isinstance(self.column_name, str):
			raise ValueError(f"'column_name' of incorrect type. Expected str, got {type(self.column_name)}")

	@staticmethod
	def create_ta(key_new: str, table_name_new: str, column_name_new: str, position_new: Union[int, ExplicitNull] = None) -> dict:
		if not (isinstance(key_new, str)):
			raise ValueError(f"'key' of incorrect type. Expected str, got {type(key_new)}")
		if position_new is not None and not (isinstance(position_new, int) or isinstance(position_new, ExplicitNull)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if not (isinstance(column_name_new, str)):
			raise ValueError(f"'column_name' of incorrect type. Expected str, got {type(column_name_new)}")

		return {'name': 'cntl.column_kvtab.create', 'new': _denullify_dict({'key': key_new, 'position': position_new, 'table_name': table_name_new, 'column_name': column_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, key_new: str, table_name_new: str, column_name_new: str, position_new: Union[int, ExplicitNull] = None) -> list:
		if not (isinstance(key_new, str)):
			raise ValueError(f"'key' of incorrect type. Expected str, got {type(key_new)}")
		if position_new is not None and not (isinstance(position_new, int) or isinstance(position_new, ExplicitNull)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if not (isinstance(column_name_new, str)):
			raise ValueError(f"'column_name' of incorrect type. Expected str, got {type(column_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(key_new=key_new, position_new=position_new, table_name_new=table_name_new, column_name_new=column_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(key_old: str, table_name_old: str, column_name_old: str) -> dict:
		if not (isinstance(key_old, str)):
			raise ValueError(f"'key' of incorrect type. Expected str, got {type(key_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")
		if not (isinstance(column_name_old, str)):
			raise ValueError(f"'column_name' of incorrect type. Expected str, got {type(column_name_old)}")

		return {'name': 'cntl.column_kvtab.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'key': key_old, 'table_name': table_name_old, 'column_name': column_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, key_old: str, table_name_old: str, column_name_old: str) -> list:
		if not (isinstance(key_old, str)):
			raise ValueError(f"'key' of incorrect type. Expected str, got {type(key_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")
		if not (isinstance(column_name_old, str)):
			raise ValueError(f"'column_name' of incorrect type. Expected str, got {type(column_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(key_old=key_old, table_name_old=table_name_old, column_name_old=column_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_list_old: list = None, key_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, table_name_list_old: list = None, column_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if key_list_old is not None and not (isinstance(key_list_old, list)):
			raise ValueError(f"'key_list' of incorrect type. Expected list, got {type(key_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if table_name_list_old is not None and not (isinstance(table_name_list_old, list)):
			raise ValueError(f"'table_name_list' of incorrect type. Expected list, got {type(table_name_list_old)}")
		if column_name_list_old is not None and not (isinstance(column_name_list_old, list)):
			raise ValueError(f"'column_name_list' of incorrect type. Expected list, got {type(column_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.column_kvtab.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk_list': gpk_list_old, 'key_list': key_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'table_name_list': table_name_list_old, 'column_name_list': column_name_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_list_old: list = None, key_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, table_name_list_old: list = None, column_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if key_list_old is not None and not (isinstance(key_list_old, list)):
			raise ValueError(f"'key_list' of incorrect type. Expected list, got {type(key_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if table_name_list_old is not None and not (isinstance(table_name_list_old, list)):
			raise ValueError(f"'table_name_list' of incorrect type. Expected list, got {type(table_name_list_old)}")
		if column_name_list_old is not None and not (isinstance(column_name_list_old, list)):
			raise ValueError(f"'column_name_list' of incorrect type. Expected list, got {type(column_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_list_old=gpk_list_old, key_list_old=key_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, table_name_list_old=table_name_list_old, column_name_list_old=column_name_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(key_old: str, table_name_old: str, column_name_old: str, key_new: str = None, position_new: Union[int, ExplicitNull] = None) -> dict:
		if key_new is not None and not (isinstance(key_new, str)):
			raise ValueError(f"'key' of incorrect type. Expected str, got {type(key_new)}")
		if position_new is not None and not (isinstance(position_new, int) or isinstance(position_new, ExplicitNull)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if not (isinstance(key_old, str)):
			raise ValueError(f"'key' of incorrect type. Expected str, got {type(key_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")
		if not (isinstance(column_name_old, str)):
			raise ValueError(f"'column_name' of incorrect type. Expected str, got {type(column_name_old)}")

		return {'name': 'cntl.column_kvtab.update', 'new': _denullify_dict({'key': key_new, 'position': position_new}), 'old': _denullify_dict({'key': key_old, 'table_name': table_name_old, 'column_name': column_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, key_old: str, table_name_old: str, column_name_old: str, key_new: str = None, position_new: Union[int, ExplicitNull] = None) -> list:
		if key_new is not None and not (isinstance(key_new, str)):
			raise ValueError(f"'key' of incorrect type. Expected str, got {type(key_new)}")
		if position_new is not None and not (isinstance(position_new, int) or isinstance(position_new, ExplicitNull)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if not (isinstance(key_old, str)):
			raise ValueError(f"'key' of incorrect type. Expected str, got {type(key_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")
		if not (isinstance(column_name_old, str)):
			raise ValueError(f"'column_name' of incorrect type. Expected str, got {type(column_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(key_new=key_new, position_new=position_new, key_old=key_old, table_name_old=table_name_old, column_name_old=column_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class WapiAuth(APIObject):
	gpk: str
	type: str
	token: str
	is_own: bool
	is_expired: bool
	login_name: str
	delete_date: str
	description: str
	expiration_date: str
	last_login_date: str
	last_generate_date: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if not isinstance(self.token, str):
			raise ValueError(f"'token' of incorrect type. Expected str, got {type(self.token)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.is_expired, bool):
			raise ValueError(f"'is_expired' of incorrect type. Expected bool, got {type(self.is_expired)}")
		if not isinstance(self.login_name, str):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(self.login_name)}")
		if not isinstance(self.delete_date, str):
			raise ValueError(f"'delete_date' of incorrect type. Expected str, got {type(self.delete_date)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if self.expiration_date is not None and not isinstance(self.expiration_date, str):
			raise ValueError(f"'expiration_date' of incorrect type. Expected str, got {type(self.expiration_date)}")
		if self.last_login_date is not None and not isinstance(self.last_login_date, str):
			raise ValueError(f"'last_login_date' of incorrect type. Expected str, got {type(self.last_login_date)}")
		if not isinstance(self.last_generate_date, str):
			raise ValueError(f"'last_generate_date' of incorrect type. Expected str, got {type(self.last_generate_date)}")

	@staticmethod
	def create_ta(login_name_new: str, description_new: Union[str, ExplicitNull] = None, expiration_date_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(login_name_new, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if expiration_date_new is not None and not (isinstance(expiration_date_new, str) or isinstance(expiration_date_new, ExplicitNull)):
			raise ValueError(f"'expiration_date' of incorrect type. Expected str, got {type(expiration_date_new)}")

		return {'name': 'cntl.wapi_auth.create', 'new': _denullify_dict({'login_name': login_name_new, 'description': description_new, 'expiration_date': expiration_date_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, login_name_new: str, description_new: Union[str, ExplicitNull] = None, expiration_date_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(login_name_new, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if expiration_date_new is not None and not (isinstance(expiration_date_new, str) or isinstance(expiration_date_new, ExplicitNull)):
			raise ValueError(f"'expiration_date' of incorrect type. Expected str, got {type(expiration_date_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(login_name_new=login_name_new, description_new=description_new, expiration_date_new=expiration_date_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'cntl.wapi_auth.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(type_old: str = None, is_own_old: bool = None, gpk_list_old: list = None, is_expired_old: bool = None, login_name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if is_expired_old is not None and not (isinstance(is_expired_old, bool)):
			raise ValueError(f"'is_expired' of incorrect type. Expected bool, got {type(is_expired_old)}")
		if login_name_old is not None and not (isinstance(login_name_old, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.wapi_auth.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'type': type_old, 'is_own': is_own_old, 'gpk_list': gpk_list_old, 'is_expired': is_expired_old, 'login_name': login_name_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, type_old: str = None, is_own_old: bool = None, gpk_list_old: list = None, is_expired_old: bool = None, login_name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if is_expired_old is not None and not (isinstance(is_expired_old, bool)):
			raise ValueError(f"'is_expired' of incorrect type. Expected bool, got {type(is_expired_old)}")
		if login_name_old is not None and not (isinstance(login_name_old, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(type_old=type_old, is_own_old=is_own_old, gpk_list_old=gpk_list_old, is_expired_old=is_expired_old, login_name_old=login_name_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, description_new: Union[str, ExplicitNull] = None, expiration_date_new: Union[str, ExplicitNull] = None, do_refresh_token_new: bool = None) -> dict:
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if expiration_date_new is not None and not (isinstance(expiration_date_new, str) or isinstance(expiration_date_new, ExplicitNull)):
			raise ValueError(f"'expiration_date' of incorrect type. Expected str, got {type(expiration_date_new)}")
		if do_refresh_token_new is not None and not (isinstance(do_refresh_token_new, bool)):
			raise ValueError(f"'do_refresh_token' of incorrect type. Expected bool, got {type(do_refresh_token_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'cntl.wapi_auth.update', 'new': _denullify_dict({'description': description_new, 'expiration_date': expiration_date_new, 'do_refresh_token': do_refresh_token_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, description_new: Union[str, ExplicitNull] = None, expiration_date_new: Union[str, ExplicitNull] = None, do_refresh_token_new: bool = None) -> list:
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if expiration_date_new is not None and not (isinstance(expiration_date_new, str) or isinstance(expiration_date_new, ExplicitNull)):
			raise ValueError(f"'expiration_date' of incorrect type. Expected str, got {type(expiration_date_new)}")
		if do_refresh_token_new is not None and not (isinstance(do_refresh_token_new, bool)):
			raise ValueError(f"'do_refresh_token' of incorrect type. Expected bool, got {type(do_refresh_token_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(description_new=description_new, expiration_date_new=expiration_date_new, do_refresh_token_new=do_refresh_token_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Mgr2group(APIObject):
	gpk: str
	is_own: bool
	group_name: str
	mgr_login_name: str
	parent_group_name: str
	parent_mgr_login_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.group_name, str):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(self.group_name)}")
		if not isinstance(self.mgr_login_name, str):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(self.mgr_login_name)}")
		if not isinstance(self.parent_group_name, str):
			raise ValueError(f"'parent_group_name' of incorrect type. Expected str, got {type(self.parent_group_name)}")
		if self.parent_mgr_login_name is not None and not isinstance(self.parent_mgr_login_name, str):
			raise ValueError(f"'parent_mgr_login_name' of incorrect type. Expected str, got {type(self.parent_mgr_login_name)}")

	@staticmethod
	def create_ta(group_name_new: str, mgr_login_name_new: str) -> dict:
		if not (isinstance(group_name_new, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_new)}")
		if not (isinstance(mgr_login_name_new, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_new)}")

		return {'name': 'cntl.mgr2group.create', 'new': _denullify_dict({'group_name': group_name_new, 'mgr_login_name': mgr_login_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, group_name_new: str, mgr_login_name_new: str) -> list:
		if not (isinstance(group_name_new, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_new)}")
		if not (isinstance(mgr_login_name_new, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(group_name_new=group_name_new, mgr_login_name_new=mgr_login_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(group_name_old: str, mgr_login_name_old: str) -> dict:
		if not (isinstance(group_name_old, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_old)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")

		return {'name': 'cntl.mgr2group.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'group_name': group_name_old, 'mgr_login_name': mgr_login_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, group_name_old: str, mgr_login_name_old: str) -> list:
		if not (isinstance(group_name_old, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_old)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(group_name_old=group_name_old, mgr_login_name_old=mgr_login_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(is_own_old: bool = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, group_name_list_old: list = None, filter_params_dict_old: dict = None, mgr_login_name_list_old: list = None, sorting_params_list_old: list = None) -> dict:
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if group_name_list_old is not None and not (isinstance(group_name_list_old, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if mgr_login_name_list_old is not None and not (isinstance(mgr_login_name_list_old, list)):
			raise ValueError(f"'mgr_login_name_list' of incorrect type. Expected list, got {type(mgr_login_name_list_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.mgr2group.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'is_own': is_own_old, 'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'group_name_list': group_name_list_old, 'filter_params_dict': filter_params_dict_old, 'mgr_login_name_list': mgr_login_name_list_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, is_own_old: bool = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, group_name_list_old: list = None, filter_params_dict_old: dict = None, mgr_login_name_list_old: list = None, sorting_params_list_old: list = None) -> list:
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if group_name_list_old is not None and not (isinstance(group_name_list_old, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if mgr_login_name_list_old is not None and not (isinstance(mgr_login_name_list_old, list)):
			raise ValueError(f"'mgr_login_name_list' of incorrect type. Expected list, got {type(mgr_login_name_list_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(is_own_old=is_own_old, gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, group_name_list_old=group_name_list_old, filter_params_dict_old=filter_params_dict_old, mgr_login_name_list_old=mgr_login_name_list_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Group(APIObject):
	gpk: str
	name: str
	is_own: bool
	is_sub: bool
	sub_id: str
	is_admin: bool
	description: str
	do_idm_sync: bool
	parent_name: str
	ou_short_name: str
	idm_description: str
	idm_sync_last_ts: str
	idm_sync_is_active: bool
	idm_sync_last_state: str
	idm_sync_max_mgr_count: int
	content_is_rw_accessible: bool
	idm_sync_last_successful_ts: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.is_sub, bool):
			raise ValueError(f"'is_sub' of incorrect type. Expected bool, got {type(self.is_sub)}")
		if self.sub_id is not None and not isinstance(self.sub_id, str):
			raise ValueError(f"'sub_id' of incorrect type. Expected str, got {type(self.sub_id)}")
		if not isinstance(self.is_admin, bool):
			raise ValueError(f"'is_admin' of incorrect type. Expected bool, got {type(self.is_admin)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.do_idm_sync, bool):
			raise ValueError(f"'do_idm_sync' of incorrect type. Expected bool, got {type(self.do_idm_sync)}")
		if not isinstance(self.parent_name, str):
			raise ValueError(f"'parent_name' of incorrect type. Expected str, got {type(self.parent_name)}")
		if self.ou_short_name is not None and not isinstance(self.ou_short_name, str):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(self.ou_short_name)}")
		if self.idm_description is not None and not isinstance(self.idm_description, str):
			raise ValueError(f"'idm_description' of incorrect type. Expected str, got {type(self.idm_description)}")
		if self.idm_sync_last_ts is not None and not isinstance(self.idm_sync_last_ts, str):
			raise ValueError(f"'idm_sync_last_ts' of incorrect type. Expected str, got {type(self.idm_sync_last_ts)}")
		if not isinstance(self.idm_sync_is_active, bool):
			raise ValueError(f"'idm_sync_is_active' of incorrect type. Expected bool, got {type(self.idm_sync_is_active)}")
		if self.idm_sync_last_state is not None and not isinstance(self.idm_sync_last_state, str):
			raise ValueError(f"'idm_sync_last_state' of incorrect type. Expected str, got {type(self.idm_sync_last_state)}")
		if not isinstance(self.idm_sync_max_mgr_count, int):
			raise ValueError(f"'idm_sync_max_mgr_count' of incorrect type. Expected int, got {type(self.idm_sync_max_mgr_count)}")
		if not isinstance(self.content_is_rw_accessible, bool):
			raise ValueError(f"'content_is_rw_accessible' of incorrect type. Expected bool, got {type(self.content_is_rw_accessible)}")
		if self.idm_sync_last_successful_ts is not None and not isinstance(self.idm_sync_last_successful_ts, str):
			raise ValueError(f"'idm_sync_last_successful_ts' of incorrect type. Expected str, got {type(self.idm_sync_last_successful_ts)}")

	@staticmethod
	def create_ta(name_new: str = None, sub_id_new: Union[str, ExplicitNull] = None, description_new: Union[str, ExplicitNull] = None, do_idm_sync_new: bool = False, parent_name_new: str = None, ou_short_name_new: str = None, do_copy_assignments_new: bool = True, do_refresh_idm_sync_new: bool = False, idm_sync_max_mgr_count_new: int = 20, content_is_rw_accessible_new: bool = True) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if sub_id_new is not None and not (isinstance(sub_id_new, str) or isinstance(sub_id_new, ExplicitNull)):
			raise ValueError(f"'sub_id' of incorrect type. Expected str, got {type(sub_id_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_idm_sync_new is not None and not (isinstance(do_idm_sync_new, bool)):
			raise ValueError(f"'do_idm_sync' of incorrect type. Expected bool, got {type(do_idm_sync_new)}")
		if parent_name_new is not None and not (isinstance(parent_name_new, str)):
			raise ValueError(f"'parent_name' of incorrect type. Expected str, got {type(parent_name_new)}")
		if ou_short_name_new is not None and not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if do_copy_assignments_new is not None and not (isinstance(do_copy_assignments_new, bool)):
			raise ValueError(f"'do_copy_assignments' of incorrect type. Expected bool, got {type(do_copy_assignments_new)}")
		if do_refresh_idm_sync_new is not None and not (isinstance(do_refresh_idm_sync_new, bool)):
			raise ValueError(f"'do_refresh_idm_sync' of incorrect type. Expected bool, got {type(do_refresh_idm_sync_new)}")
		if idm_sync_max_mgr_count_new is not None and not (isinstance(idm_sync_max_mgr_count_new, int)):
			raise ValueError(f"'idm_sync_max_mgr_count' of incorrect type. Expected int, got {type(idm_sync_max_mgr_count_new)}")
		if content_is_rw_accessible_new is not None and not (isinstance(content_is_rw_accessible_new, bool)):
			raise ValueError(f"'content_is_rw_accessible' of incorrect type. Expected bool, got {type(content_is_rw_accessible_new)}")

		return {'name': 'cntl.group.create', 'new': _denullify_dict({'name': name_new, 'sub_id': sub_id_new, 'description': description_new, 'do_idm_sync': do_idm_sync_new, 'parent_name': parent_name_new, 'ou_short_name': ou_short_name_new, 'do_copy_assignments': do_copy_assignments_new, 'do_refresh_idm_sync': do_refresh_idm_sync_new, 'idm_sync_max_mgr_count': idm_sync_max_mgr_count_new, 'content_is_rw_accessible': content_is_rw_accessible_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str = None, sub_id_new: Union[str, ExplicitNull] = None, description_new: Union[str, ExplicitNull] = None, do_idm_sync_new: bool = False, parent_name_new: str = None, ou_short_name_new: str = None, do_copy_assignments_new: bool = True, do_refresh_idm_sync_new: bool = False, idm_sync_max_mgr_count_new: int = 20, content_is_rw_accessible_new: bool = True) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if sub_id_new is not None and not (isinstance(sub_id_new, str) or isinstance(sub_id_new, ExplicitNull)):
			raise ValueError(f"'sub_id' of incorrect type. Expected str, got {type(sub_id_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_idm_sync_new is not None and not (isinstance(do_idm_sync_new, bool)):
			raise ValueError(f"'do_idm_sync' of incorrect type. Expected bool, got {type(do_idm_sync_new)}")
		if parent_name_new is not None and not (isinstance(parent_name_new, str)):
			raise ValueError(f"'parent_name' of incorrect type. Expected str, got {type(parent_name_new)}")
		if ou_short_name_new is not None and not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if do_copy_assignments_new is not None and not (isinstance(do_copy_assignments_new, bool)):
			raise ValueError(f"'do_copy_assignments' of incorrect type. Expected bool, got {type(do_copy_assignments_new)}")
		if do_refresh_idm_sync_new is not None and not (isinstance(do_refresh_idm_sync_new, bool)):
			raise ValueError(f"'do_refresh_idm_sync' of incorrect type. Expected bool, got {type(do_refresh_idm_sync_new)}")
		if idm_sync_max_mgr_count_new is not None and not (isinstance(idm_sync_max_mgr_count_new, int)):
			raise ValueError(f"'idm_sync_max_mgr_count' of incorrect type. Expected int, got {type(idm_sync_max_mgr_count_new)}")
		if content_is_rw_accessible_new is not None and not (isinstance(content_is_rw_accessible_new, bool)):
			raise ValueError(f"'content_is_rw_accessible' of incorrect type. Expected bool, got {type(content_is_rw_accessible_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, sub_id_new=sub_id_new, description_new=description_new, do_idm_sync_new=do_idm_sync_new, parent_name_new=parent_name_new, ou_short_name_new=ou_short_name_new, do_copy_assignments_new=do_copy_assignments_new, do_refresh_idm_sync_new=do_refresh_idm_sync_new, idm_sync_max_mgr_count_new=idm_sync_max_mgr_count_new, content_is_rw_accessible_new=content_is_rw_accessible_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'cntl.group.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(is_own_old: bool = None, is_sub_old: bool = None, sub_id_old: str = None, gpk_list_old: list = None, is_admin_old: bool = None, name_list_old: list = None, do_idm_sync_old: bool = None, fetch_limit_old: int = None, name_regexp_old: str = None, sub_id_list_old: list = None, fetch_offset_old: int = None, ou_short_name_old: str = None, sub_id_regexp_old: str = None, parent_name_list_old: list = None, filter_params_dict_old: dict = None, idm_sync_is_active_old: bool = None, is_admin_or_is_own_old: bool = None, sorting_params_list_old: list = None, content_is_rw_accessible_old: bool = None) -> dict:
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_sub_old is not None and not (isinstance(is_sub_old, bool)):
			raise ValueError(f"'is_sub' of incorrect type. Expected bool, got {type(is_sub_old)}")
		if sub_id_old is not None and not (isinstance(sub_id_old, str) or isinstance(sub_id_old, ExplicitNull)):
			raise ValueError(f"'sub_id' of incorrect type. Expected str, got {type(sub_id_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if is_admin_old is not None and not (isinstance(is_admin_old, bool)):
			raise ValueError(f"'is_admin' of incorrect type. Expected bool, got {type(is_admin_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if do_idm_sync_old is not None and not (isinstance(do_idm_sync_old, bool)):
			raise ValueError(f"'do_idm_sync' of incorrect type. Expected bool, got {type(do_idm_sync_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if name_regexp_old is not None and not (isinstance(name_regexp_old, str)):
			raise ValueError(f"'name_regexp' of incorrect type. Expected str, got {type(name_regexp_old)}")
		if sub_id_list_old is not None and not (isinstance(sub_id_list_old, list)):
			raise ValueError(f"'sub_id_list' of incorrect type. Expected list, got {type(sub_id_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if ou_short_name_old is not None and not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if sub_id_regexp_old is not None and not (isinstance(sub_id_regexp_old, str)):
			raise ValueError(f"'sub_id_regexp' of incorrect type. Expected str, got {type(sub_id_regexp_old)}")
		if parent_name_list_old is not None and not (isinstance(parent_name_list_old, list)):
			raise ValueError(f"'parent_name_list' of incorrect type. Expected list, got {type(parent_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if idm_sync_is_active_old is not None and not (isinstance(idm_sync_is_active_old, bool)):
			raise ValueError(f"'idm_sync_is_active' of incorrect type. Expected bool, got {type(idm_sync_is_active_old)}")
		if is_admin_or_is_own_old is not None and not (isinstance(is_admin_or_is_own_old, bool)):
			raise ValueError(f"'is_admin_or_is_own' of incorrect type. Expected bool, got {type(is_admin_or_is_own_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if content_is_rw_accessible_old is not None and not (isinstance(content_is_rw_accessible_old, bool)):
			raise ValueError(f"'content_is_rw_accessible' of incorrect type. Expected bool, got {type(content_is_rw_accessible_old)}")

		return {'name': 'cntl.group.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'is_own': is_own_old, 'is_sub': is_sub_old, 'sub_id': sub_id_old, 'gpk_list': gpk_list_old, 'is_admin': is_admin_old, 'name_list': name_list_old, 'do_idm_sync': do_idm_sync_old, 'fetch_limit': fetch_limit_old, 'name_regexp': name_regexp_old, 'sub_id_list': sub_id_list_old, 'fetch_offset': fetch_offset_old, 'ou_short_name': ou_short_name_old, 'sub_id_regexp': sub_id_regexp_old, 'parent_name_list': parent_name_list_old, 'filter_params_dict': filter_params_dict_old, 'idm_sync_is_active': idm_sync_is_active_old, 'is_admin_or_is_own': is_admin_or_is_own_old, 'sorting_params_list': sorting_params_list_old, 'content_is_rw_accessible': content_is_rw_accessible_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, is_own_old: bool = None, is_sub_old: bool = None, sub_id_old: str = None, gpk_list_old: list = None, is_admin_old: bool = None, name_list_old: list = None, do_idm_sync_old: bool = None, fetch_limit_old: int = None, name_regexp_old: str = None, sub_id_list_old: list = None, fetch_offset_old: int = None, ou_short_name_old: str = None, sub_id_regexp_old: str = None, parent_name_list_old: list = None, filter_params_dict_old: dict = None, idm_sync_is_active_old: bool = None, is_admin_or_is_own_old: bool = None, sorting_params_list_old: list = None, content_is_rw_accessible_old: bool = None) -> list:
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_sub_old is not None and not (isinstance(is_sub_old, bool)):
			raise ValueError(f"'is_sub' of incorrect type. Expected bool, got {type(is_sub_old)}")
		if sub_id_old is not None and not (isinstance(sub_id_old, str) or isinstance(sub_id_old, ExplicitNull)):
			raise ValueError(f"'sub_id' of incorrect type. Expected str, got {type(sub_id_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if is_admin_old is not None and not (isinstance(is_admin_old, bool)):
			raise ValueError(f"'is_admin' of incorrect type. Expected bool, got {type(is_admin_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if do_idm_sync_old is not None and not (isinstance(do_idm_sync_old, bool)):
			raise ValueError(f"'do_idm_sync' of incorrect type. Expected bool, got {type(do_idm_sync_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if name_regexp_old is not None and not (isinstance(name_regexp_old, str)):
			raise ValueError(f"'name_regexp' of incorrect type. Expected str, got {type(name_regexp_old)}")
		if sub_id_list_old is not None and not (isinstance(sub_id_list_old, list)):
			raise ValueError(f"'sub_id_list' of incorrect type. Expected list, got {type(sub_id_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if ou_short_name_old is not None and not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if sub_id_regexp_old is not None and not (isinstance(sub_id_regexp_old, str)):
			raise ValueError(f"'sub_id_regexp' of incorrect type. Expected str, got {type(sub_id_regexp_old)}")
		if parent_name_list_old is not None and not (isinstance(parent_name_list_old, list)):
			raise ValueError(f"'parent_name_list' of incorrect type. Expected list, got {type(parent_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if idm_sync_is_active_old is not None and not (isinstance(idm_sync_is_active_old, bool)):
			raise ValueError(f"'idm_sync_is_active' of incorrect type. Expected bool, got {type(idm_sync_is_active_old)}")
		if is_admin_or_is_own_old is not None and not (isinstance(is_admin_or_is_own_old, bool)):
			raise ValueError(f"'is_admin_or_is_own' of incorrect type. Expected bool, got {type(is_admin_or_is_own_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if content_is_rw_accessible_old is not None and not (isinstance(content_is_rw_accessible_old, bool)):
			raise ValueError(f"'content_is_rw_accessible' of incorrect type. Expected bool, got {type(content_is_rw_accessible_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(is_own_old=is_own_old, is_sub_old=is_sub_old, sub_id_old=sub_id_old, gpk_list_old=gpk_list_old, is_admin_old=is_admin_old, name_list_old=name_list_old, do_idm_sync_old=do_idm_sync_old, fetch_limit_old=fetch_limit_old, name_regexp_old=name_regexp_old, sub_id_list_old=sub_id_list_old, fetch_offset_old=fetch_offset_old, ou_short_name_old=ou_short_name_old, sub_id_regexp_old=sub_id_regexp_old, parent_name_list_old=parent_name_list_old, filter_params_dict_old=filter_params_dict_old, idm_sync_is_active_old=idm_sync_is_active_old, is_admin_or_is_own_old=is_admin_or_is_own_old, sorting_params_list_old=sorting_params_list_old, content_is_rw_accessible_old=content_is_rw_accessible_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, sub_id_new: Union[str, ExplicitNull] = None, description_new: Union[str, ExplicitNull] = None, do_idm_sync_new: bool = None, ou_short_name_new: str = None, do_refresh_idm_sync_new: bool = None, idm_sync_max_mgr_count_new: int = None, content_is_rw_accessible_new: bool = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if sub_id_new is not None and not (isinstance(sub_id_new, str) or isinstance(sub_id_new, ExplicitNull)):
			raise ValueError(f"'sub_id' of incorrect type. Expected str, got {type(sub_id_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_idm_sync_new is not None and not (isinstance(do_idm_sync_new, bool)):
			raise ValueError(f"'do_idm_sync' of incorrect type. Expected bool, got {type(do_idm_sync_new)}")
		if ou_short_name_new is not None and not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if do_refresh_idm_sync_new is not None and not (isinstance(do_refresh_idm_sync_new, bool)):
			raise ValueError(f"'do_refresh_idm_sync' of incorrect type. Expected bool, got {type(do_refresh_idm_sync_new)}")
		if idm_sync_max_mgr_count_new is not None and not (isinstance(idm_sync_max_mgr_count_new, int)):
			raise ValueError(f"'idm_sync_max_mgr_count' of incorrect type. Expected int, got {type(idm_sync_max_mgr_count_new)}")
		if content_is_rw_accessible_new is not None and not (isinstance(content_is_rw_accessible_new, bool)):
			raise ValueError(f"'content_is_rw_accessible' of incorrect type. Expected bool, got {type(content_is_rw_accessible_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'cntl.group.update', 'new': _denullify_dict({'name': name_new, 'sub_id': sub_id_new, 'description': description_new, 'do_idm_sync': do_idm_sync_new, 'ou_short_name': ou_short_name_new, 'do_refresh_idm_sync': do_refresh_idm_sync_new, 'idm_sync_max_mgr_count': idm_sync_max_mgr_count_new, 'content_is_rw_accessible': content_is_rw_accessible_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, sub_id_new: Union[str, ExplicitNull] = None, description_new: Union[str, ExplicitNull] = None, do_idm_sync_new: bool = None, ou_short_name_new: str = None, do_refresh_idm_sync_new: bool = None, idm_sync_max_mgr_count_new: int = None, content_is_rw_accessible_new: bool = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if sub_id_new is not None and not (isinstance(sub_id_new, str) or isinstance(sub_id_new, ExplicitNull)):
			raise ValueError(f"'sub_id' of incorrect type. Expected str, got {type(sub_id_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_idm_sync_new is not None and not (isinstance(do_idm_sync_new, bool)):
			raise ValueError(f"'do_idm_sync' of incorrect type. Expected bool, got {type(do_idm_sync_new)}")
		if ou_short_name_new is not None and not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if do_refresh_idm_sync_new is not None and not (isinstance(do_refresh_idm_sync_new, bool)):
			raise ValueError(f"'do_refresh_idm_sync' of incorrect type. Expected bool, got {type(do_refresh_idm_sync_new)}")
		if idm_sync_max_mgr_count_new is not None and not (isinstance(idm_sync_max_mgr_count_new, int)):
			raise ValueError(f"'idm_sync_max_mgr_count' of incorrect type. Expected int, got {type(idm_sync_max_mgr_count_new)}")
		if content_is_rw_accessible_new is not None and not (isinstance(content_is_rw_accessible_new, bool)):
			raise ValueError(f"'content_is_rw_accessible' of incorrect type. Expected bool, got {type(content_is_rw_accessible_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, sub_id_new=sub_id_new, description_new=description_new, do_idm_sync_new=do_idm_sync_new, ou_short_name_new=ou_short_name_new, do_refresh_idm_sync_new=do_refresh_idm_sync_new, idm_sync_max_mgr_count_new=idm_sync_max_mgr_count_new, content_is_rw_accessible_new=content_is_rw_accessible_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Mgr2ou(APIObject):
	gpk: str
	is_own: bool
	is_sub: bool
	ou_short_name: str
	mgr_login_name: str
	parent_ou_short_name: str
	parent_mgr_login_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.is_sub, bool):
			raise ValueError(f"'is_sub' of incorrect type. Expected bool, got {type(self.is_sub)}")
		if not isinstance(self.ou_short_name, str):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(self.ou_short_name)}")
		if not isinstance(self.mgr_login_name, str):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(self.mgr_login_name)}")
		if not isinstance(self.parent_ou_short_name, str):
			raise ValueError(f"'parent_ou_short_name' of incorrect type. Expected str, got {type(self.parent_ou_short_name)}")
		if not isinstance(self.parent_mgr_login_name, str):
			raise ValueError(f"'parent_mgr_login_name' of incorrect type. Expected str, got {type(self.parent_mgr_login_name)}")

	@staticmethod
	def create_ta(ou_short_name_new: str, mgr_login_name_new: str) -> dict:
		if not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if not (isinstance(mgr_login_name_new, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_new)}")

		return {'name': 'cntl.mgr2ou.create', 'new': _denullify_dict({'ou_short_name': ou_short_name_new, 'mgr_login_name': mgr_login_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, ou_short_name_new: str, mgr_login_name_new: str) -> list:
		if not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if not (isinstance(mgr_login_name_new, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(ou_short_name_new=ou_short_name_new, mgr_login_name_new=mgr_login_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(ou_short_name_old: str, mgr_login_name_old: str) -> dict:
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")

		return {'name': 'cntl.mgr2ou.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'ou_short_name': ou_short_name_old, 'mgr_login_name': mgr_login_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, ou_short_name_old: str, mgr_login_name_old: str) -> list:
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(ou_short_name_old=ou_short_name_old, mgr_login_name_old=mgr_login_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(is_own_old: bool = None, is_sub_old: bool = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, ou_short_name_list_old: list = None, mgr_login_name_list_old: list = None, sorting_params_list_old: list = None) -> dict:
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_sub_old is not None and not (isinstance(is_sub_old, bool)):
			raise ValueError(f"'is_sub' of incorrect type. Expected bool, got {type(is_sub_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if ou_short_name_list_old is not None and not (isinstance(ou_short_name_list_old, list)):
			raise ValueError(f"'ou_short_name_list' of incorrect type. Expected list, got {type(ou_short_name_list_old)}")
		if mgr_login_name_list_old is not None and not (isinstance(mgr_login_name_list_old, list)):
			raise ValueError(f"'mgr_login_name_list' of incorrect type. Expected list, got {type(mgr_login_name_list_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.mgr2ou.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'is_own': is_own_old, 'is_sub': is_sub_old, 'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'ou_short_name_list': ou_short_name_list_old, 'mgr_login_name_list': mgr_login_name_list_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, is_own_old: bool = None, is_sub_old: bool = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, ou_short_name_list_old: list = None, mgr_login_name_list_old: list = None, sorting_params_list_old: list = None) -> list:
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_sub_old is not None and not (isinstance(is_sub_old, bool)):
			raise ValueError(f"'is_sub' of incorrect type. Expected bool, got {type(is_sub_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if ou_short_name_list_old is not None and not (isinstance(ou_short_name_list_old, list)):
			raise ValueError(f"'ou_short_name_list' of incorrect type. Expected list, got {type(ou_short_name_list_old)}")
		if mgr_login_name_list_old is not None and not (isinstance(mgr_login_name_list_old, list)):
			raise ValueError(f"'mgr_login_name_list' of incorrect type. Expected list, got {type(mgr_login_name_list_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(is_own_old=is_own_old, is_sub_old=is_sub_old, gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, ou_short_name_list_old=ou_short_name_list_old, mgr_login_name_list_old=mgr_login_name_list_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(ou_short_name_new: str, ou_short_name_old: str, mgr_login_name_old: str) -> dict:
		if not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")

		return {'name': 'cntl.mgr2ou.update', 'new': _denullify_dict({'ou_short_name': ou_short_name_new}), 'old': _denullify_dict({'ou_short_name': ou_short_name_old, 'mgr_login_name': mgr_login_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, ou_short_name_new: str, ou_short_name_old: str, mgr_login_name_old: str) -> list:
		if not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(ou_short_name_new=ou_short_name_new, ou_short_name_old=ou_short_name_old, mgr_login_name_old=mgr_login_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class OtAttrDef(APIObject):
	gpk: str
	key_word: str
	data_type: str
	object_type_fq_name: str
	ins_trg_func_fq_name: str
	upd_trg_func_fq_name: str
	ref_object_type_fq_name: str
	object_type_ref_attribute_name: str
	object_type_api_ref_constraint_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.key_word, str):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(self.key_word)}")
		if not isinstance(self.data_type, str):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(self.data_type)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")
		if self.ins_trg_func_fq_name is not None and not isinstance(self.ins_trg_func_fq_name, str):
			raise ValueError(f"'ins_trg_func_fq_name' of incorrect type. Expected str, got {type(self.ins_trg_func_fq_name)}")
		if self.upd_trg_func_fq_name is not None and not isinstance(self.upd_trg_func_fq_name, str):
			raise ValueError(f"'upd_trg_func_fq_name' of incorrect type. Expected str, got {type(self.upd_trg_func_fq_name)}")
		if not isinstance(self.ref_object_type_fq_name, str):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(self.ref_object_type_fq_name)}")
		if not isinstance(self.object_type_ref_attribute_name, str):
			raise ValueError(f"'object_type_ref_attribute_name' of incorrect type. Expected str, got {type(self.object_type_ref_attribute_name)}")
		if not isinstance(self.object_type_api_ref_constraint_name, str):
			raise ValueError(f"'object_type_api_ref_constraint_name' of incorrect type. Expected str, got {type(self.object_type_api_ref_constraint_name)}")

	@staticmethod
	def create_ta(key_word_new: str, data_type_new: str, object_type_fq_name_new: str, ref_object_type_fq_name_new: str, object_type_api_ref_constraint_name_new: str, ins_trg_func_fq_name_new: Union[str, ExplicitNull] = None, upd_trg_func_fq_name_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(key_word_new, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_new)}")
		if not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if ins_trg_func_fq_name_new is not None and not (isinstance(ins_trg_func_fq_name_new, str) or isinstance(ins_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'ins_trg_func_fq_name' of incorrect type. Expected str, got {type(ins_trg_func_fq_name_new)}")
		if upd_trg_func_fq_name_new is not None and not (isinstance(upd_trg_func_fq_name_new, str) or isinstance(upd_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'upd_trg_func_fq_name' of incorrect type. Expected str, got {type(upd_trg_func_fq_name_new)}")
		if not (isinstance(ref_object_type_fq_name_new, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_new)}")
		if not (isinstance(object_type_api_ref_constraint_name_new, str)):
			raise ValueError(f"'object_type_api_ref_constraint_name' of incorrect type. Expected str, got {type(object_type_api_ref_constraint_name_new)}")

		return {'name': 'cntl.ot_attr_def.create', 'new': _denullify_dict({'key_word': key_word_new, 'data_type': data_type_new, 'object_type_fq_name': object_type_fq_name_new, 'ins_trg_func_fq_name': ins_trg_func_fq_name_new, 'upd_trg_func_fq_name': upd_trg_func_fq_name_new, 'ref_object_type_fq_name': ref_object_type_fq_name_new, 'object_type_api_ref_constraint_name': object_type_api_ref_constraint_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, key_word_new: str, data_type_new: str, object_type_fq_name_new: str, ref_object_type_fq_name_new: str, object_type_api_ref_constraint_name_new: str, ins_trg_func_fq_name_new: Union[str, ExplicitNull] = None, upd_trg_func_fq_name_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(key_word_new, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_new)}")
		if not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if ins_trg_func_fq_name_new is not None and not (isinstance(ins_trg_func_fq_name_new, str) or isinstance(ins_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'ins_trg_func_fq_name' of incorrect type. Expected str, got {type(ins_trg_func_fq_name_new)}")
		if upd_trg_func_fq_name_new is not None and not (isinstance(upd_trg_func_fq_name_new, str) or isinstance(upd_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'upd_trg_func_fq_name' of incorrect type. Expected str, got {type(upd_trg_func_fq_name_new)}")
		if not (isinstance(ref_object_type_fq_name_new, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_new)}")
		if not (isinstance(object_type_api_ref_constraint_name_new, str)):
			raise ValueError(f"'object_type_api_ref_constraint_name' of incorrect type. Expected str, got {type(object_type_api_ref_constraint_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(key_word_new=key_word_new, data_type_new=data_type_new, object_type_fq_name_new=object_type_fq_name_new, ins_trg_func_fq_name_new=ins_trg_func_fq_name_new, upd_trg_func_fq_name_new=upd_trg_func_fq_name_new, ref_object_type_fq_name_new=ref_object_type_fq_name_new, object_type_api_ref_constraint_name_new=object_type_api_ref_constraint_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(key_word_old: str, object_type_fq_name_old: str) -> dict:
		if not (isinstance(key_word_old, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")

		return {'name': 'cntl.ot_attr_def.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'key_word': key_word_old, 'object_type_fq_name': object_type_fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, key_word_old: str, object_type_fq_name_old: str) -> list:
		if not (isinstance(key_word_old, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(key_word_old=key_word_old, object_type_fq_name_old=object_type_fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, key_word_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, ref_object_type_fq_name_old: str = None, object_type_fq_name_list_old: list = None) -> dict:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if key_word_list_old is not None and not (isinstance(key_word_list_old, list)):
			raise ValueError(f"'key_word_list' of incorrect type. Expected list, got {type(key_word_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if ref_object_type_fq_name_old is not None and not (isinstance(ref_object_type_fq_name_old, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_old)}")
		if object_type_fq_name_list_old is not None and not (isinstance(object_type_fq_name_list_old, list)):
			raise ValueError(f"'object_type_fq_name_list' of incorrect type. Expected list, got {type(object_type_fq_name_list_old)}")

		return {'name': 'cntl.ot_attr_def.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'key_word_list': key_word_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'ref_object_type_fq_name': ref_object_type_fq_name_old, 'object_type_fq_name_list': object_type_fq_name_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, key_word_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, ref_object_type_fq_name_old: str = None, object_type_fq_name_list_old: list = None) -> list:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if key_word_list_old is not None and not (isinstance(key_word_list_old, list)):
			raise ValueError(f"'key_word_list' of incorrect type. Expected list, got {type(key_word_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if ref_object_type_fq_name_old is not None and not (isinstance(ref_object_type_fq_name_old, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_old)}")
		if object_type_fq_name_list_old is not None and not (isinstance(object_type_fq_name_list_old, list)):
			raise ValueError(f"'object_type_fq_name_list' of incorrect type. Expected list, got {type(object_type_fq_name_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, key_word_list_old=key_word_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, ref_object_type_fq_name_old=ref_object_type_fq_name_old, object_type_fq_name_list_old=object_type_fq_name_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(key_word_old: str, object_type_fq_name_old: str, key_word_new: str = None, data_type_new: str = None, object_type_fq_name_new: str = None, ins_trg_func_fq_name_new: Union[str, ExplicitNull] = None, upd_trg_func_fq_name_new: Union[str, ExplicitNull] = None, ref_object_type_fq_name_new: str = None, object_type_api_ref_constraint_name_new: str = None) -> dict:
		if key_word_new is not None and not (isinstance(key_word_new, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_new)}")
		if data_type_new is not None and not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if object_type_fq_name_new is not None and not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if ins_trg_func_fq_name_new is not None and not (isinstance(ins_trg_func_fq_name_new, str) or isinstance(ins_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'ins_trg_func_fq_name' of incorrect type. Expected str, got {type(ins_trg_func_fq_name_new)}")
		if upd_trg_func_fq_name_new is not None and not (isinstance(upd_trg_func_fq_name_new, str) or isinstance(upd_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'upd_trg_func_fq_name' of incorrect type. Expected str, got {type(upd_trg_func_fq_name_new)}")
		if ref_object_type_fq_name_new is not None and not (isinstance(ref_object_type_fq_name_new, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_new)}")
		if object_type_api_ref_constraint_name_new is not None and not (isinstance(object_type_api_ref_constraint_name_new, str)):
			raise ValueError(f"'object_type_api_ref_constraint_name' of incorrect type. Expected str, got {type(object_type_api_ref_constraint_name_new)}")
		if not (isinstance(key_word_old, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")

		return {'name': 'cntl.ot_attr_def.update', 'new': _denullify_dict({'key_word': key_word_new, 'data_type': data_type_new, 'object_type_fq_name': object_type_fq_name_new, 'ins_trg_func_fq_name': ins_trg_func_fq_name_new, 'upd_trg_func_fq_name': upd_trg_func_fq_name_new, 'ref_object_type_fq_name': ref_object_type_fq_name_new, 'object_type_api_ref_constraint_name': object_type_api_ref_constraint_name_new}), 'old': _denullify_dict({'key_word': key_word_old, 'object_type_fq_name': object_type_fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, key_word_old: str, object_type_fq_name_old: str, key_word_new: str = None, data_type_new: str = None, object_type_fq_name_new: str = None, ins_trg_func_fq_name_new: Union[str, ExplicitNull] = None, upd_trg_func_fq_name_new: Union[str, ExplicitNull] = None, ref_object_type_fq_name_new: str = None, object_type_api_ref_constraint_name_new: str = None) -> list:
		if key_word_new is not None and not (isinstance(key_word_new, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_new)}")
		if data_type_new is not None and not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if object_type_fq_name_new is not None and not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if ins_trg_func_fq_name_new is not None and not (isinstance(ins_trg_func_fq_name_new, str) or isinstance(ins_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'ins_trg_func_fq_name' of incorrect type. Expected str, got {type(ins_trg_func_fq_name_new)}")
		if upd_trg_func_fq_name_new is not None and not (isinstance(upd_trg_func_fq_name_new, str) or isinstance(upd_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'upd_trg_func_fq_name' of incorrect type. Expected str, got {type(upd_trg_func_fq_name_new)}")
		if ref_object_type_fq_name_new is not None and not (isinstance(ref_object_type_fq_name_new, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_new)}")
		if object_type_api_ref_constraint_name_new is not None and not (isinstance(object_type_api_ref_constraint_name_new, str)):
			raise ValueError(f"'object_type_api_ref_constraint_name' of incorrect type. Expected str, got {type(object_type_api_ref_constraint_name_new)}")
		if not (isinstance(key_word_old, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(key_word_new=key_word_new, data_type_new=data_type_new, object_type_fq_name_new=object_type_fq_name_new, ins_trg_func_fq_name_new=ins_trg_func_fq_name_new, upd_trg_func_fq_name_new=upd_trg_func_fq_name_new, ref_object_type_fq_name_new=ref_object_type_fq_name_new, object_type_api_ref_constraint_name_new=object_type_api_ref_constraint_name_new, key_word_old=key_word_old, object_type_fq_name_old=object_type_fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class OtAttrKey(APIObject):
	gpk: str
	set_mode: int
	display_mode: int
	default_value: str
	val_is_unique: bool
	ref_object_gfk: str
	val_is_nullable: bool
	display_position: int
	permission_fq_name: str
	object_type_fq_name: str
	ot_attr_def_key_word: str
	ref_object_type_fq_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.set_mode, int):
			raise ValueError(f"'set_mode' of incorrect type. Expected int, got {type(self.set_mode)}")
		if not isinstance(self.display_mode, int):
			raise ValueError(f"'display_mode' of incorrect type. Expected int, got {type(self.display_mode)}")
		if self.default_value is not None and not isinstance(self.default_value, str):
			raise ValueError(f"'default_value' of incorrect type. Expected str, got {type(self.default_value)}")
		if not isinstance(self.val_is_unique, bool):
			raise ValueError(f"'val_is_unique' of incorrect type. Expected bool, got {type(self.val_is_unique)}")
		if self.ref_object_gfk is not None and not isinstance(self.ref_object_gfk, str):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(self.ref_object_gfk)}")
		if not isinstance(self.val_is_nullable, bool):
			raise ValueError(f"'val_is_nullable' of incorrect type. Expected bool, got {type(self.val_is_nullable)}")
		if not isinstance(self.display_position, int):
			raise ValueError(f"'display_position' of incorrect type. Expected int, got {type(self.display_position)}")
		if self.permission_fq_name is not None and not isinstance(self.permission_fq_name, str):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(self.permission_fq_name)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")
		if not isinstance(self.ot_attr_def_key_word, str):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(self.ot_attr_def_key_word)}")
		if not isinstance(self.ref_object_type_fq_name, str):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(self.ref_object_type_fq_name)}")

	@staticmethod
	def create_ta(display_position_new: int, object_type_fq_name_new: str, ot_attr_def_key_word_new: str, set_mode_new: int = 0, display_mode_new: int = 0, default_value_new: Union[str, ExplicitNull] = None, val_is_unique_new: bool = False, ref_object_gfk_new: Union[str, ExplicitNull] = None, val_is_nullable_new: bool = True, permission_fq_name_new: Union[str, ExplicitNull] = None) -> dict:
		if set_mode_new is not None and not (isinstance(set_mode_new, int)):
			raise ValueError(f"'set_mode' of incorrect type. Expected int, got {type(set_mode_new)}")
		if display_mode_new is not None and not (isinstance(display_mode_new, int)):
			raise ValueError(f"'display_mode' of incorrect type. Expected int, got {type(display_mode_new)}")
		if default_value_new is not None and not (isinstance(default_value_new, str) or isinstance(default_value_new, ExplicitNull)):
			raise ValueError(f"'default_value' of incorrect type. Expected str, got {type(default_value_new)}")
		if val_is_unique_new is not None and not (isinstance(val_is_unique_new, bool)):
			raise ValueError(f"'val_is_unique' of incorrect type. Expected bool, got {type(val_is_unique_new)}")
		if ref_object_gfk_new is not None and not (isinstance(ref_object_gfk_new, str) or isinstance(ref_object_gfk_new, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_new)}")
		if val_is_nullable_new is not None and not (isinstance(val_is_nullable_new, bool)):
			raise ValueError(f"'val_is_nullable' of incorrect type. Expected bool, got {type(val_is_nullable_new)}")
		if not (isinstance(display_position_new, int)):
			raise ValueError(f"'display_position' of incorrect type. Expected int, got {type(display_position_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if not (isinstance(ot_attr_def_key_word_new, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_new)}")

		return {'name': 'cntl.ot_attr_key.create', 'new': _denullify_dict({'set_mode': set_mode_new, 'display_mode': display_mode_new, 'default_value': default_value_new, 'val_is_unique': val_is_unique_new, 'ref_object_gfk': ref_object_gfk_new, 'val_is_nullable': val_is_nullable_new, 'display_position': display_position_new, 'permission_fq_name': permission_fq_name_new, 'object_type_fq_name': object_type_fq_name_new, 'ot_attr_def_key_word': ot_attr_def_key_word_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, display_position_new: int, object_type_fq_name_new: str, ot_attr_def_key_word_new: str, set_mode_new: int = 0, display_mode_new: int = 0, default_value_new: Union[str, ExplicitNull] = None, val_is_unique_new: bool = False, ref_object_gfk_new: Union[str, ExplicitNull] = None, val_is_nullable_new: bool = True, permission_fq_name_new: Union[str, ExplicitNull] = None) -> list:
		if set_mode_new is not None and not (isinstance(set_mode_new, int)):
			raise ValueError(f"'set_mode' of incorrect type. Expected int, got {type(set_mode_new)}")
		if display_mode_new is not None and not (isinstance(display_mode_new, int)):
			raise ValueError(f"'display_mode' of incorrect type. Expected int, got {type(display_mode_new)}")
		if default_value_new is not None and not (isinstance(default_value_new, str) or isinstance(default_value_new, ExplicitNull)):
			raise ValueError(f"'default_value' of incorrect type. Expected str, got {type(default_value_new)}")
		if val_is_unique_new is not None and not (isinstance(val_is_unique_new, bool)):
			raise ValueError(f"'val_is_unique' of incorrect type. Expected bool, got {type(val_is_unique_new)}")
		if ref_object_gfk_new is not None and not (isinstance(ref_object_gfk_new, str) or isinstance(ref_object_gfk_new, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_new)}")
		if val_is_nullable_new is not None and not (isinstance(val_is_nullable_new, bool)):
			raise ValueError(f"'val_is_nullable' of incorrect type. Expected bool, got {type(val_is_nullable_new)}")
		if not (isinstance(display_position_new, int)):
			raise ValueError(f"'display_position' of incorrect type. Expected int, got {type(display_position_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if not (isinstance(ot_attr_def_key_word_new, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(set_mode_new=set_mode_new, display_mode_new=display_mode_new, default_value_new=default_value_new, val_is_unique_new=val_is_unique_new, ref_object_gfk_new=ref_object_gfk_new, val_is_nullable_new=val_is_nullable_new, display_position_new=display_position_new, permission_fq_name_new=permission_fq_name_new, object_type_fq_name_new=object_type_fq_name_new, ot_attr_def_key_word_new=ot_attr_def_key_word_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(object_type_fq_name_old: str, ot_attr_def_key_word_old: str, ref_object_gfk_old: str = None) -> dict:
		if ref_object_gfk_old is not None and not (isinstance(ref_object_gfk_old, str) or isinstance(ref_object_gfk_old, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")

		return {'name': 'cntl.ot_attr_key.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'ref_object_gfk': ref_object_gfk_old, 'object_type_fq_name': object_type_fq_name_old, 'ot_attr_def_key_word': ot_attr_def_key_word_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, object_type_fq_name_old: str, ot_attr_def_key_word_old: str, ref_object_gfk_old: str = None) -> list:
		if ref_object_gfk_old is not None and not (isinstance(ref_object_gfk_old, str) or isinstance(ref_object_gfk_old, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(ref_object_gfk_old=ref_object_gfk_old, object_type_fq_name_old=object_type_fq_name_old, ot_attr_def_key_word_old=ot_attr_def_key_word_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, ref_object_gfk_list_old: list = None, sorting_params_list_old: list = None, ref_object_type_fq_name_old: str = None, object_type_fq_name_list_old: list = None, ot_attr_def_key_word_list_old: list = None) -> dict:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if ref_object_gfk_list_old is not None and not (isinstance(ref_object_gfk_list_old, list)):
			raise ValueError(f"'ref_object_gfk_list' of incorrect type. Expected list, got {type(ref_object_gfk_list_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if ref_object_type_fq_name_old is not None and not (isinstance(ref_object_type_fq_name_old, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_old)}")
		if object_type_fq_name_list_old is not None and not (isinstance(object_type_fq_name_list_old, list)):
			raise ValueError(f"'object_type_fq_name_list' of incorrect type. Expected list, got {type(object_type_fq_name_list_old)}")
		if ot_attr_def_key_word_list_old is not None and not (isinstance(ot_attr_def_key_word_list_old, list)):
			raise ValueError(f"'ot_attr_def_key_word_list' of incorrect type. Expected list, got {type(ot_attr_def_key_word_list_old)}")

		return {'name': 'cntl.ot_attr_key.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'ref_object_gfk_list': ref_object_gfk_list_old, 'sorting_params_list': sorting_params_list_old, 'ref_object_type_fq_name': ref_object_type_fq_name_old, 'object_type_fq_name_list': object_type_fq_name_list_old, 'ot_attr_def_key_word_list': ot_attr_def_key_word_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, ref_object_gfk_list_old: list = None, sorting_params_list_old: list = None, ref_object_type_fq_name_old: str = None, object_type_fq_name_list_old: list = None, ot_attr_def_key_word_list_old: list = None) -> list:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if ref_object_gfk_list_old is not None and not (isinstance(ref_object_gfk_list_old, list)):
			raise ValueError(f"'ref_object_gfk_list' of incorrect type. Expected list, got {type(ref_object_gfk_list_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if ref_object_type_fq_name_old is not None and not (isinstance(ref_object_type_fq_name_old, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_old)}")
		if object_type_fq_name_list_old is not None and not (isinstance(object_type_fq_name_list_old, list)):
			raise ValueError(f"'object_type_fq_name_list' of incorrect type. Expected list, got {type(object_type_fq_name_list_old)}")
		if ot_attr_def_key_word_list_old is not None and not (isinstance(ot_attr_def_key_word_list_old, list)):
			raise ValueError(f"'ot_attr_def_key_word_list' of incorrect type. Expected list, got {type(ot_attr_def_key_word_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, ref_object_gfk_list_old=ref_object_gfk_list_old, sorting_params_list_old=sorting_params_list_old, ref_object_type_fq_name_old=ref_object_type_fq_name_old, object_type_fq_name_list_old=object_type_fq_name_list_old, ot_attr_def_key_word_list_old=ot_attr_def_key_word_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(object_type_fq_name_old: str, ot_attr_def_key_word_old: str, set_mode_new: int = None, display_mode_new: int = None, default_value_new: Union[str, ExplicitNull] = None, val_is_unique_new: bool = None, ref_object_gfk_new: Union[str, ExplicitNull] = None, val_is_nullable_new: bool = None, display_position_new: int = None, permission_fq_name_new: Union[str, ExplicitNull] = None, object_type_fq_name_new: str = None, ot_attr_def_key_word_new: str = None, ref_object_gfk_old: str = None) -> dict:
		if set_mode_new is not None and not (isinstance(set_mode_new, int)):
			raise ValueError(f"'set_mode' of incorrect type. Expected int, got {type(set_mode_new)}")
		if display_mode_new is not None and not (isinstance(display_mode_new, int)):
			raise ValueError(f"'display_mode' of incorrect type. Expected int, got {type(display_mode_new)}")
		if default_value_new is not None and not (isinstance(default_value_new, str) or isinstance(default_value_new, ExplicitNull)):
			raise ValueError(f"'default_value' of incorrect type. Expected str, got {type(default_value_new)}")
		if val_is_unique_new is not None and not (isinstance(val_is_unique_new, bool)):
			raise ValueError(f"'val_is_unique' of incorrect type. Expected bool, got {type(val_is_unique_new)}")
		if ref_object_gfk_new is not None and not (isinstance(ref_object_gfk_new, str) or isinstance(ref_object_gfk_new, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_new)}")
		if val_is_nullable_new is not None and not (isinstance(val_is_nullable_new, bool)):
			raise ValueError(f"'val_is_nullable' of incorrect type. Expected bool, got {type(val_is_nullable_new)}")
		if display_position_new is not None and not (isinstance(display_position_new, int)):
			raise ValueError(f"'display_position' of incorrect type. Expected int, got {type(display_position_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if object_type_fq_name_new is not None and not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if ot_attr_def_key_word_new is not None and not (isinstance(ot_attr_def_key_word_new, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_new)}")
		if ref_object_gfk_old is not None and not (isinstance(ref_object_gfk_old, str) or isinstance(ref_object_gfk_old, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")

		return {'name': 'cntl.ot_attr_key.update', 'new': _denullify_dict({'set_mode': set_mode_new, 'display_mode': display_mode_new, 'default_value': default_value_new, 'val_is_unique': val_is_unique_new, 'ref_object_gfk': ref_object_gfk_new, 'val_is_nullable': val_is_nullable_new, 'display_position': display_position_new, 'permission_fq_name': permission_fq_name_new, 'object_type_fq_name': object_type_fq_name_new, 'ot_attr_def_key_word': ot_attr_def_key_word_new}), 'old': _denullify_dict({'ref_object_gfk': ref_object_gfk_old, 'object_type_fq_name': object_type_fq_name_old, 'ot_attr_def_key_word': ot_attr_def_key_word_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, object_type_fq_name_old: str, ot_attr_def_key_word_old: str, set_mode_new: int = None, display_mode_new: int = None, default_value_new: Union[str, ExplicitNull] = None, val_is_unique_new: bool = None, ref_object_gfk_new: Union[str, ExplicitNull] = None, val_is_nullable_new: bool = None, display_position_new: int = None, permission_fq_name_new: Union[str, ExplicitNull] = None, object_type_fq_name_new: str = None, ot_attr_def_key_word_new: str = None, ref_object_gfk_old: str = None) -> list:
		if set_mode_new is not None and not (isinstance(set_mode_new, int)):
			raise ValueError(f"'set_mode' of incorrect type. Expected int, got {type(set_mode_new)}")
		if display_mode_new is not None and not (isinstance(display_mode_new, int)):
			raise ValueError(f"'display_mode' of incorrect type. Expected int, got {type(display_mode_new)}")
		if default_value_new is not None and not (isinstance(default_value_new, str) or isinstance(default_value_new, ExplicitNull)):
			raise ValueError(f"'default_value' of incorrect type. Expected str, got {type(default_value_new)}")
		if val_is_unique_new is not None and not (isinstance(val_is_unique_new, bool)):
			raise ValueError(f"'val_is_unique' of incorrect type. Expected bool, got {type(val_is_unique_new)}")
		if ref_object_gfk_new is not None and not (isinstance(ref_object_gfk_new, str) or isinstance(ref_object_gfk_new, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_new)}")
		if val_is_nullable_new is not None and not (isinstance(val_is_nullable_new, bool)):
			raise ValueError(f"'val_is_nullable' of incorrect type. Expected bool, got {type(val_is_nullable_new)}")
		if display_position_new is not None and not (isinstance(display_position_new, int)):
			raise ValueError(f"'display_position' of incorrect type. Expected int, got {type(display_position_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if object_type_fq_name_new is not None and not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if ot_attr_def_key_word_new is not None and not (isinstance(ot_attr_def_key_word_new, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_new)}")
		if ref_object_gfk_old is not None and not (isinstance(ref_object_gfk_old, str) or isinstance(ref_object_gfk_old, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(set_mode_new=set_mode_new, display_mode_new=display_mode_new, default_value_new=default_value_new, val_is_unique_new=val_is_unique_new, ref_object_gfk_new=ref_object_gfk_new, val_is_nullable_new=val_is_nullable_new, display_position_new=display_position_new, permission_fq_name_new=permission_fq_name_new, object_type_fq_name_new=object_type_fq_name_new, ot_attr_def_key_word_new=ot_attr_def_key_word_new, ref_object_gfk_old=ref_object_gfk_old, object_type_fq_name_old=object_type_fq_name_old, ot_attr_def_key_word_old=ot_attr_def_key_word_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class OtAttrVal(APIObject):
	value: str
	data_type: str
	object_gfk: str
	ref_object_gfk: str
	object_type_fq_name: str
	ot_attr_def_key_word: str

	def __post_init__(self):
		if self.value is not None and not isinstance(self.value, str):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(self.value)}")
		if not isinstance(self.data_type, str):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(self.data_type)}")
		if not isinstance(self.object_gfk, str):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(self.object_gfk)}")
		if self.ref_object_gfk is not None and not isinstance(self.ref_object_gfk, str):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(self.ref_object_gfk)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")
		if not isinstance(self.ot_attr_def_key_word, str):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(self.ot_attr_def_key_word)}")

	@staticmethod
	def list_ta(value_old: str = None, object_gfk_old: str = None, fetch_limit_old: int = None, value_range_old: str = None, fetch_offset_old: int = None, value_operator_old: str = 'eq', filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None, ot_attr_def_key_word_old: str = None, ot_attr_def_key_word_list_old: list = None) -> dict:
		if value_old is not None and not (isinstance(value_old, str) or isinstance(value_old, ExplicitNull)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")
		if object_gfk_old is not None and not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if value_range_old is not None and not (isinstance(value_range_old, str)):
			raise ValueError(f"'value_range' of incorrect type. Expected str, got {type(value_range_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if value_operator_old is not None and not (isinstance(value_operator_old, str)):
			raise ValueError(f"'value_operator' of incorrect type. Expected str, got {type(value_operator_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if ot_attr_def_key_word_old is not None and not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")
		if ot_attr_def_key_word_list_old is not None and not (isinstance(ot_attr_def_key_word_list_old, list)):
			raise ValueError(f"'ot_attr_def_key_word_list' of incorrect type. Expected list, got {type(ot_attr_def_key_word_list_old)}")

		return {'name': 'cntl.ot_attr_val.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'value': value_old, 'object_gfk': object_gfk_old, 'fetch_limit': fetch_limit_old, 'value_range': value_range_old, 'fetch_offset': fetch_offset_old, 'value_operator': value_operator_old, 'filter_params_dict': filter_params_dict_old, 'object_type_fq_name': object_type_fq_name_old, 'sorting_params_list': sorting_params_list_old, 'ot_attr_def_key_word': ot_attr_def_key_word_old, 'ot_attr_def_key_word_list': ot_attr_def_key_word_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, value_old: str = None, object_gfk_old: str = None, fetch_limit_old: int = None, value_range_old: str = None, fetch_offset_old: int = None, value_operator_old: str = 'eq', filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None, ot_attr_def_key_word_old: str = None, ot_attr_def_key_word_list_old: list = None) -> list:
		if value_old is not None and not (isinstance(value_old, str) or isinstance(value_old, ExplicitNull)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")
		if object_gfk_old is not None and not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if value_range_old is not None and not (isinstance(value_range_old, str)):
			raise ValueError(f"'value_range' of incorrect type. Expected str, got {type(value_range_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if value_operator_old is not None and not (isinstance(value_operator_old, str)):
			raise ValueError(f"'value_operator' of incorrect type. Expected str, got {type(value_operator_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if ot_attr_def_key_word_old is not None and not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")
		if ot_attr_def_key_word_list_old is not None and not (isinstance(ot_attr_def_key_word_list_old, list)):
			raise ValueError(f"'ot_attr_def_key_word_list' of incorrect type. Expected list, got {type(ot_attr_def_key_word_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(value_old=value_old, object_gfk_old=object_gfk_old, fetch_limit_old=fetch_limit_old, value_range_old=value_range_old, fetch_offset_old=fetch_offset_old, value_operator_old=value_operator_old, filter_params_dict_old=filter_params_dict_old, object_type_fq_name_old=object_type_fq_name_old, sorting_params_list_old=sorting_params_list_old, ot_attr_def_key_word_old=ot_attr_def_key_word_old, ot_attr_def_key_word_list_old=ot_attr_def_key_word_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(value_new: Union[str, ExplicitNull], object_gfk_old: str, ot_attr_def_key_word_old: str) -> dict:
		if not (isinstance(value_new, str) or isinstance(value_new, ExplicitNull)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_new)}")
		if not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")
		if not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")

		return {'name': 'cntl.ot_attr_val.update', 'new': _denullify_dict({'value': value_new}), 'old': _denullify_dict({'object_gfk': object_gfk_old, 'ot_attr_def_key_word': ot_attr_def_key_word_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, value_new: Union[str, ExplicitNull], object_gfk_old: str, ot_attr_def_key_word_old: str) -> list:
		if not (isinstance(value_new, str) or isinstance(value_new, ExplicitNull)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_new)}")
		if not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")
		if not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(value_new=value_new, object_gfk_old=object_gfk_old, ot_attr_def_key_word_old=ot_attr_def_key_word_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Replication(APIObject):
	gpk: str
	name: str
	oper_mode: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.oper_mode, str):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(self.oper_mode)}")

	@staticmethod
	def create_ta(name_new: str, oper_mode_new: str) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(oper_mode_new, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_new)}")

		return {'name': 'cntl.replication.create', 'new': _denullify_dict({'name': name_new, 'oper_mode': oper_mode_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, oper_mode_new: str) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(oper_mode_new, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, oper_mode_new=oper_mode_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str, oper_mode_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(oper_mode_old, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_old)}")

		return {'name': 'cntl.replication.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old, 'oper_mode': oper_mode_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str, oper_mode_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(oper_mode_old, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old, oper_mode_old=oper_mode_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_list_old: list = None, name_list_old: list = None, oper_mode_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if oper_mode_old is not None and not (isinstance(oper_mode_old, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.replication.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk_list': gpk_list_old, 'name_list': name_list_old, 'oper_mode': oper_mode_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_list_old: list = None, name_list_old: list = None, oper_mode_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if oper_mode_old is not None and not (isinstance(oper_mode_old, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_list_old=gpk_list_old, name_list_old=name_list_old, oper_mode_old=oper_mode_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, oper_mode_old: str, name_new: str = None, oper_mode_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if oper_mode_new is not None and not (isinstance(oper_mode_new, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(oper_mode_old, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_old)}")

		return {'name': 'cntl.replication.update', 'new': _denullify_dict({'name': name_new, 'oper_mode': oper_mode_new}), 'old': _denullify_dict({'name': name_old, 'oper_mode': oper_mode_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, oper_mode_old: str, name_new: str = None, oper_mode_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if oper_mode_new is not None and not (isinstance(oper_mode_new, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(oper_mode_old, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, oper_mode_new=oper_mode_new, name_old=name_old, oper_mode_old=oper_mode_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class ReplicationPub2sub(APIObject):
	gpk: str
	do_init: bool
	publisher_fqdn: str
	subscriber_fqdn: str
	replication_name: str
	replication_oper_mode: str
	replication_slot_suffix: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.do_init, bool):
			raise ValueError(f"'do_init' of incorrect type. Expected bool, got {type(self.do_init)}")
		if not isinstance(self.publisher_fqdn, str):
			raise ValueError(f"'publisher_fqdn' of incorrect type. Expected str, got {type(self.publisher_fqdn)}")
		if not isinstance(self.subscriber_fqdn, str):
			raise ValueError(f"'subscriber_fqdn' of incorrect type. Expected str, got {type(self.subscriber_fqdn)}")
		if not isinstance(self.replication_name, str):
			raise ValueError(f"'replication_name' of incorrect type. Expected str, got {type(self.replication_name)}")
		if not isinstance(self.replication_oper_mode, str):
			raise ValueError(f"'replication_oper_mode' of incorrect type. Expected str, got {type(self.replication_oper_mode)}")
		if not isinstance(self.replication_slot_suffix, str):
			raise ValueError(f"'replication_slot_suffix' of incorrect type. Expected str, got {type(self.replication_slot_suffix)}")

	@staticmethod
	def create_ta(publisher_fqdn_new: str, subscriber_fqdn_new: str, replication_name_new: str, replication_oper_mode_new: str, replication_slot_suffix_new: str, do_init_new: bool = True) -> dict:
		if do_init_new is not None and not (isinstance(do_init_new, bool)):
			raise ValueError(f"'do_init' of incorrect type. Expected bool, got {type(do_init_new)}")
		if not (isinstance(publisher_fqdn_new, str)):
			raise ValueError(f"'publisher_fqdn' of incorrect type. Expected str, got {type(publisher_fqdn_new)}")
		if not (isinstance(subscriber_fqdn_new, str)):
			raise ValueError(f"'subscriber_fqdn' of incorrect type. Expected str, got {type(subscriber_fqdn_new)}")
		if not (isinstance(replication_name_new, str)):
			raise ValueError(f"'replication_name' of incorrect type. Expected str, got {type(replication_name_new)}")
		if not (isinstance(replication_oper_mode_new, str)):
			raise ValueError(f"'replication_oper_mode' of incorrect type. Expected str, got {type(replication_oper_mode_new)}")
		if not (isinstance(replication_slot_suffix_new, str)):
			raise ValueError(f"'replication_slot_suffix' of incorrect type. Expected str, got {type(replication_slot_suffix_new)}")

		return {'name': 'cntl.replication_pub2sub.create', 'new': _denullify_dict({'do_init': do_init_new, 'publisher_fqdn': publisher_fqdn_new, 'subscriber_fqdn': subscriber_fqdn_new, 'replication_name': replication_name_new, 'replication_oper_mode': replication_oper_mode_new, 'replication_slot_suffix': replication_slot_suffix_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, publisher_fqdn_new: str, subscriber_fqdn_new: str, replication_name_new: str, replication_oper_mode_new: str, replication_slot_suffix_new: str, do_init_new: bool = True) -> list:
		if do_init_new is not None and not (isinstance(do_init_new, bool)):
			raise ValueError(f"'do_init' of incorrect type. Expected bool, got {type(do_init_new)}")
		if not (isinstance(publisher_fqdn_new, str)):
			raise ValueError(f"'publisher_fqdn' of incorrect type. Expected str, got {type(publisher_fqdn_new)}")
		if not (isinstance(subscriber_fqdn_new, str)):
			raise ValueError(f"'subscriber_fqdn' of incorrect type. Expected str, got {type(subscriber_fqdn_new)}")
		if not (isinstance(replication_name_new, str)):
			raise ValueError(f"'replication_name' of incorrect type. Expected str, got {type(replication_name_new)}")
		if not (isinstance(replication_oper_mode_new, str)):
			raise ValueError(f"'replication_oper_mode' of incorrect type. Expected str, got {type(replication_oper_mode_new)}")
		if not (isinstance(replication_slot_suffix_new, str)):
			raise ValueError(f"'replication_slot_suffix' of incorrect type. Expected str, got {type(replication_slot_suffix_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(do_init_new=do_init_new, publisher_fqdn_new=publisher_fqdn_new, subscriber_fqdn_new=subscriber_fqdn_new, replication_name_new=replication_name_new, replication_oper_mode_new=replication_oper_mode_new, replication_slot_suffix_new=replication_slot_suffix_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'cntl.replication_pub2sub.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(do_init_old: bool = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, publisher_fqdn_list_old: list = None, sorting_params_list_old: list = None, subscriber_fqdn_list_old: list = None, replication_name_list_old: list = None, replication_oper_mode_old: str = None) -> dict:
		if do_init_old is not None and not (isinstance(do_init_old, bool)):
			raise ValueError(f"'do_init' of incorrect type. Expected bool, got {type(do_init_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if publisher_fqdn_list_old is not None and not (isinstance(publisher_fqdn_list_old, list)):
			raise ValueError(f"'publisher_fqdn_list' of incorrect type. Expected list, got {type(publisher_fqdn_list_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if subscriber_fqdn_list_old is not None and not (isinstance(subscriber_fqdn_list_old, list)):
			raise ValueError(f"'subscriber_fqdn_list' of incorrect type. Expected list, got {type(subscriber_fqdn_list_old)}")
		if replication_name_list_old is not None and not (isinstance(replication_name_list_old, list)):
			raise ValueError(f"'replication_name_list' of incorrect type. Expected list, got {type(replication_name_list_old)}")
		if replication_oper_mode_old is not None and not (isinstance(replication_oper_mode_old, str)):
			raise ValueError(f"'replication_oper_mode' of incorrect type. Expected str, got {type(replication_oper_mode_old)}")

		return {'name': 'cntl.replication_pub2sub.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'do_init': do_init_old, 'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'publisher_fqdn_list': publisher_fqdn_list_old, 'sorting_params_list': sorting_params_list_old, 'subscriber_fqdn_list': subscriber_fqdn_list_old, 'replication_name_list': replication_name_list_old, 'replication_oper_mode': replication_oper_mode_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, do_init_old: bool = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, publisher_fqdn_list_old: list = None, sorting_params_list_old: list = None, subscriber_fqdn_list_old: list = None, replication_name_list_old: list = None, replication_oper_mode_old: str = None) -> list:
		if do_init_old is not None and not (isinstance(do_init_old, bool)):
			raise ValueError(f"'do_init' of incorrect type. Expected bool, got {type(do_init_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if publisher_fqdn_list_old is not None and not (isinstance(publisher_fqdn_list_old, list)):
			raise ValueError(f"'publisher_fqdn_list' of incorrect type. Expected list, got {type(publisher_fqdn_list_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if subscriber_fqdn_list_old is not None and not (isinstance(subscriber_fqdn_list_old, list)):
			raise ValueError(f"'subscriber_fqdn_list' of incorrect type. Expected list, got {type(subscriber_fqdn_list_old)}")
		if replication_name_list_old is not None and not (isinstance(replication_name_list_old, list)):
			raise ValueError(f"'replication_name_list' of incorrect type. Expected list, got {type(replication_name_list_old)}")
		if replication_oper_mode_old is not None and not (isinstance(replication_oper_mode_old, str)):
			raise ValueError(f"'replication_oper_mode' of incorrect type. Expected str, got {type(replication_oper_mode_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(do_init_old=do_init_old, gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, publisher_fqdn_list_old=publisher_fqdn_list_old, sorting_params_list_old=sorting_params_list_old, subscriber_fqdn_list_old=subscriber_fqdn_list_old, replication_name_list_old=replication_name_list_old, replication_oper_mode_old=replication_oper_mode_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, do_init_new: bool = None, publisher_fqdn_new: str = None, subscriber_fqdn_new: str = None, replication_name_new: str = None, do_init_is_recursive_new: bool = False, replication_oper_mode_new: str = None, replication_slot_suffix_new: str = None) -> dict:
		if do_init_new is not None and not (isinstance(do_init_new, bool)):
			raise ValueError(f"'do_init' of incorrect type. Expected bool, got {type(do_init_new)}")
		if publisher_fqdn_new is not None and not (isinstance(publisher_fqdn_new, str)):
			raise ValueError(f"'publisher_fqdn' of incorrect type. Expected str, got {type(publisher_fqdn_new)}")
		if subscriber_fqdn_new is not None and not (isinstance(subscriber_fqdn_new, str)):
			raise ValueError(f"'subscriber_fqdn' of incorrect type. Expected str, got {type(subscriber_fqdn_new)}")
		if replication_name_new is not None and not (isinstance(replication_name_new, str)):
			raise ValueError(f"'replication_name' of incorrect type. Expected str, got {type(replication_name_new)}")
		if do_init_is_recursive_new is not None and not (isinstance(do_init_is_recursive_new, bool)):
			raise ValueError(f"'do_init_is_recursive' of incorrect type. Expected bool, got {type(do_init_is_recursive_new)}")
		if replication_oper_mode_new is not None and not (isinstance(replication_oper_mode_new, str)):
			raise ValueError(f"'replication_oper_mode' of incorrect type. Expected str, got {type(replication_oper_mode_new)}")
		if replication_slot_suffix_new is not None and not (isinstance(replication_slot_suffix_new, str)):
			raise ValueError(f"'replication_slot_suffix' of incorrect type. Expected str, got {type(replication_slot_suffix_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'cntl.replication_pub2sub.update', 'new': _denullify_dict({'do_init': do_init_new, 'publisher_fqdn': publisher_fqdn_new, 'subscriber_fqdn': subscriber_fqdn_new, 'replication_name': replication_name_new, 'do_init_is_recursive': do_init_is_recursive_new, 'replication_oper_mode': replication_oper_mode_new, 'replication_slot_suffix': replication_slot_suffix_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, do_init_new: bool = None, publisher_fqdn_new: str = None, subscriber_fqdn_new: str = None, replication_name_new: str = None, do_init_is_recursive_new: bool = False, replication_oper_mode_new: str = None, replication_slot_suffix_new: str = None) -> list:
		if do_init_new is not None and not (isinstance(do_init_new, bool)):
			raise ValueError(f"'do_init' of incorrect type. Expected bool, got {type(do_init_new)}")
		if publisher_fqdn_new is not None and not (isinstance(publisher_fqdn_new, str)):
			raise ValueError(f"'publisher_fqdn' of incorrect type. Expected str, got {type(publisher_fqdn_new)}")
		if subscriber_fqdn_new is not None and not (isinstance(subscriber_fqdn_new, str)):
			raise ValueError(f"'subscriber_fqdn' of incorrect type. Expected str, got {type(subscriber_fqdn_new)}")
		if replication_name_new is not None and not (isinstance(replication_name_new, str)):
			raise ValueError(f"'replication_name' of incorrect type. Expected str, got {type(replication_name_new)}")
		if do_init_is_recursive_new is not None and not (isinstance(do_init_is_recursive_new, bool)):
			raise ValueError(f"'do_init_is_recursive' of incorrect type. Expected bool, got {type(do_init_is_recursive_new)}")
		if replication_oper_mode_new is not None and not (isinstance(replication_oper_mode_new, str)):
			raise ValueError(f"'replication_oper_mode' of incorrect type. Expected str, got {type(replication_oper_mode_new)}")
		if replication_slot_suffix_new is not None and not (isinstance(replication_slot_suffix_new, str)):
			raise ValueError(f"'replication_slot_suffix' of incorrect type. Expected str, got {type(replication_slot_suffix_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(do_init_new=do_init_new, publisher_fqdn_new=publisher_fqdn_new, subscriber_fqdn_new=subscriber_fqdn_new, replication_name_new=replication_name_new, do_init_is_recursive_new=do_init_is_recursive_new, replication_oper_mode_new=replication_oper_mode_new, replication_slot_suffix_new=replication_slot_suffix_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class DataTypeOperator(APIObject):
	gpk: str
	name: str
	data_type_list: list

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.data_type_list, list):
			raise ValueError(f"'data_type_list' of incorrect type. Expected list, got {type(self.data_type_list)}")

	@staticmethod
	def list_ta(gpk_list_old: list = None, data_type_old: str = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if data_type_old is not None and not (isinstance(data_type_old, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.data_type_operator.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk_list': gpk_list_old, 'data_type': data_type_old, 'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_list_old: list = None, data_type_old: str = None, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if data_type_old is not None and not (isinstance(data_type_old, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_list_old=gpk_list_old, data_type_old=data_type_old, name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Language(APIObject):
	gpk: str
	tag: str
	name: str
	is_active: bool
	is_default: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.tag, str):
			raise ValueError(f"'tag' of incorrect type. Expected str, got {type(self.tag)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.is_active, bool):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(self.is_active)}")
		if not isinstance(self.is_default, bool):
			raise ValueError(f"'is_default' of incorrect type. Expected bool, got {type(self.is_default)}")

	@staticmethod
	def create_ta(tag_new: str, name_new: str, is_active_new: bool = False, is_default_new: bool = False) -> dict:
		if not (isinstance(tag_new, str)):
			raise ValueError(f"'tag' of incorrect type. Expected str, got {type(tag_new)}")
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if is_active_new is not None and not (isinstance(is_active_new, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_new)}")
		if is_default_new is not None and not (isinstance(is_default_new, bool)):
			raise ValueError(f"'is_default' of incorrect type. Expected bool, got {type(is_default_new)}")

		return {'name': 'cntl.language.create', 'new': _denullify_dict({'tag': tag_new, 'name': name_new, 'is_active': is_active_new, 'is_default': is_default_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, tag_new: str, name_new: str, is_active_new: bool = False, is_default_new: bool = False) -> list:
		if not (isinstance(tag_new, str)):
			raise ValueError(f"'tag' of incorrect type. Expected str, got {type(tag_new)}")
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if is_active_new is not None and not (isinstance(is_active_new, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_new)}")
		if is_default_new is not None and not (isinstance(is_default_new, bool)):
			raise ValueError(f"'is_default' of incorrect type. Expected bool, got {type(is_default_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(tag_new=tag_new, name_new=name_new, is_active_new=is_active_new, is_default_new=is_default_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(tag_old: str) -> dict:
		if not (isinstance(tag_old, str)):
			raise ValueError(f"'tag' of incorrect type. Expected str, got {type(tag_old)}")

		return {'name': 'cntl.language.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'tag': tag_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, tag_old: str) -> list:
		if not (isinstance(tag_old, str)):
			raise ValueError(f"'tag' of incorrect type. Expected str, got {type(tag_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(tag_old=tag_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_list_old: list = None, tag_list_old: list = None, is_active_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if tag_list_old is not None and not (isinstance(tag_list_old, list)):
			raise ValueError(f"'tag_list' of incorrect type. Expected list, got {type(tag_list_old)}")
		if is_active_old is not None and not (isinstance(is_active_old, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.language.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk_list': gpk_list_old, 'tag_list': tag_list_old, 'is_active': is_active_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_list_old: list = None, tag_list_old: list = None, is_active_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if tag_list_old is not None and not (isinstance(tag_list_old, list)):
			raise ValueError(f"'tag_list' of incorrect type. Expected list, got {type(tag_list_old)}")
		if is_active_old is not None and not (isinstance(is_active_old, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_list_old=gpk_list_old, tag_list_old=tag_list_old, is_active_old=is_active_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(tag_old: str, tag_new: str = None, name_new: str = None, is_active_new: bool = None, is_default_new: bool = None) -> dict:
		if tag_new is not None and not (isinstance(tag_new, str)):
			raise ValueError(f"'tag' of incorrect type. Expected str, got {type(tag_new)}")
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if is_active_new is not None and not (isinstance(is_active_new, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_new)}")
		if is_default_new is not None and not (isinstance(is_default_new, bool)):
			raise ValueError(f"'is_default' of incorrect type. Expected bool, got {type(is_default_new)}")
		if not (isinstance(tag_old, str)):
			raise ValueError(f"'tag' of incorrect type. Expected str, got {type(tag_old)}")

		return {'name': 'cntl.language.update', 'new': _denullify_dict({'tag': tag_new, 'name': name_new, 'is_active': is_active_new, 'is_default': is_default_new}), 'old': _denullify_dict({'tag': tag_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, tag_old: str, tag_new: str = None, name_new: str = None, is_active_new: bool = None, is_default_new: bool = None) -> list:
		if tag_new is not None and not (isinstance(tag_new, str)):
			raise ValueError(f"'tag' of incorrect type. Expected str, got {type(tag_new)}")
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if is_active_new is not None and not (isinstance(is_active_new, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_new)}")
		if is_default_new is not None and not (isinstance(is_default_new, bool)):
			raise ValueError(f"'is_default' of incorrect type. Expected bool, got {type(is_default_new)}")
		if not (isinstance(tag_old, str)):
			raise ValueError(f"'tag' of incorrect type. Expected str, got {type(tag_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(tag_new=tag_new, name_new=name_new, is_active_new=is_active_new, is_default_new=is_default_new, tag_old=tag_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class OtLangAttrDef(APIObject):
	gpk: str
	key_word: str
	is_static: bool
	is_primary: bool
	object_type_fq_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.key_word, str):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(self.key_word)}")
		if not isinstance(self.is_static, bool):
			raise ValueError(f"'is_static' of incorrect type. Expected bool, got {type(self.is_static)}")
		if not isinstance(self.is_primary, bool):
			raise ValueError(f"'is_primary' of incorrect type. Expected bool, got {type(self.is_primary)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")

	@staticmethod
	def create_ta(key_word_new: str, object_type_fq_name_new: str, is_static_new: bool = False, is_primary_new: bool = False) -> dict:
		if not (isinstance(key_word_new, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_new)}")
		if is_static_new is not None and not (isinstance(is_static_new, bool)):
			raise ValueError(f"'is_static' of incorrect type. Expected bool, got {type(is_static_new)}")
		if is_primary_new is not None and not (isinstance(is_primary_new, bool)):
			raise ValueError(f"'is_primary' of incorrect type. Expected bool, got {type(is_primary_new)}")
		if not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")

		return {'name': 'cntl.ot_lang_attr_def.create', 'new': _denullify_dict({'key_word': key_word_new, 'is_static': is_static_new, 'is_primary': is_primary_new, 'object_type_fq_name': object_type_fq_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, key_word_new: str, object_type_fq_name_new: str, is_static_new: bool = False, is_primary_new: bool = False) -> list:
		if not (isinstance(key_word_new, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_new)}")
		if is_static_new is not None and not (isinstance(is_static_new, bool)):
			raise ValueError(f"'is_static' of incorrect type. Expected bool, got {type(is_static_new)}")
		if is_primary_new is not None and not (isinstance(is_primary_new, bool)):
			raise ValueError(f"'is_primary' of incorrect type. Expected bool, got {type(is_primary_new)}")
		if not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(key_word_new=key_word_new, is_static_new=is_static_new, is_primary_new=is_primary_new, object_type_fq_name_new=object_type_fq_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(key_word_old: str, object_type_fq_name_old: str) -> dict:
		if not (isinstance(key_word_old, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")

		return {'name': 'cntl.ot_lang_attr_def.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'key_word': key_word_old, 'object_type_fq_name': object_type_fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, key_word_old: str, object_type_fq_name_old: str) -> list:
		if not (isinstance(key_word_old, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(key_word_old=key_word_old, object_type_fq_name_old=object_type_fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_list_old: list = None, is_static_old: bool = None, is_primary_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, key_word_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, object_type_fq_name_list_old: list = None) -> dict:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if is_static_old is not None and not (isinstance(is_static_old, bool)):
			raise ValueError(f"'is_static' of incorrect type. Expected bool, got {type(is_static_old)}")
		if is_primary_old is not None and not (isinstance(is_primary_old, bool)):
			raise ValueError(f"'is_primary' of incorrect type. Expected bool, got {type(is_primary_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if key_word_list_old is not None and not (isinstance(key_word_list_old, list)):
			raise ValueError(f"'key_word_list' of incorrect type. Expected list, got {type(key_word_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if object_type_fq_name_list_old is not None and not (isinstance(object_type_fq_name_list_old, list)):
			raise ValueError(f"'object_type_fq_name_list' of incorrect type. Expected list, got {type(object_type_fq_name_list_old)}")

		return {'name': 'cntl.ot_lang_attr_def.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk_list': gpk_list_old, 'is_static': is_static_old, 'is_primary': is_primary_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'key_word_list': key_word_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'object_type_fq_name_list': object_type_fq_name_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_list_old: list = None, is_static_old: bool = None, is_primary_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, key_word_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, object_type_fq_name_list_old: list = None) -> list:
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if is_static_old is not None and not (isinstance(is_static_old, bool)):
			raise ValueError(f"'is_static' of incorrect type. Expected bool, got {type(is_static_old)}")
		if is_primary_old is not None and not (isinstance(is_primary_old, bool)):
			raise ValueError(f"'is_primary' of incorrect type. Expected bool, got {type(is_primary_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if key_word_list_old is not None and not (isinstance(key_word_list_old, list)):
			raise ValueError(f"'key_word_list' of incorrect type. Expected list, got {type(key_word_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if object_type_fq_name_list_old is not None and not (isinstance(object_type_fq_name_list_old, list)):
			raise ValueError(f"'object_type_fq_name_list' of incorrect type. Expected list, got {type(object_type_fq_name_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_list_old=gpk_list_old, is_static_old=is_static_old, is_primary_old=is_primary_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, key_word_list_old=key_word_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, object_type_fq_name_list_old=object_type_fq_name_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(key_word_old: str, object_type_fq_name_old: str, key_word_new: str = None) -> dict:
		if key_word_new is not None and not (isinstance(key_word_new, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_new)}")
		if not (isinstance(key_word_old, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")

		return {'name': 'cntl.ot_lang_attr_def.update', 'new': _denullify_dict({'key_word': key_word_new}), 'old': _denullify_dict({'key_word': key_word_old, 'object_type_fq_name': object_type_fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, key_word_old: str, object_type_fq_name_old: str, key_word_new: str = None) -> list:
		if key_word_new is not None and not (isinstance(key_word_new, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_new)}")
		if not (isinstance(key_word_old, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(key_word_new=key_word_new, key_word_old=key_word_old, object_type_fq_name_old=object_type_fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class OtLangAttrVal(APIObject):
	value: str
	object_gfk: str
	language_tag: str
	object_type_fq_name: str
	ot_lang_attr_def_key_word: str

	def __post_init__(self):
		if self.value is not None and not isinstance(self.value, str):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(self.value)}")
		if not isinstance(self.object_gfk, str):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(self.object_gfk)}")
		if not isinstance(self.language_tag, str):
			raise ValueError(f"'language_tag' of incorrect type. Expected str, got {type(self.language_tag)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")
		if not isinstance(self.ot_lang_attr_def_key_word, str):
			raise ValueError(f"'ot_lang_attr_def_key_word' of incorrect type. Expected str, got {type(self.ot_lang_attr_def_key_word)}")

	@staticmethod
	def list_ta(value_old: str = None, object_gfk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, language_tag_old: str = None, value_regexp_old: str = None, filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None, use_transaction_language_old: bool = False, ot_lang_attr_def_key_word_old: str = None, ot_lang_attr_def_key_word_list_old: list = None) -> dict:
		if value_old is not None and not (isinstance(value_old, str) or isinstance(value_old, ExplicitNull)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")
		if object_gfk_old is not None and not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if language_tag_old is not None and not (isinstance(language_tag_old, str)):
			raise ValueError(f"'language_tag' of incorrect type. Expected str, got {type(language_tag_old)}")
		if value_regexp_old is not None and not (isinstance(value_regexp_old, str)):
			raise ValueError(f"'value_regexp' of incorrect type. Expected str, got {type(value_regexp_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if use_transaction_language_old is not None and not (isinstance(use_transaction_language_old, bool)):
			raise ValueError(f"'use_transaction_language' of incorrect type. Expected bool, got {type(use_transaction_language_old)}")
		if ot_lang_attr_def_key_word_old is not None and not (isinstance(ot_lang_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_lang_attr_def_key_word' of incorrect type. Expected str, got {type(ot_lang_attr_def_key_word_old)}")
		if ot_lang_attr_def_key_word_list_old is not None and not (isinstance(ot_lang_attr_def_key_word_list_old, list)):
			raise ValueError(f"'ot_lang_attr_def_key_word_list' of incorrect type. Expected list, got {type(ot_lang_attr_def_key_word_list_old)}")

		return {'name': 'cntl.ot_lang_attr_val.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'value': value_old, 'object_gfk': object_gfk_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'language_tag': language_tag_old, 'value_regexp': value_regexp_old, 'filter_params_dict': filter_params_dict_old, 'object_type_fq_name': object_type_fq_name_old, 'sorting_params_list': sorting_params_list_old, 'use_transaction_language': use_transaction_language_old, 'ot_lang_attr_def_key_word': ot_lang_attr_def_key_word_old, 'ot_lang_attr_def_key_word_list': ot_lang_attr_def_key_word_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, value_old: str = None, object_gfk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, language_tag_old: str = None, value_regexp_old: str = None, filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None, use_transaction_language_old: bool = False, ot_lang_attr_def_key_word_old: str = None, ot_lang_attr_def_key_word_list_old: list = None) -> list:
		if value_old is not None and not (isinstance(value_old, str) or isinstance(value_old, ExplicitNull)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")
		if object_gfk_old is not None and not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if language_tag_old is not None and not (isinstance(language_tag_old, str)):
			raise ValueError(f"'language_tag' of incorrect type. Expected str, got {type(language_tag_old)}")
		if value_regexp_old is not None and not (isinstance(value_regexp_old, str)):
			raise ValueError(f"'value_regexp' of incorrect type. Expected str, got {type(value_regexp_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if use_transaction_language_old is not None and not (isinstance(use_transaction_language_old, bool)):
			raise ValueError(f"'use_transaction_language' of incorrect type. Expected bool, got {type(use_transaction_language_old)}")
		if ot_lang_attr_def_key_word_old is not None and not (isinstance(ot_lang_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_lang_attr_def_key_word' of incorrect type. Expected str, got {type(ot_lang_attr_def_key_word_old)}")
		if ot_lang_attr_def_key_word_list_old is not None and not (isinstance(ot_lang_attr_def_key_word_list_old, list)):
			raise ValueError(f"'ot_lang_attr_def_key_word_list' of incorrect type. Expected list, got {type(ot_lang_attr_def_key_word_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(value_old=value_old, object_gfk_old=object_gfk_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, language_tag_old=language_tag_old, value_regexp_old=value_regexp_old, filter_params_dict_old=filter_params_dict_old, object_type_fq_name_old=object_type_fq_name_old, sorting_params_list_old=sorting_params_list_old, use_transaction_language_old=use_transaction_language_old, ot_lang_attr_def_key_word_old=ot_lang_attr_def_key_word_old, ot_lang_attr_def_key_word_list_old=ot_lang_attr_def_key_word_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(object_gfk_old: str, language_tag_old: str, ot_lang_attr_def_key_word_old: str, value_new: Union[str, ExplicitNull] = None) -> dict:
		if value_new is not None and not (isinstance(value_new, str) or isinstance(value_new, ExplicitNull)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_new)}")
		if not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")
		if not (isinstance(language_tag_old, str)):
			raise ValueError(f"'language_tag' of incorrect type. Expected str, got {type(language_tag_old)}")
		if not (isinstance(ot_lang_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_lang_attr_def_key_word' of incorrect type. Expected str, got {type(ot_lang_attr_def_key_word_old)}")

		return {'name': 'cntl.ot_lang_attr_val.update', 'new': _denullify_dict({'value': value_new}), 'old': _denullify_dict({'object_gfk': object_gfk_old, 'language_tag': language_tag_old, 'ot_lang_attr_def_key_word': ot_lang_attr_def_key_word_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, object_gfk_old: str, language_tag_old: str, ot_lang_attr_def_key_word_old: str, value_new: Union[str, ExplicitNull] = None) -> list:
		if value_new is not None and not (isinstance(value_new, str) or isinstance(value_new, ExplicitNull)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_new)}")
		if not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")
		if not (isinstance(language_tag_old, str)):
			raise ValueError(f"'language_tag' of incorrect type. Expected str, got {type(language_tag_old)}")
		if not (isinstance(ot_lang_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_lang_attr_def_key_word' of incorrect type. Expected str, got {type(ot_lang_attr_def_key_word_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(value_new=value_new, object_gfk_old=object_gfk_old, language_tag_old=language_tag_old, ot_lang_attr_def_key_word_old=ot_lang_attr_def_key_word_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
